package com.slibra.web.controller.business;

import java.util.List;
import javax.servlet.http.HttpServletResponse;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.slibra.common.annotation.Log;
import com.slibra.common.core.controller.BaseController;
import com.slibra.common.core.domain.AjaxResult;
import com.slibra.common.enums.BusinessType;
import com.slibra.business.domain.AutoFeedback;
import com.slibra.business.service.IAutoFeedbackService;
import com.slibra.common.utils.poi.ExcelUtil;
import com.slibra.common.core.page.TableDataInfo;

/**
 * 【请填写功能名称】Controller
 * 
 * @author slibra
 * @date 2025-05-09
 */
@RestController
@RequestMapping("/business/autoFeedback")
public class AutoFeedbackController extends BaseController
{
    @Autowired
    private IAutoFeedbackService autoFeedbackService;

    /**
     * 查询【请填写功能名称】列表
     */
    @PreAuthorize("@ss.hasPermi('business:feedback:list')")
    @GetMapping("/list")
    public TableDataInfo list(AutoFeedback autoFeedback)
    {
        startPage();
        List<AutoFeedback> list = autoFeedbackService.selectAutoFeedbackList(autoFeedback);
        return getDataTable(list);
    }

    /**
     * 导出【请填写功能名称】列表
     */
    @PreAuthorize("@ss.hasPermi('business:feedback:export')")
    @Log(title = "【请填写功能名称】", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, AutoFeedback autoFeedback)
    {
        List<AutoFeedback> list = autoFeedbackService.selectAutoFeedbackList(autoFeedback);
        ExcelUtil<AutoFeedback> util = new ExcelUtil<AutoFeedback>(AutoFeedback.class);
        util.exportExcel(response, list, "【请填写功能名称】数据");
    }

    /**
     * 获取【请填写功能名称】详细信息
     */
    @PreAuthorize("@ss.hasPermi('business:feedback:query')")
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") Long id)
    {
        return success(autoFeedbackService.selectAutoFeedbackById(id));
    }

    /**
     * 新增【请填写功能名称】
     */
    @PreAuthorize("@ss.hasPermi('business:feedback:add')")
    @Log(title = "【请填写功能名称】", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody AutoFeedback autoFeedback)
    {
        return toAjax(autoFeedbackService.insertAutoFeedback(autoFeedback));
    }

    /**
     * 修改【请填写功能名称】
     */
    @PreAuthorize("@ss.hasPermi('business:feedback:edit')")
    @Log(title = "【请填写功能名称】", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody AutoFeedback autoFeedback)
    {
        return toAjax(autoFeedbackService.updateAutoFeedback(autoFeedback));
    }

    /**
     * 删除【请填写功能名称】
     */
    @PreAuthorize("@ss.hasPermi('business:feedback:remove')")
    @Log(title = "【请填写功能名称】", businessType = BusinessType.DELETE)
	@DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable Long[] ids)
    {
        return toAjax(autoFeedbackService.deleteAutoFeedbackByIds(ids));
    }
}
