package com.slibra.web.controller.business;


import com.slibra.business.domain.TXinyiNormConfig;
import com.slibra.business.mapper.TXinyiNormConfigMapper;
import com.slibra.business.res.DailyWorkerRes;
import com.slibra.common.core.domain.TXinyiDaily;
import com.slibra.business.mapper.TXinyiDailyMapper;
import com.slibra.common.core.domain.AjaxResult;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.CollectionUtils;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/out")
@Slf4j
public class OutController {


    @Autowired
    private TXinyiDailyMapper xinyiDailyMapper;

    @Autowired
    private TXinyiNormConfigMapper xinyiNormConfigMapper;

    /**
     * 通过日期获取某天的日报情况
     * @return
     */
    @GetMapping("/getDailyByDate")
    public AjaxResult getDailyByDate(@RequestParam String date)
    {
        log.info("进入了 通过日期获取某天的日报情况  接口");
        List<TXinyiDaily> xinyiDailies = xinyiDailyMapper.selectTXinyiDailyList(TXinyiDaily.builder().testDate(date).build());
        if(!CollectionUtils.isEmpty(xinyiDailies))
            return AjaxResult.success(xinyiDailies.get(0));
        return AjaxResult.error("没有查询到对应的日报数据");
    }


    @GetMapping("generateReqData")
    public DailyWorkerRes generateReqData(){
        DailyWorkerRes dailyWorkerRes = new DailyWorkerRes();
        //获取配置
        //查询配置信息
        List<TXinyiNormConfig> tXinyiNormConfigs = this.xinyiNormConfigMapper.selectTXinyiNormConfigList(null);
        if(CollectionUtils.isEmpty(tXinyiNormConfigs))
            return null;
        TXinyiNormConfig normConfig = tXinyiNormConfigs.get(0);
        dailyWorkerRes.setNormConfig(normConfig);
        //查询最近15天的数据
        dailyWorkerRes.setDailyRecords(this.xinyiDailyMapper.selectNRecords(15));
        return dailyWorkerRes;
    }
}
