package com.slibra.common.enums;

public class BusinessEnum {


    /**
     * 登录的用户类型【前后台隔离】： 0后端  1前端  2小程序
     */
    public enum LoginUserTypeEnum
    {
        front(0, "前端"),
        background(1, "后端"),
        applet(2, "小程序"),
        ;

        private final int code;
        private final String msg;

        LoginUserTypeEnum(int code, String msg)
        {
            this.code = code;
            this.msg = msg;
        }

        public int getCode()
        {
            return code;
        }

        public String getMsg()
        {
            return msg;
        }
    }


    /**
     * 告警类型枚举
     */
    public enum WarningCategoryEnum
    {

        //水质报警
        CS_COD("出水COD", "出水COD"),
        CS_SS("出水SS", "出水SS"),
        CS_ZD("出水总氮", "出水总氮"),
        CS_ZL("出水总磷", "出水总磷"),
        CS_AD("出水氨氮", "出水氨氮"),
        JS_COD("进水COD", "进水COD"),
        JS_SS("进水SS", "进水SS"),
        JS_ZD("进水总氮", "进水总氮"),
        JS_ZL("进水总磷", "进水总磷"),
        JS_AD("进水氨氮", "进水氨氮"),

        //----2024年7月11日17:25:11  新增的 化验室报警类型----
        ROBOT_XSY_1("#1好氧硝酸盐", "#1好氧硝酸盐"),
        ROBOT_XSY_2("#2好氧硝酸盐", "#2好氧硝酸盐"),
        ROBOT_ECCZLSY("二沉池正磷酸盐", "二沉池正磷酸盐"),
        ROBOT_ANDAN_1("#1氨氮", "#1氨氮"),
        ROBOT_ANDAN_2("#2氨氮", "#2氨氮"),
        ROBOT_CS_AD("出水氨氮连续检测", "出水氨氮连续检测"),

        //2024年7月26日11:11:06 氨氮报警（两个池子）合成一个出水氨氮  CS_AD

        //生化报警
        NHLB("内回流比", "内回流比"),
        WHLB("外回流比", "外回流比"),
        WNND("污泥浓度", "污泥浓度"),
        WNFH("污泥负荷", "污泥负荷"),
        TDB("碳氮比", "碳氮比"),
        TLB("碳磷比", "碳磷比"),
        BODCODB("BOD比COD", "BOD比COD"),
        YYQDO("厌氧区DO", "厌氧区DO"),
        QYQDO("缺氧区DO", "缺氧区DO"),
        HYQDO_ONE("好氧区DO#1", "好氧区DO#1"),
        HYQDO_TWO("好氧区DO#2", "好氧区DO#2"),
        QSB("气水比", "气水比"),
        CS_COD_YC("出水COD", "出水COD"),
        CS_SS_YC("出水SS", "出水SS"),
        CS_TN_YC("出水总氮", "出水总氮"),
        CS_TP_YC("二沉池正磷酸盐", "二沉池正磷酸盐"),
        CS_AD_YC("出水氨氮", "出水氨氮"),
        CS_XSY_1_YC("1号好氧池硝酸盐", "1号好氧池硝酸盐"),
        CS_XSY_2_YC("2号好氧池硝酸盐", "2号好氧池硝酸盐"),
        WNND_MLSS_1("污泥浓度MLSS#1", "污泥浓度MLSS#1"),
        WNND_MLSS_2("污泥浓度MLSS#2", "污泥浓度MLSS#2"),
        HFXWNNDZB("挥发性污泥浓度占比（MLVSS/MLSS）", "挥发性污泥浓度占比（MLVSS/MLSS）"),

        ECC_BMFH("二沉池表面负荷", "二沉池表面负荷"),
        ECC_GTFH("二沉池固体负荷", "二沉池固体负荷"),
        FCXSL("反冲洗水量", "反冲洗水量"),

        QYCXSY_1("#1缺氧硝酸盐  ", "#1缺氧硝酸盐"),
        QYCXSY_2("#2缺氧硝酸盐", "#2缺氧硝酸盐"),
        QYAD_1("#1缺氧氨氮", "#1缺氧氨氮"),
        QYAD_2("#2缺氧氨氮", "#2缺氧氨氮"),

        ;

        private final String code;
        private final String msg;

        WarningCategoryEnum(String code, String msg)
        {
            this.code = code;
            this.msg = msg;
        }

        public String getCode()
        {
            return code;
        }

        public String getMsg()
        {
            return msg;
        }
    }


    /**
     * 大模型返回结果类型枚举
     */
    public enum BigModelBizEnum
    {
        OK("OK", "正常结束"),
        ERROR("ERROR", "出现错误"),
        DECISION_ALERT("DECISION_ALERT", "弹窗类型"),
        DECISION_DEBUGGER("DECISION_DEBUGGER", "中间过程"),
        DECISION_REPORT("DECISION_REPORT", "最终的输出结果"),
        DECISION_SIMULATE("DECISION_SIMULATE", "仿真推荐值"),
        ;

        private final String code;
        private final String msg;

        BigModelBizEnum(String code, String msg)
        {
            this.code = code;
            this.msg = msg;
        }

        public String getCode()
        {
            return code;
        }

        public String getMsg()
        {
            return msg;
        }
    }


    /**
     *
     * 展示单位相关的枚举
     *
     */
    public enum BigModelUnitEnum
    {
        PERCENT("%", "%"),
        MG_L("mg/L", "mg/L"),
        KGBOD_KGMLSS_D("kgBOD/(kgMLSS·d)", "kgBOD/(kgMLSS·d)"),
        M3_M3("m³/m³", "m³/m³"),
        M3_M2_H("m³/(m²·h)", "m³/(m²·h)"),
        KG_M2_D("kg/(m²·d)", "kg/(m²·d)"),
        NULL("", ""),
        ;

        private final String code;
        private final String msg;

        BigModelUnitEnum(String code, String msg)
        {
            this.code = code;
            this.msg = msg;
        }

        public String getCode()
        {
            return code;
        }

        public String getMsg()
        {
            return msg;
        }
    }



    /**
     * 预测调用参数枚举
     */
    public enum BigModelForecastEnum
    {
        ZLSY("zlsy", "zlsy"),
        XSY1("xsy1", "xsy1"),
        XSY2("xsy2", "xsy2"),
        TN("tn", "tn"),
        COD("cod", "cod"),
        SS("ss", "ss"),
        NH3("nh3", "nh3"),
        TP("tp", "tp"),
        QYXSY1("qyxsy1", "qyxsy1"),
        QYXSY2("qyxsy2", "qyxsy2"),
        QYNH31("qynh31", "qynh31"),
        QYNH32("qynh32", "qynh32"),
        ;

        private final String code;
        private final String msg;

        BigModelForecastEnum(String code, String msg)
        {
            this.code = code;
            this.msg = msg;
        }

        public String getCode()
        {
            return code;
        }

        public String getMsg()
        {
            return msg;
        }
    }


    /**
     *
     * 区分来源的报警类型枚举
     *
     */
    public enum BigModelWarningTypeRemarkEnum
    {
        ZERO_SZ_WARNING("0", "水质报警"),
        ONE_SH_WARNING("1", "生化报警"),
        TWO_YC_WARNING("2", "预测预警"),
        THREE_HYS_WARNING("3", "化验室报警"),

        ;

        private final String code;
        private final String msg;

        BigModelWarningTypeRemarkEnum(String code, String msg)
        {
            this.code = code;
            this.msg = msg;
        }

        public String getCode()
        {
            return code;
        }

        public String getMsg()
        {
            return msg;
        }
    }



    /**
     *
     * 智能投药请求参数枚举
     *      * 0：进水流量
     *      * 1：#1好氧池硝酸盐
     *      * 2：#2好氧池硝酸盐
     *      * 3：#1缺氧池氨氮
     *      * 4：#2缺氧池氨氮
     *      * 5：进水COD
     *      * 6：进水总氮
     *      * 7：碳源投加量
     *
     */
    public enum SmartAddMedicineReqEnum
    {
        JSLL(0, "进水流量"),
        HY_1_XSY(1, "#1好氧池硝酸盐"),
        HY_2_XSY(2, "#2好氧池硝酸盐"),
        QY_1_AD(3, "#1缺氧池氨氮"),
        QY_2_AD(4, "#2缺氧池氨氮"),
        JSCOD(5, "进水COD"),
        JSTN(6, "进水总氮"),
        TYTJL(7, "碳源投加量"),


        ;

        private final int code;
        private final String msg;

        SmartAddMedicineReqEnum(int code, String msg)
        {
            this.code = code;
            this.msg = msg;
        }

        public int getCode()
        {
            return code;
        }

        public String getMsg()
        {
            return msg;
        }
    }


    /**
     *
     * 数据来源枚举
     *
     */
    public enum DataSourceEnum
    {
        YB("YB", "仪表"),
        HY("HY", "化验"),
        YC("YC", "预测"),


        ;

        private final String code;
        private final String msg;

        DataSourceEnum(String code, String msg)
        {
            this.code = code;
            this.msg = msg;
        }

        public String getCode()
        {
            return code;
        }

        public String getMsg()
        {
            return msg;
        }
    }


    /**
     * 大模型返回结果类型枚举
     */
    public enum CarbonExtraTeypEnum
    {
        ZERO(0, "外加碳源矿化产生的化石源CO₂碳排放量"),
        ONE(1, "固定式能源燃料消耗产生的碳排放量"),
        TWO(2, "污水处理阶段药剂消耗产生的碳排放量"),
        THREE(3, "热泵技术-替碳量"),
        FOUR(4, "污泥厌氧消化沼气利用的替碳量"),
        FIVE(5, "污泥焚烧或热解热能利用的替碳量"),
        ;

        private final int code;
        private final String msg;

        CarbonExtraTeypEnum(int code, String msg)
        {
            this.code = code;
            this.msg = msg;
        }

        public int getCode()
        {
            return code;
        }

        public String getMsg()
        {
            return msg;
        }
    }



    /**
     *
     * 进出水类型枚举
     *
     */
    public enum WaterTypeEnum
    {
        JS(0, "进水"),
        CS(1, "出水"),
        ;

        private final Integer code;
        private final String msg;

        WaterTypeEnum(Integer code, String msg)
        {
            this.code = code;
            this.msg = msg;
        }

        public Integer getCode()
        {
            return code;
        }

        public String getMsg()
        {
            return msg;
        }
    }




    /**
     *
     * 报警类型枚举
     * 2025年02月28日15:49:56  虽然工业库和化验库都是叫 仪表故障（多指标断点）  但是需要不同类型做区分，方便查询
     *
     */
    public enum WarningSymbolEnum
    {
//        CBZZ(0, "超标准值"),
//        CGKZ(1, "超管控值"),
//        YBGZ_DD_SINGLE(2, "仪表故障（单指标断点）"),
//        YBGZ_DD_MORE_GYK(3, "仪表故障（多指标断点）"),
//        YBGZ_DD_MORE_HYS(4, "仪表故障（多指标断点）"),
//        YBGZ_LX_SINGLE(5, "仪表故障（单指标连续不变）"),
//        YBGZ_LX_MORE(6, "仪表故障（多指标连续不变）"),
//        SJYC_YCSG(7, "数据异常（单点突变 - 异常升高）"),
//        SJYC_YCPD(8, "数据异常（单点突变 - 异常偏低）"),
////        SJYC_DDYC(9, "数据异常（单点异常 - 超过标准值）"),  //此种类型 代维导致异常的，现在无规律，无法处理
//        INDUSTRY_SYNC_ERROR(10, "在线仪表数据同步失败"),
//        ROBOT_SYNC_ERROR(11, "连续检测数据同步失败"),
//        ;

        CBZZ(0, "超标准值"),
        CGKZ(1, "超管控值"),
//        YBGZ_DD_SINGLE(2, "仪表故障 - 断点"),
        YBGZ_DD_SINGLE(2, "设备故障"),
        YBGZ_DD_MORE_GYK(3, "仪表故障 - 断点"),
//        YBGZ_DD_MORE_HYS(4, "仪表故障 - 断点"),
        YBGZ_DD_MORE_HYS(4, "设备故障"),
        YBGZ_LX_SINGLE(5, "仪表故障 - 连续不变"),
        YBGZ_LX_MORE(6, "仪表故障 - 连续不变"),
        SJYC_YCSG(7, "数据异常"),
        SJYC_YCPD(8, "数据异常"),
        //        SJYC_DDYC(9, "数据异常（单点异常 - 超过标准值）"),  //此种类型 代维导致异常的，现在无规律，无法处理
        INDUSTRY_SYNC_ERROR(10, "在线仪表数据同步失败"),
        ROBOT_SYNC_ERROR(11, "连续检测数据同步失败"),
        SJYC_GDZ(12, "数据异常"),
        DEVICE_ERR_CS_COD(13, "设备故障"),
        ;

        private final Integer code;
        private final String msg;

        WarningSymbolEnum(Integer code, String msg)
        {
            this.code = code;
            this.msg = msg;
        }

        public Integer getCode()
        {
            return code;
        }

        public String getMsg()
        {
            return msg;
        }

        public static String getMsgByCode(int code) {
            for (WarningSymbolEnum status : WarningSymbolEnum.values()) {
                if (status.getCode() == code) {
                    return status.getMsg();
                }
            }
            return "Unknown code";
        }
    }


    /**
     *
     * 机理模型预测类型枚举
     *
     */
    public enum JLModelPredictEnum
    {
        COD(0, "出水COD"),
        NH3(1, "出水氨氮"),
        TN(2, "出水总氮"),
        TP(3, "出水正磷盐"),
        AD(4, "缺氧氨氮"),
        XSY(5, "缺氧硝酸盐"),
        HY_XSY_1(6, "好氧池硝酸盐#1"),
        HY_XSY_2(7, "好氧池硝酸盐#2"),
        QY_NH3_1(8, "缺氧氨氮#1"),
        QY_NH3_2(9, "缺氧氨氮#2"),
        ;

        private final Integer code;
        private final String msg;

        JLModelPredictEnum(Integer code, String msg)
        {
            this.code = code;
            this.msg = msg;
        }

        public Integer getCode()
        {
            return code;
        }

        public String getMsg()
        {
            return msg;
        }
    }
}
