package com.slibra.common.utils.format;

import com.alibaba.fastjson2.JSON;
import com.slibra.common.DecimalUtils;
import com.slibra.common.constant.MyConstants;
import com.slibra.common.core.domain.DecisionReq;
import com.slibra.common.core.domain.TXinyiDaily;
import com.slibra.common.utils.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.CollectionUtils;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.List;
import java.util.Objects;

import static com.slibra.common.constant.MyConstants.*;

public class WaterFormat {

    public static DecisionReq getWaterDecimationData(DecisionReq decisionReq, TXinyiDaily daily ) {
        // 格式化小数
        // 溶解氧1位 碳源投加量 2位 其他都是整数
        //2024年08月26日19:58:28 所有报警相关的真实值改成两位小数
        //2024年08月27日09:21:26 对应的管控值和标准值也改成保留两位小数
        decisionReq.setCodIn(DecimalUtils.getAbsAndScale(decisionReq.getCodIn(), INT_2));
        decisionReq.setCodInName(DecimalUtils.getAbsAndScale(decisionReq.getCodInName(), INT_2));
        decisionReq.setCodOff(DecimalUtils.getAbsAndScale(decisionReq.getCodOff(), INT_2));
        decisionReq.setCodOffName(DecimalUtils.getAbsAndScale(decisionReq.getCodOffName(), INT_2));
        decisionReq.setCodOffCon(DecimalUtils.getAbsAndScale(decisionReq.getCodOffCon(), INT_2));
        decisionReq.setTpIn(DecimalUtils.getAbsAndScale(decisionReq.getTpIn(), INT_2));
        decisionReq.setTpInName(DecimalUtils.getAbsAndScale(decisionReq.getTpInName(), INT_2));
        decisionReq.setTpOff(DecimalUtils.getAbsAndScale(decisionReq.getTpOff(), INT_2));
        decisionReq.setTpOffName(DecimalUtils.getAbsAndScale(decisionReq.getTpOffName(), INT_2));
        decisionReq.setTpOffCon(DecimalUtils.getAbsAndScale(decisionReq.getTpOffCon(), INT_2));
        decisionReq.setTnIn(DecimalUtils.getAbsAndScale(decisionReq.getTnIn(), INT_2));
        decisionReq.setTnInName(DecimalUtils.getAbsAndScale(decisionReq.getTnInName(), INT_2));
        decisionReq.setTnOff(DecimalUtils.getAbsAndScale(decisionReq.getTnOff(), INT_2));
        decisionReq.setTnOffName(DecimalUtils.getAbsAndScale(decisionReq.getTnOffName(), INT_2));
        decisionReq.setTnOffCon(DecimalUtils.getAbsAndScale(decisionReq.getTnOffCon(), INT_2));
        decisionReq.setAddanIn(DecimalUtils.getAbsAndScale(decisionReq.getAddanIn(), INT_2));
        decisionReq.setAddanInName(DecimalUtils.getAbsAndScale(decisionReq.getAddanInName(), INT_2));
        decisionReq.setAndanOff(DecimalUtils.getAbsAndScale(decisionReq.getAndanOff(), INT_2));
        decisionReq.setAndanOffName(DecimalUtils.getAbsAndScale(decisionReq.getAndanOffName(), INT_2));
        decisionReq.setAndanOffCon(DecimalUtils.getAbsAndScale(decisionReq.getAndanOffCon(), INT_2));
        decisionReq.setSsIn(DecimalUtils.getAbsAndScale(decisionReq.getSsIn(), INT_2));
        decisionReq.setSsInName(DecimalUtils.getAbsAndScale(decisionReq.getSsInName(), INT_2));
        decisionReq.setSsOff(DecimalUtils.getAbsAndScale(decisionReq.getSsOff(), INT_2));
        decisionReq.setSsOffName(DecimalUtils.getAbsAndScale(decisionReq.getSsOffName(), INT_2));
        decisionReq.setSsOffCon(DecimalUtils.getAbsAndScale(decisionReq.getSsOffCon(), INT_2));
        decisionReq.setTdsIn(DecimalUtils.getAbsAndScale(decisionReq.getTdsIn(), INT_0));
        decisionReq.setTdsInName(DecimalUtils.getAbsAndScale(decisionReq.getTdsInName(), INT_0));
        decisionReq.setT(DecimalUtils.getAbsAndScale(daily.getJsSw(), MyConstants.INT_0));
        decisionReq.setPH(DecimalUtils.getAbsAndScale(decisionReq.getPH(), INT_0));
        decisionReq.setQIn(DecimalUtils.getAbsAndScale(decisionReq.getQIn(), INT_0));
        decisionReq.setQInName(DecimalUtils.getAbsAndScale(decisionReq.getQInName(), INT_0));
        decisionReq.setCheckRise(DecimalUtils.getAbsAndScaleStr(decisionReq.getCheckRise(), INT_0));
        decisionReq.setSVI(DecimalUtils.getAbsForArray(daily.getWntjzsAll(), INT_0));
        decisionReq.setSviCon(DecimalUtils.getAbsAndScale(decisionReq.getSviCon(), INT_0));
        decisionReq.setSV(DecimalUtils.getAbsForArray(daily.getWncjbAll(), INT_0));
        decisionReq.setSvCon(DecimalUtils.getAbsAndScale(decisionReq.getSviCon(), INT_0));
        decisionReq.setMlvss(DecimalUtils.getAbsForArray(daily.getHfxwnndAll(), INT_0));
        decisionReq.setMlss(DecimalUtils.getAbsForArray(daily.getHycWnndAll(), INT_0));
        decisionReq.setMlvssWentai(DecimalUtils.getAbsAndScaleStr(decisionReq.getMlvssWentai(), INT_0));
        decisionReq.setMlssWentai(DecimalUtils.getAbsAndScaleStr(decisionReq.getMlssWentai(), INT_0));
        decisionReq.setDoAna(DecimalUtils.getAbsForArray(daily.getYycRjyAll(), INT_1));
        decisionReq.setDoO(DecimalUtils.getAbsForArray(daily.getHycRjyAll(), INT_1));
        decisionReq.setDoQue(DecimalUtils.getAbsForArray(daily.getQycRjyAll(), INT_1));
        // decisionReq.setDoQueWentai(DecimalUtils.getAbsAndScaleStr(decisionReq.getDoQueWentai(), INT_0));
        // decisionReq.setDoAnaWentai(DecimalUtils.getAbsAndScaleStr(decisionReq.getDoAnaWentai(), INT_0));
        // decisionReq.setDoOWentai(DecimalUtils.getAbsAndScaleStr(decisionReq.getDoAnaWentai(), INT_0));
        decisionReq.setC(DecimalUtils.getAbsAndScale(decisionReq.getC(), INT_0));
        decisionReq.setB(DecimalUtils.getAbsAndScale(decisionReq.getB(), INT_0));
        decisionReq.setBtpWending(DecimalUtils.getAbsAndScaleStr(decisionReq.getBtpWending(), INT_0));
        decisionReq.setJsTnWentai(DecimalUtils.getAbsAndScaleStr(decisionReq.getJsTnWentai(), INT_0));
        decisionReq.setClP04YCZ(DecimalUtils.getAbsAndScale(decisionReq.getClP04YCZ(), INT_0));
        decisionReq.setTpLv(DecimalUtils.getAbsAndScale(decisionReq.getTpLv(), INT_0));
        decisionReq.setTpLvContinuity(DecimalUtils.getAbsAndScale(decisionReq.getTpLvContinuity(), INT_0));
        // 碳源投加量 2位
        //2024年08月27日20:10:49 化验室多个池子的也改成保留两位
        decisionReq.setTyjyl(DecimalUtils.getAbsAndScaleStr(decisionReq.getTyjyl(), INT_2));
        decisionReq.setCltjl(DecimalUtils.getAbsAndScaleStr(decisionReq.getCltjl(), INT_0));
        decisionReq.setHycxsyAll(DecimalUtils.getAbsForArray(decisionReq.getHycxsyAll(), INT_2));
        decisionReq.setQyanAll(DecimalUtils.getAbsForArray(decisionReq.getQyanAll(), INT_2));
        decisionReq.setQyckxsyAll(DecimalUtils.getAbsForArray(decisionReq.getQyckxsyAll(), INT_2));
        decisionReq.setGwnl(DecimalUtils.getAbsAndScale(daily.getGWNL(), INT_0));
        decisionReq.setEccZl(DecimalUtils.getAbsAndScaleStr(decisionReq.getEccZl(), INT_2));//这里要保留2为小数，否则数据太小，全都是0  示例：0.411195  0.372263
        decisionReq.setHyzlsyAll(DecimalUtils.getAbsForArray(decisionReq.getHyzlsyAll(), INT_2));
        decisionReq.setR(DecimalUtils.getAbsAndScale(daily.getNhlR(), INT_0));
        decisionReq.setRR(DecimalUtils.getAbsAndScale(daily.getWhlR(), INT_0));
        BigDecimal jsBod5 = daily.getJsBod5();
        BigDecimal tpIn = decisionReq.getTpIn();
        BigDecimal tnIn = decisionReq.getTnIn();
        decisionReq.setBodIn(DecimalUtils.getAbsAndScale(daily.getJsBod5(), INT_0));
        if(!Objects.isNull(jsBod5)){
            if(!Objects.isNull(tpIn) && tpIn.compareTo(new BigDecimal("0")) >0){
                decisionReq.setC(jsBod5.divide(tpIn, INT_0, RoundingMode.HALF_UP));
            }
            if(!Objects.isNull(tnIn) && tnIn.compareTo(new BigDecimal("0")) >0){
                decisionReq.setB(jsBod5.divide(tnIn, INT_0, RoundingMode.HALF_UP));
            }
        }
        // decisionReq.setT(DecimalUtils.getAbsAndScale(daily.getJsSw(), MyConstants.INT_0));
        // decisionReq.setSVI(daily.getWntjzsAll());
        // decisionReq.setSV(daily.getWncjbAll());
        // decisionReq.setMlvss(daily.getHfxwnndAll());
        //2024年7月2日17:20:12  mlss和DO_O也要从日报获取
        // decisionReq.setMlss(daily.getHycWnndAll());
        // decisionReq.setDoO(daily.getHycRjyAll());
        // decisionReq.setDoAna(daily.getYycRjyAll());
        // decisionReq.setDoQue(daily.getQycRjyAll());
        //2024年5月26日11:59:02 干污泥量数据做了同步
        // decisionReq.setGwnl(daily.getGWNL());
        // BigDecimal jsBod5 = daily.getJsBod5();
        // decisionReq.setBodIn(jsBod5);
        // BigDecimal tpIn = decisionReq.getTpIn();
        // BigDecimal tnIn = decisionReq.getTnIn();
        // if(!Objects.isNull(jsBod5)){
        //     if(!Objects.isNull(tpIn) && tpIn.compareTo(new BigDecimal("0")) >0){
        //         decisionReq.setC(jsBod5.divide(tpIn, 4, RoundingMode.HALF_UP));
        //     }
        //     if(!Objects.isNull(tnIn) && tnIn.compareTo(new BigDecimal("0")) >0){
        //         decisionReq.setB(jsBod5.divide(tnIn, 4, RoundingMode.HALF_UP));
        //     }
        // }
        //2024年6月1日08:37:09 内回流加上
        // decisionReq.setR(daily.getNhlR());
        // decisionReq.setRR(daily.getWhlR());
        //2024年08月19日18:18:57 新增参数
        decisionReq.setCodInDaily(DecimalUtils.getAbsAndScale(daily.getJsCod(), INT_0));
        decisionReq.setTpInDaily(DecimalUtils.getAbsAndScale(daily.getJsTp(), INT_0));
        decisionReq.setTnInDaily(DecimalUtils.getAbsAndScale(daily.getJsTn(), INT_0));
        decisionReq.setAnDanInDaily(DecimalUtils.getAbsAndScale(daily.getJsNh3(), INT_0));
        decisionReq.setSsInDaily(DecimalUtils.getAbsAndScale(daily.getJsSs(), INT_0));

        decisionReq.setCodOffDaily(DecimalUtils.getAbsAndScale(daily.getCsCod(), INT_0));
        decisionReq.setTpOffDaily(DecimalUtils.getAbsAndScale(daily.getCsTp(), INT_0));
        decisionReq.setTnOffDaily(DecimalUtils.getAbsAndScale(daily.getCsTn(), INT_0));
        decisionReq.setAnDanOffDaily(DecimalUtils.getAbsAndScale(daily.getCsNh3(), INT_0));
        decisionReq.setSsOffDaily(DecimalUtils.getAbsAndScale(daily.getCsSs(), INT_0));

        //2024年08月20日13:22:38 新增参数
        //好氧硝酸盐
        String hycxsyAll = decisionReq.getHycxsyAll();
        if(StringUtils.isNotBlank(hycxsyAll)){//好氧
            List<BigDecimal> hyStrings = JSON.parseArray(hycxsyAll, BigDecimal.class);
            BigDecimal no3Hlj1Jqr = hyStrings.get(0);
            decisionReq.setTnOffLxjc1(DecimalUtils.getAbsAndScale(no3Hlj1Jqr, INT_2));
            BigDecimal no3Hlj2Jqr = hyStrings.get(1);
            decisionReq.setTnOffLxjc2(DecimalUtils.getAbsAndScale(no3Hlj2Jqr, INT_2));
            //处理氨氮 需要计算
            //缺氧硝酸盐
            String qyckxsyAll = decisionReq.getQyckxsyAll();
            if(StringUtils.isNotBlank(qyckxsyAll)){
                List<BigDecimal> qyStrings = JSON.parseArray(qyckxsyAll, BigDecimal.class);
                BigDecimal no3Qyc1Jqr = qyStrings.get(0);
                BigDecimal no3Qyc2Jqr = qyStrings.get(1);
                //缺氧氨氮
                String qyanAll = decisionReq.getQyanAll();
                if(StringUtils.isNotBlank(qyanAll)){
                    List<BigDecimal> qyStrings2 = JSON.parseArray(qyanAll, BigDecimal.class);
                    BigDecimal nh31Jqr = qyStrings2.get(0);
                    BigDecimal nh32Jqr = qyStrings2.get(1);
                    BigDecimal anDan1 = no3Qyc1Jqr.add(nh31Jqr).subtract(no3Hlj1Jqr);
                    BigDecimal anDan2 = no3Qyc2Jqr.add(nh32Jqr).subtract(no3Hlj2Jqr);
                    decisionReq.setAnDanOffLxjc(DecimalUtils.getAbsAndScale(anDan1.add(anDan2).divide(DECIMAL_2, INT_2, RoundingMode.HALF_UP), INT_2));
                }
            }
        }
        String eccZl = decisionReq.getEccZl();
        if(StringUtils.isNotBlank(eccZl)){
            decisionReq.setTpOffLxjc(DecimalUtils.getAbsAndScale(new BigDecimal(eccZl), INT_2));
        }
        return decisionReq;

    }

    public static void main(String[] args) {
        List<BigDecimal> strings = JSON.parseArray("[11.898019,12.96599]", BigDecimal.class);
        System.out.println(strings.get(0));
        System.out.println(strings.get(1));
        System.out.println(DecimalUtils.getAbsAndScaleStr("12.819", INT_2));
    }

}
