package com.slibra.quartz.business;


import com.alibaba.fastjson2.JSONArray;
import com.alibaba.fastjson2.JSONObject;
import com.slibra.business.domain.TXinyiBigTableHour;
import com.slibra.business.domain.TXinyiIndustry;
import com.slibra.business.domain.TXinyiNormConfig;
import com.slibra.business.domain.TXinyiRobot;
import com.slibra.business.mapper.TXinyiRobotMapper;
import com.slibra.common.DecimalUtils;
import com.slibra.common.constant.MyConstants;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.CollectionUtils;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.List;
import java.util.Objects;
import java.util.stream.Collectors;

import static com.slibra.common.constant.MyConstants.INT_2;

@Component
public class JsCsFormatData {

    @Autowired
    private TXinyiRobotMapper xinyiRobotMapper;

    public JSONObject getJsonObject(TXinyiIndustry tXinyiIndustry, TXinyiNormConfig normConfig) {
        JSONObject jsData = new JSONObject();
        HashMap<Object, Object> temp1 = new HashMap<>();
        BigDecimal jsSlq = tXinyiIndustry.getJsSlq();
        temp1.put("value", DecimalUtils.getAbsAndScale(jsSlq, INT_2));
        temp1.put("exceed", !Objects.isNull(jsSlq) && jsSlq.compareTo(normConfig.getJsslSjz()) >0);
        jsData.put("流量", temp1);
        HashMap<Object, Object> temp2 = new HashMap<>();
        BigDecimal jsCod = tXinyiIndustry.getJsCod();
        temp2.put("value", DecimalUtils.getAbsAndScale(jsCod, INT_2));
        temp2.put("exceed", !Objects.isNull(jsCod) && jsCod.compareTo(normConfig.getJscodSjz()) > 0);
        jsData.put("COD", temp2);
        HashMap<Object, Object> temp3 = new HashMap<>();
        BigDecimal jsNh3 = tXinyiIndustry.getJsNh3();
        temp3.put("value", DecimalUtils.getAbsAndScale(jsNh3, INT_2));
        temp3.put("exceed", !Objects.isNull(jsNh3) && jsNh3.compareTo(normConfig.getJsadSjz()) > 0);
        jsData.put("NH3-N", temp3);
        HashMap<Object, Object> temp4 = new HashMap<>();
        BigDecimal jsTp = tXinyiIndustry.getJsTp();
        temp4.put("value", DecimalUtils.getAbsAndScale(jsTp, INT_2));
        temp4.put("exceed", !Objects.isNull(jsTp) && jsTp.compareTo(normConfig.getJszlSjz()) > 0);
        jsData.put("TP", temp4);
        HashMap<Object, Object> temp5 = new HashMap<>();
        BigDecimal jsSs = tXinyiIndustry.getJsSs();
        temp5.put("value", DecimalUtils.getAbsAndScale(jsSs, INT_2));
        temp5.put("exceed", !Objects.isNull(jsSs) && jsSs.compareTo(normConfig.getJsssSjz()) > 0);
        jsData.put("SS", temp5);
        HashMap<Object, Object> temp6 = new HashMap<>();
        BigDecimal jsTn = tXinyiIndustry.getJsTn();
        temp6.put("value", DecimalUtils.getAbsAndScale(jsTn, INT_2));
        temp6.put("exceed", !Objects.isNull(jsTn) && jsTn.compareTo(normConfig.getJszdSjz()) > 0);
        jsData.put("TN", temp6);
        return jsData;
    }

    public JSONObject getCsonObject(TXinyiIndustry tXinyiIndustry, TXinyiNormConfig normConfig) {

        JSONObject csData = new JSONObject();

        // 出水cod - 连续检测
        HashMap<Object, Object> temp1 = new HashMap<>();
        BigDecimal csCod = tXinyiIndustry.getCsCod();
        temp1.put("value", DecimalUtils.getAbsAndScale(csCod, INT_2));
        temp1.put("exceed", !Objects.isNull(csCod) && csCod.compareTo(normConfig.getCscodGkz()) > 0);
        csData.put("COD", temp1);

        // 好氧池硝酸盐 | 二沉池正磷酸盐 | 连续监测 - 化验室
        List<TXinyiRobot> tXinyiRobots = this.xinyiRobotMapper.selectNRobot(1);
        if ( !CollectionUtils.isEmpty(tXinyiRobots) ) {
            BigDecimal csTp = tXinyiIndustry.getCsTp();

            TXinyiRobot tXinyiRobot = tXinyiRobots.get(0);
            //2024年7月30日14:10:23 取值问题调整
            /*BigDecimal hl1Jqr = tXinyiRobot.getTpHl1Jqr();
            BigDecimal hl2Jqr = tXinyiRobot.getTpHl2Jqr();*/
            BigDecimal hl1Jqr = tXinyiRobot.getNo3Hlj1Jqr();
            BigDecimal hl2Jqr = tXinyiRobot.getNo3Hlj2Jqr();
            BigDecimal tpRccJqr = tXinyiRobot.getTpRccJqr();

            HashMap<Object, Object> temp2 = new HashMap<>();
            HashMap<Object, Object> temp3 = new HashMap<>();
            HashMap<Object, Object> temp4 = new HashMap<>();

            temp2.put("value", DecimalUtils.getAbsAndScale(hl1Jqr, INT_2));
            temp2.put("exceed", !Objects.isNull(hl1Jqr) && hl1Jqr.compareTo(normConfig.getCszzGkz()) > 0);

            temp3.put("value", DecimalUtils.getAbsAndScale(hl2Jqr, INT_2));
            temp3.put("exceed", !Objects.isNull(hl2Jqr) && hl2Jqr.compareTo(normConfig.getCszzGkz()) > 0);

            temp4.put("value", DecimalUtils.getAbsAndScale(tpRccJqr, INT_2));
            temp4.put("exceed", !Objects.isNull(tpRccJqr) && tpRccJqr.compareTo(normConfig.getCszlGkz()) > 0);

            csData.put("HYC1", temp2);
            csData.put("HYC2", temp3);
            csData.put("RCC", temp4);
        }

        // 出水SS | 在线仪表 - 工业
        HashMap<Object, Object> temp5 = new HashMap<>();
        BigDecimal csSs = tXinyiIndustry.getCsSs();
        temp5.put("value", DecimalUtils.getAbsAndScale(csSs, INT_2));
        temp5.put("exceed", !Objects.isNull(csSs) && csSs.compareTo(normConfig.getCsssGkz()) > 0);
        csData.put("SS", temp5);

        // 出水氨氮 | 在线仪表 - 工业
        HashMap<Object, Object> temp6 = new HashMap<>();
        BigDecimal csNh3 = tXinyiIndustry.getCsNh3();
        temp6.put("value", DecimalUtils.getAbsAndScale(csNh3, INT_2));
        temp6.put("exceed", !Objects.isNull(csNh3) && csNh3.compareTo(normConfig.getCsadGkz()) > 0);
        csData.put("NH3-N", temp6);

        //2024年08月08日09:50:53 出水增加出水水量展示
        HashMap<Object, Object> temp0 = new HashMap<>();
        BigDecimal csSlq = tXinyiIndustry.getCsSlqc();
        temp0.put("value", DecimalUtils.getAbsAndScale(csSlq, INT_2));
        temp0.put("exceed", false);//出水水量没有管控值
        csData.put("流量", temp0);

        return csData;
    }


    public void addRobot2Hour(TXinyiBigTableHour tXinyiBigTableHour, TXinyiRobot tXinyiRobot) {
        tXinyiBigTableHour.setHyCodYb(tXinyiRobot.getCodYb());
        tXinyiBigTableHour.setHyCodJqr(tXinyiRobot.getCodJqr());
        tXinyiBigTableHour.setHyCodYz(tXinyiRobot.getCodYz());
        tXinyiBigTableHour.setHyTpHl1Jqr(tXinyiRobot.getTpHl1Jqr());
        tXinyiBigTableHour.setHyTpHl2Jqr(tXinyiRobot.getTpHl2Jqr());
        tXinyiBigTableHour.setHyTpRccJqr(tXinyiRobot.getTpRccJqr());
        tXinyiBigTableHour.setHyTp1Yz(tXinyiRobot.getTp1Yz());
        tXinyiBigTableHour.setHyTp2Yz(tXinyiRobot.getTp2Yz());
        tXinyiBigTableHour.setHyTpRccYz(tXinyiRobot.getTpRccYz());
        tXinyiBigTableHour.setHyNh31Jqr(tXinyiRobot.getNh31Jqr());
        tXinyiBigTableHour.setHyNh32Jqr(tXinyiRobot.getNh32Jqr());
        tXinyiBigTableHour.setHyNh31Yz(tXinyiRobot.getNh31Yz());
        tXinyiBigTableHour.setHyNo3Hlc1Yz(tXinyiRobot.getNo3Hlc1Yz());
        tXinyiBigTableHour.setHyNh32Yz(tXinyiRobot.getNh32Yz());
        tXinyiBigTableHour.setHyNo3Hlc2Yz(tXinyiRobot.getNo3Hlc2Yz());
        tXinyiBigTableHour.setHyNo3Hlj1Jqr(tXinyiRobot.getNo3Hlj1Jqr());
        tXinyiBigTableHour.setHyNo3Hlj2Jqr(tXinyiRobot.getNo3Hlj2Jqr());
        tXinyiBigTableHour.setHyTyll(tXinyiRobot.getTYLL());
        tXinyiBigTableHour.setHyNo3Qyc1Jqr(tXinyiRobot.getNo3Qyc1Jqr());
        tXinyiBigTableHour.setHyNo3Qyc2Jqr(tXinyiRobot.getNo3Qyc2Jqr());
        tXinyiBigTableHour.setHyNo3Qyc1Yz(tXinyiRobot.getNo3Qyc1Yz());
        tXinyiBigTableHour.setHyNo3Qyc2Yz(tXinyiRobot.getNo3Qyc2Yz());
        tXinyiBigTableHour.setHyJsll(tXinyiRobot.getJSLL());
        tXinyiBigTableHour.setHyHycxsyAll(tXinyiRobot.getHycxsyAll());
        tXinyiBigTableHour.setHyQyanAll(tXinyiRobot.getQyanAll());
        tXinyiBigTableHour.setHyQyckxsyAll(tXinyiRobot.getQyckxsyAll());
        tXinyiBigTableHour.setHyHyzlsyAll(tXinyiRobot.getHyzlsyAll());
    }

}
