package com.slibra.business.domain;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.slibra.common.annotation.Excel;
import com.slibra.common.core.domain.BaseEntity;

import java.math.BigDecimal;

/**
 * 【请填写功能名称】对象 auto_feedback
 * 
 * @author slibra
 * @date 2025-04-22
 */

@Builder
@Data
@NoArgsConstructor
@AllArgsConstructor
public class AutoFeedback
{
    private static final long serialVersionUID = 1L;

    /** $column.columnComment */
    private Long id;

    /** 当前请求时间 */
    @Excel(name = "当前请求时间")
    private String reqTime;

    /** 来源#1，#2 */
    @Excel(name = "来源#1，#2")
    private Long source;

    /** 反馈控制状态 */
    @Excel(name = "反馈控制状态")
    private String feedbackType;

    /** 硝酸盐后反馈设置目标 */
    @Excel(name = "硝酸盐后反馈设置目标")
    private BigDecimal basePara;

    /** 反馈默认基础控制系数 */
    @Excel(name = "反馈默认基础控制系数")
    private BigDecimal controlCoef;

    /** 当前所属大区间 */
    @Excel(name = "当前所属大区间")
    private Long cate;

    /** 当前所属小区间 */
    @Excel(name = "当前所属小区间")
    private Long subcate;

    /** 当前反馈系数 */
    @Excel(name = "当前反馈系数")
    private BigDecimal coef;

    /** 基础调参配置信息 */
    @Excel(name = "基础调参配置信息")
    private String cf;

    /** 记录变化过程信息 */
    @Excel(name = "记录变化过程信息")
    private String ext;

    /** 当前请求时间 */
    @Excel(name = "当前请求时间")
    private String updateTime;

    //2025年05月09日16:40:08 新增请求参数
    //开始日期
    private String dateBegin;

    //截止日期
    private String dateEnd;
}
