package com.slibra.business.domain;

import java.math.BigDecimal;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.slibra.common.annotation.Excel;
import com.slibra.common.core.domain.BaseEntity;

/**
 * 机理预测配置对象 t_jl_predict
 * 
 * @author slibra
 * @date 2025-04-22
 */
public class TJlPredict extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键 */
    private Long id;

    /** 化验时间 精确到小时 */
    @Excel(name = "化验时间 精确到小时")
    private String testHour;

    /** #1好氧池硝酸盐 */
    @Excel(name = "#1好氧池硝酸盐")
    private BigDecimal no3Hlj1Jqr;

    /** #2好氧池硝酸盐 */
    @Excel(name = "#2好氧池硝酸盐")
    private BigDecimal no3Hlj2Jqr;

    /** #1缺氧硝酸盐 */
    @Excel(name = "#1缺氧硝酸盐")
    private BigDecimal no3Qyc1Jqr;

    /** #2缺氧硝酸盐 */
    @Excel(name = "#2缺氧硝酸盐")
    private BigDecimal no3Qyc2Jqr;

    /** 二沉池正磷酸盐 */
    @Excel(name = "二沉池正磷酸盐")
    private BigDecimal tpRccJqr;

    /** #1好氧池正磷酸盐 */
    @Excel(name = "#1好氧池正磷酸盐")
    private BigDecimal tpHl1Jqr;

    /** #2好氧池正磷酸盐 */
    @Excel(name = "#2好氧池正磷酸盐")
    private BigDecimal tpHl2Jqr;

    /** #1缺氧氨氮 */
    @Excel(name = "#1缺氧氨氮")
    private BigDecimal nh31Jqr;

    /** #2缺氧氨氮 */
    @Excel(name = "#2缺氧氨氮")
    private BigDecimal nh32Jqr;

    /** 删除标志（0代表存在 2代表删除） */
    private Long delFlag;

    /** 乐观锁 */
    @Excel(name = "乐观锁")
    private Long revision;

    public void setId(Long id) 
    {
        this.id = id;
    }

    public Long getId() 
    {
        return id;
    }
    public void setTestHour(String testHour) 
    {
        this.testHour = testHour;
    }

    public String getTestHour() 
    {
        return testHour;
    }
    public void setNo3Hlj1Jqr(BigDecimal no3Hlj1Jqr) 
    {
        this.no3Hlj1Jqr = no3Hlj1Jqr;
    }

    public BigDecimal getNo3Hlj1Jqr() 
    {
        return no3Hlj1Jqr;
    }
    public void setNo3Hlj2Jqr(BigDecimal no3Hlj2Jqr) 
    {
        this.no3Hlj2Jqr = no3Hlj2Jqr;
    }

    public BigDecimal getNo3Hlj2Jqr() 
    {
        return no3Hlj2Jqr;
    }
    public void setNo3Qyc1Jqr(BigDecimal no3Qyc1Jqr) 
    {
        this.no3Qyc1Jqr = no3Qyc1Jqr;
    }

    public BigDecimal getNo3Qyc1Jqr() 
    {
        return no3Qyc1Jqr;
    }
    public void setNo3Qyc2Jqr(BigDecimal no3Qyc2Jqr) 
    {
        this.no3Qyc2Jqr = no3Qyc2Jqr;
    }

    public BigDecimal getNo3Qyc2Jqr() 
    {
        return no3Qyc2Jqr;
    }
    public void setTpRccJqr(BigDecimal tpRccJqr) 
    {
        this.tpRccJqr = tpRccJqr;
    }

    public BigDecimal getTpRccJqr() 
    {
        return tpRccJqr;
    }
    public void setTpHl1Jqr(BigDecimal tpHl1Jqr) 
    {
        this.tpHl1Jqr = tpHl1Jqr;
    }

    public BigDecimal getTpHl1Jqr() 
    {
        return tpHl1Jqr;
    }
    public void setTpHl2Jqr(BigDecimal tpHl2Jqr) 
    {
        this.tpHl2Jqr = tpHl2Jqr;
    }

    public BigDecimal getTpHl2Jqr() 
    {
        return tpHl2Jqr;
    }
    public void setNh31Jqr(BigDecimal nh31Jqr) 
    {
        this.nh31Jqr = nh31Jqr;
    }

    public BigDecimal getNh31Jqr() 
    {
        return nh31Jqr;
    }
    public void setNh32Jqr(BigDecimal nh32Jqr) 
    {
        this.nh32Jqr = nh32Jqr;
    }

    public BigDecimal getNh32Jqr() 
    {
        return nh32Jqr;
    }
    public void setDelFlag(Long delFlag) 
    {
        this.delFlag = delFlag;
    }

    public Long getDelFlag() 
    {
        return delFlag;
    }
    public void setRevision(Long revision) 
    {
        this.revision = revision;
    }

    public Long getRevision() 
    {
        return revision;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this,ToStringStyle.MULTI_LINE_STYLE)
            .append("id", getId())
            .append("testHour", getTestHour())
            .append("no3Hlj1Jqr", getNo3Hlj1Jqr())
            .append("no3Hlj2Jqr", getNo3Hlj2Jqr())
            .append("no3Qyc1Jqr", getNo3Qyc1Jqr())
            .append("no3Qyc2Jqr", getNo3Qyc2Jqr())
            .append("tpRccJqr", getTpRccJqr())
            .append("tpHl1Jqr", getTpHl1Jqr())
            .append("tpHl2Jqr", getTpHl2Jqr())
            .append("nh31Jqr", getNh31Jqr())
            .append("nh32Jqr", getNh32Jqr())
            .append("delFlag", getDelFlag())
            .append("revision", getRevision())
            .append("createBy", getCreateBy())
            .append("createTime", getCreateTime())
            .append("updateBy", getUpdateBy())
            .append("updateTime", getUpdateTime())
            .append("remark", getRemark())
            .toString();
    }
}
