package com.slibra.business.domain;

import java.math.BigDecimal;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.slibra.common.annotation.Excel;
import com.slibra.common.core.domain.BaseEntity;

/**
 * 机理模型预测配置对象 t_predict_conf
 * 
 * @author slibra
 * @date 2025-02-11
 */
public class TPredictConf extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键 */
    private Long id;

    /** 预测类型（0出水COD 1出水氨氮 2出水总氮 3出水正磷盐 4缺氧氨氮 5缺氧硝酸盐 6好氧池硝酸盐#1 7好氧池硝酸盐#2） */
    @Excel(name = "预测类型", readConverterExp = "0出水COD 1出水氨氮 2出水总氮 3出水正磷盐 4缺氧氨氮 5缺氧硝酸盐 6好氧池硝酸盐#1 7好氧池硝酸盐#2")
    private Integer type;

    /** Y1 可选择时间起始小时-最小值 */
    @Excel(name = "Y1 可选择时间起始小时-最小值")
    private Integer y1Min;

    /** Y1 可选择时间起始小时-最大值 */
    @Excel(name = "Y1 可选择时间起始小时-最大值")
    private Integer y1Max;

    /** X 可选择时间起始小时时间-最小值 */
    @Excel(name = "X 可选择时间起始小时时间-最小值")
    private Integer xMin;

    /** X 可选择时间起始小时时间-最大值 */
    @Excel(name = "X 可选择时间起始小时时间-最大值")
    private Integer xMax;

    /** 进水COD限定值或者其他业务变量限定值 */
    @Excel(name = "进水COD限定值或者其他业务变量限定值")
    private BigDecimal x1;

    /** 变动系统 */
    @Excel(name = "变动系统")
    private BigDecimal a;

    /** 符合变动范围 */
    @Excel(name = "符合变动范围")
    private BigDecimal b;

    /** 删除标志（0代表存在 2代表删除） */
    private Long delFlag;

    /** 乐观锁 */
    @Excel(name = "乐观锁")
    private Long revision;

    public void setId(Long id) 
    {
        this.id = id;
    }

    public Long getId() 
    {
        return id;
    }
    public void setType(Integer type)
    {
        this.type = type;
    }

    public Integer getType()
    {
        return type;
    }
    public void setY1Min(Integer y1Min)
    {
        this.y1Min = y1Min;
    }

    public Integer getY1Min()
    {
        return y1Min;
    }
    public void setY1Max(Integer y1Max)
    {
        this.y1Max = y1Max;
    }

    public Integer getY1Max()
    {
        return y1Max;
    }
    public void setxMin(Integer xMin)
    {
        this.xMin = xMin;
    }

    public Integer getxMin()
    {
        return xMin;
    }
    public void setxMax(Integer xMax)
    {
        this.xMax = xMax;
    }

    public Integer getxMax()
    {
        return xMax;
    }
    public void setX1(BigDecimal x1) 
    {
        this.x1 = x1;
    }

    public BigDecimal getX1() 
    {
        return x1;
    }
    public void setA(BigDecimal a) 
    {
        this.a = a;
    }

    public BigDecimal getA() 
    {
        return a;
    }
    public void setB(BigDecimal b) 
    {
        this.b = b;
    }

    public BigDecimal getB() 
    {
        return b;
    }
    public void setDelFlag(Long delFlag) 
    {
        this.delFlag = delFlag;
    }

    public Long getDelFlag() 
    {
        return delFlag;
    }
    public void setRevision(Long revision) 
    {
        this.revision = revision;
    }

    public Long getRevision() 
    {
        return revision;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this,ToStringStyle.MULTI_LINE_STYLE)
            .append("id", getId())
            .append("type", getType())
            .append("y1Min", getY1Min())
            .append("y1Max", getY1Max())
            .append("xMin", getxMin())
            .append("xMax", getxMax())
            .append("x1", getX1())
            .append("a", getA())
            .append("b", getB())
            .append("delFlag", getDelFlag())
            .append("revision", getRevision())
            .append("createBy", getCreateBy())
            .append("createTime", getCreateTime())
            .append("updateBy", getUpdateBy())
            .append("updateTime", getUpdateTime())
            .append("remark", getRemark())
            .toString();
    }
}
