package com.slibra.business.domain;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.slibra.common.annotation.Excel;
import com.slibra.common.core.domain.BaseEntity;

/**
 * 信义智能体助手配置对象 t_xinyi_agent_assistant
 * 
 * @author slibra
 * @date 2024-05-17
 */

@Builder
@Data
@AllArgsConstructor
@NoArgsConstructor
public class TXinyiAgentAssistant extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键 */
    private Long id;

    /** 分类（写报告 日常生活 工作文案） */
    @Excel(name = "分类", readConverterExp = "写=报告,日=常生活,工=作文案")
    private String category;

    /** 标题 */
    @Excel(name = "标题")
    private String title;

    /** 工具 */
    @Excel(name = "工具")
    private String tools;

    /** 调用大模型的提示词 */
    @Excel(name = "调用大模型的提示词")
    private String prompt;

    /** 提示词内容 */
    @Excel(name = "展示内容")
    private String content;

    /** banner地址 */
    @Excel(name = "banner地址")
    private String banner;

    /** 排序（按升序排列） */
    @Excel(name = "排序", readConverterExp = "按=升序排列")
    private String sort;

    /** 删除标志（0代表存在 2代表删除） */
    private Long delFlag;

    /** 乐观锁 */
    @Excel(name = "乐观锁")
    private Long revision;

}
