package com.slibra.business.domain;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.slibra.common.annotation.Excel;
import com.slibra.common.core.domain.BaseEntity;

/**
 * 信义大模型问答记录对象 t_xinyi_chat_record
 * 
 * @author slibra
 * @date 2024-05-15
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class TXinyiChatRecord extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键 */
    private Long id;

    /** 会话ID */
    @Excel(name = "会话ID")
    private String sessionId;

    /** 类型（0问答 1决策 2本地 3仿真预测） */
    @Excel(name = "类型", readConverterExp = "0=问答,1=决策,2=本地,3仿真预测")
    private Integer type;

    /** 隶属哪个模块（0专家问答 1智能工单 2智能体助手 3告警 4简报） */
    @Excel(name = "隶属哪个模块", readConverterExp = "0=专家问答,1=智能工单,2=智能体助手,3.告警, 4.简报")
    private Integer module;

    /** 用户ID */
    @Excel(name = "用户ID")
    private String userId;

    /** 显示内容（JSON） */
    @Excel(name = "显示内容", readConverterExp = "J=SON")
    private String showVal;

    /** 用户提问 */
    @Excel(name = "用户提问")
    private String question;

    /** 大模型回答 */
    @Excel(name = "大模型回答")
    private String answer;

    /** 告警记录ID */
    @Excel(name = "告警记录ID")
    private String warningId;

    /** 问答次数 */
    @Excel(name = "问答次数")
    private Integer counts;

    /** 是否使用搜索增强（0否 1是） */
    @Excel(name = "是否使用搜索增强", readConverterExp = "0=否,1=是")
    private Integer isStrong;

    /** 回复是否满意（0否 1是 2默认：既不支持，也不反对） */
    @Excel(name = "回复是否满意", readConverterExp = "0否 1是 2默认：既不支持，也不反对")
    private Integer isSatisfied;

    /** 是否中断问答（0否 1是） */
    @Excel(name = "是否中断问答", readConverterExp = "0=否,1=是")
    private Integer isShutdown;

    /** 删除标志（0代表存在 2代表删除） */
    private Long delFlag;

    /** 乐观锁 */
    @Excel(name = "乐观锁")
    private Long revision;

    //2024年7月1日14:40:48 新增字段，运营端展示的

    /** 用户账号 */
    @Excel(name = "登录名称")
    private String userName;

    /** 手机号码 */
    @Excel(name = "手机号码")
    private String phonenumber;

    //2025年04月08日13:51:42 新增返回的日期 只保留到年月日
    private String dateStr = "";


}
