package com.slibra.business.domain;

import java.math.BigDecimal;
import java.util.Objects;

import com.slibra.common.DecimalUtils;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.slibra.common.annotation.Excel;
import com.slibra.common.core.domain.BaseEntity;

import static com.slibra.common.constant.MyConstants.PERCENT_SYMBOL;
import static com.slibra.common.constant.MyConstants.SORT_DESC;

/**
 * 信义预测对比对象 t_xinyi_forecast_comparison
 *
 * @author slibra
 * @date 2024-06-18
 */

@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class TXinyiForecastComparison extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键 */
    private Long id;

    /** 时间 */
    @Excel(name = "时间")
    private String remark;

    /** 预测类型 */
    @Excel(name = "预测类型")
    private String category;

    /** 预测时间1 */
    @Excel(name = "预测1时间")
    private String forecastTimeOne;

    /** 实际值1 */
    @Excel(name = "实际1小时值")
    private BigDecimal realOne;

    /** 红杉预测值1 */
    @Excel(name = "TFT预测1小时值")
    private BigDecimal hsForecastOne;

    /** 红杉值1误差率 */
    private BigDecimal hsErrorRateOne;

    /** 红杉预测1差值 */
    @Excel(name = "TFT预测1小时误差值")
    private BigDecimal hsOneSubtract;

    @Excel(name = "TFT预测1小时百分比误差")
    private String hsErrorRateOneStr;

    /** 跃渊预测值1 */
    @Excel(name = "LSTM预测1小时值")
    private BigDecimal yyForecastOne;

    /** 跃渊值1误差率 */
    private BigDecimal yyErrorRateOne;

    /** 跃渊预测1差值 */
    @Excel(name = "LSTM预测1小时误差值")
    private BigDecimal yyOneSubtract;

    @Excel(name = "LSTM预测1小时百分比误差")
    private String yyErrorRateOneStr;

    /** 机理模型预测值1 */
    @Excel(name = "机理模型预测值1")
    private BigDecimal jlForecastOne;

    /** 机理模型预测值1误差率 */
//    @Excel(name = "机理模型预测值1误差率")
    private BigDecimal jlErrorRateOne;

    /** 机理模型预测值1差值 */
    @Excel(name = "机理模型预测值1差值")
    private BigDecimal jlOneSubtract;

    @Excel(name = "机理模型预测值1百分比误差")
    private String jlErrorRateOneStr;

    /** 预测时间2 */
    @Excel(name = "预测2时间")
    private String forecastTimeTwo;

    /** 实际值2 */
    @Excel(name = "实际2小时值")
    private BigDecimal realTwo;

    /** 红杉预测值2 */
    @Excel(name = "TFT预测2小时值")
    private BigDecimal hsForecastTwo;

    /** 红杉值2误差率 */
    private BigDecimal hsErrorRateTwo;

    /** 红杉预测2差值 */
    @Excel(name = "TFT预测2小时误差值")
    private BigDecimal hsTwoSubtract;

    @Excel(name = "TFT预测2小时百分比误差")
    private String hsErrorRateTwoStr;

    /** 跃渊预测值2 */
    @Excel(name = "LSTM预测2小时值")
    private BigDecimal yyForecastTwo;

    /** 跃渊值2误差率 */
    private BigDecimal yyErrorRateTwo;

    /** 跃渊预测2差值 */
    @Excel(name = "LSTM预测2小时误差值")
    private BigDecimal yyTwoSubtract;

    @Excel(name = "LSTM预测2小时百分比误差")
    private String yyErrorRateTwoStr;

    /** 机理模型预测值2 */
    @Excel(name = "机理模型预测值2")
    private BigDecimal jlForecastTwo;

    /** 机理模型预测值2误差率 */
//    @Excel(name = "机理模型预测值2误差率")
    private BigDecimal jlErrorRateTwo;

    /** 机理模型预测值2差值 */
    @Excel(name = "机理模型预测值2差值")
    private BigDecimal jlTwoSubtract;

    @Excel(name = "机理模型预测值2百分比误差")
    private String jlErrorRateTwoStr;

    /** 预测时间3 */
    @Excel(name = "预测3时间")
    private String forecastTimeThree;

    /** 实际值3 */
    @Excel(name = "实际3小时值")
    private BigDecimal realThree;

    /** 红杉预测值3 */
    @Excel(name = "TFT预测3小时值")
    private BigDecimal hsForecastThree;

    /** 红杉值3误差率 */
    private BigDecimal hsErrorRateThree;

    /** 红杉预测3差值 */
    @Excel(name = "TFT预测3小时误差值")
    private BigDecimal hsThreeSubtract;

    @Excel(name = "TFT预测3小时百分比误差")
    private String hsErrorRateThreeStr;

    /** 跃渊预测值3 */
    @Excel(name = "LSTM预测3小时值")
    private BigDecimal yyForecastThree;

    /** 跃渊值3误差率 */
    private BigDecimal yyErrorRateThree;

    /** 跃渊预测3差值 */
    @Excel(name = "LSTM预测3小时误差值")
    private BigDecimal yyThreeSubtract;

    @Excel(name = "LSTM预测3小时百分比误差")
    private String yyErrorRateThreeStr;

    /** 机理模型预测值3 */
    @Excel(name = "机理模型预测值3")
    private BigDecimal jlForecastThree;

    /** 机理模型预测值3误差率 */
//    @Excel(name = "机理模型预测值3误差率")
    private BigDecimal jlErrorRateThree;

    /** 机理模型预测值3差值 */
    @Excel(name = "机理模型预测值3差值")
    private BigDecimal jlThreeSubtract;

    @Excel(name = "机理模型预测值3百分比误差")
    private String jlErrorRateThreeStr;

    /** 删除标志（0代表存在 2代表删除） */
    private Long delFlag;

    /** 乐观锁 */
//    @Excel(name = "乐观锁")
    private Long revision;


    //2024年6月20日14:15:09 新增查询条件
    /**  开始时间  2024/06/18 13 格式的*/
    private String timeBegin;

    /** 截止时间 2024/06/18 13 格式的*/
    private String timeEnd;



    //2024年08月16日14:23:50  新增字段，降序还是升序
    private String sort = SORT_DESC;


    //2024年6月24日15:27:47 因为导出关系，必须要set进去才能有结果
    /*public String getHsErrorRateOneStr() {
        if(Objects.isNull(hsErrorRateOne))
            return null;
        return DecimalUtils.getAbsAndScale(hsErrorRateOne, 2) + PERCENT_SYMBOL;
    }

    public String getYyErrorRateOneStr() {
        if(Objects.isNull(yyErrorRateOne))
            return null;
        return DecimalUtils.getAbsAndScale(yyErrorRateOne, 2) + PERCENT_SYMBOL;
    }

    public String getHsErrorRateTwoStr() {
        if(Objects.isNull(hsErrorRateTwo))
            return null;
        return DecimalUtils.getAbsAndScale(hsErrorRateTwo, 2) + PERCENT_SYMBOL;
    }

    public String getYyErrorRateTwoStr() {
        if(Objects.isNull(yyErrorRateTwo))
            return null;
        return DecimalUtils.getAbsAndScale(yyErrorRateTwo, 2) + PERCENT_SYMBOL;
    }

    public String getHsErrorRateThreeStr() {
        if(Objects.isNull(hsErrorRateThree))
            return null;
        return DecimalUtils.getAbsAndScale(hsErrorRateThree, 2) + PERCENT_SYMBOL;
    }

    public String getYyErrorRateThreeStr() {
        if(Objects.isNull(yyErrorRateThree))
            return null;
        return DecimalUtils.getAbsAndScale(yyErrorRateThree, 2) + PERCENT_SYMBOL;
    }*/
}
