package com.slibra.business.domain;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.slibra.common.annotation.Excel;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;
import java.util.Date;

@Builder
@Data
@AllArgsConstructor
@NoArgsConstructor
public class TXinyiIndustry
{
    private static final long serialVersionUID = 1L;

    /** 主键 */
    private Long ID;

    /** 化验日期 精确到日期*/
    private String testDate;

    /** 化验时间 精确到小时*/
    private String testHour;


    /** 化验时间（2023/12/13 5:00:00格式的） */
    @Excel(name = "化验时间", readConverterExp = "2=023/12/13,5=:00:00格式的")
    private String testTime;

    /** 进水化学需氧量COD */
    @Excel(name = "进水化学需氧量COD")
    private BigDecimal jsCod;

    /** 进水酸碱度pH */
    @Excel(name = "进水酸碱度pH")
    private BigDecimal jsPh;

    /** 进水悬浮物SS */
    @Excel(name = "进水悬浮物SS")
    private BigDecimal jsSs;

    /** 进水总磷TP */
    @Excel(name = "进水总磷TP")
    private BigDecimal jsTp;

    /** 进水总氮TN */
    @Excel(name = "进水总氮TN")
    private BigDecimal jsTn;

    /** 进水氨氮NH₃-N */
    @Excel(name = "进水氨氮NH₃-N")
    private BigDecimal jsNh3;

    /** 进水水温/进水PH - 2个值 */
    @Excel(name = "进水水温/进水PH - 2个值")
    private BigDecimal jsSwPh;

    /** 进水泵房液位 （粗细格栅一提液位） */
    @Excel(name = "进水泵房液位 ", readConverterExp = "粗=细格栅一提液位")
    private BigDecimal jsBfyw;

    /** 出水水量Q出 */
    @Excel(name = "出水水量Q出")
    private BigDecimal csSlqc;

    /** 出水化学需氧量COD */
    @Excel(name = "出水化学需氧量COD")
    private BigDecimal csCod;

    /** 出水酸碱度pH */
    @Excel(name = "出水酸碱度pH")
    private BigDecimal csPh;

    /** 出水悬浮物SS */
    @Excel(name = "出水悬浮物SS")
    private BigDecimal csSs;

    /** 出水总氮TN */
    @Excel(name = "出水总氮TN")
    private BigDecimal csTn;

    /** 出水总磷TP */
    @Excel(name = "出水总磷TP")
    private BigDecimal csTp;

    /** 出水氨氮NH₃-N */
    @Excel(name = "出水氨氮NH₃-N")
    private BigDecimal csNh3;

    /** 1#池好氧中段溶解氧 DO */
    @Excel(name = "1#池好氧中段溶解氧 DO")
    private BigDecimal oneHyzdDo;

    /** 1#池好氧末段溶解氧 DO */
    @Excel(name = "1#池好氧末段溶解氧 DO")
    private BigDecimal oneHymdDo;

    /** 2#池好氧中段溶解氧 DO */
    @Excel(name = "2#池好氧中段溶解氧 DO")
    private BigDecimal twoHyzdDo;

    /** 2#池好氧末段溶解氧 DO */
    @Excel(name = "2#池好氧末段溶解氧 DO")
    private BigDecimal twoHymdDo;

    /** 1#池污泥浓度（MLSS） */
    @Excel(name = "1#池污泥浓度", readConverterExp = "M=LSS")
    private BigDecimal oneMlss;

    /** 2#池污泥浓度（MLSS） */
    @Excel(name = "2#池污泥浓度", readConverterExp = "M=LSS")
    private BigDecimal twoMlss;

    /** 进水溶解性总固体TDS */
    @Excel(name = "进水溶解性总固体TDS")
    private BigDecimal jsTds;

    /** 进水水量Q进 */
    @Excel(name = "进水水量Q进")
    private BigDecimal jsSlq;

    /** 内回流泵1# 1号泵 工频 */
    @Excel(name = "内回流泵1# 1号泵 工频")
    private BigDecimal nHlbOneGp;

    /** 内回流泵1# 2号泵 工频 */
    @Excel(name = "内回流泵1# 2号泵 工频")
    private BigDecimal nHlbTwoGp;

    /** 内回流泵1# 3号泵 工频 */
    @Excel(name = "内回流泵1# 3号泵 工频")
    private BigDecimal nHlbThreeGp;

    /** 内回流泵2# 4号泵 工频 */
    @Excel(name = "内回流泵2# 4号泵 工频")
    private BigDecimal nHlbFourGp;

    /** 内回流泵2# 5号泵 工频 */
    @Excel(name = "内回流泵2# 5号泵 工频")
    private BigDecimal nhlBFiveGp;

    /** 内回流泵2# 6号泵 工频 */
    @Excel(name = "内回流泵2# 6号泵 工频")
    private BigDecimal nHlbSixGp;

    /** 外回流泵1 工频 */
    @Excel(name = "外回流泵1 工频")
    private BigDecimal wHlbOneGp;

    /** 外回流泵2 工频 */
    @Excel(name = "外回流泵2 工频")
    private BigDecimal wHlbTwoGp;

    /** 外回流泵3 工频 */
    @Excel(name = "外回流泵3 工频")
    private BigDecimal wHlbThreeGp;

    /** 外回流泵4 工频 */
    @Excel(name = "外回流泵4 工频")
    private BigDecimal wHlbFourGp;

    /** 外回流泵5 工频 */
    @Excel(name = "外回流泵5 工频")
    private BigDecimal wHlbFiveGp;

    /** 风机1（启停） */
    @Excel(name = "风机1", readConverterExp = "启=停")
    private BigDecimal fjOne;

    /** 风机2（启停） */
    @Excel(name = "风机2", readConverterExp = "启=停")
    private BigDecimal fjTwo;

    /** 风机3（启停） */
    @Excel(name = "风机3", readConverterExp = "启=停")
    private BigDecimal fjThree;

    /** 风机4（启停） */
    @Excel(name = "风机4", readConverterExp = "启=停")
    private BigDecimal fjFour;

    /** 风机5（启停） */
    @Excel(name = "风机5", readConverterExp = "启=停")
    private BigDecimal fjFive;

    /** 风机6（启停） */
    @Excel(name = "风机6", readConverterExp = "启=停")
    private BigDecimal fjSix;

    /** 空气流量1（风机现阶段送风量） */
    @Excel(name = "空气流量1", readConverterExp = "风=机现阶段送风量")
    private BigDecimal kqllOne;

    /** 空气流量2（风机现阶段送风量） */
    @Excel(name = "空气流量2", readConverterExp = "风=机现阶段送风量")
    private BigDecimal kqllTwo;

    /** 空气流量3（风机现阶段送风量） */
    @Excel(name = "空气流量3", readConverterExp = "风=机现阶段送风量")
    private BigDecimal kqllThree;

    /** 空气流量4（风机现阶段送风量） */
    @Excel(name = "空气流量4", readConverterExp = "风=机现阶段送风量")
    private BigDecimal kqllFour;

    /** 空气流量5（风机现阶段送风量） */
    @Excel(name = "空气流量5", readConverterExp = "风=机现阶段送风量")
    private BigDecimal kqllFive;

    /** 空气流量6（风机现阶段送风量） */
    @Excel(name = "空气流量6", readConverterExp = "风=机现阶段送风量")
    private BigDecimal kqllSix;


    //2024年3月29日13:55:45 新增的字段
    /** 信义污水厂实际碳源加药量 */
    @Excel(name = "信义污水厂实际碳源加药量")
    private BigDecimal SJTYJLY;

    /** 信义污水厂除磷加药瞬时流量 */
    @Excel(name = "信义污水厂除磷加药瞬时流量")
    private BigDecimal CLJYSSLL;

    /** 好氧池溶解氧集合 */
    @Excel(name = "好氧池末端溶解氧集合")
    private String hycRjyAll;

    /** 好氧池中断溶解氧 */
    @Excel(name = "好氧池中段溶解氧集合")
    private String hycRjyZdAll;

    /** 好氧池污泥浓度集合 */
    @Excel(name = "好氧池污泥浓度集合")
    private String hycWnndAll;

    //2024年4月25日10:10:43 新增字段
    /** 信义污水厂_除磷P04预测值_ */
    @Excel(name = "信义污水厂_除磷P04预测值_")
    private BigDecimal CLP04YCZ;

    /** 一号鼓风机电流 */
    @Excel(name = "一号鼓风机电流")
    private BigDecimal oneFjDl;

    /** 二号鼓风机电流 */
    @Excel(name = "二号鼓风机电流")
    private BigDecimal twoFjDl;

    /** 三号鼓风机电流 */
    @Excel(name = "三号鼓风机电流")
    private BigDecimal threeFjDl;

    /** 四号鼓风机电流 */
    @Excel(name = "四号鼓风机电流")
    private BigDecimal fourFjDl;

    /** 五号鼓风机电流 */
    @Excel(name = "五号鼓风机电流")
    private BigDecimal fiveFjDl;

    /** 六号鼓风机电流 */
    @Excel(name = "六号鼓风机电流")
    private BigDecimal sixFjDl;

    /** 1细格栅启停 */
    @Excel(name = "1细格栅启停")
    private BigDecimal oneXgsQt;

    /** 2细格栅启停 */
    @Excel(name = "2细格栅启停")
    private BigDecimal twoXgsQt;

    /** 3细格栅启停 */
    @Excel(name = "3细格栅启停")
    private BigDecimal threeXgsQt;

    /** 4细格栅启停 */
    @Excel(name = "4细格栅启停")
    private BigDecimal fourXgsQt;

    /** 5细格栅启停 */
    @Excel(name = "5细格栅启停")
    private BigDecimal fiveXgsQt;

    /** 6细格栅启停 */
    @Excel(name = "6细格栅启停")
    private BigDecimal sixXgsQt;

    /** 1内回流泵电流 */
    @Excel(name = "1内回流泵电流")
    private BigDecimal oneNhlbDl;

    /** 2内回流泵电流 */
    @Excel(name = "2内回流泵电流")
    private BigDecimal twoNhlbDl;

    /** 3内回流泵电流 */
    @Excel(name = "3内回流泵电流")
    private BigDecimal threeNhlbDl;

    /** 4内回流泵电流 */
    @Excel(name = "4内回流泵电流")
    private BigDecimal fourNhlbDl;

    /** 5内回流泵电流 */
    @Excel(name = "5内回流泵电流")
    private BigDecimal fiveNhlbDl;

    /** 6内回流泵电流 */
    @Excel(name = "6内回流泵电流")
    private BigDecimal sixNhlbDl;

    /** 1初沉池排泥泵启停 */
    @Excel(name = "1初沉池排泥泵启停")
    private BigDecimal oneCccpnbQt;

    /** 2初沉池排泥泵启停 */
    @Excel(name = "2初沉池排泥泵启停")
    private BigDecimal twoCccpnbQt;

    /** 1剩余污泥打泥泵启停 */
    @Excel(name = "1剩余污泥打泥泵启停")
    private BigDecimal oneSywndbQt;

    /** 2剩余污泥打泥泵启停 */
    @Excel(name = "2剩余污泥打泥泵启停")
    private BigDecimal twoSywndbQt;

    /** 1深度处理（砂滤）电流 */
    @Excel(name = "1深度处理", readConverterExp = "砂=滤")
    private BigDecimal oneSdclDl;

    /** 2深度处理（砂滤）电流 */
    @Excel(name = "2深度处理", readConverterExp = "砂=滤")
    private BigDecimal twoSdclDl;

    /** 3深度处理（砂滤）电流 */
    @Excel(name = "3深度处理", readConverterExp = "砂=滤")
    private BigDecimal threeSdclDl;

    /** 4深度处理（砂滤）电流 */
    @Excel(name = "4深度处理", readConverterExp = "砂=滤")
    private BigDecimal fourSdclDl;

    /** 创建时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "创建时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date createdTime;

    //2024年09月10日10:47:07 新增的请求参数
    /**  开始时间 */
    private String timeBegin;

    /** 截止时间 */
    private String timeEnd;

}

