package com.slibra.business.domain;

import java.math.BigDecimal;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.slibra.common.annotation.Excel;
import com.slibra.common.core.domain.BaseEntity;

/**
 * 信义化验数据;对象 t_xinyi_laboratory
 * 
 * @author slibra
 * @date 2024-03-27
 */
@Builder
@Data
@AllArgsConstructor
@NoArgsConstructor
public class TXinyiLaboratory extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键 */
    private Long ID;

    /** 化验日期 */
    @Excel(name = "化验日期")
    private String testDate;

    /** 化验日期-小时 */
    @Excel(name = "化验日期-小时")
    private String testHour;

    /** 化验时间（2023/12/13 5:00:00格式的） */
    @Excel(name = "化验时间", readConverterExp = "2=023/12/13,5=:00:00格式的")
    private String testTime;

    /** 1#好氧池硝酸盐（内回流） */
    @Excel(name = "1#好氧池硝酸盐", readConverterExp = "内=回流")
    private BigDecimal oneHycxsy;

    /** 2#好氧池硝酸盐（内回流） */
    @Excel(name = "2#好氧池硝酸盐", readConverterExp = "内=回流")
    private BigDecimal twoHycxsy;

    /** 1#缺氧出口硝酸盐 */
    @Excel(name = "1#缺氧出口硝酸盐")
    private BigDecimal oneQyckxsy;

    /** 2#缺氧出-硝酸盐 */
    @Excel(name = "2#缺氧出-硝酸盐")
    private BigDecimal twoQyckxsy;

    /** 正磷 */
    @Excel(name = "正磷")
    private BigDecimal ZL;

    /** #1好氧池-正磷酸盐 */
    @Excel(name = "#1好氧池-正磷酸盐")
    private BigDecimal oneHyZlsy;

    /** #2好氧池-正磷酸盐 */
    @Excel(name = "#2好氧池-正磷酸盐")
    private BigDecimal twoHyZlsy;

    /** 1#缺氧氨氮 */
    @Excel(name = "1#缺氧氨氮")
    private BigDecimal oneQyad;

    /** 2#缺氧氨氮 */
    @Excel(name = "2#缺氧氨氮")
    private BigDecimal twoQyad;

    /** 创建时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "创建时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date createdTime;

}
