package com.slibra.business.domain;

import java.math.BigDecimal;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.slibra.common.annotation.Excel;
import com.slibra.common.core.domain.BaseEntity;

/**
 * 信义碳源投加记录对象 t_xinyi_medicine_add_record
 * 
 * @author slibra
 * @date 2025-04-24
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class TXinyiMedicineAddRecord extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键 */
    private Long id;

    /** 采用控制系数ID */
    @Excel(name = "采用控制系数ID")
    private Long relativeId;

    /** 投加时间（yyyy/MM/dd HH格式的） */
    @Excel(name = "投加时间", readConverterExp = "y=yyy/MM/dd,H=H格式的")
    private String addHour;

    /** 投放方式（0一池 1二池 2自动） */
    @Excel(name = "投放方式", readConverterExp = "0=一池,1=二池,2=自动")
    private Integer choosePool;

    /** 实际投放方式（0一池 1二池） */
    @Excel(name = "实际投放方式", readConverterExp = "0=一池,1=二池")
    private Integer addPool;

    /** 使用控制系数 */
    @Excel(name = "使用控制系数")
    private BigDecimal kzxs;

    /** 使用后反馈设定 */
    @Excel(name = "使用后反馈设定")
    private BigDecimal htfksd;

    /** 组态是否允许投放（0否  1是） */
    @Excel(name = "组态是否允许投放", readConverterExp = "0=否,1=是")
    private Boolean canAdd;

    /** 瞬时加药量 */
    @Excel(name = "瞬时加药量")
    private BigDecimal realVal;

    /** 使用碳源投加值 */
    @Excel(name = "使用碳源投加值")
    private BigDecimal calculateVal;

    /** 1池碳源投加值 */
    @Excel(name = "1池碳源投加值")
    private BigDecimal oneVal;

    /** 2池碳源投加值 */
    @Excel(name = "2池碳源投加值")
    private BigDecimal twoVal;

    /** 1池后反馈设定 */
    @Excel(name = "1池后反馈设定")
    private BigDecimal oneHtfksd;

    /** 2池后反馈设定 */
    @Excel(name = "2池后反馈设定")
    private BigDecimal twoHtfksd;

    /** 1池控制系数 */
    @Excel(name = "1池控制系数")
    private BigDecimal oneKzxs;

    /** 2池控制系数 */
    @Excel(name = "2池控制系数")
    private BigDecimal twoKzxs;

    /** 质控值下限 */
    @Excel(name = "质控值下限")
    private BigDecimal zkzDown;

    /** 质控值下限 */
    @Excel(name = "质控值下限")
    private BigDecimal zkzUp;

    /** 删除标志（0代表存在 2代表删除） */
    private Long delFlag;

    /** 乐观锁 */
    @Excel(name = "乐观锁")
    private Long revision;

    //2025年05月09日18:59:13 新增请求参数
    //开始日期
    private String dateBegin;

    //截止日期
    private String dateEnd;



}
