package com.slibra.business.domain;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import com.slibra.common.annotation.Excel;
import com.slibra.common.core.domain.BaseEntity;

/**
 * 投药控制对象 t_xinyi_medicine_conf
 * 
 * @author slibra
 * @date 2024-09-13
 */

@Builder
@Data
@AllArgsConstructor
@NoArgsConstructor
public class TXinyiMedicineConf extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键 */
    private Long id;

    /** 投药状态（0不允许  1允许） */
    @Excel(name = "投药状态", readConverterExp = "0=不允许,1=允许")
    private Integer addStatus;

    /** 删除标志（0代表存在 2代表删除） */
    private Long delFlag;

    /** 乐观锁 */
    @Excel(name = "乐观锁")
    private Long revision;


}
