package com.slibra.business.domain;

import java.math.BigDecimal;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.slibra.common.annotation.Excel;
import com.slibra.common.core.domain.BaseEntity;

/**
 * 信义一些指标的配置对象 t_xinyi_norm_config
 * 
 * @author slibra
 * @date 2024-04-27
 */
@Builder
@Data
@AllArgsConstructor
@NoArgsConstructor
public class TXinyiNormConfig extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键 */
    private Long id;

    /** 进水总磷设计值 */
    @Excel(name = "进水总磷设计值")
    private BigDecimal jszlSjz;

    /** 出水总磷标准值 */
    @Excel(name = "出水总磷标准值")
    private BigDecimal cszlBzz;

    /** 出水总磷管控值 */
    @Excel(name = "出水总磷管控值")
    private BigDecimal cszlGkz;

    /** 进水COD设计值 */
    @Excel(name = "进水COD设计值")
    private BigDecimal jscodSjz;

    /** 出水COD标准值 */
    @Excel(name = "出水COD标准值")
    private BigDecimal cscodBzz;

    /** 出水COD管控值 */
    @Excel(name = "出水COD管控值")
    private BigDecimal cscodGkz;

    /** 进水总氮设计值 */
    @Excel(name = "进水总氮设计值")
    private BigDecimal jszdSjz;

    /** 出水总氮标准值 */
    @Excel(name = "出水总氮标准值")
    private BigDecimal cszzBzz;

    /** 出水总氮管控值 */
    @Excel(name = "出水总氮管控值")
    private BigDecimal cszzGkz;

    /** 进水氨氮设计值 */
    @Excel(name = "进水氨氮设计值")
    private BigDecimal jsadSjz;

    /** 出水氨氮标准值 */
    @Excel(name = "出水氨氮标准值")
    private BigDecimal csadBzz;

    /** 出水氨氮管控值 */
    @Excel(name = "出水氨氮管控值")
    private BigDecimal csadGkz;

    /** 进水SS设计值 */
    @Excel(name = "进水SS设计值")
    private BigDecimal jsssSjz;

    /** 出水SS标准值 */
    @Excel(name = "出水SS标准值")
    private BigDecimal csssBzz;

    /** 出水SS管控值 */
    @Excel(name = "出水SS管控值")
    private BigDecimal csssGkz;

    /** 厌氧池硝态氮 */
    @Excel(name = "厌氧池硝态氮")
    private BigDecimal YYCXTD;

    /** 进水水量设计值 */
    @Excel(name = "进水水量设计值")
    private BigDecimal jsslSjz;

    /** 污泥沉降比管控值 */
    @Excel(name = "污泥沉降比管控值")
    private BigDecimal wncjbGkz;

    /** 污泥体积指数管控值 */
    @Excel(name = "污泥体积指数管控值")
    private BigDecimal wntjzsGkz;

    /** 进水TDS管控值 */
    @Excel(name = "进水TDS管控值")
    private BigDecimal jdtdsGkz;

    /** 出水大肠杆菌标准值 */
    @Excel(name = "出水大肠杆菌标准值")
    private BigDecimal csdcgjBzz;

    /** 进水大肠杆菌稳态值 */
    @Excel(name = "进水大肠杆菌稳态值")
    private BigDecimal jsdcgjWtz;

    /** 粗细格栅一提液位管控值 */
    @Excel(name = "粗细格栅一提液位管控值")
    private BigDecimal cxgsTywGkz;

    /** 厌氧区停留时间设计值 */
    @Excel(name = "厌氧区停留时间设计值")
    private BigDecimal yyqtlsjSjz;

    /** 厌氧区停留时间管控值 */
    @Excel(name = "厌氧区停留时间管控值")
    private BigDecimal yyqtlsjGkz;

    /** 厌氧区有效池容 */
    @Excel(name = "厌氧区有效池容")
    private BigDecimal YYQYXCR;

    /** 缺氧区停留时间设计值 */
    @Excel(name = "缺氧区停留时间设计值")
    private BigDecimal qyqtlsjSjz;

    /** 缺氧区停留时间管控值 */
    @Excel(name = "缺氧区停留时间管控值")
    private BigDecimal qyqtlsjGkz;

    /** 缺氧区有效池容 */
    @Excel(name = "缺氧区有效池容")
    private BigDecimal QYQYXCR;

    /** 好氧区停留时间设计值 */
    @Excel(name = "好氧区停留时间设计值")
    private BigDecimal hyqtlsjSjz;

    /** 好氧区停留时间管控值 */
    @Excel(name = "好氧区停留时间管控值")
    private BigDecimal hyqtlsjGkz;

    /** 好氧区有效池容 */
    @Excel(name = "好氧区有效池容")
    private BigDecimal HYQYXCR;

    /** 内回流泵启动数量 */
    @Excel(name = "内回流泵启动数量")
    private BigDecimal NHLBQDSL;

    /** 内回流泵的设计流量 */
    @Excel(name = "内回流泵的设计流量")
    private BigDecimal NHLBDSJLL;

    /** 内回流泵工作效率 */
    @Excel(name = "内回流泵工作效率")
    private BigDecimal NHLBGZXL;

    /** 内回流比设计值 */
    @Excel(name = "内回流比设计值")
    private BigDecimal nhlbSjz;

    /** 内回流比内控下限值 */
    @Excel(name = "内回流比内控下限值")
    private BigDecimal nhlbnkXxz;

    /** 内回流比内控上限值 */
    @Excel(name = "内回流比内控上限值")
    private BigDecimal nhlbnkSxz;

    /** 外回流比设计值 */
    @Excel(name = "外回流比设计值")
    private BigDecimal whlbSjz;

    /** 外回流比内控下限值 */
    @Excel(name = "外回流比内控下限值")
    private BigDecimal whlbnkXxz;

    /** 外回流泵启动数量 */
    @Excel(name = "外回流泵启动数量")
    private BigDecimal WHLBQDSL;

    /** 外回流泵的设计流量 */
    @Excel(name = "外回流泵的设计流量")
    private BigDecimal WHLBDSJLL;

    /** 外回流泵工作效率 */
    @Excel(name = "外回流泵工作效率")
    private BigDecimal WHLBGZXL;

    /** 夏季污泥浓度上限值 */
    @Excel(name = "夏季污泥浓度上限值")
    private BigDecimal xjwnndSxz;

    /** 夏季污泥浓度下限值 */
    @Excel(name = "夏季污泥浓度下限值")
    private BigDecimal xjwnndXxz;

    /** 冬季污泥浓度上限 */
    @Excel(name = "冬季污泥浓度上限")
    private BigDecimal djwnndSxz;

    /** 冬季污泥浓度下限值 */
    @Excel(name = "冬季污泥浓度下限值")
    private BigDecimal djwnndXxz;

    /** 污泥负荷设计值 */
    @Excel(name = "污泥负荷设计值")
    private BigDecimal wnfhSjz;

    /** 污泥负荷内控上限值 */
    @Excel(name = "污泥负荷内控上限值")
    private BigDecimal wnfhnkSxz;

    /** 污泥负荷内控下限值 */
    @Excel(name = "污泥负荷内控下限值")
    private BigDecimal wnfhnkXxz;

    /** 污泥龄设计值 */
    @Excel(name = "污泥龄设计值")
    private BigDecimal wnlSjz;

    /** 污泥龄内控值 */
    @Excel(name = "污泥龄内控值")
    private BigDecimal wnlNkz;

    /** 产泥率设计值 */
    @Excel(name = "产泥率设计值")
    private BigDecimal cnlSjz;

    /** 产泥率内控值下限 */
    @Excel(name = "产泥率内控值下限")
    private BigDecimal CNLNKZXX;

    /** 产泥率内控值上限 */
    @Excel(name = "产泥率内控值上限")
    private BigDecimal CNLNKZSX;

    /** 挥发性污泥浓度占比设计值 */
    @Excel(name = "挥发性污泥浓度占比设计值")
    private BigDecimal hfxwnndzbSjz;

    /** 挥发性污泥浓度占比管控值 */
    @Excel(name = "挥发性污泥浓度占比管控值")
    private BigDecimal hfxwnndzbGkz;

    /** 进水碳氮比设计值 */
    @Excel(name = "进水碳氮比设计值")
    private BigDecimal cstdbSjz;

    /** 进水碳氮比内控上限值 */
    @Excel(name = "进水碳氮比内控上限值")
    private BigDecimal jstdbnkzSxz;

    /** 进水碳氮比内控下限值 */
    @Excel(name = "进水碳氮比内控下限值")
    private BigDecimal jstdbnkzXxz;

    /** 进水碳磷比设计值 */
    @Excel(name = "进水碳磷比设计值")
    private BigDecimal jstlbSjz;

    /** 进水碳磷比内控制 */
    @Excel(name = "进水碳磷比内控制")
    private BigDecimal jstlbNkz;

    /** 进水BOD与COD比值的设计值 */
    @Excel(name = "进水BOD与COD比值的设计值")
    private BigDecimal jsbodycodbzSzj;

    /** 进水BOD与COD比值的管控范围 */
    @Excel(name = "进水BOD与COD比值的管控范围")
    private String jsbodycodbzGkz;

    /** 厌氧池溶解氧内控值 */
    @Excel(name = "厌氧池溶解氧内控值")
    private BigDecimal yycyjyNkz;

    /** 厌氧池溶解氧设计值上限值 */
    @Excel(name = "厌氧池溶解氧设计值上限值")
    private BigDecimal yycyjysjzSxz;

    /** 缺氧池溶解氧内控值 */
    @Excel(name = "缺氧池溶解氧内控值")
    private BigDecimal qycrjyNkz;

    /** 缺氧池溶解氧设计值上限值 */
    @Excel(name = "缺氧池溶解氧设计值上限值")
    private BigDecimal qycrjysjzSxz;

    /** 好氧池溶解氧内控值 */
    @Excel(name = "好氧池溶解氧内控值")
    private BigDecimal hycrjyNkz;

    /** 好氧池溶解氧设计值上限值 */
    @Excel(name = "好氧池溶解氧设计值上限值")
    private BigDecimal hycrjysjzSxz;

    /** 生化池气水比内控值 */
    @Excel(name = "生化池气水比内控值")
    private BigDecimal shcqbNkz;

    /** 生化池气水比设计值 */
    @Excel(name = "生化池气水比设计值")
    private BigDecimal shcqbSjz;

    /** 鼓风机工作台数 */
    @Excel(name = "鼓风机工作台数")
    private BigDecimal GFJGZTS;

    /** 鼓风机出口流量 */
    @Excel(name = "鼓风机出口流量")
    private BigDecimal GFJCKLL;

    /** 污泥沉降比设计值上限值 */
    @Excel(name = "污泥沉降比设计值上限值")
    private BigDecimal wncjbsjzSxz;

    /** 污泥体积指数设计值 */
    @Excel(name = "污泥体积指数设计值")
    private BigDecimal wntjzsSjz;

    /** 二沉池表面负荷内控值上限值 */
    @Excel(name = "二沉池表面负荷内控值上限值")
    private BigDecimal eccbmfhznkzSxz;

    /** 二沉池表面负荷内控值下限值 */
    @Excel(name = "二沉池表面负荷内控值下限值")
    private BigDecimal eccbmfhznkzXxz;

    /** 二沉池表面负荷设计值 */
    @Excel(name = "二沉池表面负荷设计值")
    private BigDecimal eccbmfhSjz;

    /** 二沉池设计直径 */
    @Excel(name = "二沉池设计直径")
    private BigDecimal ECCSJZZJ;

    /** 二沉池数量 */
    @Excel(name = "二沉池数量")
    private BigDecimal ECCSL;

    /** 二沉池固体负荷内控值上限值 */
    @Excel(name = "二沉池固体负荷内控值上限值")
    private BigDecimal eccglfhnkzSxz;

    /** 二沉池固体负荷内控值下限值 */
    @Excel(name = "二沉池固体负荷内控值下限值")
    private BigDecimal eccglfhnkzXxz;

    /** 二沉池固体负荷设计值 */
    @Excel(name = "二沉池固体负荷设计值")
    private BigDecimal eccgtfhSjz;

    /** 反冲洗泵设计流量 */
    @Excel(name = "反冲洗泵设计流量")
    private BigDecimal FCXBSJLL;

    /** 反冲洗泵数量 */
    @Excel(name = "反冲洗泵数量")
    private BigDecimal FCLBSL;

    /** 反冲洗泵工作效率 */
    @Excel(name = "反冲洗泵工作效率")
    private BigDecimal FCXBGZXL;

    /** 反冲洗水量比例设计值上限值 */
    @Excel(name = "反冲洗水量比例设计值上限值")
    private BigDecimal fcxslblsjzSxz;

    /** 反冲洗水量比例设计值下限值 */
    @Excel(name = "反冲洗水量比例设计值下限值")
    private BigDecimal fcxslblsjzXxz;

    /** 活性砂滤池过滤面积 */
    @Excel(name = "活性砂滤池过滤面积")
    private BigDecimal HXSLCGLMJ;

    /** 活性砂滤池数量 */
    @Excel(name = "活性砂滤池数量")
    private BigDecimal HXSLCSL;

    /** 深度处理峰值过滤速度设计值 */
    @Excel(name = "深度处理峰值过滤速度设计值")
    private BigDecimal sdclfzglsdSjz;

    /** 污泥总产率系数（每周平均值） */
    @Excel(name = "污泥总产率系数", readConverterExp = "每=周平均值")
    private BigDecimal WNZLLXS;

    /** 万吨水产泥率 */
    @Excel(name = "万吨水产泥率")
    private BigDecimal WDSCNL;

    /** 剩余污泥泵启动数量 */
    @Excel(name = "剩余污泥泵启动数量")
    private BigDecimal SYWNBQDSL;

    /** 剩余污泥泵的设计流量 */
    @Excel(name = "剩余污泥泵的设计流量")
    private BigDecimal SYWNBDSJLL;

    /** 剩余污泥泵工作效率 */
    @Excel(name = "剩余污泥泵工作效率")
    private BigDecimal SYWNBGZXL;

    /** 碳源投加隔膜计量泵启动数量 */
    @Excel(name = "碳源投加隔膜计量泵启动数量")
    private BigDecimal TYTJGMSJBQDSL;

    /** 碳源投加隔膜计量泵设计流量 */
    @Excel(name = "碳源投加隔膜计量泵设计流量")
    private BigDecimal TYTJGMSJBSJLL;

    /** 碳源投加隔膜计量泵工作效率 */
    @Excel(name = "碳源投加隔膜计量泵工作效率")
    private BigDecimal TYTJGMSJBGZXL;

    /** 次氯酸钠隔膜计量泵启动数量 */
    @Excel(name = "次氯酸钠隔膜计量泵启动数量")
    private BigDecimal CLSNGMSJBQDSL;

    /** 次氯酸钠隔膜计量泵设计流量 */
    @Excel(name = "次氯酸钠隔膜计量泵设计流量")
    private BigDecimal CLSNGMSJBSJLL;

    /** 次氯酸钠隔膜计量泵工作效率 */
    @Excel(name = "次氯酸钠隔膜计量泵工作效率")
    private BigDecimal CLSNGMSJBGZXL;

    /** 生化池除磷隔膜计量泵启动数量 */
    @Excel(name = "生化池除磷隔膜计量泵启动数量")
    private BigDecimal SHCCLGMJLBQDSL;

    /** 生化池除磷隔膜计量泵设计流量 */
    @Excel(name = "生化池除磷隔膜计量泵设计流量")
    private BigDecimal SHCCLGMJLBSJLL;

    /** 生化池除磷隔膜计量泵工作效率 */
    @Excel(name = "生化池除磷隔膜计量泵工作效率")
    private BigDecimal SHCCLGMJLBGZXL;

    /** 深度处理除磷隔膜计量泵启动数量 */
    @Excel(name = "深度处理除磷隔膜计量泵启动数量")
    private BigDecimal SDCLCLGMSJBQDSL;

    /** 深度处理除磷隔膜计量泵设计流量 */
    @Excel(name = "深度处理除磷隔膜计量泵设计流量")
    private BigDecimal SDCLCLGMSJBSJLL;

    /** 深度处理除磷隔膜计量泵工作效率 */
    @Excel(name = "深度处理除磷隔膜计量泵工作效率")
    private BigDecimal SDCLCLGMSJBGZXL;

    /** 二沉池固体负荷内控值下限值 */
    @Excel(name = "二沉池固体负荷内控值下限值")
    private BigDecimal ECCGTFHNKXXZ;

    /** 删除标志（0代表存在 2代表删除） */
    private Long delFlag;

    /** 乐观锁 */
    @Excel(name = "乐观锁")
    private Long revision;

}
