package com.slibra.business.domain;

import java.math.BigDecimal;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.apache.commons.lang3.StringUtils;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.slibra.common.annotation.Excel;
import com.slibra.common.core.domain.BaseEntity;

/**
 * 信义正磷对象 t_xinyi_phosphorus
 * 
 * @author slibra
 * @date 2024-03-27
 */
public class TXinyiPhosphorus
{
    private static final long serialVersionUID = 1L;

    /** 主键 */
    private Long ID;

    /** 化验日期 */
    @Excel(name = "化验日期")
    private String testDate;

    /** 化验时间 */
    @Excel(name = "化验时间")
    private String testTime;

    /** 二沉池 */
    @Excel(name = "二沉池")
    private BigDecimal ECC;

    /** 一号回流 */
    @Excel(name = "一号回流")
    private BigDecimal YHHL;

    /** 二号回流 */
    @Excel(name = "二号回流")
    private BigDecimal EHHL;

    /** 创建时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "创建时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date createdTime;


    private int sort;//排序

    public int getSort() {
        return sort;
    }

    public void setSort(int sort) {
        this.sort = sort;
    }

    public void setID(Long ID)
    {
        this.ID = ID;
    }

    public Long getID() 
    {
        return ID;
    }
    public void setTestDate(String testDate) 
    {
        this.testDate = testDate;
    }

    public String getTestDate() 
    {
        return testDate;
    }
    public void setTestTime(String testTime) 
    {
        this.testTime = testTime;
    }

    public String getTestTime() 
    {
        return testTime;
    }
    public void setECC(BigDecimal ECC) 
    {
        this.ECC = ECC;
    }

    public BigDecimal getECC() 
    {
        return ECC;
    }
    public void setYHHL(BigDecimal YHHL) 
    {
        this.YHHL = YHHL;
    }

    public BigDecimal getYHHL() 
    {
        return YHHL;
    }
    public void setEHHL(BigDecimal EHHL) 
    {
        this.EHHL = EHHL;
    }

    public BigDecimal getEHHL() 
    {
        return EHHL;
    }
    public void setCreatedTime(Date createdTime) 
    {
        this.createdTime = createdTime;
    }

    public Date getCreatedTime() 
    {
        return createdTime;
    }


}
