package com.slibra.business.domain;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.slibra.common.annotation.Excel;
import com.slibra.common.core.domain.BaseEntity;

/**
 * 信义推荐问答列对象 t_xinyi_recommend_qa
 * 
 * @author slibra
 * @date 2024-05-17
 */
@Builder
@Data
@AllArgsConstructor
@NoArgsConstructor
public class TXinyiRecommendQa extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键 */
    private Long id;

    /** 类型(0专家问答 1水质报警  2生化报警 3预测预警 ) */
    @Excel(name = "类型(0专家问答 1水质报警  2生化报警 3预测预警 )")
    private Integer type;

    /** 问题 */
    @Excel(name = "问题")
    private String question;

    /** 提示词内容 */
    @Excel(name = "提示词内容")
    private String content;

    /** 排序（升序排列） */
    @Excel(name = "排序", readConverterExp = "升=序排列")
    private String sort;

    /** 删除标志（0代表存在 2代表删除） */
    private Long delFlag;

    /** 乐观锁 */
    @Excel(name = "乐观锁")
    private Long revision;

}
