package com.slibra.business.domain;

import java.math.BigDecimal;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.slibra.common.annotation.Excel;
import com.slibra.common.core.domain.BaseEntity;

/**
 * 信义碳源投加参数配置对象 t_xinyi_tytj_params
 * 
 * @author slibra
 * @date 2025-04-23
 */

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class TXinyiTytjParams extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键 */
    private Long id;

    /** 控制目标偏离报警值 */
    @Excel(name = "控制目标偏离报警值")
    private BigDecimal kzmbplbjz;

    /** 好氧池硝酸盐管控值 */
    @Excel(name = "好氧池硝酸盐管控值")
    private BigDecimal hycxsygkz;

    /** 硝化异常报警值 */
    @Excel(name = "硝化异常报警值")
    private BigDecimal xhycbjz;

    /** 加药量偏移报警值 */
    @Excel(name = "加药量偏移报警值")
    private BigDecimal jylpybjz;

    /** 偏移量统计时间 */
    @Excel(name = "偏移量统计时间")
    private BigDecimal timeVal;

    /** 进水流量-限定最小值 */
    @Excel(name = "进水流量-限定最小值")
    private BigDecimal minJsll;

    /** 进水流量-限定最大值 */
    @Excel(name = "进水流量-限定最大值")
    private BigDecimal maxJsll;

    /** 进水COD-限定最小值 */
    @Excel(name = "进水COD-限定最小值")
    private BigDecimal minJsCod;

    /** 进水COD-限定最大值 */
    @Excel(name = "进水COD-限定最大值")
    private BigDecimal maxJsCod;

    /** 投药量-限定最小值 */
    @Excel(name = "投药量-限定最小值")
    private BigDecimal minAddAmount;

    /** 投药量-限定最大值 */
    @Excel(name = "投药量-限定最大值")
    private BigDecimal maxAddAmount;

    /** 小于最小值停止投放-冗余字段(0否 1是) */
    @Excel(name = "小于最小值停止投放-冗余字段(0否 1是)")
    private Long stopAddFlag;

    /** 基准系数 */
    @Excel(name = "基准系数")
    private BigDecimal jzxs;

    /** 修正系数 */
    @Excel(name = "修正系数")
    private BigDecimal xzxs;

    /** 水量分配系数 */
    @Excel(name = "水量分配系数")
    private BigDecimal slfpxs;

    /** 碳源当量 */
    @Excel(name = "碳源当量")
    private BigDecimal tydl;

    /** 转换系数 */
    @Excel(name = "转换系数")
    private BigDecimal zhxs;

    /** 稀释倍数 */
    @Excel(name = "稀释倍数")
    private BigDecimal sxps;

    /** 药剂密度 */
    @Excel(name = "药剂密度")
    private BigDecimal yymd;

    /** 碳氮比 */
    @Excel(name = "碳氮比")
    private BigDecimal tdb;

    /** 最小启动流量-冗余 */
    @Excel(name = "最小启动流量-冗余")
    private BigDecimal zxqdll;

    /** 硝酸盐目标值-减 */
    @Excel(name = "硝酸盐目标值-减")
    private BigDecimal xsySub;

    /** 硝酸盐目标值-加 */
    @Excel(name = "硝酸盐目标值-加")
    private BigDecimal xsyAdd;

    /** 删除标志（0代表存在 2代表删除） */
    private Long delFlag;

    /** 乐观锁 */
    @Excel(name = "乐观锁")
    private Long revision;

}
