package com.slibra.business.domain;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.slibra.common.annotation.Excel;
import com.slibra.common.core.domain.BaseEntity;

import java.math.BigDecimal;

/**
 * 【请填写功能名称】对象 validate_coef
 * 
 * @author slibra
 * @date 2025-05-09
 */
@Builder
@Data
@NoArgsConstructor
@AllArgsConstructor
public class ValidateCoef
{
    private static final long serialVersionUID = 1L;

    /** $column.columnComment */
    private Long id;

    /** 有效系数发生日期 */
    @Excel(name = "有效系数发生日期")
    private String validateDate;

    /** 有效系数发生时间 */
    @Excel(name = "有效系数发生时间")
    private String validateTime;

    /** 投放池字 */
    @Excel(name = "投放池字")
    private Long source;

    /** 有效控制系数 */
    @Excel(name = "有效控制系数")
    private BigDecimal coef;

    /** 有效档位 */
    @Excel(name = "有效档位")
    private Long subcate;

    /** 第一组好氧池硝酸盐 */
    @Excel(name = "第一组好氧池硝酸盐")
    private BigDecimal hycXsy1;

    /** 第二组好氧池硝酸盐 */
    @Excel(name = "第二组好氧池硝酸盐")
    private BigDecimal hycXsy2;

    /** 第三组好氧池硝酸盐 */
    @Excel(name = "第三组好氧池硝酸盐")
    private BigDecimal hycXsy3;

    /** 计算碳源投加总量 */
    @Excel(name = "计算碳源投加总量")
    private BigDecimal carbonCalculate;

    /** 实际碳源投加总量 */
    @Excel(name = "实际碳源投加总量")
    private BigDecimal carbonReal;

    /** 碳氮比 */
    @Excel(name = "碳氮比")
    private BigDecimal CN;

    /** 进水流量 */
    @Excel(name = "进水流量")
    private BigDecimal waterInflow;

    /** mlss */
    @Excel(name = "mlss")
    private BigDecimal MLSS;

    /** mlvss */
    @Excel(name = "mlvss")
    private BigDecimal MLVSS;

    /** others */
    @Excel(name = "others")
    private String ext;

    //2025年05月09日16:40:08 新增请求参数
    //开始日期
    private String dateBegin;

    //截止日期
    private String dateEnd;

}
