package com.slibra.business.domain;

import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.slibra.common.annotation.Excel;
import com.slibra.common.core.domain.BaseEntity;

/**
 * 【请填写功能名称】对象 xsy_feedback
 * 
 * @author slibra
 * @date 2025-04-22
 */
public class XsyFeedback extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** $column.columnComment */
    private Long id;

    /** 当前时间 */
    @Excel(name = "当前时间")
    private String reqTime;

    /** 后反馈设定目标最新更新时间 */
    @Excel(name = "后反馈设定目标最新更新时间")
    private String startTime;

    /** 硝酸盐后反馈控制目标 */
    @Excel(name = "硝酸盐后反馈控制目标")
    private Long feedbackXsy;

    /** 缺氧区出水硝酸盐+缺氧区出水氨氮-好氧区出水硝酸盐 */
    @Excel(name = "缺氧区出水硝酸盐+缺氧区出水氨氮-好氧区出水硝酸盐")
    private Long hyNh3;

    /** 后反馈设定告警信息,好氧区出水氨氮<10 触发 */
    @Excel(name = "后反馈设定告警信息,好氧区出水氨氮<10 触发")
    private String warnings;

    /** 历史数据 */
    @Excel(name = "历史数据")
    private String history;

    /** 硝酸盐后反馈控制目标变化监控次数 */
    @Excel(name = "硝酸盐后反馈控制目标变化监控次数")
    private Long times;

    /** 监控状态:与最新的硝酸盐后反馈控制目标比较标记 */
    @Excel(name = "监控状态:与最新的硝酸盐后反馈控制目标比较标记")
    private Long flag;

    /** 记录变化过程信息 */
    @Excel(name = "记录变化过程信息")
    private String ext;

    public void setId(Long id) 
    {
        this.id = id;
    }

    public Long getId() 
    {
        return id;
    }
    public void setReqTime(String reqTime) 
    {
        this.reqTime = reqTime;
    }

    public String getReqTime() 
    {
        return reqTime;
    }
    public void setStartTime(String startTime) 
    {
        this.startTime = startTime;
    }

    public String getStartTime() 
    {
        return startTime;
    }
    public void setFeedbackXsy(Long feedbackXsy) 
    {
        this.feedbackXsy = feedbackXsy;
    }

    public Long getFeedbackXsy() 
    {
        return feedbackXsy;
    }
    public void setHyNh3(Long hyNh3) 
    {
        this.hyNh3 = hyNh3;
    }

    public Long getHyNh3() 
    {
        return hyNh3;
    }
    public void setWarnings(String warnings) 
    {
        this.warnings = warnings;
    }

    public String getWarnings() 
    {
        return warnings;
    }
    public void setHistory(String history) 
    {
        this.history = history;
    }

    public String getHistory() 
    {
        return history;
    }
    public void setTimes(Long times) 
    {
        this.times = times;
    }

    public Long getTimes() 
    {
        return times;
    }
    public void setFlag(Long flag) 
    {
        this.flag = flag;
    }

    public Long getFlag() 
    {
        return flag;
    }
    public void setExt(String ext) 
    {
        this.ext = ext;
    }

    public String getExt() 
    {
        return ext;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this,ToStringStyle.MULTI_LINE_STYLE)
            .append("id", getId())
            .append("reqTime", getReqTime())
            .append("updateTime", getUpdateTime())
            .append("startTime", getStartTime())
            .append("feedbackXsy", getFeedbackXsy())
            .append("hyNh3", getHyNh3())
            .append("warnings", getWarnings())
            .append("history", getHistory())
            .append("times", getTimes())
            .append("flag", getFlag())
            .append("ext", getExt())
            .toString();
    }
}
