package com.slibra.business.mapper;

import java.util.List;
import com.slibra.business.domain.TJlPredict;

/**
 * 机理预测配置Mapper接口
 * 
 * @author slibra
 * @date 2025-04-22
 */
public interface TJlPredictMapper 
{
    /**
     * 查询机理预测配置
     * 
     * @param id 机理预测配置主键
     * @return 机理预测配置
     */
    public TJlPredict selectTJlPredictById(Long id);

    /**
     * 查询机理预测配置列表
     * 
     * @param tJlPredict 机理预测配置
     * @return 机理预测配置集合
     */
    public List<TJlPredict> selectTJlPredictList(TJlPredict tJlPredict);

    /**
     * 新增机理预测配置
     * 
     * @param tJlPredict 机理预测配置
     * @return 结果
     */
    public int insertTJlPredict(TJlPredict tJlPredict);

    /**
     * 修改机理预测配置
     * 
     * @param tJlPredict 机理预测配置
     * @return 结果
     */
    public int updateTJlPredict(TJlPredict tJlPredict);

    /**
     * 删除机理预测配置
     * 
     * @param id 机理预测配置主键
     * @return 结果
     */
    public int deleteTJlPredictById(Long id);

    /**
     * 批量删除机理预测配置
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteTJlPredictByIds(Long[] ids);

    public int deleteAll();
}
