package com.slibra.business.mapper;

import java.util.List;
import com.slibra.business.domain.TPredictConf;

/**
 * 机理模型预测配置Mapper接口
 * 
 * @author slibra
 * @date 2025-02-11
 */
public interface TPredictConfMapper 
{
    /**
     * 查询机理模型预测配置
     * 
     * @param id 机理模型预测配置主键
     * @return 机理模型预测配置
     */
    public TPredictConf selectTPredictConfById(Long id);

    /**
     * 查询机理模型预测配置列表
     * 
     * @param tPredictConf 机理模型预测配置
     * @return 机理模型预测配置集合
     */
    public List<TPredictConf> selectTPredictConfList(TPredictConf tPredictConf);

    /**
     * 新增机理模型预测配置
     * 
     * @param tPredictConf 机理模型预测配置
     * @return 结果
     */
    public int insertTPredictConf(TPredictConf tPredictConf);

    /**
     * 修改机理模型预测配置
     * 
     * @param tPredictConf 机理模型预测配置
     * @return 结果
     */
    public int updateTPredictConf(TPredictConf tPredictConf);

    /**
     * 删除机理模型预测配置
     * 
     * @param id 机理模型预测配置主键
     * @return 结果
     */
    public int deleteTPredictConfById(Long id);

    /**
     * 批量删除机理模型预测配置
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteTPredictConfByIds(Long[] ids);
}
