package com.slibra.business.mapper;

import java.util.List;
import com.slibra.business.domain.TXinyiAgentAssistant;

/**
 * 信义智能体助手配置Mapper接口
 * 
 * @author slibra
 * @date 2024-05-17
 */
public interface TXinyiAgentAssistantMapper 
{
    /**
     * 查询信义智能体助手配置
     * 
     * @param id 信义智能体助手配置主键
     * @return 信义智能体助手配置
     */
    public TXinyiAgentAssistant selectTXinyiAgentAssistantById(Long id);

    /**
     * 查询信义智能体助手配置列表
     * 
     * @param tXinyiAgentAssistant 信义智能体助手配置
     * @return 信义智能体助手配置集合
     */
    public List<TXinyiAgentAssistant> selectTXinyiAgentAssistantList(TXinyiAgentAssistant tXinyiAgentAssistant);

    /**
     * 新增信义智能体助手配置
     * 
     * @param tXinyiAgentAssistant 信义智能体助手配置
     * @return 结果
     */
    public int insertTXinyiAgentAssistant(TXinyiAgentAssistant tXinyiAgentAssistant);

    /**
     * 修改信义智能体助手配置
     * 
     * @param tXinyiAgentAssistant 信义智能体助手配置
     * @return 结果
     */
    public int updateTXinyiAgentAssistant(TXinyiAgentAssistant tXinyiAgentAssistant);

    /**
     * 删除信义智能体助手配置
     * 
     * @param id 信义智能体助手配置主键
     * @return 结果
     */
    public int deleteTXinyiAgentAssistantById(Long id);

    /**
     * 批量删除信义智能体助手配置
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteTXinyiAgentAssistantByIds(Long[] ids);
}
