package com.slibra.business.mapper;

import java.util.List;
import com.slibra.business.domain.TXinyiBigTableDay;
import com.slibra.business.domain.TXinyiBigTableHour;
import com.slibra.business.domain.TXinyiBigTableMonth;

/**
 * 信义大天维度统计Mapper接口
 * 
 * @author slibra
 * @date 2024-07-07
 */
public interface TXinyiBigTableDayMapper 
{
    /**
     * 查询信义大天维度统计
     * 
     * @param ID 信义大天维度统计主键
     * @return 信义大天维度统计
     */
    public TXinyiBigTableDay selectTXinyiBigTableDayByID(Long ID);

    /**
     * 查询信义大天维度统计列表
     * 
     * @param tXinyiBigTableDay 信义大天维度统计
     * @return 信义大天维度统计集合
     */
    public List<TXinyiBigTableDay> selectTXinyiBigTableDayList(TXinyiBigTableDay tXinyiBigTableDay);

    /**
     * 新增信义大天维度统计
     * 
     * @param tXinyiBigTableDay 信义大天维度统计
     * @return 结果
     */
    public int insertTXinyiBigTableDay(TXinyiBigTableDay tXinyiBigTableDay);

    /**
     * 修改信义大天维度统计
     * 
     * @param tXinyiBigTableDay 信义大天维度统计
     * @return 结果
     */
    public int updateTXinyiBigTableDay(TXinyiBigTableDay tXinyiBigTableDay);

    /**
     * 删除信义大天维度统计
     * 
     * @param ID 信义大天维度统计主键
     * @return 结果
     */
    public int deleteTXinyiBigTableDayByID(Long ID);

    /**
     * 批量删除信义大天维度统计
     * 
     * @param IDs 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteTXinyiBigTableDayByIDs(Long[] IDs);

    TXinyiBigTableDay selectAvgByDay(String day);

    List<TXinyiBigTableMonth> selectTXinyiBigTableDayByMonthAvg();

    TXinyiBigTableDay selectTXinyiBigTableHourAvg(String testDate);
}
