package com.slibra.business.mapper;

import java.util.List;
import com.slibra.business.domain.TXinyiCalculate;

/**
 * 信义计算数据Mapper接口
 * 
 * @author slibra
 * @date 2024-06-07
 */
public interface TXinyiCalculateMapper 
{
    /**
     * 查询信义计算数据
     * 
     * @param id 信义计算数据主键
     * @return 信义计算数据
     */
    public TXinyiCalculate selectTXinyiCalculateById(Long id);

    /**
     * 查询信义计算数据列表
     * 
     * @param tXinyiCalculate 信义计算数据
     * @return 信义计算数据集合
     */
    public List<TXinyiCalculate> selectTXinyiCalculateList(TXinyiCalculate tXinyiCalculate);

    /**
     * 新增信义计算数据
     * 
     * @param tXinyiCalculate 信义计算数据
     * @return 结果
     */
    public int insertTXinyiCalculate(TXinyiCalculate tXinyiCalculate);

    /**
     * 修改信义计算数据
     * 
     * @param tXinyiCalculate 信义计算数据
     * @return 结果
     */
    public int updateTXinyiCalculate(TXinyiCalculate tXinyiCalculate);

    /**
     * 删除信义计算数据
     * 
     * @param id 信义计算数据主键
     * @return 结果
     */
    public int deleteTXinyiCalculateById(Long id);

    /**
     * 批量删除信义计算数据
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteTXinyiCalculateByIds(Long[] ids);

    Integer insertBatchData(List<TXinyiCalculate> tempInsertData);
}
