package com.slibra.business.mapper;

import java.util.List;
import com.slibra.business.domain.TXinyiCarbonExtra;

/**
 * 碳排放关联其他计算指标Mapper接口
 * 
 * @author slibra
 * @date 2024-08-26
 */
public interface TXinyiCarbonExtraMapper 
{
    /**
     * 查询碳排放关联其他计算指标
     * 
     * @param id 碳排放关联其他计算指标主键
     * @return 碳排放关联其他计算指标
     */
    public TXinyiCarbonExtra selectTXinyiCarbonExtraById(Long id);

    /**
     * 查询碳排放关联其他计算指标列表
     * 
     * @param tXinyiCarbonExtra 碳排放关联其他计算指标
     * @return 碳排放关联其他计算指标集合
     */
    public List<TXinyiCarbonExtra> selectTXinyiCarbonExtraList(TXinyiCarbonExtra tXinyiCarbonExtra);

    /**
     * 新增碳排放关联其他计算指标
     * 
     * @param tXinyiCarbonExtra 碳排放关联其他计算指标
     * @return 结果
     */
    public int insertTXinyiCarbonExtra(TXinyiCarbonExtra tXinyiCarbonExtra);

    /**
     * 修改碳排放关联其他计算指标
     * 
     * @param tXinyiCarbonExtra 碳排放关联其他计算指标
     * @return 结果
     */
    public int updateTXinyiCarbonExtra(TXinyiCarbonExtra tXinyiCarbonExtra);

    /**
     * 删除碳排放关联其他计算指标
     * 
     * @param id 碳排放关联其他计算指标主键
     * @return 结果
     */
    public int deleteTXinyiCarbonExtraById(Long id);

    /**
     * 批量删除碳排放关联其他计算指标
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteTXinyiCarbonExtraByIds(Long[] ids);
}
