package com.slibra.business.mapper;

import java.math.BigDecimal;
import java.util.List;
import com.slibra.business.domain.TXinyiCarbonMajor;
import com.slibra.business.res.CarbonSmartQueryDB;

/**
 * 碳排放主Mapper接口
 * 
 * @author slibra
 * @date 2024-08-24
 */
public interface TXinyiCarbonMajorMapper 
{
    /**
     * 查询碳排放主
     * 
     * @param id 碳排放主主键
     * @return 碳排放主
     */
    public TXinyiCarbonMajor selectTXinyiCarbonMajorById(Long id);

    /**
     * 查询碳排放主列表
     * 
     * @param tXinyiCarbonMajor 碳排放主
     * @return 碳排放主集合
     */
    public List<TXinyiCarbonMajor> selectTXinyiCarbonMajorList(TXinyiCarbonMajor tXinyiCarbonMajor);

    /**
     * 新增碳排放主
     * 
     * @param tXinyiCarbonMajor 碳排放主
     * @return 结果
     */
    public int insertTXinyiCarbonMajor(TXinyiCarbonMajor tXinyiCarbonMajor);

    /**
     * 修改碳排放主
     * 
     * @param tXinyiCarbonMajor 碳排放主
     * @return 结果
     */
    public int updateTXinyiCarbonMajor(TXinyiCarbonMajor tXinyiCarbonMajor);

    /**
     * 删除碳排放主
     * 
     * @param id 碳排放主主键
     * @return 结果
     */
    public int deleteTXinyiCarbonMajorById(Long id);

    /**
     * 批量删除碳排放主
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteTXinyiCarbonMajorByIds(Long[] ids);

    List<String> allMonths();

    CarbonSmartQueryDB getDBDatasByMonth(String month);

    BigDecimal selectSumJslByMonth(String month);

    BigDecimal selectAvgCodByMonth(String month);

}
