package com.slibra.business.mapper;

import com.slibra.common.core.domain.TXinyiDaily;
import org.apache.ibatis.annotations.Param;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.List;

/**
 * 信义日报数据Mapper接口
 * 
 * @author slibra
 * @date 2024-04-13
 */
public interface TXinyiDailyMapper 
{
    /**
     * 查询信义日报数据
     * 
     * @param ID 信义日报数据主键
     * @return 信义日报数据
     */
    public TXinyiDaily selectTXinyiDailyByID(Long ID);

    /**
     * 查询信义日报数据列表
     * 
     * @param tXinyiDaily 信义日报数据
     * @return 信义日报数据集合
     */
    public List<TXinyiDaily> selectTXinyiDailyList(TXinyiDaily tXinyiDaily);

    /**
     * 新增信义日报数据
     * 
     * @param tXinyiDaily 信义日报数据
     * @return 结果
     */
    public int insertTXinyiDaily(TXinyiDaily tXinyiDaily);

    /**
     * 修改信义日报数据
     * 
     * @param tXinyiDaily 信义日报数据
     * @return 结果
     */
    public int updateTXinyiDaily(TXinyiDaily tXinyiDaily);

    /**
     * 删除信义日报数据
     * 
     * @param ID 信义日报数据主键
     * @return 结果
     */
    public int deleteTXinyiDailyByID(Long ID);

    /**
     * 批量删除信义日报数据
     * 
     * @param IDs 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteTXinyiDailyByIDs(Long[] IDs);

    HashMap<String, BigDecimal> selectAvgWater(@Param("begin") String begin, @Param("end") String end);

    TXinyiDaily selectNewestData();

    List<TXinyiDaily> selectNRecords(int size);

    TXinyiDaily getDetailByDay(String testDate);
}
