package com.slibra.business.mapper;

import java.util.Date;
import java.util.List;
import com.slibra.business.domain.TXinyiForecastComparison;
import com.slibra.business.res.ChartBasic;

/**
 * 信义预测对比Mapper接口
 * 
 * @author slibra
 * @date 2024-06-18
 */
public interface TXinyiForecastComparisonMapper 
{
    /**
     * 查询信义预测对比
     * 
     * @param id 信义预测对比主键
     * @return 信义预测对比
     */
    public TXinyiForecastComparison selectTXinyiForecastComparisonById(Long id);

    /**
     * 查询信义预测对比列表
     * 
     * @param tXinyiForecastComparison 信义预测对比
     * @return 信义预测对比集合
     */
    public List<TXinyiForecastComparison> selectTXinyiForecastComparisonList(TXinyiForecastComparison tXinyiForecastComparison);

    /**
     * 新增信义预测对比
     * 
     * @param tXinyiForecastComparison 信义预测对比
     * @return 结果
     */
    public int insertTXinyiForecastComparison(TXinyiForecastComparison tXinyiForecastComparison);

    /**
     * 修改信义预测对比
     * 
     * @param tXinyiForecastComparison 信义预测对比
     * @return 结果
     */
    public int updateTXinyiForecastComparison(TXinyiForecastComparison tXinyiForecastComparison);

    /**
     * 删除信义预测对比
     * 
     * @param id 信义预测对比主键
     * @return 结果
     */
    public int deleteTXinyiForecastComparisonById(Long id);

    /**
     * 批量删除信义预测对比
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteTXinyiForecastComparisonByIds(Long[] ids);

    TXinyiForecastComparison selectNewestForecastComparison(String category);

    List<ChartBasic> selectOneValAndTimeByDate(String category);
}
