package com.slibra.business.mapper;

import java.util.List;
import com.slibra.business.domain.TXinyiLaboratory;

/**
 * 信义化验数据;Mapper接口
 * 
 * @author slibra
 * @date 2024-03-27
 */
public interface TXinyiLaboratoryMapper 
{
    /**
     * 查询信义化验数据;
     * 
     * @param ID 信义化验数据;主键
     * @return 信义化验数据;
     */
    public TXinyiLaboratory selectTXinyiLaboratoryByID(Long ID);

    /**
     * 查询信义化验数据;列表
     * 
     * @param tXinyiLaboratory 信义化验数据;
     * @return 信义化验数据;集合
     */
    public List<TXinyiLaboratory> selectTXinyiLaboratoryList(TXinyiLaboratory tXinyiLaboratory);

    /**
     * 新增信义化验数据;
     * 
     * @param tXinyiLaboratory 信义化验数据;
     * @return 结果
     */
    public int insertTXinyiLaboratory(TXinyiLaboratory tXinyiLaboratory);

    /**
     * 修改信义化验数据;
     * 
     * @param tXinyiLaboratory 信义化验数据;
     * @return 结果
     */
    public int updateTXinyiLaboratory(TXinyiLaboratory tXinyiLaboratory);

    /**
     * 删除信义化验数据;
     * 
     * @param ID 信义化验数据;主键
     * @return 结果
     */
    public int deleteTXinyiLaboratoryByID(Long ID);

    /**
     * 批量删除信义化验数据;
     * 
     * @param IDs 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteTXinyiLaboratoryByIDs(Long[] IDs);


    TXinyiLaboratory getUniqueByDate(String date);

}
