package com.slibra.business.mapper;

import java.util.List;
import com.slibra.business.domain.TXinyiMedicineRemote;
import com.slibra.business.req.MedicineParamsDetail;

/**
 * 调参逻辑设定Mapper接口
 * 
 * @author slibra
 * @date 2025-04-23
 */
public interface TXinyiMedicineRemoteMapper 
{
    /**
     * 查询调参逻辑设定
     * 
     * @param id 调参逻辑设定主键
     * @return 调参逻辑设定
     */
    public TXinyiMedicineRemote selectTXinyiMedicineRemoteById(Long id);

    /**
     * 查询调参逻辑设定列表
     * 
     * @param tXinyiMedicineRemote 调参逻辑设定
     * @return 调参逻辑设定集合
     */
    public List<TXinyiMedicineRemote> selectTXinyiMedicineRemoteList(TXinyiMedicineRemote tXinyiMedicineRemote);

    /**
     * 新增调参逻辑设定
     * 
     * @param tXinyiMedicineRemote 调参逻辑设定
     * @return 结果
     */
    public int insertTXinyiMedicineRemote(TXinyiMedicineRemote tXinyiMedicineRemote);

    /**
     * 修改调参逻辑设定
     * 
     * @param tXinyiMedicineRemote 调参逻辑设定
     * @return 结果
     */
    public int updateTXinyiMedicineRemote(TXinyiMedicineRemote tXinyiMedicineRemote);

    /**
     * 删除调参逻辑设定
     * 
     * @param id 调参逻辑设定主键
     * @return 结果
     */
    public int deleteTXinyiMedicineRemoteById(Long id);

    /**
     * 批量删除调参逻辑设定
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteTXinyiMedicineRemoteByIds(Long[] ids);

    TXinyiMedicineRemote getLatestRecord();
}
