package com.slibra.business.mapper;

import java.util.List;
import com.slibra.business.domain.TXinyiPhosphorus;

/**
 * 信义正磷Mapper接口
 * 
 * @author slibra
 * @date 2024-03-27
 */
public interface TXinyiPhosphorusMapper 
{
    /**
     * 查询信义正磷
     * 
     * @param ID 信义正磷主键
     * @return 信义正磷
     */
    public TXinyiPhosphorus selectTXinyiPhosphorusByID(Long ID);

    /**
     * 查询信义正磷列表
     * 
     * @param tXinyiPhosphorus 信义正磷
     * @return 信义正磷集合
     */
    public List<TXinyiPhosphorus> selectTXinyiPhosphorusList(TXinyiPhosphorus tXinyiPhosphorus);

    /**
     * 新增信义正磷
     * 
     * @param tXinyiPhosphorus 信义正磷
     * @return 结果
     */
    public int insertTXinyiPhosphorus(TXinyiPhosphorus tXinyiPhosphorus);

    /**
     * 修改信义正磷
     * 
     * @param tXinyiPhosphorus 信义正磷
     * @return 结果
     */
    public int updateTXinyiPhosphorus(TXinyiPhosphorus tXinyiPhosphorus);

    /**
     * 删除信义正磷
     * 
     * @param ID 信义正磷主键
     * @return 结果
     */
    public int deleteTXinyiPhosphorusByID(Long ID);

    /**
     * 批量删除信义正磷
     * 
     * @param IDs 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteTXinyiPhosphorusByIDs(Long[] IDs);
}
