package com.slibra.business.mapper;

import java.util.List;
import com.slibra.business.domain.TXinyiTytjParams;

/**
 * 信义碳源投加参数配置Mapper接口
 * 
 * @author slibra
 * @date 2025-04-23
 */
public interface TXinyiTytjParamsMapper 
{
    /**
     * 查询信义碳源投加参数配置
     * 
     * @param id 信义碳源投加参数配置主键
     * @return 信义碳源投加参数配置
     */
    public TXinyiTytjParams selectTXinyiTytjParamsById(Long id);

    /**
     * 查询信义碳源投加参数配置列表
     * 
     * @param tXinyiTytjParams 信义碳源投加参数配置
     * @return 信义碳源投加参数配置集合
     */
    public List<TXinyiTytjParams> selectTXinyiTytjParamsList(TXinyiTytjParams tXinyiTytjParams);

    /**
     * 新增信义碳源投加参数配置
     * 
     * @param tXinyiTytjParams 信义碳源投加参数配置
     * @return 结果
     */
    public int insertTXinyiTytjParams(TXinyiTytjParams tXinyiTytjParams);

    /**
     * 修改信义碳源投加参数配置
     * 
     * @param tXinyiTytjParams 信义碳源投加参数配置
     * @return 结果
     */
    public int updateTXinyiTytjParams(TXinyiTytjParams tXinyiTytjParams);

    /**
     * 删除信义碳源投加参数配置
     * 
     * @param id 信义碳源投加参数配置主键
     * @return 结果
     */
    public int deleteTXinyiTytjParamsById(Long id);

    /**
     * 批量删除信义碳源投加参数配置
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteTXinyiTytjParamsByIds(Long[] ids);
}
