package com.slibra.business.mapper;

import java.util.List;
import com.slibra.business.domain.TXinyiWarningRecord;
import org.apache.ibatis.annotations.Param;

/**
 * 信义告警记录Mapper接口
 * 
 * @author slibra
 * @date 2024-05-17
 */
public interface TXinyiWarningRecordMapper 
{
    /**
     * 查询信义告警记录
     * 
     * @param id 信义告警记录主键
     * @return 信义告警记录
     */
    public TXinyiWarningRecord selectTXinyiWarningRecordById(Long id);

    /**
     * 查询信义告警记录列表
     * 
     * @param tXinyiWarningRecord 信义告警记录
     * @return 信义告警记录集合
     */
    public List<TXinyiWarningRecord> selectTXinyiWarningRecordList(TXinyiWarningRecord tXinyiWarningRecord);

    /**
     * 新增信义告警记录
     * 
     * @param tXinyiWarningRecord 信义告警记录
     * @return 结果
     */
    public int insertTXinyiWarningRecord(TXinyiWarningRecord tXinyiWarningRecord);

    /**
     * 修改信义告警记录
     * 
     * @param tXinyiWarningRecord 信义告警记录
     * @return 结果
     */
    public int updateTXinyiWarningRecord(TXinyiWarningRecord tXinyiWarningRecord);

    /**
     * 删除信义告警记录
     * 
     * @param id 信义告警记录主键
     * @return 结果
     */
    public int deleteTXinyiWarningRecordById(Long id);

    /**
     * 批量删除信义告警记录
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteTXinyiWarningRecordByIds(Long[] ids);

    int getWarningCountByType(int type);

    List<TXinyiWarningRecord> homeWarningList();

    /**
     * 通过报警类型 获取非工业同步失败和化验失败的 全部报警数据
     * @param symbol
     * @return
     */
    List<TXinyiWarningRecord> getOtherWarningsBySymbol(Integer symbol);

    List<TXinyiWarningRecord> getOtherWarningsByCategory(@Param("category") String category, @Param("symbol") Integer symbol);
}
