package com.slibra.business.res;


import com.baomidou.mybatisplus.annotation.TableField;
import com.slibra.common.annotation.Excel;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;

@Builder
@Data
@AllArgsConstructor
@NoArgsConstructor
public class CarbonMajorSimple {


    /** 所属年月（2024-02） */
    @Excel(name = "核算日期", readConverterExp = "2=024-02")
    private String addYearMonth;

    /** 总碳排放量 */
    @Excel(name = "总碳排放量")
    private BigDecimal ztTotalCo2;

    /** 污水处理碳排放量 */
    @Excel(name = "污水处理碳排放量")
    private BigDecimal wsclTotalCo2;

    /** 能源、药剂碳排量 */
    @Excel(name = "能源、药剂碳排量")
    private BigDecimal nyyjTotalCo2;

    /** 污泥处理碳排量 */
    @Excel(name = "污泥处理碳排量")
    private BigDecimal wnclTotalCo2;

    /** 替碳、碳汇替碳量 */
    @Excel(name = "替碳、碳汇替碳量")
    private BigDecimal ttthTotalCo2;

    /** 创建者 */
    @Excel(name = "录入人员")
    private String createBy;

    /** 备注，这里存放的是 填报日期 */
    @Excel(name = "填报日期")
    private String remark;



}
