package com.slibra.business.res;

import com.slibra.common.annotation.Excel;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;

@Builder
@Data
@AllArgsConstructor
@NoArgsConstructor
public class IndustrySimpleBean {

    /** 主键 */
    private Long ID;

    /** 化验时间 精确到小时 */
    @Excel(name = "化验时间 精确到小时")
    private String testHour;

    /** 进水化学需氧量COD */
    @Excel(name = "进水化学需氧量COD")
    private BigDecimal jsCod;

    /** 出水化学需氧量COD */
    @Excel(name = "出水化学需氧量COD")
    private BigDecimal csCod;

    /** 进水氨氮NH₃-N */
    @Excel(name = "进水氨氮NH₃-N")
    private BigDecimal jsNh3;

    /** 出水氨氮NH₃-N */
    @Excel(name = "出水氨氮NH₃-N")
    private BigDecimal csNh3;

    /** 进水总氮TN */
    @Excel(name = "进水总氮TN")
    private BigDecimal jsTn;

    /** 出水总氮TN */
    @Excel(name = "出水总氮TN")
    private BigDecimal csTn;

    /** 进水总磷TP */
    @Excel(name = "进水总磷TP")
    private BigDecimal jsTp;

    /** 出水总磷TP */
    @Excel(name = "出水总磷TP")
    private BigDecimal csTp;

    /** 进水悬浮物SS */
    @Excel(name = "进水悬浮物SS")
    private BigDecimal jsSs;

    /** 出水悬浮物SS */
    @Excel(name = "出水悬浮物SS")
    private BigDecimal csSs;

    /** 进水酸碱度pH */
    @Excel(name = "进水酸碱度pH")
    private BigDecimal jsPh;

    /** 出水酸碱度pH */
    @Excel(name = "出水酸碱度pH")
    private BigDecimal csPh;

    /** 进水水量Q进 */
    @Excel(name = "进水水量Q进")
    private BigDecimal jsSlq;

    /** 出水水量Q出 */
    @Excel(name = "出水水量Q出")
    private BigDecimal csSlqc;
}
