package com.slibra.business.res;


import com.slibra.common.annotation.Excel;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;

@Builder
@Data
@AllArgsConstructor
@NoArgsConstructor
public class MedicineChart {


    /** 化验时间 精确到小时 */
    private String testHour;

    /** 进水水量Q进 */
    private BigDecimal jsSlq;

    /** 1#好氧池硝酸盐（内回流）+ 回流进水化验机器人有效值1（硝氮1池回流机器人） */
    private BigDecimal no3Hlj1Jqr;

    /** 2#好氧池硝酸盐（内回流） + 回流进水化验机器人有效值2（硝氮2池回流机器人） */
    private BigDecimal no3Hlj2Jqr;

    /** 1#缺氧氨氮 + 化验机器人氨氮化验有效值1（氨氮1池缺氧机器人） */
    private BigDecimal nh31Jqr;

    /** 2#缺氧氨氮 + 化验机器人氨氮化验有效值2（氨氮2池缺氧机器人） */
    private BigDecimal nh32Jqr;

    /** 进水化学需氧量COD-仪表 */
    private BigDecimal jsCod;

    /** 仪表COD-化验室（连续检测） */
    private BigDecimal codYb;

    /** 进水总氮TN */
    private BigDecimal jsTn;

    //2025年05月07日17:39:58 新增的统计值
    /** 1#缺氧出口硝酸盐 */
    private BigDecimal no3Qyc1Jqr;

    /** 2#缺氧出-硝酸盐 */
    private BigDecimal no3Qyc2Jqr;

    /** 质控值下限 */
    private BigDecimal zkzDown;

    /** 质控值下限 */
    private BigDecimal zkzUp;

    /** 组态是否允许投放 */
    private Boolean canAdd;

    /** 控制系数 */
    @Excel(name = "控制系数")
    private BigDecimal kzxs;

    /** 后台反馈设定 */
    @Excel(name = "后台反馈设定")
    private BigDecimal htfksd;



}
