package com.slibra.business.res;


import com.slibra.common.annotation.Excel;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;

@Builder
@Data
@AllArgsConstructor
@NoArgsConstructor
public class MedicineRemote {


    private BigDecimal kzxs;//控制系数

    private BigDecimal htfksd;//后反馈设定

    private BigDecimal calculateVal;//计算投药量

    private Integer choosePool;//用户选择的采用的哪个池子投药 0一池 1二池 2自动 3手动

    private Integer addPool;//真实的投药池子（自动的话，2选1）0一池 1二池

    //2025年05月09日17:41:38 额外存储的字段

    /** 采用控制系数ID */
    @Excel(name = "采用控制系数ID")
    private Long relativeId;

    /** 1池控制系数 */
    @Excel(name = "1池控制系数")
    private BigDecimal oneKzxs;

    /** 2池控制系数 */
    @Excel(name = "2池控制系数")
    private BigDecimal twoKzxs;

    /** 1池后反馈设定 */
    @Excel(name = "1池后反馈设定")
    private BigDecimal oneHtfksd;

    /** 2池后反馈设定 */
    @Excel(name = "2池后反馈设定")
    private BigDecimal twoHtfksd;

    /** 1池碳源投加值 */
    @Excel(name = "1池碳源投加值")
    private BigDecimal oneVal;

    /** 2池碳源投加值 */
    @Excel(name = "2池碳源投加值")
    private BigDecimal twoVal;


}
