package com.slibra.business.res;

import com.slibra.common.annotation.Excel;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;

@Builder
@Data
@AllArgsConstructor
@NoArgsConstructor
public class RobotSimpleBean {

    /** 主键 */
    private Long ID;

    /** 化验时间 精确到小时 */
    @Excel(name = "化验时间 精确到小时")
    private String testHour;

    /** 1#好氧池硝酸盐（内回流）+ 回流进水化验机器人有效值1（硝氮1池回流机器人） */
    @Excel(name = "1#好氧池硝酸盐", readConverterExp = "内=回流")
    private BigDecimal no3Hlj1Jqr;

    /** 2#好氧池硝酸盐（内回流） + 回流进水化验机器人有效值2（硝氮2池回流机器人） */
    @Excel(name = "2#好氧池硝酸盐", readConverterExp = "内=回流")
    private BigDecimal no3Hlj2Jqr;

    /** 二沉池-正磷酸盐 + 化验机器人正磷化验有效值二沉池（正磷二沉池机器人） */
    @Excel(name = "二沉池-正磷酸盐 + 化验机器人正磷化验有效值二沉池", readConverterExp = "正=磷二沉池机器人")
    private BigDecimal tpRccJqr;

    /** 1#缺氧氨氮 + 化验机器人氨氮化验有效值1（氨氮1池缺氧机器人） */
    @Excel(name = "1#缺氧氨氮 + 化验机器人氨氮化验有效值1", readConverterExp = "氨=氮1池缺氧机器人")
    private BigDecimal nh31Jqr;

    /** 2#缺氧氨氮 + 化验机器人氨氮化验有效值2（氨氮2池缺氧机器人） */
    @Excel(name = "2#缺氧氨氮 + 化验机器人氨氮化验有效值2", readConverterExp = "氨=氮2池缺氧机器人")
    private BigDecimal nh32Jqr;
}
