package com.slibra.business.res;


import com.fasterxml.jackson.annotation.JsonIgnore;
import com.slibra.common.annotation.Excel;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;

@Builder
@Data
@AllArgsConstructor
@NoArgsConstructor
public class XinyiIndustrySimple {

    //2024年5月29日17:39:16 新增字段 时间戳
    private long timestamp = System.currentTimeMillis();

    @Excel(name = "化验时间-小时", readConverterExp = "yyyy年MM月dd日 HH:mm")
    private String testHour;

    @JsonIgnore
    /** 化验时间（2023/12/13 5:00:00格式的） */
    @Excel(name = "化验时间", readConverterExp = "2=023/12/13,5=:00:00格式的")
    private String testTime;

    //工业库数据
    /** 进水化学需氧量COD */
    @Excel(name = "进水化学需氧量COD")
    private BigDecimal jsCod;

    /** 出水化学需氧量COD */
    @Excel(name = "出水化学需氧量COD")
    private BigDecimal csCod;


    /** 进水氨氮NH₃-N */
    @Excel(name = "进水氨氮NH₃-N")
    private BigDecimal jsNh3;


    /** 出水氨氮NH₃-N */
    @Excel(name = "出水氨氮NH₃-N")
    private BigDecimal csNh3;


    /** 进水总氮TN */
    @Excel(name = "进水总氮TN")
    private BigDecimal jsTn;

    /** 出水总氮TN */
    @Excel(name = "出水总氮TN")
    private BigDecimal csTn;

    /** 进水总磷TP */
    @Excel(name = "进水总磷TP")
    private BigDecimal jsTp;

    /** 出水总磷TP */
    @Excel(name = "出水总磷TP")
    private BigDecimal csTp;

    /** 进水悬浮物SS */
    @Excel(name = "进水悬浮物SS")
    private BigDecimal jsSs;

    /** 出水悬浮物SS */
    @Excel(name = "出水悬浮物SS")
    private BigDecimal csSs;

    /** 进水酸碱度pH */
    @Excel(name = "进水酸碱度pH")
    private BigDecimal jsPh;

    /** 出水酸碱度pH */
    @Excel(name = "出水酸碱度pH")
    private BigDecimal csPh;

    /** 进水水量Q进 */
    @Excel(name = "进水水量Q进")
    private BigDecimal jsSlq;

    /** 出水水量Q出 */
    @Excel(name = "出水水量Q出")
    private BigDecimal csSlqc;





    //需要计算的
    /** 瞬时进水环比 */
    @Excel(name = "瞬时进水环比")
    private BigDecimal ssJsHb;

    /** 瞬时出水环比 */
    @Excel(name = "瞬时出水环比")
    private BigDecimal ssCsHb;





    //日报获取
    /** 出水生化需氧量BOD₅ */
    @Excel(name = "出水生化需氧量BOD₅")
    private BigDecimal csBod5;

    /** 进水生化需氧量BOD₅ */
    @Excel(name = "进水生化需氧量BOD₅")
    private BigDecimal jsBod5;

    /** 进水水温 */
    @Excel(name = "进水水温")
    private BigDecimal jsSw;

    /** 出水水温 */
    @Excel(name = "出水水温")
    private BigDecimal csSw;


    /** 进水量 */
    @Excel(name = "昨日总进水量")
    private BigDecimal zrZJSL;

    /** 出水量 */
    @Excel(name = "昨日总出水量")
    private BigDecimal zrZCSL;



    /** 昨日总进水环比 */
    @Excel(name = "昨日总进水环比")
    private BigDecimal zrZJsHb;

    /** 昨日总出水环比 */
    @Excel(name = "昨日总出水环比")
    private BigDecimal zrZCsHb;



    /** 上周总进水平均值 */
    @Excel(name = "上周总进水平均值")
    private BigDecimal szZJSAvg;

    /** 上周总进水环比 */
    @Excel(name = "上周总进水环比")
    private BigDecimal szZJSHb;

    /** 上周总出水平均值 */
    @Excel(name = "上周总出水平均值")
    private BigDecimal szZCSAvg;

    /** 上周总出水环比 */
    @Excel(name = "上周总出水环比")
    private BigDecimal szZCSHb;



    //管控值
    /** 进水COD设计值 */
    @Excel(name = "进水COD设计值")
    private BigDecimal jscodSjz;

    /** 出水COD标准值 */
    @Excel(name = "出水COD标准值")
    private BigDecimal cscodBzz;


    /** 进水氨氮设计值 */
    @Excel(name = "进水氨氮设计值")
    private BigDecimal jsadSjz;

    /** 出水氨氮标准值 */
    @Excel(name = "出水氨氮标准值")
    private BigDecimal csadBzz;

    /** 进水总氮设计值 */
    @Excel(name = "进水总氮设计值")
    private BigDecimal jszdSjz;

    /** 出水总氮标准值 */
    @Excel(name = "出水总氮标准值")
    private BigDecimal cszzBzz;

    /** 出水总氮管控值 */
    @Excel(name = "出水总氮管控值")
    private BigDecimal cszzGkz;

    /** 进水总磷设计值 */
    @Excel(name = "进水总磷设计值")
    private BigDecimal jszlSjz;

    /** 出水总磷标准值 */
    @Excel(name = "出水总磷标准值")
    private BigDecimal cszlBzz;

    /** 出水总磷管控值 */
    @Excel(name = "出水总磷管控值")
    private BigDecimal cszlGkz;

    /** 进水SS设计值 */
    @Excel(name = "进水SS设计值")
    private BigDecimal jsssSjz;

    /** 出水SS标准值 */
    @Excel(name = "出水SS标准值")
    private BigDecimal csssBzz;

    /** 出水SS管控值 */
    @Excel(name = "出水SS管控值")
    private BigDecimal csssGkz;


    //2024年6月11日16:28:59 新增返回的一些字段(化验室的数据)
    /** 1#好氧池硝酸盐（内回流）+ 回流进水化验机器人有效值1（硝氮1池回流机器人） */
    @Excel(name = "1#好氧池硝酸盐", readConverterExp = "内=回流")
    private BigDecimal no3Hlj1Jqr;

    /** 2#好氧池硝酸盐（内回流） + 回流进水化验机器人有效值2（硝氮2池回流机器人） */
    @Excel(name = "2#好氧池硝酸盐", readConverterExp = "内=回流")
    private BigDecimal no3Hlj2Jqr;

    /** 二沉池-正磷酸盐 + 化验机器人正磷化验有效值二沉池（正磷二沉池机器人） */
    @Excel(name = "二沉池-正磷酸盐 + 化验机器人正磷化验有效值二沉池", readConverterExp = "正=磷二沉池机器人")
    private BigDecimal tpRccJqr;

    /** 1#缺氧氨氮 + 化验机器人氨氮化验有效值1（氨氮1池缺氧机器人） */
    @Excel(name = "1#缺氧氨氮 + 化验机器人氨氮化验有效值1", readConverterExp = "氨=氮1池缺氧机器人")
    private BigDecimal nh31Jqr;

    /** 2#缺氧氨氮 + 化验机器人氨氮化验有效值2（氨氮2池缺氧机器人） */
    @Excel(name = "2#缺氧氨氮 + 化验机器人氨氮化验有效值2", readConverterExp = "氨=氮2池缺氧机器人")
    private BigDecimal nh32Jqr;

    //2024年12月24日14:01:42 新增字段，累计出水总量【统计的是今日的所有的工业库的出水水量】
    private BigDecimal totalTodayCSL;

}
