package com.slibra.business.service;

import com.alibaba.fastjson2.JSONObject;
import com.slibra.business.domain.*;
import com.slibra.business.req.ChatReq;
import com.slibra.business.req.WorkOrderReq;
import com.slibra.business.res.*;

import java.util.List;
import java.util.Map;
import java.util.Objects;

/**
 * 信义日报数据Service接口
 * 
 * @author slibra
 * @date 2024-04-13
 */
public interface IFrontService
{

    XinyiIndustrySimple countInfo();

    List<String> warningCount();

    List<TXinyiWarningRecord> homeWarningList();

    List<TXinyiRecommendQa> recommendQAList(Integer type);

    TXinyiChatRecord qaDetailByWarningId(String warningId);

    String isSatisfiedAnswer(ChatReq chatReq);

    String handleWarningByMan(TXinyiWarningRecord warningRecord);

    TXinyiChatRecord getLeastShortReport();

    List<TXinyiChatRecord> forecastList(String warningId);

    XinyiDailyFeeSimple recentlyOneFeeInfo();

    List<WorkOrderRes> customWorkOrder(WorkOrderReq workOrderReq);

    JSONObject customWorkOrderHandle(WorkOrderReq workOrderReq);

    JSONObject customWorkOrderHandleByData(WorkOrderReq workOrderReq, List<WorkOrderRes> workOrderRes);

    String stopChat(String sessionId);

    SmartAdd smartAddDataInfo();

    Map<String, List<ChartBasic>> smartAddCharList(int type, String timeBegin, String timeEnd);

    List<AutoFeedback> configPredict(List<TJlPredict> tJlPredicts);

    List<MedicineChart> smartAddCharListNew(String timeBegin, String timeEnd);

    List<TXinyiMedicineAddRecord> addMedicineRecordList(String timeBegin, String timeEnd);
}
