package com.slibra.business.service;

import java.util.List;
import com.slibra.business.domain.TXinyiBigTableDay;

/**
 * 信义大天维度统计Service接口
 * 
 * @author slibra
 * @date 2024-07-07
 */
public interface ITXinyiBigTableDayService 
{
    /**
     * 查询信义大天维度统计
     * 
     * @param ID 信义大天维度统计主键
     * @return 信义大天维度统计
     */
    public TXinyiBigTableDay selectTXinyiBigTableDayByID(Long ID);

    /**
     * 查询信义大天维度统计列表
     * 
     * @param tXinyiBigTableDay 信义大天维度统计
     * @return 信义大天维度统计集合
     */
    public List<TXinyiBigTableDay> selectTXinyiBigTableDayList(TXinyiBigTableDay tXinyiBigTableDay);

    /**
     * 新增信义大天维度统计
     * 
     * @param tXinyiBigTableDay 信义大天维度统计
     * @return 结果
     */
    public int insertTXinyiBigTableDay(TXinyiBigTableDay tXinyiBigTableDay);

    /**
     * 修改信义大天维度统计
     * 
     * @param tXinyiBigTableDay 信义大天维度统计
     * @return 结果
     */
    public int updateTXinyiBigTableDay(TXinyiBigTableDay tXinyiBigTableDay);

    /**
     * 批量删除信义大天维度统计
     * 
     * @param IDs 需要删除的信义大天维度统计主键集合
     * @return 结果
     */
    public int deleteTXinyiBigTableDayByIDs(Long[] IDs);

    /**
     * 删除信义大天维度统计信息
     * 
     * @param ID 信义大天维度统计主键
     * @return 结果
     */
    public int deleteTXinyiBigTableDayByID(Long ID);
}
