package com.slibra.business.service;

import java.util.List;
import com.slibra.business.domain.TXinyiBigTableHour;

/**
 * 信义大小时维度统计Service接口
 * 
 * @author slibra
 * @date 2024-07-03
 */
public interface ITXinyiBigTableHourService 
{
    /**
     * 查询信义大小时维度统计
     * 
     * @param ID 信义大小时维度统计主键
     * @return 信义大小时维度统计
     */
    public TXinyiBigTableHour selectTXinyiBigTableHourByID(Long ID);

    /**
     * 查询信义大小时维度统计列表
     * 
     * @param tXinyiBigTableHour 信义大小时维度统计
     * @return 信义大小时维度统计集合
     */
    public List<TXinyiBigTableHour> selectTXinyiBigTableHourList(TXinyiBigTableHour tXinyiBigTableHour);

    /**
     * 新增信义大小时维度统计
     * 
     * @param tXinyiBigTableHour 信义大小时维度统计
     * @return 结果
     */
    public int insertTXinyiBigTableHour(TXinyiBigTableHour tXinyiBigTableHour);

    /**
     * 修改信义大小时维度统计
     * 
     * @param tXinyiBigTableHour 信义大小时维度统计
     * @return 结果
     */
    public int updateTXinyiBigTableHour(TXinyiBigTableHour tXinyiBigTableHour);

    /**
     * 批量删除信义大小时维度统计
     * 
     * @param IDs 需要删除的信义大小时维度统计主键集合
     * @return 结果
     */
    public int deleteTXinyiBigTableHourByIDs(Long[] IDs);

    /**
     * 删除信义大小时维度统计信息
     * 
     * @param ID 信义大小时维度统计主键
     * @return 结果
     */
    public int deleteTXinyiBigTableHourByID(Long ID);
}
