package com.slibra.business.service;

import java.util.List;
import com.slibra.business.domain.TXinyiBigTableMonth;

/**
 * 信义大月维度统计Service接口
 * 
 * @author slibra
 * @date 2024-07-07
 */
public interface ITXinyiBigTableMonthService 
{
    /**
     * 查询信义大月维度统计
     * 
     * @param ID 信义大月维度统计主键
     * @return 信义大月维度统计
     */
    public TXinyiBigTableMonth selectTXinyiBigTableMonthByID(Long ID);

    /**
     * 查询信义大月维度统计列表
     * 
     * @param tXinyiBigTableMonth 信义大月维度统计
     * @return 信义大月维度统计集合
     */
    public List<TXinyiBigTableMonth> selectTXinyiBigTableMonthList(TXinyiBigTableMonth tXinyiBigTableMonth);

    /**
     * 新增信义大月维度统计
     * 
     * @param tXinyiBigTableMonth 信义大月维度统计
     * @return 结果
     */
    public int insertTXinyiBigTableMonth(TXinyiBigTableMonth tXinyiBigTableMonth);

    /**
     * 修改信义大月维度统计
     * 
     * @param tXinyiBigTableMonth 信义大月维度统计
     * @return 结果
     */
    public int updateTXinyiBigTableMonth(TXinyiBigTableMonth tXinyiBigTableMonth);

    /**
     * 批量删除信义大月维度统计
     * 
     * @param IDs 需要删除的信义大月维度统计主键集合
     * @return 结果
     */
    public int deleteTXinyiBigTableMonthByIDs(Long[] IDs);

    /**
     * 删除信义大月维度统计信息
     * 
     * @param ID 信义大月维度统计主键
     * @return 结果
     */
    public int deleteTXinyiBigTableMonthByID(Long ID);
}
