package com.slibra.business.service;

import java.util.List;
import com.slibra.business.domain.TXinyiCarbonMajor;
import com.slibra.business.res.CarbonSmartQueryDB;

/**
 * 碳排放主Service接口
 * 
 * @author slibra
 * @date 2024-08-24
 */
public interface ITXinyiCarbonMajorService 
{
    /**
     * 查询碳排放主
     * 
     * @param id 碳排放主主键
     * @return 碳排放主
     */
    public TXinyiCarbonMajor selectTXinyiCarbonMajorById(Long id);

    /**
     * 查询碳排放主列表
     * 
     * @param tXinyiCarbonMajor 碳排放主
     * @return 碳排放主集合
     */
    public List<TXinyiCarbonMajor> selectTXinyiCarbonMajorList(TXinyiCarbonMajor tXinyiCarbonMajor);

    /**
     * 新增碳排放主
     * 
     * @param tXinyiCarbonMajor 碳排放主
     * @return 结果
     */
    public int insertTXinyiCarbonMajor(TXinyiCarbonMajor tXinyiCarbonMajor);

    /**
     * 修改碳排放主
     * 
     * @param tXinyiCarbonMajor 碳排放主
     * @return 结果
     */
    public int updateTXinyiCarbonMajor(TXinyiCarbonMajor tXinyiCarbonMajor);

    /**
     * 批量删除碳排放主
     * 
     * @param ids 需要删除的碳排放主主键集合
     * @return 结果
     */
    public int deleteTXinyiCarbonMajorByIds(Long[] ids);

    /**
     * 删除碳排放主信息
     * 
     * @param id 碳排放主主键
     * @return 结果
     */
    public int deleteTXinyiCarbonMajorById(Long id);

    CarbonSmartQueryDB getDBDatasByMonth(String month);

    TXinyiCarbonMajor getCarbonDetailsByMonth(String month);

    TXinyiCarbonMajor getCarbonDetailsById(Long id);

}
