package com.slibra.business.service;

import java.util.List;
import com.slibra.business.domain.TXinyiChatRecord;

/**
 * 信义大模型问答记录Service接口
 * 
 * @author slibra
 * @date 2024-05-15
 */
public interface ITXinyiChatRecordService 
{
    /**
     * 查询信义大模型问答记录
     * 
     * @param id 信义大模型问答记录主键
     * @return 信义大模型问答记录
     */
    public TXinyiChatRecord selectTXinyiChatRecordById(Long id);

    /**
     * 查询信义大模型问答记录列表
     * 
     * @param tXinyiChatRecord 信义大模型问答记录
     * @return 信义大模型问答记录集合
     */
    public List<TXinyiChatRecord> selectTXinyiChatRecordList(TXinyiChatRecord tXinyiChatRecord);

    /**
     * 新增信义大模型问答记录
     * 
     * @param tXinyiChatRecord 信义大模型问答记录
     * @return 结果
     */
    public int insertTXinyiChatRecord(TXinyiChatRecord tXinyiChatRecord);

    /**
     * 修改信义大模型问答记录
     * 
     * @param tXinyiChatRecord 信义大模型问答记录
     * @return 结果
     */
    public int updateTXinyiChatRecord(TXinyiChatRecord tXinyiChatRecord);

    /**
     * 批量删除信义大模型问答记录
     * 
     * @param ids 需要删除的信义大模型问答记录主键集合
     * @return 结果
     */
    public int deleteTXinyiChatRecordByIds(Long[] ids);

    /**
     * 删除信义大模型问答记录信息
     * 
     * @param id 信义大模型问答记录主键
     * @return 结果
     */
    public int deleteTXinyiChatRecordById(Long id);
}
