package com.slibra.business.service;

import com.slibra.business.domain.TXinyiBigTableHour;
import com.slibra.common.core.domain.TXinyiDaily;
import com.slibra.business.res.XinyiDailySimple;

import java.util.List;

/**
 * 信义日报数据Service接口
 * 
 * @author slibra
 * @date 2024-04-13
 */
public interface ITXinyiDailyService 
{
    /**
     * 查询信义日报数据
     * 
     * @param ID 信义日报数据主键
     * @return 信义日报数据
     */
    public TXinyiDaily selectTXinyiDailyByID(Long ID);

    /**
     * 查询信义日报数据列表
     * 
     * @param tXinyiDaily 信义日报数据
     * @return 信义日报数据集合
     */
    public List<TXinyiDaily> selectTXinyiDailyList(TXinyiDaily tXinyiDaily);

    /**
     * 新增信义日报数据
     * 
     * @param tXinyiDaily 信义日报数据
     * @return 结果
     */
    public int insertTXinyiDaily(TXinyiDaily tXinyiDaily);

    /**
     * 修改信义日报数据
     * 
     * @param tXinyiDaily 信义日报数据
     * @return 结果
     */
    public int updateTXinyiDaily(TXinyiDaily tXinyiDaily);

    /**
     * 批量删除信义日报数据
     * 
     * @param IDs 需要删除的信义日报数据主键集合
     * @return 结果
     */
    public int deleteTXinyiDailyByIDs(Long[] IDs);

    /**
     * 删除信义日报数据信息
     * 
     * @param ID 信义日报数据主键
     * @return 结果
     */
    public int deleteTXinyiDailyByID(Long ID);

    List<XinyiDailySimple> getRecently30CountInfo();

    void addDailyData(TXinyiDaily tXinyiDaily, TXinyiBigTableHour tXinyiBigTableHour);
}
