package com.slibra.business.service;

import java.util.List;
import com.slibra.business.domain.TXinyiFeedback;

/**
 * 信义意见反馈Service接口
 * 
 * @author slibra
 * @date 2024-05-27
 */
public interface ITXinyiFeedbackService 
{
    /**
     * 查询信义意见反馈
     * 
     * @param id 信义意见反馈主键
     * @return 信义意见反馈
     */
    public TXinyiFeedback selectTXinyiFeedbackById(Long id);

    /**
     * 查询信义意见反馈列表
     * 
     * @param tXinyiFeedback 信义意见反馈
     * @return 信义意见反馈集合
     */
    public List<TXinyiFeedback> selectTXinyiFeedbackList(TXinyiFeedback tXinyiFeedback);

    /**
     * 新增信义意见反馈
     * 
     * @param tXinyiFeedback 信义意见反馈
     * @return 结果
     */
    public int insertTXinyiFeedback(TXinyiFeedback tXinyiFeedback);

    /**
     * 修改信义意见反馈
     * 
     * @param tXinyiFeedback 信义意见反馈
     * @return 结果
     */
    public int updateTXinyiFeedback(TXinyiFeedback tXinyiFeedback);

    /**
     * 批量删除信义意见反馈
     * 
     * @param ids 需要删除的信义意见反馈主键集合
     * @return 结果
     */
    public int deleteTXinyiFeedbackByIds(Long[] ids);

    /**
     * 删除信义意见反馈信息
     * 
     * @param id 信义意见反馈主键
     * @return 结果
     */
    public int deleteTXinyiFeedbackById(Long id);
}
