package com.slibra.business.service;

import java.util.List;

import com.alibaba.fastjson2.JSONObject;
import com.slibra.business.domain.TXinyiForecastComparison;

/**
 * 信义预测对比Service接口
 * 
 * @author slibra
 * @date 2024-06-18
 */
public interface ITXinyiForecastComparisonService 
{
    /**
     * 查询信义预测对比
     * 
     * @param id 信义预测对比主键
     * @return 信义预测对比
     */
    public TXinyiForecastComparison selectTXinyiForecastComparisonById(Long id);

    /**
     * 查询信义预测对比列表
     * 
     * @param tXinyiForecastComparison 信义预测对比
     * @return 信义预测对比集合
     */
    public List<TXinyiForecastComparison> selectTXinyiForecastComparisonList(TXinyiForecastComparison tXinyiForecastComparison);

    /**
     * 新增信义预测对比
     * 
     * @param tXinyiForecastComparison 信义预测对比
     * @return 结果
     */
    public int insertTXinyiForecastComparison(TXinyiForecastComparison tXinyiForecastComparison);

    /**
     * 修改信义预测对比
     * 
     * @param tXinyiForecastComparison 信义预测对比
     * @return 结果
     */
    public int updateTXinyiForecastComparison(TXinyiForecastComparison tXinyiForecastComparison);

    /**
     * 批量删除信义预测对比
     * 
     * @param ids 需要删除的信义预测对比主键集合
     * @return 结果
     */
    public int deleteTXinyiForecastComparisonByIds(Long[] ids);

    /**
     * 删除信义预测对比信息
     * 
     * @param id 信义预测对比主键
     * @return 结果
     */
    public int deleteTXinyiForecastComparisonById(Long id);

    JSONObject echartsList(TXinyiForecastComparison tXinyiForecastComparison);
}
