package com.slibra.business.service;

import java.util.List;
import com.slibra.business.domain.TXinyiIndustry;

/**
 * 信义工业数据Service接口
 * 
 * @author slibra
 * @date 2024-09-10
 */
public interface ITXinyiIndustryService 
{
    /**
     * 查询信义工业数据
     * 
     * @param ID 信义工业数据主键
     * @return 信义工业数据
     */
    public TXinyiIndustry selectTXinyiIndustryByID(Long ID);

    /**
     * 查询信义工业数据列表
     * 
     * @param tXinyiIndustry 信义工业数据
     * @return 信义工业数据集合
     */
    public List<TXinyiIndustry> selectTXinyiIndustryList(TXinyiIndustry tXinyiIndustry);

    /**
     * 新增信义工业数据
     * 
     * @param tXinyiIndustry 信义工业数据
     * @return 结果
     */
    public int insertTXinyiIndustry(TXinyiIndustry tXinyiIndustry);

    /**
     * 修改信义工业数据
     * 
     * @param tXinyiIndustry 信义工业数据
     * @return 结果
     */
    public int updateTXinyiIndustry(TXinyiIndustry tXinyiIndustry);

    /**
     * 批量删除信义工业数据
     * 
     * @param IDs 需要删除的信义工业数据主键集合
     * @return 结果
     */
    public int deleteTXinyiIndustryByIDs(Long[] IDs);

    /**
     * 删除信义工业数据信息
     * 
     * @param ID 信义工业数据主键
     * @return 结果
     */
    public int deleteTXinyiIndustryByID(Long ID);
}
