package com.slibra.business.service;

import java.util.List;
import com.slibra.business.domain.TXinyiMedicineAddRecord;

/**
 * 信义碳源投加记录Service接口
 * 
 * @author slibra
 * @date 2025-04-24
 */
public interface ITXinyiMedicineAddRecordService 
{
    /**
     * 查询信义碳源投加记录
     * 
     * @param id 信义碳源投加记录主键
     * @return 信义碳源投加记录
     */
    public TXinyiMedicineAddRecord selectTXinyiMedicineAddRecordById(Long id);

    /**
     * 查询信义碳源投加记录列表
     * 
     * @param tXinyiMedicineAddRecord 信义碳源投加记录
     * @return 信义碳源投加记录集合
     */
    public List<TXinyiMedicineAddRecord> selectTXinyiMedicineAddRecordList(TXinyiMedicineAddRecord tXinyiMedicineAddRecord);

    /**
     * 新增信义碳源投加记录
     * 
     * @param tXinyiMedicineAddRecord 信义碳源投加记录
     * @return 结果
     */
    public int insertTXinyiMedicineAddRecord(TXinyiMedicineAddRecord tXinyiMedicineAddRecord);

    /**
     * 修改信义碳源投加记录
     * 
     * @param tXinyiMedicineAddRecord 信义碳源投加记录
     * @return 结果
     */
    public int updateTXinyiMedicineAddRecord(TXinyiMedicineAddRecord tXinyiMedicineAddRecord);

    /**
     * 批量删除信义碳源投加记录
     * 
     * @param ids 需要删除的信义碳源投加记录主键集合
     * @return 结果
     */
    public int deleteTXinyiMedicineAddRecordByIds(Long[] ids);

    /**
     * 删除信义碳源投加记录信息
     * 
     * @param id 信义碳源投加记录主键
     * @return 结果
     */
    public int deleteTXinyiMedicineAddRecordById(Long id);
}
