package com.slibra.business.service;

import java.util.List;
import com.slibra.business.domain.TXinyiMedicineConf;

/**
 * 投药控制Service接口
 * 
 * @author slibra
 * @date 2024-09-13
 */
public interface ITXinyiMedicineConfService 
{
    /**
     * 查询投药控制
     * 
     * @param id 投药控制主键
     * @return 投药控制
     */
    public TXinyiMedicineConf selectTXinyiMedicineConfById(Long id);

    /**
     * 查询投药控制列表
     * 
     * @param tXinyiMedicineConf 投药控制
     * @return 投药控制集合
     */
    public List<TXinyiMedicineConf> selectTXinyiMedicineConfList(TXinyiMedicineConf tXinyiMedicineConf);

    /**
     * 新增投药控制
     * 
     * @param tXinyiMedicineConf 投药控制
     * @return 结果
     */
    public int insertTXinyiMedicineConf(TXinyiMedicineConf tXinyiMedicineConf);

    /**
     * 修改投药控制
     * 
     * @param tXinyiMedicineConf 投药控制
     * @return 结果
     */
    public int updateTXinyiMedicineConf(TXinyiMedicineConf tXinyiMedicineConf);

    /**
     * 批量删除投药控制
     * 
     * @param ids 需要删除的投药控制主键集合
     * @return 结果
     */
    public int deleteTXinyiMedicineConfByIds(Long[] ids);

    /**
     * 删除投药控制信息
     * 
     * @param id 投药控制主键
     * @return 结果
     */
    public int deleteTXinyiMedicineConfById(Long id);
}
