package com.slibra.business.service;

import java.util.List;
import com.slibra.business.domain.TXinyiNormConfig;

/**
 * 信义一些指标的配置Service接口
 * 
 * @author slibra
 * @date 2024-04-27
 */
public interface ITXinyiNormConfigService 
{
    /**
     * 查询信义一些指标的配置
     * 
     * @param id 信义一些指标的配置主键
     * @return 信义一些指标的配置
     */
    public TXinyiNormConfig selectTXinyiNormConfigById(Long id);

    /**
     * 查询信义一些指标的配置列表
     * 
     * @param tXinyiNormConfig 信义一些指标的配置
     * @return 信义一些指标的配置集合
     */
    public List<TXinyiNormConfig> selectTXinyiNormConfigList(TXinyiNormConfig tXinyiNormConfig);

    /**
     * 新增信义一些指标的配置
     * 
     * @param tXinyiNormConfig 信义一些指标的配置
     * @return 结果
     */
    public int insertTXinyiNormConfig(TXinyiNormConfig tXinyiNormConfig);

    /**
     * 修改信义一些指标的配置
     * 
     * @param tXinyiNormConfig 信义一些指标的配置
     * @return 结果
     */
    public int updateTXinyiNormConfig(TXinyiNormConfig tXinyiNormConfig);

    /**
     * 批量删除信义一些指标的配置
     * 
     * @param ids 需要删除的信义一些指标的配置主键集合
     * @return 结果
     */
    public int deleteTXinyiNormConfigByIds(Long[] ids);

    /**
     * 删除信义一些指标的配置信息
     * 
     * @param id 信义一些指标的配置主键
     * @return 结果
     */
    public int deleteTXinyiNormConfigById(Long id);
}
