package com.slibra.business.service;

import java.util.List;
import com.slibra.business.domain.TXinyiRecommendQa;

/**
 * 信义推荐问答列Service接口
 * 
 * @author slibra
 * @date 2024-05-17
 */
public interface ITXinyiRecommendQaService 
{
    /**
     * 查询信义推荐问答列
     * 
     * @param id 信义推荐问答列主键
     * @return 信义推荐问答列
     */
    public TXinyiRecommendQa selectTXinyiRecommendQaById(Long id);

    /**
     * 查询信义推荐问答列列表
     * 
     * @param tXinyiRecommendQa 信义推荐问答列
     * @return 信义推荐问答列集合
     */
    public List<TXinyiRecommendQa> selectTXinyiRecommendQaList(TXinyiRecommendQa tXinyiRecommendQa);

    /**
     * 新增信义推荐问答列
     * 
     * @param tXinyiRecommendQa 信义推荐问答列
     * @return 结果
     */
    public int insertTXinyiRecommendQa(TXinyiRecommendQa tXinyiRecommendQa);

    /**
     * 修改信义推荐问答列
     * 
     * @param tXinyiRecommendQa 信义推荐问答列
     * @return 结果
     */
    public int updateTXinyiRecommendQa(TXinyiRecommendQa tXinyiRecommendQa);

    /**
     * 批量删除信义推荐问答列
     * 
     * @param ids 需要删除的信义推荐问答列主键集合
     * @return 结果
     */
    public int deleteTXinyiRecommendQaByIds(Long[] ids);

    /**
     * 删除信义推荐问答列信息
     * 
     * @param id 信义推荐问答列主键
     * @return 结果
     */
    public int deleteTXinyiRecommendQaById(Long id);
}
