package com.slibra.business.service;

import java.util.List;
import com.slibra.business.domain.TXinyiRobot;

/**
 * 信义化验数据Service接口
 * 
 * @author slibra
 * @date 2024-09-10
 */
public interface ITXinyiRobotService 
{
    /**
     * 查询信义化验数据
     * 
     * @param ID 信义化验数据主键
     * @return 信义化验数据
     */
    public TXinyiRobot selectTXinyiRobotByID(Long ID);

    /**
     * 查询信义化验数据列表
     * 
     * @param tXinyiRobot 信义化验数据
     * @return 信义化验数据集合
     */
    public List<TXinyiRobot> selectTXinyiRobotList(TXinyiRobot tXinyiRobot);

    /**
     * 新增信义化验数据
     * 
     * @param tXinyiRobot 信义化验数据
     * @return 结果
     */
    public int insertTXinyiRobot(TXinyiRobot tXinyiRobot);

    /**
     * 修改信义化验数据
     * 
     * @param tXinyiRobot 信义化验数据
     * @return 结果
     */
    public int updateTXinyiRobot(TXinyiRobot tXinyiRobot);

    /**
     * 批量删除信义化验数据
     * 
     * @param IDs 需要删除的信义化验数据主键集合
     * @return 结果
     */
    public int deleteTXinyiRobotByIDs(Long[] IDs);

    /**
     * 删除信义化验数据信息
     * 
     * @param ID 信义化验数据主键
     * @return 结果
     */
    public int deleteTXinyiRobotByID(Long ID);
}
