package com.slibra.business.service;

import java.util.List;
import com.slibra.business.domain.TXinyiWarningRecord;

/**
 * 信义告警记录Service接口
 * 
 * @author slibra
 * @date 2024-05-17
 */
public interface ITXinyiWarningRecordService 
{
    /**
     * 查询信义告警记录
     * 
     * @param id 信义告警记录主键
     * @return 信义告警记录
     */
    public TXinyiWarningRecord selectTXinyiWarningRecordById(Long id);

    /**
     * 查询信义告警记录列表
     * 
     * @param tXinyiWarningRecord 信义告警记录
     * @return 信义告警记录集合
     */
    public List<TXinyiWarningRecord> selectTXinyiWarningRecordList(TXinyiWarningRecord tXinyiWarningRecord);

    /**
     * 新增信义告警记录
     * 
     * @param tXinyiWarningRecord 信义告警记录
     * @return 结果
     */
    public int insertTXinyiWarningRecord(TXinyiWarningRecord tXinyiWarningRecord);

    /**
     * 修改信义告警记录
     * 
     * @param tXinyiWarningRecord 信义告警记录
     * @return 结果
     */
    public int updateTXinyiWarningRecord(TXinyiWarningRecord tXinyiWarningRecord);

    /**
     * 批量删除信义告警记录
     * 
     * @param ids 需要删除的信义告警记录主键集合
     * @return 结果
     */
    public int deleteTXinyiWarningRecordByIds(Long[] ids);

    /**
     * 删除信义告警记录信息
     * 
     * @param id 信义告警记录主键
     * @return 结果
     */
    public int deleteTXinyiWarningRecordById(Long id);
}
