package com.slibra.business.service.impl;

import java.util.List;
import com.slibra.common.utils.DateUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.slibra.business.mapper.TXinyiBigTableDayMapper;
import com.slibra.business.domain.TXinyiBigTableDay;
import com.slibra.business.service.ITXinyiBigTableDayService;

/**
 * 信义大天维度统计Service业务层处理
 * 
 * @author slibra
 * @date 2024-07-07
 */
@Service
public class TXinyiBigTableDayServiceImpl implements ITXinyiBigTableDayService 
{
    @Autowired
    private TXinyiBigTableDayMapper tXinyiBigTableDayMapper;

    /**
     * 查询信义大天维度统计
     * 
     * @param ID 信义大天维度统计主键
     * @return 信义大天维度统计
     */
    @Override
    public TXinyiBigTableDay selectTXinyiBigTableDayByID(Long ID)
    {
        return tXinyiBigTableDayMapper.selectTXinyiBigTableDayByID(ID);
    }

    /**
     * 查询信义大天维度统计列表
     * 
     * @param tXinyiBigTableDay 信义大天维度统计
     * @return 信义大天维度统计
     */
    @Override
    public List<TXinyiBigTableDay> selectTXinyiBigTableDayList(TXinyiBigTableDay tXinyiBigTableDay)
    {
        return tXinyiBigTableDayMapper.selectTXinyiBigTableDayList(tXinyiBigTableDay);
    }

    /**
     * 新增信义大天维度统计
     * 
     * @param tXinyiBigTableDay 信义大天维度统计
     * @return 结果
     */
    @Override
    public int insertTXinyiBigTableDay(TXinyiBigTableDay tXinyiBigTableDay)
    {
        tXinyiBigTableDay.setCreateTime(DateUtils.getNowDate());
        return tXinyiBigTableDayMapper.insertTXinyiBigTableDay(tXinyiBigTableDay);
    }

    /**
     * 修改信义大天维度统计
     * 
     * @param tXinyiBigTableDay 信义大天维度统计
     * @return 结果
     */
    @Override
    public int updateTXinyiBigTableDay(TXinyiBigTableDay tXinyiBigTableDay)
    {
        tXinyiBigTableDay.setUpdateTime(DateUtils.getNowDate());
        return tXinyiBigTableDayMapper.updateTXinyiBigTableDay(tXinyiBigTableDay);
    }

    /**
     * 批量删除信义大天维度统计
     * 
     * @param IDs 需要删除的信义大天维度统计主键
     * @return 结果
     */
    @Override
    public int deleteTXinyiBigTableDayByIDs(Long[] IDs)
    {
        return tXinyiBigTableDayMapper.deleteTXinyiBigTableDayByIDs(IDs);
    }

    /**
     * 删除信义大天维度统计信息
     * 
     * @param ID 信义大天维度统计主键
     * @return 结果
     */
    @Override
    public int deleteTXinyiBigTableDayByID(Long ID)
    {
        return tXinyiBigTableDayMapper.deleteTXinyiBigTableDayByID(ID);
    }
}
