package com.slibra.business.service.impl;

import java.util.List;
import com.slibra.common.utils.DateUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.slibra.business.mapper.TXinyiBigTableHourMapper;
import com.slibra.business.domain.TXinyiBigTableHour;
import com.slibra.business.service.ITXinyiBigTableHourService;

/**
 * 信义大小时维度统计Service业务层处理
 * 
 * @author slibra
 * @date 2024-07-03
 */
@Service
public class TXinyiBigTableHourServiceImpl implements ITXinyiBigTableHourService 
{
    @Autowired
    private TXinyiBigTableHourMapper tXinyiBigTableHourMapper;

    /**
     * 查询信义大小时维度统计
     * 
     * @param ID 信义大小时维度统计主键
     * @return 信义大小时维度统计
     */
    @Override
    public TXinyiBigTableHour selectTXinyiBigTableHourByID(Long ID)
    {
        return tXinyiBigTableHourMapper.selectTXinyiBigTableHourByID(ID);
    }

    /**
     * 查询信义大小时维度统计列表
     * 
     * @param tXinyiBigTableHour 信义大小时维度统计
     * @return 信义大小时维度统计
     */
    @Override
    public List<TXinyiBigTableHour> selectTXinyiBigTableHourList(TXinyiBigTableHour tXinyiBigTableHour)
    {
        return tXinyiBigTableHourMapper.selectTXinyiBigTableHourList(tXinyiBigTableHour);
    }

    /**
     * 新增信义大小时维度统计
     * 
     * @param tXinyiBigTableHour 信义大小时维度统计
     * @return 结果
     */
    @Override
    public int insertTXinyiBigTableHour(TXinyiBigTableHour tXinyiBigTableHour)
    {
        tXinyiBigTableHour.setCreateTime(DateUtils.getNowDate());
        return tXinyiBigTableHourMapper.insertTXinyiBigTableHour(tXinyiBigTableHour);
    }

    /**
     * 修改信义大小时维度统计
     * 
     * @param tXinyiBigTableHour 信义大小时维度统计
     * @return 结果
     */
    @Override
    public int updateTXinyiBigTableHour(TXinyiBigTableHour tXinyiBigTableHour)
    {
        tXinyiBigTableHour.setUpdateTime(DateUtils.getNowDate());
        return tXinyiBigTableHourMapper.updateTXinyiBigTableHour(tXinyiBigTableHour);
    }

    /**
     * 批量删除信义大小时维度统计
     * 
     * @param IDs 需要删除的信义大小时维度统计主键
     * @return 结果
     */
    @Override
    public int deleteTXinyiBigTableHourByIDs(Long[] IDs)
    {
        return tXinyiBigTableHourMapper.deleteTXinyiBigTableHourByIDs(IDs);
    }

    /**
     * 删除信义大小时维度统计信息
     * 
     * @param ID 信义大小时维度统计主键
     * @return 结果
     */
    @Override
    public int deleteTXinyiBigTableHourByID(Long ID)
    {
        return tXinyiBigTableHourMapper.deleteTXinyiBigTableHourByID(ID);
    }
}
