package com.slibra.business.service.impl;

import java.util.List;
import com.slibra.common.utils.DateUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.slibra.business.mapper.TXinyiBigTableMonthMapper;
import com.slibra.business.domain.TXinyiBigTableMonth;
import com.slibra.business.service.ITXinyiBigTableMonthService;

/**
 * 信义大月维度统计Service业务层处理
 * 
 * @author slibra
 * @date 2024-07-07
 */
@Service
public class TXinyiBigTableMonthServiceImpl implements ITXinyiBigTableMonthService 
{
    @Autowired
    private TXinyiBigTableMonthMapper tXinyiBigTableMonthMapper;

    /**
     * 查询信义大月维度统计
     * 
     * @param ID 信义大月维度统计主键
     * @return 信义大月维度统计
     */
    @Override
    public TXinyiBigTableMonth selectTXinyiBigTableMonthByID(Long ID)
    {
        return tXinyiBigTableMonthMapper.selectTXinyiBigTableMonthByID(ID);
    }

    /**
     * 查询信义大月维度统计列表
     * 
     * @param tXinyiBigTableMonth 信义大月维度统计
     * @return 信义大月维度统计
     */
    @Override
    public List<TXinyiBigTableMonth> selectTXinyiBigTableMonthList(TXinyiBigTableMonth tXinyiBigTableMonth)
    {
        return tXinyiBigTableMonthMapper.selectTXinyiBigTableMonthList(tXinyiBigTableMonth);
    }

    /**
     * 新增信义大月维度统计
     * 
     * @param tXinyiBigTableMonth 信义大月维度统计
     * @return 结果
     */
    @Override
    public int insertTXinyiBigTableMonth(TXinyiBigTableMonth tXinyiBigTableMonth)
    {
        tXinyiBigTableMonth.setCreateTime(DateUtils.getNowDate());
        return tXinyiBigTableMonthMapper.insertTXinyiBigTableMonth(tXinyiBigTableMonth);
    }

    /**
     * 修改信义大月维度统计
     * 
     * @param tXinyiBigTableMonth 信义大月维度统计
     * @return 结果
     */
    @Override
    public int updateTXinyiBigTableMonth(TXinyiBigTableMonth tXinyiBigTableMonth)
    {
        tXinyiBigTableMonth.setUpdateTime(DateUtils.getNowDate());
        return tXinyiBigTableMonthMapper.updateTXinyiBigTableMonth(tXinyiBigTableMonth);
    }

    /**
     * 批量删除信义大月维度统计
     * 
     * @param IDs 需要删除的信义大月维度统计主键
     * @return 结果
     */
    @Override
    public int deleteTXinyiBigTableMonthByIDs(Long[] IDs)
    {
        return tXinyiBigTableMonthMapper.deleteTXinyiBigTableMonthByIDs(IDs);
    }

    /**
     * 删除信义大月维度统计信息
     * 
     * @param ID 信义大月维度统计主键
     * @return 结果
     */
    @Override
    public int deleteTXinyiBigTableMonthByID(Long ID)
    {
        return tXinyiBigTableMonthMapper.deleteTXinyiBigTableMonthByID(ID);
    }
}
