package com.slibra.business.service.impl;

import java.util.List;
import com.slibra.common.utils.DateUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.slibra.business.mapper.TXinyiCalculateMapper;
import com.slibra.business.domain.TXinyiCalculate;
import com.slibra.business.service.ITXinyiCalculateService;

/**
 * 信义计算数据Service业务层处理
 * 
 * @author slibra
 * @date 2024-06-07
 */
@Service
public class TXinyiCalculateServiceImpl implements ITXinyiCalculateService 
{
    @Autowired
    private TXinyiCalculateMapper tXinyiCalculateMapper;

    /**
     * 查询信义计算数据
     * 
     * @param id 信义计算数据主键
     * @return 信义计算数据
     */
    @Override
    public TXinyiCalculate selectTXinyiCalculateById(Long id)
    {
        return tXinyiCalculateMapper.selectTXinyiCalculateById(id);
    }

    /**
     * 查询信义计算数据列表
     * 
     * @param tXinyiCalculate 信义计算数据
     * @return 信义计算数据
     */
    @Override
    public List<TXinyiCalculate> selectTXinyiCalculateList(TXinyiCalculate tXinyiCalculate)
    {
        return tXinyiCalculateMapper.selectTXinyiCalculateList(tXinyiCalculate);
    }

    /**
     * 新增信义计算数据
     * 
     * @param tXinyiCalculate 信义计算数据
     * @return 结果
     */
    @Override
    public int insertTXinyiCalculate(TXinyiCalculate tXinyiCalculate)
    {
        tXinyiCalculate.setCreateTime(DateUtils.getNowDate());
        return tXinyiCalculateMapper.insertTXinyiCalculate(tXinyiCalculate);
    }

    /**
     * 修改信义计算数据
     * 
     * @param tXinyiCalculate 信义计算数据
     * @return 结果
     */
    @Override
    public int updateTXinyiCalculate(TXinyiCalculate tXinyiCalculate)
    {
        tXinyiCalculate.setUpdateTime(DateUtils.getNowDate());
        return tXinyiCalculateMapper.updateTXinyiCalculate(tXinyiCalculate);
    }

    /**
     * 批量删除信义计算数据
     * 
     * @param ids 需要删除的信义计算数据主键
     * @return 结果
     */
    @Override
    public int deleteTXinyiCalculateByIds(Long[] ids)
    {
        return tXinyiCalculateMapper.deleteTXinyiCalculateByIds(ids);
    }

    /**
     * 删除信义计算数据信息
     * 
     * @param id 信义计算数据主键
     * @return 结果
     */
    @Override
    public int deleteTXinyiCalculateById(Long id)
    {
        return tXinyiCalculateMapper.deleteTXinyiCalculateById(id);
    }
}
