package com.slibra.business.service.impl;

import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.slibra.business.mapper.TXinyiIndustryMapper;
import com.slibra.business.domain.TXinyiIndustry;
import com.slibra.business.service.ITXinyiIndustryService;

/**
 * 信义工业数据Service业务层处理
 * 
 * @author slibra
 * @date 2024-09-10
 */
@Service
public class TXinyiIndustryServiceImpl implements ITXinyiIndustryService 
{
    @Autowired
    private TXinyiIndustryMapper tXinyiIndustryMapper;

    /**
     * 查询信义工业数据
     * 
     * @param ID 信义工业数据主键
     * @return 信义工业数据
     */
    @Override
    public TXinyiIndustry selectTXinyiIndustryByID(Long ID)
    {
        return tXinyiIndustryMapper.selectTXinyiIndustryByID(ID);
    }

    /**
     * 查询信义工业数据列表
     * 
     * @param tXinyiIndustry 信义工业数据
     * @return 信义工业数据
     */
    @Override
    public List<TXinyiIndustry> selectTXinyiIndustryList(TXinyiIndustry tXinyiIndustry)
    {
        return tXinyiIndustryMapper.selectTXinyiIndustryList(tXinyiIndustry);
    }

    /**
     * 新增信义工业数据
     * 
     * @param tXinyiIndustry 信义工业数据
     * @return 结果
     */
    @Override
    public int insertTXinyiIndustry(TXinyiIndustry tXinyiIndustry)
    {
        return tXinyiIndustryMapper.insertTXinyiIndustry(tXinyiIndustry);
    }

    /**
     * 修改信义工业数据
     * 
     * @param tXinyiIndustry 信义工业数据
     * @return 结果
     */
    @Override
    public int updateTXinyiIndustry(TXinyiIndustry tXinyiIndustry)
    {
        return tXinyiIndustryMapper.updateTXinyiIndustry(tXinyiIndustry);
    }

    /**
     * 批量删除信义工业数据
     * 
     * @param IDs 需要删除的信义工业数据主键
     * @return 结果
     */
    @Override
    public int deleteTXinyiIndustryByIDs(Long[] IDs)
    {
        return tXinyiIndustryMapper.deleteTXinyiIndustryByIDs(IDs);
    }

    /**
     * 删除信义工业数据信息
     * 
     * @param ID 信义工业数据主键
     * @return 结果
     */
    @Override
    public int deleteTXinyiIndustryByID(Long ID)
    {
        return tXinyiIndustryMapper.deleteTXinyiIndustryByID(ID);
    }
}
