package com.slibra.business.service.impl;

import java.util.List;
import com.slibra.common.utils.DateUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.slibra.business.mapper.TXinyiMedicineConfMapper;
import com.slibra.business.domain.TXinyiMedicineConf;
import com.slibra.business.service.ITXinyiMedicineConfService;

/**
 * 投药控制Service业务层处理
 * 
 * @author slibra
 * @date 2024-09-13
 */
@Service
public class TXinyiMedicineConfServiceImpl implements ITXinyiMedicineConfService 
{
    @Autowired
    private TXinyiMedicineConfMapper tXinyiMedicineConfMapper;

    /**
     * 查询投药控制
     * 
     * @param id 投药控制主键
     * @return 投药控制
     */
    @Override
    public TXinyiMedicineConf selectTXinyiMedicineConfById(Long id)
    {
        return tXinyiMedicineConfMapper.selectTXinyiMedicineConfById(id);
    }

    /**
     * 查询投药控制列表
     * 
     * @param tXinyiMedicineConf 投药控制
     * @return 投药控制
     */
    @Override
    public List<TXinyiMedicineConf> selectTXinyiMedicineConfList(TXinyiMedicineConf tXinyiMedicineConf)
    {
        return tXinyiMedicineConfMapper.selectTXinyiMedicineConfList(tXinyiMedicineConf);
    }

    /**
     * 新增投药控制
     * 
     * @param tXinyiMedicineConf 投药控制
     * @return 结果
     */
    @Override
    public int insertTXinyiMedicineConf(TXinyiMedicineConf tXinyiMedicineConf)
    {
        tXinyiMedicineConf.setCreateTime(DateUtils.getNowDate());
        return tXinyiMedicineConfMapper.insertTXinyiMedicineConf(tXinyiMedicineConf);
    }

    /**
     * 修改投药控制
     * 
     * @param tXinyiMedicineConf 投药控制
     * @return 结果
     */
    @Override
    public int updateTXinyiMedicineConf(TXinyiMedicineConf tXinyiMedicineConf)
    {
        tXinyiMedicineConf.setUpdateTime(DateUtils.getNowDate());
        return tXinyiMedicineConfMapper.updateTXinyiMedicineConf(tXinyiMedicineConf);
    }

    /**
     * 批量删除投药控制
     * 
     * @param ids 需要删除的投药控制主键
     * @return 结果
     */
    @Override
    public int deleteTXinyiMedicineConfByIds(Long[] ids)
    {
        return tXinyiMedicineConfMapper.deleteTXinyiMedicineConfByIds(ids);
    }

    /**
     * 删除投药控制信息
     * 
     * @param id 投药控制主键
     * @return 结果
     */
    @Override
    public int deleteTXinyiMedicineConfById(Long id)
    {
        return tXinyiMedicineConfMapper.deleteTXinyiMedicineConfById(id);
    }
}
