package com.slibra.business.service.impl;

import java.util.List;
import com.slibra.common.utils.DateUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.slibra.business.mapper.TXinyiNormConfigMapper;
import com.slibra.business.domain.TXinyiNormConfig;
import com.slibra.business.service.ITXinyiNormConfigService;

/**
 * 信义一些指标的配置Service业务层处理
 * 
 * @author slibra
 * @date 2024-04-27
 */
@Service
public class TXinyiNormConfigServiceImpl implements ITXinyiNormConfigService 
{
    @Autowired
    private TXinyiNormConfigMapper tXinyiNormConfigMapper;

    /**
     * 查询信义一些指标的配置
     * 
     * @param id 信义一些指标的配置主键
     * @return 信义一些指标的配置
     */
    @Override
    public TXinyiNormConfig selectTXinyiNormConfigById(Long id)
    {
        return tXinyiNormConfigMapper.selectTXinyiNormConfigById(id);
    }

    /**
     * 查询信义一些指标的配置列表
     * 
     * @param tXinyiNormConfig 信义一些指标的配置
     * @return 信义一些指标的配置
     */
    @Override
    public List<TXinyiNormConfig> selectTXinyiNormConfigList(TXinyiNormConfig tXinyiNormConfig)
    {
        return tXinyiNormConfigMapper.selectTXinyiNormConfigList(tXinyiNormConfig);
    }

    /**
     * 新增信义一些指标的配置
     * 
     * @param tXinyiNormConfig 信义一些指标的配置
     * @return 结果
     */
    @Override
    public int insertTXinyiNormConfig(TXinyiNormConfig tXinyiNormConfig)
    {
        tXinyiNormConfig.setCreateTime(DateUtils.getNowDate());
        return tXinyiNormConfigMapper.insertTXinyiNormConfig(tXinyiNormConfig);
    }

    /**
     * 修改信义一些指标的配置
     * 
     * @param tXinyiNormConfig 信义一些指标的配置
     * @return 结果
     */
    @Override
    public int updateTXinyiNormConfig(TXinyiNormConfig tXinyiNormConfig)
    {
        tXinyiNormConfig.setUpdateTime(DateUtils.getNowDate());
        return tXinyiNormConfigMapper.updateTXinyiNormConfig(tXinyiNormConfig);
    }

    /**
     * 批量删除信义一些指标的配置
     * 
     * @param ids 需要删除的信义一些指标的配置主键
     * @return 结果
     */
    @Override
    public int deleteTXinyiNormConfigByIds(Long[] ids)
    {
        return tXinyiNormConfigMapper.deleteTXinyiNormConfigByIds(ids);
    }

    /**
     * 删除信义一些指标的配置信息
     * 
     * @param id 信义一些指标的配置主键
     * @return 结果
     */
    @Override
    public int deleteTXinyiNormConfigById(Long id)
    {
        return tXinyiNormConfigMapper.deleteTXinyiNormConfigById(id);
    }
}
