package com.slibra.business.service.impl;

import java.util.List;
import com.slibra.common.utils.DateUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.slibra.business.mapper.TXinyiRecommendQaMapper;
import com.slibra.business.domain.TXinyiRecommendQa;
import com.slibra.business.service.ITXinyiRecommendQaService;

/**
 * 信义推荐问答列Service业务层处理
 * 
 * @author slibra
 * @date 2024-05-17
 */
@Service
public class TXinyiRecommendQaServiceImpl implements ITXinyiRecommendQaService 
{
    @Autowired
    private TXinyiRecommendQaMapper tXinyiRecommendQaMapper;

    /**
     * 查询信义推荐问答列
     * 
     * @param id 信义推荐问答列主键
     * @return 信义推荐问答列
     */
    @Override
    public TXinyiRecommendQa selectTXinyiRecommendQaById(Long id)
    {
        return tXinyiRecommendQaMapper.selectTXinyiRecommendQaById(id);
    }

    /**
     * 查询信义推荐问答列列表
     * 
     * @param tXinyiRecommendQa 信义推荐问答列
     * @return 信义推荐问答列
     */
    @Override
    public List<TXinyiRecommendQa> selectTXinyiRecommendQaList(TXinyiRecommendQa tXinyiRecommendQa)
    {
        return tXinyiRecommendQaMapper.selectTXinyiRecommendQaList(tXinyiRecommendQa);
    }

    /**
     * 新增信义推荐问答列
     * 
     * @param tXinyiRecommendQa 信义推荐问答列
     * @return 结果
     */
    @Override
    public int insertTXinyiRecommendQa(TXinyiRecommendQa tXinyiRecommendQa)
    {
        tXinyiRecommendQa.setCreateTime(DateUtils.getNowDate());
        return tXinyiRecommendQaMapper.insertTXinyiRecommendQa(tXinyiRecommendQa);
    }

    /**
     * 修改信义推荐问答列
     * 
     * @param tXinyiRecommendQa 信义推荐问答列
     * @return 结果
     */
    @Override
    public int updateTXinyiRecommendQa(TXinyiRecommendQa tXinyiRecommendQa)
    {
        tXinyiRecommendQa.setUpdateTime(DateUtils.getNowDate());
        return tXinyiRecommendQaMapper.updateTXinyiRecommendQa(tXinyiRecommendQa);
    }

    /**
     * 批量删除信义推荐问答列
     * 
     * @param ids 需要删除的信义推荐问答列主键
     * @return 结果
     */
    @Override
    public int deleteTXinyiRecommendQaByIds(Long[] ids)
    {
        return tXinyiRecommendQaMapper.deleteTXinyiRecommendQaByIds(ids);
    }

    /**
     * 删除信义推荐问答列信息
     * 
     * @param id 信义推荐问答列主键
     * @return 结果
     */
    @Override
    public int deleteTXinyiRecommendQaById(Long id)
    {
        return tXinyiRecommendQaMapper.deleteTXinyiRecommendQaById(id);
    }
}
