package com.slibra.business.service.impl;

import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.slibra.business.mapper.TXinyiRobotMapper;
import com.slibra.business.domain.TXinyiRobot;
import com.slibra.business.service.ITXinyiRobotService;

/**
 * 信义化验数据Service业务层处理
 * 
 * @author slibra
 * @date 2024-09-10
 */
@Service
public class TXinyiRobotServiceImpl implements ITXinyiRobotService 
{
    @Autowired
    private TXinyiRobotMapper tXinyiRobotMapper;

    /**
     * 查询信义化验数据
     * 
     * @param ID 信义化验数据主键
     * @return 信义化验数据
     */
    @Override
    public TXinyiRobot selectTXinyiRobotByID(Long ID)
    {
        return tXinyiRobotMapper.selectTXinyiRobotByID(ID);
    }

    /**
     * 查询信义化验数据列表
     * 
     * @param tXinyiRobot 信义化验数据
     * @return 信义化验数据
     */
    @Override
    public List<TXinyiRobot> selectTXinyiRobotList(TXinyiRobot tXinyiRobot)
    {
        return tXinyiRobotMapper.selectTXinyiRobotList(tXinyiRobot);
    }

    /**
     * 新增信义化验数据
     * 
     * @param tXinyiRobot 信义化验数据
     * @return 结果
     */
    @Override
    public int insertTXinyiRobot(TXinyiRobot tXinyiRobot)
    {
        return tXinyiRobotMapper.insertTXinyiRobot(tXinyiRobot);
    }

    /**
     * 修改信义化验数据
     * 
     * @param tXinyiRobot 信义化验数据
     * @return 结果
     */
    @Override
    public int updateTXinyiRobot(TXinyiRobot tXinyiRobot)
    {
        return tXinyiRobotMapper.updateTXinyiRobot(tXinyiRobot);
    }

    /**
     * 批量删除信义化验数据
     * 
     * @param IDs 需要删除的信义化验数据主键
     * @return 结果
     */
    @Override
    public int deleteTXinyiRobotByIDs(Long[] IDs)
    {
        return tXinyiRobotMapper.deleteTXinyiRobotByIDs(IDs);
    }

    /**
     * 删除信义化验数据信息
     * 
     * @param ID 信义化验数据主键
     * @return 结果
     */
    @Override
    public int deleteTXinyiRobotByID(Long ID)
    {
        return tXinyiRobotMapper.deleteTXinyiRobotByID(ID);
    }
}
