package com.slibra.business.service.impl;

import java.util.List;
import com.slibra.common.utils.DateUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.slibra.business.mapper.TXinyiTytjParamsMapper;
import com.slibra.business.domain.TXinyiTytjParams;
import com.slibra.business.service.ITXinyiTytjParamsService;

/**
 * 信义碳源投加参数配置Service业务层处理
 * 
 * @author slibra
 * @date 2025-04-23
 */
@Service
public class TXinyiTytjParamsServiceImpl implements ITXinyiTytjParamsService 
{
    @Autowired
    private TXinyiTytjParamsMapper tXinyiTytjParamsMapper;

    /**
     * 查询信义碳源投加参数配置
     * 
     * @param id 信义碳源投加参数配置主键
     * @return 信义碳源投加参数配置
     */
    @Override
    public TXinyiTytjParams selectTXinyiTytjParamsById(Long id)
    {
        return tXinyiTytjParamsMapper.selectTXinyiTytjParamsById(id);
    }

    /**
     * 查询信义碳源投加参数配置列表
     * 
     * @param tXinyiTytjParams 信义碳源投加参数配置
     * @return 信义碳源投加参数配置
     */
    @Override
    public List<TXinyiTytjParams> selectTXinyiTytjParamsList(TXinyiTytjParams tXinyiTytjParams)
    {
        return tXinyiTytjParamsMapper.selectTXinyiTytjParamsList(tXinyiTytjParams);
    }

    /**
     * 新增信义碳源投加参数配置
     * 
     * @param tXinyiTytjParams 信义碳源投加参数配置
     * @return 结果
     */
    @Override
    public int insertTXinyiTytjParams(TXinyiTytjParams tXinyiTytjParams)
    {
        tXinyiTytjParams.setCreateTime(DateUtils.getNowDate());
        return tXinyiTytjParamsMapper.insertTXinyiTytjParams(tXinyiTytjParams);
    }

    /**
     * 修改信义碳源投加参数配置
     * 
     * @param tXinyiTytjParams 信义碳源投加参数配置
     * @return 结果
     */
    @Override
    public int updateTXinyiTytjParams(TXinyiTytjParams tXinyiTytjParams)
    {
        tXinyiTytjParams.setUpdateTime(DateUtils.getNowDate());
        return tXinyiTytjParamsMapper.updateTXinyiTytjParams(tXinyiTytjParams);
    }

    /**
     * 批量删除信义碳源投加参数配置
     * 
     * @param ids 需要删除的信义碳源投加参数配置主键
     * @return 结果
     */
    @Override
    public int deleteTXinyiTytjParamsByIds(Long[] ids)
    {
        return tXinyiTytjParamsMapper.deleteTXinyiTytjParamsByIds(ids);
    }

    /**
     * 删除信义碳源投加参数配置信息
     * 
     * @param id 信义碳源投加参数配置主键
     * @return 结果
     */
    @Override
    public int deleteTXinyiTytjParamsById(Long id)
    {
        return tXinyiTytjParamsMapper.deleteTXinyiTytjParamsById(id);
    }
}
