package com.slibra.web.controller.business;

import cn.hutool.core.date.DateUtil;
import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpUtil;
import cn.hutool.poi.excel.ExcelReader;
import cn.hutool.poi.excel.ExcelUtil;
import com.alibaba.fastjson2.JSON;
import com.alibaba.fastjson2.JSONArray;
import com.alibaba.fastjson2.JSONObject;
import com.alibaba.fastjson2.JSONWriter;
import com.google.protobuf.ByteString;
import com.slibra.business.domain.*;
import com.slibra.business.mapper.*;
import com.slibra.business.req.ChatReq;
import com.slibra.business.req.GenerateArgs;
import com.slibra.business.req.PolicyReq;
import com.slibra.business.res.ChartBasic;
import com.slibra.business.res.ShowValueCSBasic;
import com.slibra.business.res.ShowValueJSBasic;
import com.slibra.business.service.ITXinyiForecastComparisonService;
import com.slibra.common.DecimalUtils;
import com.slibra.common.config.BigModelConfig;
import com.slibra.common.core.domain.DecisionReq;
import com.slibra.common.core.domain.TXinyiDaily;
import com.slibra.common.core.controller.BaseController;
import com.slibra.common.enums.BusinessEnum;
import com.slibra.common.exception.ServiceException;
import com.slibra.common.utils.DateUtils;
import com.slibra.common.utils.StringUtils;
import com.slibra.common.utils.format.WaterFormat;
import com.slibra.common.utils.uuid.IdUtils;
import com.slibra.quartz.business.JsCsFormatData;
import com.slibra.quartz.task.AsyncTask;
import com.slibra.quartz.task.RyTask;
import inference.InferenceAPIsServiceGrpc;
import inference.PredictionResponse;
import inference.PredictionsRequest;
import io.grpc.ManagedChannel;
import io.grpc.ManagedChannelBuilder;
import lombok.extern.slf4j.Slf4j;
import org.apache.ibatis.session.ExecutorType;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.CollectionUtils;
import org.springframework.web.bind.annotation.*;

import java.io.File;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.*;

import static com.slibra.common.constant.MyConstants.*;
import static com.slibra.common.constant.MyConstants.BigDecimal_100;
import static com.slibra.common.enums.BusinessEnum.BigModelWarningTypeRemarkEnum.*;
import static com.slibra.common.enums.BusinessEnum.WarningCategoryEnum.*;

/**
 * 参数配置 信息操作处理
 * 
 *
 */
@Slf4j
@RestController
@RequestMapping("/test")
public class HandleDataController extends BaseController
{
    @Autowired
    private TXinyiIndustryMapper xinyiIndustryMapper;

    @Autowired
    private TXinyiDailyMapper xinyiDailyMapper;

    @Autowired
    private TXinyiLaboratoryMapper xinyiLaboratoryMapper;

    @Autowired
    private TXinyiRobotMapper xinyiRobotMapper;

    @Autowired
    private TXinyiNormConfigMapper xinyiNormConfigMapper;

    @Autowired
    private TXinyiCalculateMapper xinyiCalculateMapper;

    @Autowired
    private TXinyiBigTableHourMapper tXinyiBigTableHourMapper;

    @Autowired
    private TXinyiBigTableDayMapper tXinyiBigTableDayMapper;

    @Autowired
    private  TXinyiBigTableMonthMapper tXinyiBigTableMonthMapper;

    @Autowired
    private SqlSessionFactory sqlSessionFactory;

    @Autowired
    private RyTask ryTask;

    @Autowired
    private AsyncTask asyncTask;

    @Autowired
    private ITXinyiForecastComparisonService xinyiForecastComparisonService;

    @Autowired
    private TXinyiWarningRecordMapper xinyiWarningRecordMapper;

    @Autowired
    private BigModelConfig bigModelConfig;

    @Autowired
    private JsCsFormatData jsCsFormatData;

    @Autowired
    private TXinyiChatRecordMapper xinyiChatRecordMapper;


    public static final String[] queryTags = {"信义污水厂JS_COD_Value","信义污水厂JS_PH_Value","信义污水厂JS_SS_Value","信义污水厂JS_ZL_Value","信义污水厂JS_ZA_Value","信义污水厂JS_AD_Value","信义污水厂JS_T_Value","信义污水厂进水泵房液位","信义污水厂出水瞬时流量","信义污水厂升级出水COD","信义污水厂升级出水PH","信义污水厂升级出水SS","信义污水厂升级出水TN","信义污水厂升级出水TP","信义污水厂升级出水氨氮","信义污水厂AIT202_Value","信义污水厂AIT203_Value","信义污水厂AIT207_Value","信义污水厂AIT206_Value","信义污水厂AIT209_Value","信义污水厂AIT210_Value","信义污水厂进水TDS","信义污水厂FT101_Value","信义污水厂SWCHHYHLB1_R_Value","信义污水厂SWCHHYHLB2_R_Value","信义污水厂SWCHHYHLB3_R_Value","信义污水厂SWCHHYHLB4_R_Value","信义污水厂SWCHHYHLB5_R_Value","信义污水厂SWCHHYHLB6_R_Value","信义污水厂SWCWNHLB1_R_Value","信义污水厂SWCWNHLB2_R_Value","信义污水厂SWCWNHLB3_R_Value","信义污水厂SWCWNHLB4_R_Value","信义污水厂SWCWNHLB5_R_Value","信义污水厂GFJ1_R_Value","信义污水厂GFJ2_R_Value","信义污水厂GFJ3_R_Value","信义污水厂GFJ4_R_Value","信义污水厂GFJ5_R_Value","信义污水厂GFJ6_R_Value","信义污水厂GFJ1_KQLL_Value","信义污水厂GFJ2_KQLL_Value","信义污水厂GFJ3_KQLL_Value","信义污水厂GFJ4_KQLL_Value","信义污水厂GFJ5_KQLL_Value","信义污水厂GFJ6_KQLL_Value"};

//    public static final String[] predictorArr = {"出水COD", "出水SS", "出水总磷", "出水氨氮", "xsy1", "xsy2"};
    public static final String[] predictorArr = {"cs_cod", "cs_ss", "cs_tp", "cs_andan", "xsy1", "xsy2", "qyxsy1", "qyxsy2", "缺氧出水氨氮1", "缺氧出水氨氮2"};

    /**
     *手动处理水质报警
     */
   @GetMapping("/waterWarning")
   public String waterWarning(){
       log.info("进入了 手动触发水质报警的 操作");
       //获取配置表
       List<TXinyiNormConfig> tXinyiNormConfigs = this.xinyiNormConfigMapper.selectTXinyiNormConfigList(null);
       if(CollectionUtils.isEmpty(tXinyiNormConfigs))
           throw new RuntimeException("未查询到配置信息");
       TXinyiNormConfig normConfig = tXinyiNormConfigs.get(0);
       TXinyiIndustry tXinyiIndustry = this.xinyiIndustryMapper.selectTXinyiIndustryNewest();
       if(Objects.isNull(tXinyiIndustry))
           throw new RuntimeException("未查询到工业库信息");
//       asyncTask.handleSZWarning(tXinyiIndustry, normConfig);
       return "success";
   }


    /**
     *手动处理生化报警
     */
    @GetMapping("/shWarning")
    public String shWarning(){
        log.info("进入了 手动处理生化报警 操作");
        //获取配置表
        List<TXinyiNormConfig> tXinyiNormConfigs = this.xinyiNormConfigMapper.selectTXinyiNormConfigList(null);
        if(CollectionUtils.isEmpty(tXinyiNormConfigs))
            throw new RuntimeException("未查询到配置信息");
        TXinyiNormConfig normConfig = tXinyiNormConfigs.get(0);
        TXinyiIndustry tXinyiIndustry = this.xinyiIndustryMapper.selectTXinyiIndustryNewest();
        if(Objects.isNull(tXinyiIndustry))
            throw new RuntimeException("未查询到工业库信息");
        List<TXinyiCalculate> tXinyiCalculates = xinyiCalculateMapper.selectTXinyiCalculateList(TXinyiCalculate.builder().testHour(tXinyiIndustry.getTestHour()).build());
        if (!CollectionUtils.isEmpty(tXinyiCalculates)) {
            TXinyiCalculate tXinyiCalculate = tXinyiCalculates.get(0);
            asyncTask.handleSHWarning(tXinyiIndustry, normConfig, tXinyiCalculate);
        }
        return "success";
    }


    /**
     *手动处理化验室报警
     */
    /*@GetMapping("/robotWarning")
    public String robotWarning(){
        log.info("进入了 手动触发化验室报警的 操作");
        asyncTask.handleRobotWarning(this.xinyiRobotMapper.selectNRobot(1));
        return "success";
    }*/


    /**
     *手动处理预测报警
     */
    @GetMapping("/forecastWarning")
    public String forecastWarning(){
        log.info("进入了 手动触发预测报警的 操作");
        //获取最新的6条工业科数据
        List<TXinyiIndustry> tXinyiIndustries6 = this.xinyiIndustryMapper.selectNIndustry(INT_6);
        List<TXinyiRobot> tXinyiRobots6 = this.xinyiRobotMapper.selectNRobot(INT_6);
        //2024年7月18日10:31:18  加个校验，只有从来没有数据的水厂才会进入下面的判断
        if(CollectionUtils.isEmpty(tXinyiIndustries6) || tXinyiIndustries6.size() < INT_6
                || CollectionUtils.isEmpty(tXinyiRobots6) || tXinyiRobots6.size() <INT_6){
            log.error("预测的时候，获取最新的6条工业数据或者化验数据不满足，任务终止，工业数据为{}\n化验数据为{}", JSON.toJSONString(tXinyiIndustries6), JSON.toJSONString(tXinyiRobots6));
            return "预测的时候，获取最新的6条工业数据或者化验数据不满足，任务终止";
        }
        //先处理xsy1 和 xsy2 合并成一个数据
//        this.predictorSpecial(tXinyiIndustries6, tXinyiRobots6);
        //2024年7月11日16:55:27  xsy1 和 xsy2 又不合并了。。。 再次分开处理
        for (int i = 0; i < predictorArr.length; i++) {
            String result = ryTask.getPredictor(predictorArr[i]);
            if(StringUtils.isBlank(result) || "error".equals(result)){
                log.info("预测数据返回结果不符合解析条件，返回结果为{}", result);
                continue;
            }
            JSONObject jsonObject = null;
            try {
                jsonObject = JSON.parseObject(result);
            } catch (Exception e) {
                log.error("[转JSON的时候]预测数据返回结果不符合解析条件，返回结果为{}", result);
                continue;
            }
            log.info("^^^^^^^^^^^^^预测接口转弯JSON对象后，原内容是{}", JSON.toJSONString(jsonObject));
            //2024年7月8日15:25:51 加个校验 因为各种奇葩返回。。 比如返回的结果是 "null"
            if(Objects.isNull(jsonObject)){
                log.error("[转JSON的时候]预测数据返回结果是null，不处里");
                continue;
            }
            String task = jsonObject.getString("task");
            String hour = jsonObject.getString("hour");
            String pred = jsonObject.getString("pred");
            String date = jsonObject.getString("date");
            if(StringUtils.isNotBlank(pred) && pred.contains(",")){
                String[] split = pred.split(",");
                if(split.length != 3){
                    log.error("预测数据返回结果为{},长度不是3，无法正常解析", result);
                    //因为部分预测还不支持  所以不需要
//                    ryTask.handleXinYiWarningsYC(cscodBzz, split, cscodGkz, BusinessEnum.WarningCategoryEnum.CS_COD_YC.getCode(), hour, normConfig);
                    continue;
                }
                //解析数据 处理报警 调研prompt 保存等
                this.handlePredictorWarning(split, hour, task, tXinyiIndustries6, tXinyiRobots6, date);
            }else {
                log.error("预测数据返回结果为{},无法正常解析", result);
            }
        }
        return "success";
    }

    @GetMapping("/dateAdd")
    public String dateAdd() {


        // 给定时间段的起始时间和结束时间
        LocalDateTime startTime = LocalDateTime.parse("2024-04-13T16:00:00");
        LocalDateTime endTime = LocalDateTime.parse("2024-04-13T17:00:00");


        /*LocalDateTime startTime = LocalDateTime.parse("2024-02-26T00:00:00");
        LocalDateTime endTime = LocalDateTime.parse("2024-02-27T00:00:00");*/

        // 每个小时的时间格式
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");

        // 循环按小时分割
        LocalDateTime currentHour = startTime;
        while (currentHour.isBefore(endTime)) {
            String begin = currentHour.format(formatter);
            String end = currentHour.plusMinutes(10).format(formatter);
            // 输出当前小时的起始时间和结束时间
            System.out.println("起始时间：" + begin);
            System.out.println("结束时间：" + end);

            // 当前小时加一小时，作为下一个小时的起始时间
            currentHour = currentHour.plusMinutes(10);

            //每个小时查询一次数据
            HashMap<String, Object> req = new HashMap<>();
            req.put("tagNames", queryTags);
            req.put("startTime", begin);
            req.put("endTime", end);
            req.put("recordNumbers", 100000);
            String body = HttpRequest.post(INDUSTRY_INTERFACE_ADDR).header("Authorization", "c2E6c2E=").header("clientName", "hongshan").body(JSON.toJSONString(req)).execute().body();
//            System.out.println("body = " + body);
            List<HashMap<String, String>> list = new ArrayList<>();

            //行转列数据处理
            for (String queryTag : queryTags) {
                JSONArray array = JSON.parseObject(body).getJSONArray(queryTag);
                //特殊数据处理一
                if(Objects.isNull(array) || array.isEmpty()){
                    System.out.println(queryTag + "查询到了空的数据，跳过本次循环");
                    continue;
                }
                int size = array.size();
                //特殊数据处理二
                if("0".equals(array.get(1) + "")){
                    System.out.println(queryTag + "查询到了数据，但是数据集合只有一条，且都是0");
                    continue;
                }
                //结合至少62个数据才满足条件(有可能获取不到)
                /*if(size < 62){
                    System.out.println(queryTag + "查询到了不符合条件的数据，跳过本次循环");
                    continue;
                }*/

                //存放的数据集
                //利用map去重
                HashMap<String, String> map = new LinkedHashMap<>();
                for (int i = 2; i < size; i++) {
//            System.out.println(i + "" + array.get(i));
                    JSONArray oneRecord = JSON.parseArray(JSON.toJSONString(array.get(i)));
                    //处理为空或者为0的数据
                    Object timeStampValue = oneRecord.get(2);
                    if(Objects.isNull(timeStampValue) || "0".equals(timeStampValue + ""))
                        continue;
                    BigDecimal value = Objects.isNull(oneRecord.get(0)) ? null : new BigDecimal(oneRecord.get(0) + "");
                    long timestamp = (long) timeStampValue;
                    String format = DateUtil.format(new Date(timestamp), DateUtils.YYYYMMDDHH_TS);
                    map.put(format, queryTag + "-" + value);
                }
                list.add(map);
            }
//        System.out.println("list = " + list);
            //先构造对象（list中任意一个map遍历的key个数）  因为合并完并不是1分钟60条，参考上面筛选区间，有时候会有几个值获取不到
            /*HashMap<String, String> oneRow = list.get(0);
            Set<String> set = oneRow.keySet();
            List<Industry> result = new ArrayList<>(set.size());
            set.forEach(s -> {
                Industry industry = new Industry();
                industry.setTestTime(s);
                result.add(industry);
            });*/
            Set<String> recordTimeSet = new HashSet<>();
            Map<String, TXinyiIndustry> recordMap = new HashMap<>();
            for (int i = 0; i < list.size(); i++) {
                HashMap<String, String> map = list.get(i);
                int finalJ = i;
                map.forEach((k, v) ->{
                    TXinyiIndustry industry = null;
                    if(!recordTimeSet.contains(k)){//第一次
                        industry = new TXinyiIndustry();
                        recordTimeSet.add(k);
                        recordMap.put(k, industry);
                    }else{
                        industry = recordMap.get(k);
                    }
                    industry.setTestTime(k);
                    //2024年4月15日11:19:52  额外增加2个字段
                    industry.setTestDate(k.substring(0,10));
                    industry.setTestHour(k.substring(0,13));
                    //解析值
                    String[] split = v.split("-");
                    String type = split[0];
                    BigDecimal value = new BigDecimal(split[1]);
                    if ("信义污水厂JS_COD_Value".equals(type)) {
                        industry.setJsCod(value);
                    } else if ("信义污水厂JS_PH_Value".equals(type)) {
                        industry.setJsPh(value);
                    } else if ("信义污水厂JS_SS_Value".equals(type)) {
                        industry.setJsSs(value);
                    } else if ("信义污水厂JS_ZL_Value".equals(type)) {
                        industry.setJsTp(value);
                    } else if ("信义污水厂JS_ZA_Value".equals(type)) {
                        industry.setJsTn(value);
                    } else if ("信义污水厂JS_AD_Value".equals(type)) {
                        industry.setJsNh3(value);
                    } else if ("信义污水厂JS_T_Value".equals(type)) {
                        industry.setJsSwPh(value);
                    } else if ("信义污水厂进水泵房液位".equals(type)) {
                        industry.setJsBfyw(value);
                    } else if ("信义污水厂出水瞬时流量".equals(type)) {
                        industry.setCsSlqc(value);
                    } else if ("信义污水厂升级出水COD".equals(type)) {
                        industry.setCsCod(value);
                    } else if ("信义污水厂升级出水PH".equals(type)) {
                        industry.setCsPh(value);
                    } else if ("信义污水厂升级出水SS".equals(type)) {
                        industry.setCsSs(value);
                    } else if ("信义污水厂升级出水TN".equals(type)) {
                        industry.setCsTn(value);
                    } else if ("信义污水厂升级出水TP".equals(type)) {
                        industry.setCsTp(value);
                    } else if ("信义污水厂升级出水氨氮".equals(type)) {
                        industry.setCsNh3(value);
                    } else if ("信义污水厂AIT202_Value".equals(type)) {
                        industry.setOneHyzdDo(value);
                    } else if ("信义污水厂AIT203_Value".equals(type)) {
                        industry.setOneHymdDo(value);
                    } else if ("信义污水厂AIT207_Value".equals(type)) {
                        industry.setTwoHyzdDo(value);
                    } else if ("信义污水厂AIT206_Value".equals(type)) {
                        industry.setTwoHymdDo(value);
                    } else if ("信义污水厂AIT209_Value".equals(type)) {
                        industry.setOneMlss(value);
                    } else if ("信义污水厂AIT210_Value".equals(type)) {
                        industry.setTwoMlss(value);
                    } else if ("信义污水厂进水TDS".equals(type)) {
                        industry.setJsTds(value);
                    } else if ("信义污水厂FT101_Value".equals(type)) {
                        industry.setJsSlq(value);
                    } else if ("信义污水厂SWCHHYHLB1_R_Value".equals(type)) {
                        industry.setNHlbOneGp(value);
                    } else if ("信义污水厂SWCHHYHLB2_R_Value".equals(type)) {
                        industry.setNHlbTwoGp(value);
                    } else if ("信义污水厂SWCHHYHLB3_R_Value".equals(type)) {
                        industry.setNHlbThreeGp(value);
                    } else if ("信义污水厂SWCHHYHLB4_R_Value".equals(type)) {
                        industry.setNHlbFourGp(value);
                    } else if ("信义污水厂SWCHHYHLB5_R_Value".equals(type)) {
                        industry.setNhlBFiveGp(value);
                    } else if ("信义污水厂SWCHHYHLB6_R_Value".equals(type)) {
                        industry.setNHlbSixGp(value);
                    } else if ("信义污水厂SWCWNHLB1_R_Value".equals(type)) {
                        industry.setWHlbOneGp(value);
                    } else if ("信义污水厂SWCWNHLB2_R_Value".equals(type)) {
                        industry.setWHlbTwoGp(value);
                    } else if ("信义污水厂SWCWNHLB3_R_Value".equals(type)) {
                        industry.setWHlbThreeGp(value);
                    } else if ("信义污水厂SWCWNHLB4_R_Value".equals(type)) {
                        industry.setWHlbFourGp(value);
                    } else if ("信义污水厂SWCWNHLB5_R_Value".equals(type)) {
                        industry.setWHlbFiveGp(value);
                    } else if ("信义污水厂GFJ1_R_Value".equals(type)) {
                        industry.setFjOne(value);
                    } else if ("信义污水厂GFJ2_R_Value".equals(type)) {
                        industry.setFjTwo(value);
                    } else if ("信义污水厂GFJ3_R_Value".equals(type)) {
                        industry.setFjThree(value);
                    } else if ("信义污水厂GFJ4_R_Value".equals(type)) {
                        industry.setFjFour(value);
                    } else if ("信义污水厂GFJ5_R_Value".equals(type)) {
                        industry.setFjFive(value);
                    } else if ("信义污水厂GFJ6_R_Value".equals(type)) {
                        industry.setFjSix(value);
                    } else if ("信义污水厂GFJ1_KQLL_Value".equals(type)) {
                        industry.setKqllOne(value);
                    } else if ("信义污水厂GFJ2_KQLL_Value".equals(type)) {
                        industry.setKqllTwo(value);
                    } else if ("信义污水厂GFJ3_KQLL_Value".equals(type)) {
                        industry.setKqllThree(value);
                    } else if ("信义污水厂GFJ4_KQLL_Value".equals(type)) {
                        industry.setKqllFour(value);
                    } else if ("信义污水厂GFJ5_KQLL_Value".equals(type)) {
                        industry.setKqllFive(value);
                    } else if ("信义污水厂GFJ6_KQLL_Value".equals(type)) {
                        industry.setKqllSix(value);
                    }else if ("信义污水厂实际碳源加药量".equals(type)) {
                        industry.setSJTYJLY(value);
                    }else if ("信义污水厂除磷加药瞬时流量".equals(type)) {
                        industry.setCLJYSSLL(value);
                    }
                    //只有最后一次才执行数据库添加
                    if(finalJ == list.size()-1){
                        //插入数据库
                        xinyiIndustryMapper.insertTXinyiIndustry(industry);
                    }
                });




            }

        }
        return "ok";
    }

//    @GetMapping("/dateUpdateCL")
//    public String dateUpdateCL() {
//        String fileName = "除磷加药瞬时流量";
//        //输入目录
//        ExcelReader reader = ExcelUtil.getReader("C:\\Users\\10109\\Desktop\\新程序\\" + fileName + ".xls");
//        //解析数据
//        List<List<Object>> readAll = reader.read();
//        if(!CollectionUtils.isEmpty(readAll)){
//            for (List<Object> objects : readAll) {
//                String time = "20" + objects.get(0) + " " + objects.get(1).toString().substring(0, 5);
//                System.out.println("time = " + time);
//                TXinyiIndustry uniqueTXinyiIndustry = this.xinyiIndustryMapper.getUniqueTXinyiIndustry(time);
//                if(!Objects.isNull(uniqueTXinyiIndustry)){
//                    System.out.println(objects.get(2));
//                    BigDecimal CLJYSSLL = Objects.isNull(objects.get(2)) ? null : new BigDecimal(String.valueOf(objects.get(2)));
//                    uniqueTXinyiIndustry.setCLJYSSLL(CLJYSSLL);
//                    this.xinyiIndustryMapper.updateTXinyiIndustry(uniqueTXinyiIndustry);
//                }
//            }
//        }
//        return "ok";
//    }
//
//
//    @GetMapping("/dateUpdateSJTY")
//    public String dateUpdateSJTY() {
//        String fileName = "信义污水厂实际碳源加药量";
//        //输入目录
//        ExcelReader reader = ExcelUtil.getReader("C:\\Users\\10109\\Desktop\\新程序\\" + fileName + ".xls");
//        //解析数据
//        List<List<Object>> readAll = reader.read();
//        if(!CollectionUtils.isEmpty(readAll)){
//            int i = 0;
//            for (List<Object> objects : readAll) {
//                String format = "";
//                if(objects.get(0) instanceof String){
//                    System.out.println("----------是字符串类型的");
//                    String time = ((String) objects.get(0));
//                    System.out.println("time = " + time);
//                    format =  time.replaceAll("-", "/").substring(0, 16);
//                }else if (objects.get(0) instanceof cn.hutool.core.date.DateTime){
//                    System.out.println("++++++++++是日期类型的");
//                    cn.hutool.core.date.DateTime time = (DateTime) objects.get(0);
//                    System.out.println("time = " + time);
//                    format = DateUtil.format(time, DateUtils.YYYYMMDDHHMM_TS);
//                    System.out.println("format = " + format);
//                }else {
//                    System.out.println(JSON.toJSONString(objects));
//                    format = "";
//                    i++;
//                }
//                TXinyiIndustry uniqueTXinyiIndustry = this.xinyiIndustryMapper.getUniqueTXinyiIndustry(format);
//                if(!Objects.isNull(uniqueTXinyiIndustry)){
//                    BigDecimal SJTYJLY = Objects.isNull(objects.get(1)) ? null : new BigDecimal(String.valueOf(objects.get(1)));
//                    uniqueTXinyiIndustry.setSJTYJLY(SJTYJLY);
//                    this.xinyiIndustryMapper.updateTXinyiIndustry(uniqueTXinyiIndustry);
//                }
//            }
//            System.out.println("i =" + i);
//        }
//        return "ok";
//    }
//
//    //下面是新的 将一个小时的数据 更新到一个小时之内的所有的数据中
//    @GetMapping("/dateUpdateCLMinute")
//    public String dateUpdateCLMinute() {
//        String fileName = "除磷加药瞬时流量";
//        //输入目录
//        ExcelReader reader = ExcelUtil.getReader("C:\\Users\\10109\\Desktop\\新程序\\" + fileName + ".xls");
//        //解析数据
//        List<List<Object>> readAll = reader.read();
//        int i = 0;
//        if(!CollectionUtils.isEmpty(readAll)){
//            for (List<Object> objects : readAll) {
//                if(!Objects.isNull(objects.get(0)) && !Objects.isNull(objects.get(1))){
//                    String beginTime = "20" + objects.get(0) + " " + objects.get(1).toString().substring(0, 5);
//                    System.out.println("beginTime = " + beginTime);
//                    String endTime = "20" + objects.get(0) + " " + objects.get(1).toString().substring(0, 3) + "59";
//                    System.out.println("endTime = " + endTime);
//                    //更新数据
//                    System.out.println(objects.get(2));
//                    //有特殊情况
//                    if(Objects.isNull(objects.get(2)) || objects.get(2).toString().contains("-")){
//                        System.out.println("存在特殊的情况，值包含-,不做更新");
//                        i++;
//                    }else{
//                    this.xinyiIndustryMapper.updateTXinyiIndustryCLByBetweenTime(beginTime, endTime, new BigDecimal(String.valueOf(objects.get(2))));
//                    }
//                }
//            }
//        }
//        System.out.println("i = " + i);
//        return "ok";
//    }
//
//
//    @GetMapping("/dateUpdateSJTYMinute")
//    public String dateUpdateSJTYMinute() {
//        String fileName = "信义污水厂实际碳源加药量";
//        //输入目录
//        ExcelReader reader = ExcelUtil.getReader("C:\\Users\\10109\\Desktop\\新程序\\" + fileName + ".xls");
//        //解析数据
//        List<List<Object>> readAll = reader.read();
//        if(!CollectionUtils.isEmpty(readAll)){
//            int i = 0;
//            for (List<Object> objects : readAll) {
//                String beginTime = "";
//                if(objects.get(0) instanceof String){
//                    System.out.println("----------是字符串类型的");
//                    String time = ((String) objects.get(0));
////                    System.out.println("time = " + time);
//                    beginTime = time.replaceAll("-", "/").substring(0, 16);
//                }else if (objects.get(0) instanceof cn.hutool.core.date.DateTime){
//                    System.out.println("++++++++++是日期类型的");
//                    cn.hutool.core.date.DateTime time = (DateTime) objects.get(0);
////                    System.out.println("time = " + time);
//                    beginTime = DateUtil.format(time, DateUtils.YYYYMMDDHHMM_TS);
//                    System.out.println("beginTime = " + beginTime);
//                }else {
//                    System.out.println(JSON.toJSONString(objects));
//                    beginTime = "";
//                    i++;
//                }
//                //endTime
//                String endTime = beginTime.substring(0, 14) + "59";
//                System.out.println("endTime = " + endTime);
//                //更新数据
//                BigDecimal sjtyjly = Objects.isNull(objects.get(1)) ? null : new BigDecimal(String.valueOf(objects.get(1)));
//                this.xinyiIndustryMapper.updateTXinyiIndustrySJByBetweenTime(beginTime, endTime, sjtyjly);
//            }
//            System.out.println("i =" + i);
//        }
//        return "ok";
//    }





//    @GetMapping("/dateUpdateSJTYMinute")
//    public String dateUpdateSJTYMinute() {
//        log.info("进入了手动处理两个值的操作~~~~~~~~");
//        File file = new File("/home/slibra/历史数据");
//        if(file.isDirectory()){
//            for (File listFile : file.listFiles()) {
//                //        输入目录
//                ExcelReader reader = ExcelUtil.getReader(listFile);
//                List<List<Object>> readAll = reader.read();
//                if(!CollectionUtils.isEmpty(readAll)){
//                    for (int i = 3; i < readAll.size(); i++) {
//                        //解析数据
//                        List<Object> objects = readAll.get(i);
//                        String time = "20" + objects.get(0).toString().replaceAll(" ", "") + " " + objects.get(1).toString().replaceAll(" ", "").substring(0, 5);
////                        System.out.println("time = " + time);
//                        TXinyiIndustry uniqueTXinyiIndustry = this.xinyiIndustryMapper.getUniqueTXinyiIndustry(time);
//                        if(!Objects.isNull(uniqueTXinyiIndustry)){
//                            TXinyiIndustry updateBean = new TXinyiIndustry();
//                            updateBean.setID(uniqueTXinyiIndustry.getID());
//                            BigDecimal CLJYSSLL = Objects.isNull(objects.get(2)) || String.valueOf(objects.get(2)).contains("-") ? null : new BigDecimal(String.valueOf(objects.get(2)));
//                            updateBean.setCLJYSSLL(CLJYSSLL);
//                            BigDecimal SJTYJLY = Objects.isNull(objects.get(3)) || String.valueOf(objects.get(3)).contains("-") ? null : new BigDecimal(String.valueOf(objects.get(3)));
//                            updateBean.setSJTYJLY(SJTYJLY);
//                            //如果两个都不为空再更新
//                            if(!Objects.isNull(CLJYSSLL) || !Objects.isNull(SJTYJLY)){
//                                this.xinyiIndustryMapper.updateTXinyiIndustry(updateBean);
//                            }else{
//                                log.error("要更新的两个字段全部为空--------");
//                            }
//                        }
//                    }
//                }
//                }
//            }
//        return "ok";
//    }


    /**
     *
     * 从Excel读取数据 将新增的列数据更新到新的日报字段中
     * @return
     */
    @GetMapping("/dailyAddDataByExcel")
    public String dailyAddDataByExcel() {
        log.info("从Excel读取数据 将新增的列数据更新到新的日报字段中~~~~~~~~");
        File file = new File("/home/slibra/绝干泥量.xlsx");
//        File file = new File("C:\\Users\\10109\\Documents\\WeChat Files\\mz1010995810\\FileStorage\\File\\2024-05\\绝干泥量.xlsx");
        //        输入目录
        ExcelReader reader = ExcelUtil.getReader(file);
        List<List<Object>> readAll = reader.read();
//        log.info("Excel解析的结果为{}", JSON.toJSONString(readAll));
        if(!CollectionUtils.isEmpty(readAll)){
            for (int i = 1; i < readAll.size(); i++) {
                //解析数据
                List<Object> objects = readAll.get(i);
                String date = (String) objects.get(0);
                date = date.replaceAll("\\.", "/");
                date = handleDate(date);

                //用时间去查询 如果存在就更新，否则跳过
                List<TXinyiDaily> tXinyiDailies = this.xinyiDailyMapper.selectTXinyiDailyList(TXinyiDaily.builder().testDate(date).build());
                if(CollectionUtils.isEmpty(tXinyiDailies)){
                    log.error("没有查询到对应的历史数据，跳过~~~~~~{}", date);
                    continue;
                }

                //目前集合就一个对象  以后可能会多个
                TXinyiDaily tXinyiDaily = tXinyiDailies.get(0);

                //出泥量
                Object o1 = objects.get(1);
                BigDecimal CHUNILIANG = null;
                if(o1 instanceof String){
                    log.error("数据异常，解析为null");
                    CHUNILIANG = null;
                }else  if(o1 instanceof Double){
                    CHUNILIANG = new BigDecimal((Double) o1);
                }else {
                    log.error("错误的类型，不用解析了");
                    CHUNILIANG = null;
                }

                //出泥含水率
                BigDecimal CNHSL = null;
                Object o2 = objects.get(2);
                if(o2 instanceof String){
                    log.error("数据异常，解析为null");
                    CNHSL = null;
                }else  if(o2 instanceof Double){
                    CNHSL = new BigDecimal((Double) o2);
                }else {
                    log.error("错误的类型，不用解析了");
                    CNHSL = null;
                }

                //干污泥量
                Object o3 = objects.get(3);
                BigDecimal GWNL = null;
                if(o3 instanceof String){
                    log.error("数据异常，解析为null");
                    GWNL = null;
                }else  if(o3 instanceof Double){
                    GWNL = new BigDecimal((Double) o3);
                }else {
                    log.error("错误的类型，不用解析了");
                    GWNL = null;
                }

                //更新数据
                tXinyiDaily.setCHUNILIANG(CHUNILIANG);
                tXinyiDaily.setCNHSL(CNHSL);
                tXinyiDaily.setGWNL(GWNL);
                this.xinyiDailyMapper.updateTXinyiDaily(tXinyiDaily);

            }
        }
        return "ok";
    }


    /**
     * 手动处理日报数据 增加两个字段 时间和小时
     * @return
     */
    @GetMapping("/dateUpdateDaily")
    public String dateUpdateDaily() {
        //获取全部数据
        List<TXinyiDaily> tXinyiDailies = this.xinyiDailyMapper.selectTXinyiDailyList(null);
        if(!CollectionUtils.isEmpty(tXinyiDailies)){
            for (TXinyiDaily tXinyiDaily : tXinyiDailies) {
                String handleTime = handleDate(tXinyiDaily.getTestTime());
                tXinyiDaily.setTestTime(handleTime);
                tXinyiDaily.setTestDate(handleTime);
                //更新
                this.xinyiDailyMapper.updateTXinyiDaily(tXinyiDaily);
            }
        }
        return "ok";
    }


    /**
     * 手动处理化验数据 增加两个字段 时间和小时
     * @return
     */
    @GetMapping("/dateUpdateHuaYan")
    public String dateUpdateHuaYan() {
        //获取全部数据
        List<TXinyiLaboratory> tXinyiLaboratories = this.xinyiLaboratoryMapper.selectTXinyiLaboratoryList(null);
        if(!CollectionUtils.isEmpty(tXinyiLaboratories)){
            for (TXinyiLaboratory tXinyiLaboratory : tXinyiLaboratories) {
                String handleTime = handleDate(tXinyiLaboratory.getTestTime());
                tXinyiLaboratory.setTestTime(handleTime);//到分为止
                tXinyiLaboratory.setTestDate(handleTime.substring(0, 10));
                tXinyiLaboratory.setTestHour(handleTime.substring(0, 13));
                //更新
                this.xinyiLaboratoryMapper.updateTXinyiLaboratory(tXinyiLaboratory);
            }
        }
        return "ok";
    }



    /**
     * 手动处理 工业库的 某个值，将历史数据全部都更新
     * @return
     */
    @GetMapping("/updateGYKSomeFields")
    public String updateGYKSomeFields() {
        //更新的某个指标
//        String[] queryTags = {"信义污水厂_除磷P04预测值_"};
        String[] queryTags = {"信义污水厂一号鼓风机电流", "信义污水厂二号鼓风机电流", "信义污水厂三号鼓风机电流", "信义污水厂四号鼓风机电流", "信义污水厂五号鼓风机电流", "信义污水厂六号鼓风机电流", "信义污水厂XGS1_R_Value", "信义污水厂细格栅间_2号细格栅主机_运行信号", "信义污水厂细格栅间_3号细格栅主机_运行信号", "信义污水厂XGS4_R_Value", "信义污水厂细格栅间_5号细格栅主机_运行信号", "信义污水厂细格栅间_6号细格栅主机_运行信号", "信义污水厂内回流1#_Ia", "信义污水厂内回流2#_Ia", "信义污水厂内回流3#_Ia", "信义污水厂内回流4#_Ia", "信义污水厂内回流5#_Ia", "信义污水厂内回流6#_Ia", "信义污水厂PNBFPNB1_R_Value", "信义污水厂PNBFPNB2_R_Value", "信义污水厂SWCSYWNHLB1_R_Value", "信义污水厂SWCSYWNHLB2_R_Value", "信义污水厂升级1#空压机主机A相电流", "信义污水厂升级2#空压机主机A相电流", "信义污水厂升级3#空压机主机A相电流", "信义污水厂升级4#空压机主机A相电流"};
        //找到对应的数据，然后更新它
        // 给定时间段的起始时间和结束时间
        LocalDateTime startTime = LocalDateTime.parse("2022-07-01T00:00:00");
        LocalDateTime endTime = LocalDateTime.parse("2025-04-03T10:00:01");

        // 每个小时的时间格式
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");

        // 循环按小时分割
        LocalDateTime currentHour = startTime;
        while (currentHour.isBefore(endTime)) {
            String begin = currentHour.format(formatter);
            String end = currentHour.plusDays(1).format(formatter);
            // 输出当前小时的起始时间和结束时间
            System.out.println("起始时间：" + begin);
            System.out.println("结束时间：" + end);

            // 当前小时加一小时，作为下一个小时的起始时间
            currentHour = currentHour.plusDays(1);

            //每个小时查询一次数据
            HashMap<String, Object> req = new HashMap<>();
            req.put("tagNames", queryTags);
            req.put("startTime", begin);
            req.put("endTime", end);
            req.put("recordNumbers", 100000);
            String body = HttpRequest.post(INDUSTRY_INTERFACE_ADDR).header("Authorization", "c2E6c2E=").header("clientName", "hongshan").body(JSON.toJSONString(req)).execute().body();
//            System.out.println("body = " + body);
            List<HashMap<String, String>> list = new ArrayList<>();

            //行转列数据处理
            for (String queryTag : queryTags) {
                JSONArray array = JSON.parseObject(body).getJSONArray(queryTag);
                //特殊数据处理一
                if(Objects.isNull(array) || array.isEmpty()){
                    System.out.println(queryTag + "查询到了空的数据，跳过本次循环");
                    continue;
                }
                int size = array.size();
                //特殊数据处理二
                if("0".equals(array.get(1) + "")){
                    System.out.println(queryTag + "查询到了数据，但是数据集合只有一条，且都是0");
                    continue;
                }

                //存放的数据集
                //利用map去重
                HashMap<String, String> map = new LinkedHashMap<>();
                for (int i = 2; i < size; i++) {
//            System.out.println(i + "" + array.get(i));
                    JSONArray oneRecord = JSON.parseArray(JSON.toJSONString(array.get(i)));
                    //处理为空或者为0的数据
                    Object timeStampValue = oneRecord.get(2);
                    if(Objects.isNull(timeStampValue) || "0".equals(timeStampValue + ""))
                        continue;
                    BigDecimal value = Objects.isNull(oneRecord.get(0)) ? null : new BigDecimal(oneRecord.get(0) + "");
                    long timestamp = (long) timeStampValue;
                    String format = DateUtil.format(new Date(timestamp), DateUtils.YYYYMMDDHH_TS);
                    map.put(format, queryTag + "-" + value);
                }
                list.add(map);
            }
            Set<String> recordTimeSet = new HashSet<>();
            Map<String, TXinyiIndustry> recordMap = new HashMap<>();
            for (int i = 0; i < list.size(); i++) {
                HashMap<String, String> map = list.get(i);
                int finalJ = i;
                map.forEach((k, v) ->{
                    TXinyiIndustry industry = null;
                    if(!recordTimeSet.contains(k)){//第一次
                        industry = new TXinyiIndustry();
                        recordTimeSet.add(k);
                        recordMap.put(k, industry);
                    }else{
                        industry = recordMap.get(k);
                    }
                    industry.setTestHour(k);
                    //解析值
                    String[] split = v.split("-");
                    String type = split[0];
                    BigDecimal value = new BigDecimal(split[1]);
                    if ("信义污水厂_除磷P04预测值_".equals(type)) {
                        industry.setCLP04YCZ(value);//目前值更新此字段
                    }else if ("信义污水厂一号鼓风机电流".equals(type)) {
                        industry.setOneFjDl(value);
                    }else if ("信义污水厂二号鼓风机电流".equals(type)) {
                        industry.setTwoFjDl(value);
                    }else if ("信义污水厂三号鼓风机电流".equals(type)) {
                        industry.setThreeFjDl(value);
                    }else if ("信义污水厂四号鼓风机电流".equals(type)) {
                        industry.setFourFjDl(value);
                    }else if ("信义污水厂五号鼓风机电流".equals(type)) {
                        industry.setFiveFjDl(value);
                    }else if ("信义污水厂六号鼓风机电流".equals(type)) {
                        industry.setSixFjDl(value);
                    }else if ("信义污水厂XGS1_R_Value".equals(type)) {
                        industry.setOneXgsQt(value);
                    }else if ("信义污水厂细格栅间_2号细格栅主机_运行信号".equals(type)) {
                        industry.setTwoXgsQt(value);
                    }else if ("信义污水厂细格栅间_3号细格栅主机_运行信号".equals(type)) {
                        industry.setThreeXgsQt(value);
                    }else if ("信义污水厂XGS4_R_Value".equals(type)) {
                        industry.setFourXgsQt(value);
                    }else if ("信义污水厂细格栅间_5号细格栅主机_运行信号".equals(type)) {
                        industry.setFiveXgsQt(value);
                    }else if ("信义污水厂细格栅间_6号细格栅主机_运行信号".equals(type)) {
                        industry.setSixXgsQt(value);
                    }else if ("信义污水厂内回流1#_Ia".equals(type)) {
                        industry.setOneNhlbDl(value);
                    }else if ("信义污水厂内回流2#_Ia".equals(type)) {
                        industry.setTwoNhlbDl(value);
                    }else if ("信义污水厂内回流3#_Ia".equals(type)) {
                        industry.setThreeNhlbDl(value);
                    }else if ("信义污水厂内回流4#_Ia".equals(type)) {
                        industry.setFourNhlbDl(value);
                    }else if ("信义污水厂内回流5#_Ia".equals(type)) {
                        industry.setFiveNhlbDl(value);
                    }else if ("信义污水厂内回流6#_Ia".equals(type)) {
                        industry.setSixNhlbDl(value);
                    }else if ("信义污水厂PNBFPNB1_R_Value".equals(type)) {
                        industry.setOneCccpnbQt(value);
                    }else if ("信义污水厂PNBFPNB2_R_Value".equals(type)) {
                        industry.setTwoCccpnbQt(value);
                    }else if ("信义污水厂SWCSYWNHLB1_R_Value".equals(type)) {
                        industry.setOneSywndbQt(value);
                    }else if ("信义污水厂SWCSYWNHLB2_R_Value".equals(type)) {
                        industry.setTwoSywndbQt(value);
                    }else if ("信义污水厂升级1#空压机主机A相电流".equals(type)) {
                        industry.setOneSdclDl(value);
                    }else if ("信义污水厂升级2#空压机主机A相电流".equals(type)) {
                        industry.setTwoSdclDl(value);
                    }else if ("信义污水厂升级3#空压机主机A相电流".equals(type)) {
                        industry.setThreeSdclDl(value);
                    }else if ("信义污水厂升级4#空压机主机A相电流".equals(type)) {
                        industry.setFourSdclDl(value);
                    }
                    /*else if ("信义污水厂除磷加药瞬时流量".equals(type)) {
                        industry.setCLJYSSLL(value);
                    }*/

                    //只有最后一次才执行数据库添加
                    if(finalJ == list.size()-1){
                        //先去查询数据库
                        TXinyiIndustry uniqueTXinyiIndustry = this.xinyiIndustryMapper.getUniqueTXinyiIndustry(industry.getTestHour());
                        if(Objects.isNull(uniqueTXinyiIndustry))
                            log.error("查询到的工业库数据为null，化验时间为{}", industry.getTestHour());
                        else {
                            //防止其他信息被更新，新建对象
                            TXinyiIndustry updateTXinyiIndustry = new TXinyiIndustry();
                            //赋值
                            updateTXinyiIndustry.setID(uniqueTXinyiIndustry.getID());
//                            updateTXinyiIndustry.setCLP04YCZ(industry.getCLP04YCZ());
                            updateTXinyiIndustry.setOneFjDl(industry.getOneFjDl());
                            updateTXinyiIndustry.setTwoFjDl(industry.getTwoFjDl());
                            updateTXinyiIndustry.setThreeFjDl(industry.getThreeFjDl());
                            updateTXinyiIndustry.setFourFjDl(industry.getFourFjDl());
                            updateTXinyiIndustry.setFiveFjDl(industry.getFiveFjDl());
                            updateTXinyiIndustry.setSixFjDl(industry.getSixFjDl());
                            updateTXinyiIndustry.setOneXgsQt(industry.getOneXgsQt());
                            updateTXinyiIndustry.setTwoXgsQt(industry.getTwoXgsQt());
                            updateTXinyiIndustry.setThreeXgsQt(industry.getThreeXgsQt());
                            updateTXinyiIndustry.setFourXgsQt(industry.getFourXgsQt());
                            updateTXinyiIndustry.setFiveXgsQt(industry.getFiveXgsQt());
                            updateTXinyiIndustry.setSixXgsQt(industry.getSixXgsQt());
                            updateTXinyiIndustry.setOneNhlbDl(industry.getOneNhlbDl());
                            updateTXinyiIndustry.setTwoNhlbDl(industry.getTwoNhlbDl());
                            updateTXinyiIndustry.setThreeNhlbDl(industry.getThreeNhlbDl());
                            updateTXinyiIndustry.setFourNhlbDl(industry.getFourNhlbDl());
                            updateTXinyiIndustry.setFiveNhlbDl(industry.getFiveNhlbDl());
                            updateTXinyiIndustry.setSixNhlbDl(industry.getSixNhlbDl());
                            updateTXinyiIndustry.setOneCccpnbQt(industry.getOneCccpnbQt());
                            updateTXinyiIndustry.setTwoCccpnbQt(industry.getTwoCccpnbQt());
                            updateTXinyiIndustry.setOneSywndbQt(industry.getOneSywndbQt());
                            updateTXinyiIndustry.setTwoSywndbQt(industry.getTwoSywndbQt());
                            updateTXinyiIndustry.setOneSdclDl(industry.getOneSdclDl());
                            updateTXinyiIndustry.setTwoSdclDl(industry.getTwoSdclDl());
                            updateTXinyiIndustry.setThreeSdclDl(industry.getThreeSdclDl());
                            updateTXinyiIndustry.setFourSdclDl(industry.getFourSdclDl());
                            //更新数据库
                            xinyiIndustryMapper.updateTXinyiIndustry(updateTXinyiIndustry);
                        }
                    }
                });

            }
        }
        return "ok";
    }


    /**
     * 手动处理 计算相关的数据，处理历史数据
     * @return
     */
    @GetMapping("/handleCalculateHistoryDates")
    public String handleCalculateHistoryDates() {
        log.info("进入了 手动处理-重置计算表历史数据");
        long begin = System.currentTimeMillis();

        List<TXinyiNormConfig> tXinyiNormConfigs = xinyiNormConfigMapper.selectTXinyiNormConfigList(null);
        if(CollectionUtils.isEmpty(tXinyiNormConfigs)) {
            log.error( "未查询到配置信息");
            return null;
        }

        TXinyiNormConfig normConfig = tXinyiNormConfigs.get(0);

        int size = 500;
        int count = xinyiIndustryMapper.getCount();

        int num = ( count / size ) + 1;

        for (int i = 0; i < num; i++) {
            List<TXinyiIndustry> tXinyiIndustries = xinyiIndustryMapper.selectTXinyiIndustryListByPage(i * size, size);
            List<TXinyiCalculate> tempInsertData = new ArrayList<>();
            if (!CollectionUtils.isEmpty( tXinyiIndustries )) {
                for (int j = 0; j < tXinyiIndustries.size(); j++) {

                    TXinyiIndustry tXinyiIndustry = tXinyiIndustries.get(j);

                    //获取的一些配置信息
                    BigDecimal nhlbqdsl = normConfig.getNHLBQDSL();
                    BigDecimal nhlbdsjll = normConfig.getNHLBDSJLL();
                    BigDecimal nhlbgzxl = normConfig.getNHLBGZXL();
                    BigDecimal whlbqdsl = normConfig.getWHLBQDSL();
                    BigDecimal whlbdsjll = normConfig.getWHLBDSJLL();
                    BigDecimal whlbgzxl = normConfig.getWHLBGZXL();
                    BigDecimal gfjgzts = normConfig.getGFJGZTS();
                    BigDecimal gfjckll = normConfig.getGFJCKLL();
                    BigDecimal fcxbsjll = normConfig.getFCXBSJLL();
                    BigDecimal fclbsl = normConfig.getFCLBSL();
                    BigDecimal fcxbgzxl = normConfig.getFCXBGZXL();
                    BigDecimal jsslSjz = normConfig.getJsslSjz();

                    //结算结果
                    TXinyiCalculate tXinyiCalculate = new TXinyiCalculate();
                    //时间相关
                    tXinyiCalculate.setTestDate(tXinyiIndustry.getTestDate());
                    tXinyiCalculate.setTestHour(tXinyiIndustry.getTestHour());
                    tXinyiCalculate.setTestTime(tXinyiIndustry.getTestTime());

                    //获取最新的一条日报信息
                    TXinyiDaily tXinyiDaily = this.xinyiDailyMapper.getDetailByDay(tXinyiIndustry.getTestDate());
                    if(Objects.isNull(tXinyiDaily)){
                        //理论不会出现
                        log.error("没有日报数据，取最新的");
                        tXinyiDaily = this.xinyiDailyMapper.selectNewestData();
                    }

                    BigDecimal jsBod5 = tXinyiDaily.getJsBod5();
                    BigDecimal csBod5 = tXinyiDaily.getCsBod5();
                    BigDecimal whlR = tXinyiDaily.getWhlR();
                    BigDecimal oneMlvss = tXinyiDaily.getShcHyOneMlvss();
                    BigDecimal twoMlvss = tXinyiDaily.getShcHyTwoMlvss();
                    BigDecimal avgMlvss = null;
                    if(!Objects.isNull(oneMlvss) && !Objects.isNull(twoMlvss))
                        avgMlvss = ((oneMlvss.add(twoMlvss)).divide(new BigDecimal(2),4, RoundingMode.HALF_UP));
                    BigDecimal oneMlss = tXinyiDaily.getShcHyOneMlss();
                    BigDecimal twoMlss = tXinyiDaily.getShcHyTwoMlss();
                    BigDecimal avgMlss = null;
                    if(!Objects.isNull(oneMlss) && !Objects.isNull(twoMlss))
                        avgMlss = ((oneMlss.add(twoMlss)).divide(new BigDecimal(NUMBER_2),NUMBER_SCALE_4, RoundingMode.HALF_UP));

                    //工业库的指标
                    BigDecimal jsTn = tXinyiIndustry.getJsTn();
                    BigDecimal jsTp = tXinyiIndustry.getJsTp();
                    BigDecimal jsCod = tXinyiIndustry.getJsCod();
                    BigDecimal jsSlq = tXinyiIndustry.getJsSlq();
                    BigDecimal jsSs = tXinyiIndustry.getJsSs();
                    BigDecimal jsNh3 = tXinyiIndustry.getJsNh3();

                    BigDecimal csCod = tXinyiIndustry.getCsCod();
                    BigDecimal csSs = tXinyiIndustry.getCsSs();
                    BigDecimal csTn = tXinyiIndustry.getCsTn();
                    BigDecimal csTp = tXinyiIndustry.getCsTp();
                    BigDecimal csNh3 = tXinyiIndustry.getCsNh3();
                    //计算
                    if(!Objects.isNull(jsBod5)){
                        if(!Objects.isNull(jsTn) && jsTn.compareTo(BigDecimal.ZERO) > 0)
                            tXinyiCalculate.setJsTdb(jsBod5.divide(jsTn, NUMBER_SCALE_4, RoundingMode.HALF_UP));
                        if(!Objects.isNull(jsTp) && jsTp.compareTo(BigDecimal.ZERO) > 0)
                            tXinyiCalculate.setJsTlb(jsBod5.divide(jsTp, NUMBER_SCALE_4, RoundingMode.HALF_UP));
                        if(!Objects.isNull(jsCod) && jsCod.compareTo(BigDecimal.ZERO) > 0)
                            tXinyiCalculate.setJsBodBCod(jsBod5.divide(jsCod, NUMBER_SCALE_4, RoundingMode.HALF_UP));
                        if(!Objects.isNull(csBod5) && !Objects.isNull(avgMlss) && avgMlss.compareTo(BigDecimal.ZERO) > 0 && !Objects.isNull(jsSlq) && jsSlq.compareTo(BigDecimal.ZERO) > 0)
                            tXinyiCalculate.setFM(new BigDecimal(ONE_DAY_HOURS).multiply((jsBod5.subtract(csBod5))).multiply(jsSlq).divide(avgMlss, NUMBER_SCALE_4, RoundingMode.HALF_UP).divide(new BigDecimal(F_M_LAST), NUMBER_SCALE_4, RoundingMode.HALF_UP));
                    }
                    if(!Objects.isNull(avgMlss) && avgMlss.compareTo(BigDecimal.ZERO) > 0 && !Objects.isNull(avgMlvss) && avgMlvss.compareTo(BigDecimal.ZERO) > 0)
                        tXinyiCalculate.setHFXWNNDZB(avgMlvss.divide(avgMlss, NUMBER_SCALE_4, RoundingMode.HALF_UP));
                    if(!Objects.isNull(jsSlq) && jsSlq.compareTo(BigDecimal.ZERO) > 0){
                        tXinyiCalculate.setYyqHrt(new BigDecimal(YYQ_TLSJ_FIRST).divide(jsSlq, NUMBER_SCALE_4, RoundingMode.HALF_UP));
                        tXinyiCalculate.setQyqHrt(new BigDecimal(QYQ_TLSJ_FIRST).divide(jsSlq, NUMBER_SCALE_4, RoundingMode.HALF_UP));
                        tXinyiCalculate.setHyqHrt(new BigDecimal(HYQ_TLSJ_FIRST).divide(jsSlq, NUMBER_SCALE_4, RoundingMode.HALF_UP));
//            tXinyiCalculate.setGSLS(jsSlq.divide(new BigDecimal(NUMBER_3600), NUMBER_SCALE_4, RoundingMode.HALF_UP).multiply(new BigDecimal(NUMBER_4)).divide((new BigDecimal(Math.PI).multiply(new BigDecimal(NUMBER_0_0_0_3)).multiply(new BigDecimal(NUMBER_0_0_0_3)).multiply(new BigDecimal(NUMBER_4)).multiply(new BigDecimal(NUMBER_4)).multiply(new BigDecimal(NUMBER_97119))) , NUMBER_SCALE_4, RoundingMode.HALF_UP));
                        tXinyiCalculate.setGSLS(jsSlq.divide(GSLS_LAST, NUMBER_SCALE_4, RoundingMode.HALF_UP));
                        tXinyiCalculate.setGslsOne(jsSlq.divide(new BigDecimal(NUMBER_3600), NUMBER_SCALE_4, RoundingMode.HALF_UP).multiply(new BigDecimal(Math.sqrt(Math.sin(Math.toRadians(DOUBLE_75))))).divide(GSLSONE_LAST, NUMBER_SCALE_4, RoundingMode.HALF_UP));
                        tXinyiCalculate.setGslsTwo(jsSlq.divide(new BigDecimal(NUMBER_3600), NUMBER_SCALE_4, RoundingMode.HALF_UP).multiply(new BigDecimal(Math.sqrt(Math.sin(Math.toRadians(DOUBLE_75))))).divide(GSLSTWO_LAST, NUMBER_SCALE_4, RoundingMode.HALF_UP));
                        tXinyiCalculate.setXgsGsls(jsSlq.divide(new BigDecimal(NUMBER_3600), NUMBER_SCALE_4, RoundingMode.HALF_UP).multiply(new BigDecimal(NUMBER_4)).divide((GSLS_XGS_LAST) , NUMBER_SCALE_4, RoundingMode.HALF_UP));

                        tXinyiCalculate.setXlcscBmfh(jsSlq.divide(XLCSCBMFH_LAST, NUMBER_SCALE_4, RoundingMode.HALF_UP));
                        tXinyiCalculate.setXlcscHrt(XLCSCHRT_LAST.divide(jsSlq, NUMBER_SCALE_4, RoundingMode.HALF_UP));
                        tXinyiCalculate.setCccdcBmfh(jsSlq.divide(CCCDCBMFH_LAST, NUMBER_SCALE_4, RoundingMode.HALF_UP));
                        tXinyiCalculate.setCccdcHrt(CCCDCHRT_LAST.divide(jsSlq, NUMBER_SCALE_4, RoundingMode.HALF_UP));
                        tXinyiCalculate.setEccBmfh(jsSlq.divide(ECCBMFH_LAST, NUMBER_SCALE_4, RoundingMode.HALF_UP));
                        tXinyiCalculate.setEccHrt(ECCHRT_LAST.divide(jsSlq, NUMBER_SCALE_4, RoundingMode.HALF_UP));
                        //2024年7月1日17:16:16 计算逻辑调整
                        if(!Objects.isNull(whlR) && avgMlss != null && jsSlq != null) {
                            tXinyiCalculate.setEccGtfh((new BigDecimal(1).add(whlR.divide(BigDecimal_100, NUMBER_SCALE_4, RoundingMode.HALF_UP))).multiply(jsSlq).multiply(new BigDecimal(NUMBER_24)).multiply(avgMlss).divide(ECCGTFH_LAST, NUMBER_SCALE_4, RoundingMode.HALF_UP));
                        }
                        tXinyiCalculate.setClsnJcsj(CLSNJCSJ_LAST.divide(jsSlq, NUMBER_SCALE_4, RoundingMode.HALF_UP));
                        tXinyiCalculate.setXgcdcQsqSsls(jsSlq.multiply(XGCDCQSQSSLS_LAST));
                        //2024年6月29日15:18:01 增加几个新的计算指标
                        if(!Objects.isNull(nhlbqdsl) && !Objects.isNull(nhlbdsjll) && !Objects.isNull(nhlbgzxl))
                            tXinyiCalculate.setNHLB(nhlbqdsl.multiply(nhlbdsjll).multiply(nhlbgzxl).multiply(BigDecimal_100).divide(jsSlq, 4, RoundingMode.HALF_UP));
                        if(!Objects.isNull(whlbqdsl) && !Objects.isNull(whlbdsjll) && !Objects.isNull(whlbgzxl))
                            tXinyiCalculate.setWHLB(whlbqdsl.multiply(whlbdsjll).multiply(whlbgzxl).multiply(BigDecimal_100).divide(jsSlq, 4, RoundingMode.HALF_UP));
                        if(!Objects.isNull(gfjgzts) && !Objects.isNull(gfjckll))
                            tXinyiCalculate.setQSB(gfjgzts.multiply(gfjckll).divide(jsSlq, NUMBER_SCALE_4, RoundingMode.HALF_UP));
                        if(!Objects.isNull(fcxbsjll) && !Objects.isNull(fclbsl) && !Objects.isNull(fcxbgzxl)){
                            BigDecimal fcxsl = fcxbsjll.multiply(fclbsl).multiply(fcxbgzxl);
                            tXinyiCalculate.setFCXSL(fcxsl);
                            //2024年7月3日10:54:28 额外再增加一个字段
                            tXinyiCalculate.setFCXSLBL(fcxsl.divide(jsSlq, NUMBER_SCALE_4, RoundingMode.HALF_UP).multiply(BigDecimal_100));
                        }
                        //2024年7月11日15:43:47  之前给的外回流比计算不准确，额外一个字段记录新的外回流比
                        BigDecimal divide = jsSlq.divide(DECIMAL_2, NUMBER_SCALE_4, RoundingMode.HALF_UP);
                        if(divide.compareTo(DECIMAL_1500) < 0)
                            tXinyiCalculate.setWhlRN(DECIMAL_1200.divide(divide, NUMBER_SCALE_4, RoundingMode.HALF_UP).multiply(BigDecimal_100));
                        else
                            tXinyiCalculate.setWhlRN(DECIMAL_1620.divide(divide, NUMBER_SCALE_4, RoundingMode.HALF_UP).multiply(BigDecimal_100));
                        //2025年03月19日19:05:07 新增超污染物限制 和 超污染物负荷 进出水五大指标相关计算
                        if(!Objects.isNull(jsslSjz) && jsslSjz.compareTo(BigDecimal.ZERO) > 0){
                            if(!Objects.isNull(jsCod))
                                tXinyiCalculate.setJsCodCwrwfh(getCwrwfhzByDetail(jsSlq, jsCod, jsslSjz, normConfig.getJscodSjz()));
                            if(!Objects.isNull(jsSs))
                                tXinyiCalculate.setJsSsCwrwfh(getCwrwfhzByDetail(jsSlq, jsSs, jsslSjz, normConfig.getJsssSjz()));
                            if(!Objects.isNull(jsTn))
                                tXinyiCalculate.setJsZdCwrwfh(getCwrwfhzByDetail(jsSlq, jsTn, jsslSjz, normConfig.getJszdSjz()));
                            if(!Objects.isNull(jsTp))
                                tXinyiCalculate.setJsZlCwrwfh(getCwrwfhzByDetail(jsSlq, jsTp, jsslSjz, normConfig.getJszlSjz()));
                            if(!Objects.isNull(jsNh3))
                                tXinyiCalculate.setJsAdCwrwfh(getCwrwfhzByDetail(jsSlq, jsNh3, jsslSjz, normConfig.getJsadSjz()));
                        }
                    }

                    if(!Objects.isNull(csCod))
                        tXinyiCalculate.setCsCodCwrwxz(getCwrwxzByDetail(csCod, normConfig, CS_COD.getCode(), false));
                    if(!Objects.isNull(csSs))
                        tXinyiCalculate.setCsSsCwrwxz(getCwrwxzByDetail(csSs, normConfig, CS_SS.getCode(), false));
                    if(!Objects.isNull(csTn))
                        tXinyiCalculate.setCsZdCwrwxz(getCwrwxzByDetail(csTn, normConfig, CS_ZD.getCode(), false));
                    if(!Objects.isNull(csTp))
                        tXinyiCalculate.setCsZlCwrwxz(getCwrwxzByDetail(csTp, normConfig, CS_ZL.getCode(), false));
                    if(!Objects.isNull(csNh3))
                        tXinyiCalculate.setCsAdCwrwxz(getCwrwxzByDetail(csNh3, normConfig, CS_AD.getCode(), false));

                    if(!Objects.isNull(jsCod))
                        tXinyiCalculate.setJsCodCwrwxz(getCwrwxzByDetail(jsCod, normConfig, JS_COD.getCode(), false));
                    if(!Objects.isNull(jsSs))
                        tXinyiCalculate.setJsSsCwrwxz(getCwrwxzByDetail(jsSs, normConfig, JS_SS.getCode(), false));
                    if(!Objects.isNull(jsTn))
                        tXinyiCalculate.setJsZdCwrwxz(getCwrwxzByDetail(jsTn, normConfig, JS_ZD.getCode(), false));
                    if(!Objects.isNull(jsTp))
                        tXinyiCalculate.setJsZlCwrwxz(getCwrwxzByDetail(jsTp, normConfig, JS_ZL.getCode(), false));
                    if(!Objects.isNull(jsNh3))
                        tXinyiCalculate.setJsAdCwrwxz(getCwrwxzByDetail(jsNh3, normConfig, JS_AD.getCode(), false));

                    tempInsertData.add(tXinyiCalculate);
                    xinyiCalculateMapper.insertTXinyiCalculate(tXinyiCalculate);
                }

                // xinyiCalculateMapper.insertBatchData(tempInsertData);
                // return tXinyiCalculate;
            }
        }

        long end = System.currentTimeMillis();
        return "ok;耗时：" + (end - begin) /1000 + "秒。";
    }


    /**
     * 2025年02月14日10:26:03 因为超污染物负荷值 要根据具体的指标计算
     * @param itemVal
     * @param jsslSjz
     * @return
     */
    private BigDecimal getCwrwfhzByDetail(BigDecimal jsSlq, BigDecimal itemVal, BigDecimal jsslSjz, BigDecimal itemConfigVal) {
        return (jsSlq.multiply(itemVal)).divide((jsslSjz.multiply(itemConfigVal)), NUMBER_SCALE_4, RoundingMode.HALF_UP);
    }


    /**
     * 计算超污染物限制的值： 需要判断进水还是出水；是超标准还是超管控  出水的标准值=进水的设计值
     * 2025年03月19日10:25:45：逻辑调整：这里和以前不一样，以前是需要区分超标准还是超管控，现在全部都是超管控制。 不修改上层调用，这里默认都是false即可，防止以后再次修改回来。
     * @param currentVal
     * @param normConfig
     * @param code
     * @param isBzz
     * @return
     */
    private BigDecimal getCwrwxzByDetail(BigDecimal currentVal, TXinyiNormConfig normConfig, String code, boolean isBzz) {
        isBzz = false;
        if(BusinessEnum.WarningCategoryEnum.CS_COD.getCode().equals(code)){
            if(isBzz)
                return currentVal.divide(normConfig.getCscodBzz(), NUMBER_SCALE_4, RoundingMode.HALF_UP);
            return currentVal.divide(normConfig.getCscodGkz(), NUMBER_SCALE_4, RoundingMode.HALF_UP);
        }else if(BusinessEnum.WarningCategoryEnum.CS_ZL.getCode().equals(code) || ROBOT_ECCZLSY.getCode().equals(code)){
            if(isBzz)
                return currentVal.divide(normConfig.getCszlBzz(), NUMBER_SCALE_4, RoundingMode.HALF_UP);
            return currentVal.divide(normConfig.getCszlGkz(), NUMBER_SCALE_4, RoundingMode.HALF_UP);
        }else if(BusinessEnum.WarningCategoryEnum.CS_ZD.getCode().equals(code) || ROBOT_XSY_1.getCode().equals(code) || ROBOT_XSY_2.getCode().equals(code)){
            if(isBzz)
                return currentVal.divide(normConfig.getCszzBzz(), NUMBER_SCALE_4, RoundingMode.HALF_UP);
            return currentVal.divide(normConfig.getCszzGkz(), NUMBER_SCALE_4, RoundingMode.HALF_UP);
        }else if(BusinessEnum.WarningCategoryEnum.CS_AD.getCode().equals(code) || ROBOT_CS_AD.getCode().equals(code)){
            if(isBzz)
                return currentVal.divide(normConfig.getCsadBzz(), NUMBER_SCALE_4, RoundingMode.HALF_UP);
            return currentVal.divide(normConfig.getCsadGkz(), NUMBER_SCALE_4, RoundingMode.HALF_UP);
        }else if(BusinessEnum.WarningCategoryEnum.CS_SS.getCode().equals(code)){
            if(isBzz)
                return currentVal.divide(normConfig.getCsssBzz(), NUMBER_SCALE_4, RoundingMode.HALF_UP);
            return currentVal.divide(normConfig.getCsssGkz(), NUMBER_SCALE_4, RoundingMode.HALF_UP);
        }else if(BusinessEnum.WarningCategoryEnum.JS_ZL.getCode().equals(code)){
            return currentVal.divide(normConfig.getJszlSjz(), NUMBER_SCALE_4, RoundingMode.HALF_UP);
        }else if(BusinessEnum.WarningCategoryEnum.JS_COD.getCode().equals(code)){
            return currentVal.divide(normConfig.getJscodSjz(), NUMBER_SCALE_4, RoundingMode.HALF_UP);
        }else if(BusinessEnum.WarningCategoryEnum.JS_ZD.getCode().equals(code)){
            return currentVal.divide(normConfig.getJszdSjz(), NUMBER_SCALE_4, RoundingMode.HALF_UP);
        }else if(BusinessEnum.WarningCategoryEnum.JS_AD.getCode().equals(code)){
            return currentVal.divide(normConfig.getJsadSjz(), NUMBER_SCALE_4, RoundingMode.HALF_UP);
        }else if(BusinessEnum.WarningCategoryEnum.JS_SS.getCode().equals(code)){
            return currentVal.divide(normConfig.getJsssSjz(), NUMBER_SCALE_4, RoundingMode.HALF_UP);
        }else{
            log.error("暂时不支持的类型，返回null");
            return null;
        }
    }


    public void main(String[] args) {

        // handleBigTableDayHistoryData();

        // HandleDataController handleDataController = new HandleDataController();
        //
        // handleDataController.handleBigTableDayHistoryData();

//        File file = new File("C:\\Users\\10109\\Desktop\\新程序\\历史数据");
//        if(file.isDirectory()){
//            for (File listFile : file.listFiles()) {
////                System.out.println(listFile.getName());
//                ExcelReader reader = ExcelUtil.getReader(listFile);
//                List<List<Object>> readAll = reader.read();
//                for (int i = 3; i < 10; i++) {
//                    System.out.println(readAll.get(i));
//                }
//                System.out.println("------------------");
//            }
//        }


        String str = "2022/07/11 19:00";
//        String str = "2022/7/1";
//        String str = "0:0:1";
//        String newStr = handleDate(str);
//        System.out.println(newStr);
//        System.out.println(str.substring(0, 12));
//        System.out.println(str.substring(0, 9));

//        System.out.println(handleDate("2024-3-9"));
        System.out.println(handleDate("2023/12/26 02:00"));
        System.out.println(handleDate("2023/12/26 02:00").substring(0, 10));
        System.out.println(handleDate("2023/12/26 02:00").substring(0, 13));

    }

    public static String handleDate(String str){
        StringBuilder sb = new StringBuilder();
        if(str.contains(" ")){//包含空格 就是年月日时分秒了
            String[] split = str.split(" ");
            addBeforeZero(sb, split[0], "/");
            sb.append(" ");
            addBeforeZero(sb, split[1], ":");
        }else{
            if(str.contains("/")){//年月日
                addBeforeZero(sb, str, "/");
            }else if(str.contains(":")){//时分秒
                addBeforeZero(sb, str, ":");
            }else if(str.contains("-")){//只有年月日
                addBeforeZero(sb, str, "-");
            }else {
                sb.append(str);
            }
       }
        return sb.toString();
    }

    public static StringBuilder addBeforeZero(StringBuilder sb, String str, String tag){
        String[] split = str.split(tag);
        int length = split.length;
        for (int i = 0; i < length; i++) {
            String value = split[i];
            Integer intValue = Integer.parseInt(value);
            if(intValue < 10 && value.length() == 1){////防止有正确的情况 额外再补充字符串
                sb.append(0).append(value);
            }else{
                sb.append(value);
            }
            if(i < length-1){
                sb.append(tag);
            }
        }
        return sb;
    }

    public BigDecimal getListAvg (Collection<BigDecimal> bigDecimals) {
        if (bigDecimals.isEmpty()) {
            return null;
        }

        BigDecimal sum = bigDecimals.stream()
                .reduce(BigDecimal.ZERO, BigDecimal::add);

        int size = bigDecimals.size();
        return sum.divide(new BigDecimal(size), 6, RoundingMode.HALF_UP);
    }

    public String formatList(List<BigDecimal> list) {
        if (CollectionUtils.isEmpty(list)) {
            return null;
        }

        boolean isNullList = list.stream().allMatch(x -> x == null);

        return isNullList ? null : list.toString();
    }


    /**
     * 处理big_table_month历史数据
     * @return
     */
    @GetMapping("/handleBigTableMonthHistoryData")
    public String handleBigTableMonthHistoryData() {
        log.info("进入了处理big_table_month历史数据");
        long begin = System.currentTimeMillis();

        List<TXinyiBigTableMonth> tXinyiBigTableDayList = tXinyiBigTableDayMapper.selectTXinyiBigTableDayByMonthAvg();

        if ( !CollectionUtils.isEmpty(tXinyiBigTableDayList)  ) {

            for (int i = 0; i < tXinyiBigTableDayList.size(); i++) {
                TXinyiBigTableMonth tableMonth = tXinyiBigTableDayList.get(i);


                ArrayList<BigDecimal> gyHycRjyAll = new ArrayList<>();
                ArrayList<BigDecimal> gyHycRjyZdAll = new ArrayList<>();
                ArrayList<BigDecimal> gyHycWnndAll = new ArrayList<>();

                ArrayList<BigDecimal> rbHycRjyAll = new ArrayList<>();
                ArrayList<BigDecimal> rbHycWnndAll = new ArrayList<>();
                ArrayList<BigDecimal> rbYycRjyAll = new ArrayList<>();
                ArrayList<BigDecimal> rbQycRjyAll = new ArrayList<>();
                ArrayList<BigDecimal> rbWncjbAll = new ArrayList<>();
                ArrayList<BigDecimal> rbWntjzsAll = new ArrayList<>();
                ArrayList<BigDecimal> rbHfxwnndAll = new ArrayList<>();

                ArrayList<BigDecimal> hyHycxsyAll = new ArrayList<>();
                ArrayList<BigDecimal> hyQyanAll = new ArrayList<>();
                ArrayList<BigDecimal> hyQyckxsyAll = new ArrayList<>();
                ArrayList<BigDecimal> hyHyzlsyAll = new ArrayList<>();

                gyHycRjyAll.add(tableMonth.getGyOneHymdDo());
                gyHycRjyAll.add(tableMonth.getGyTwoHymdDo());
                gyHycRjyZdAll.add(tableMonth.getGyOneHyzdDo());
                gyHycRjyZdAll.add(tableMonth.getGyTwoHyzdDo());
                gyHycWnndAll.add(tableMonth.getGyOneMlss());
                gyHycWnndAll.add(tableMonth.getGyTwoMlss());

                rbHycRjyAll.add(tableMonth.getRbShcHyOneDo());
                rbHycRjyAll.add(tableMonth.getRbShcHyTwoDo());
                rbHycWnndAll.add(tableMonth.getRbShcHyOneMlss());
                rbHycWnndAll.add(tableMonth.getRbShcHyTwoMlss());
                rbYycRjyAll.add(tableMonth.getRbShcYyOneDo());
                rbYycRjyAll.add(tableMonth.getRbShcYyTwoDo());
                rbQycRjyAll.add(tableMonth.getRbShcQyOneDo());
                rbQycRjyAll.add(tableMonth.getRbShcQyTwoDo());
                rbWncjbAll.add(tableMonth.getRbShcHyOneSv());
                rbWncjbAll.add(tableMonth.getRbShcHyTwoSv());
                rbWntjzsAll.add(tableMonth.getRbShcHyOneSvi());
                rbWntjzsAll.add(tableMonth.getRbShcHyTwoSvi());
                rbHfxwnndAll.add(tableMonth.getRbShcHyOneMlvss());
                rbHfxwnndAll.add(tableMonth.getRbShcHyTwoMlvss());

                hyHycxsyAll.add(tableMonth.getHyNo3Hlj1Jqr());
                hyHycxsyAll.add(tableMonth.getHyNo3Hlj2Jqr());
                hyQyanAll.add(tableMonth.getHyNh31Jqr());
                hyQyanAll.add(tableMonth.getHyNh32Jqr());
                hyQyckxsyAll.add(tableMonth.getHyNo3Qyc1Jqr());
                hyQyckxsyAll.add(tableMonth.getHyNo3Qyc2Jqr());
                hyHyzlsyAll.add(tableMonth.getHyTpHl1Jqr());
                hyHyzlsyAll.add(tableMonth.getHyTpHl2Jqr());

                tableMonth.setGyHycRjyAll(formatList(gyHycRjyAll));
                tableMonth.setGyHycRjyZdAll(formatList(gyHycRjyZdAll));
                tableMonth.setGyHycWnndAll(formatList(gyHycWnndAll));
                tableMonth.setRbHycRjyAll(formatList(rbHycRjyAll));
                tableMonth.setRbHycWnndAll(formatList(rbHycWnndAll));
                tableMonth.setRbYycRjyAll(formatList(rbYycRjyAll));
                tableMonth.setRbQycRjyAll(formatList(rbQycRjyAll));
                tableMonth.setRbWncjbAll(formatList(rbWncjbAll));
                tableMonth.setRbWntjzsAll(formatList(rbWntjzsAll));
                tableMonth.setRbHfxwnndAll(formatList(rbHfxwnndAll));
                tableMonth.setHyHycxsyAll(formatList(hyHycxsyAll));
                tableMonth.setHyQyanAll(formatList(hyQyanAll));
                tableMonth.setHyQyckxsyAll(formatList(hyQyckxsyAll));
                tableMonth.setHyHyzlsyAll(formatList(hyHyzlsyAll));


                tXinyiBigTableMonthMapper.insertTXinyiBigTableMonth(tableMonth);
            }
        }

        long end = System.currentTimeMillis();
        return "ok;耗时：" + (end - begin) / 1000 + "秒。";
    }


    /**
     * 处理big_table_day历史数据
     * @return
     */
    @GetMapping("/handleBigTableDayHistoryData")
    public String handleBigTableDayHistoryData(@RequestParam String date) {
        log.info("进入了 处理big_table_day历史数据");
        long begin = System.currentTimeMillis();

        List<TXinyiBigTableHour> tXinyiBigTableHours = tXinyiBigTableHourMapper.selectTXinyiBigTableHourByTestDate(date);
        if ( !CollectionUtils.isEmpty(tXinyiBigTableHours) ) {

            List<TXinyiBigTableDay> bigTableDayList = new ArrayList<>();

            for (TXinyiBigTableHour tXinyiBigTableHour : tXinyiBigTableHours) {
                String testDate = tXinyiBigTableHour.getTestDate();

                TXinyiBigTableDay tableDay = tXinyiBigTableDayMapper.selectTXinyiBigTableHourAvg(testDate);
                if (!Objects.isNull(tableDay)) {

                    ArrayList<BigDecimal> gyHycRjyAll = new ArrayList<>();
                    ArrayList<BigDecimal> gyHycRjyZdAll = new ArrayList<>();
                    ArrayList<BigDecimal> gyHycWnndAll = new ArrayList<>();

                    ArrayList<BigDecimal> rbHycRjyAll = new ArrayList<>();
                    ArrayList<BigDecimal> rbHycWnndAll = new ArrayList<>();
                    ArrayList<BigDecimal> rbYycRjyAll = new ArrayList<>();
                    ArrayList<BigDecimal> rbQycRjyAll = new ArrayList<>();
                    ArrayList<BigDecimal> rbWncjbAll = new ArrayList<>();
                    ArrayList<BigDecimal> rbWntjzsAll = new ArrayList<>();
                    ArrayList<BigDecimal> rbHfxwnndAll = new ArrayList<>();

                    ArrayList<BigDecimal> hyHycxsyAll = new ArrayList<>();
                    ArrayList<BigDecimal> hyQyanAll = new ArrayList<>();
                    ArrayList<BigDecimal> hyQyckxsyAll = new ArrayList<>();
                    ArrayList<BigDecimal> hyHyzlsyAll = new ArrayList<>();

                    gyHycRjyAll.add(tableDay.getGyOneHymdDo());
                    gyHycRjyAll.add(tableDay.getGyTwoHymdDo());
                    gyHycRjyZdAll.add(tableDay.getGyOneHyzdDo());
                    gyHycRjyZdAll.add(tableDay.getGyTwoHyzdDo());
                    gyHycWnndAll.add(tableDay.getGyOneMlss());
                    gyHycWnndAll.add(tableDay.getGyTwoMlss());

                    rbHycRjyAll.add(tableDay.getRbShcHyOneDo());
                    rbHycRjyAll.add(tableDay.getRbShcHyTwoDo());
                    rbHycWnndAll.add(tableDay.getRbShcHyOneMlss());
                    rbHycWnndAll.add(tableDay.getRbShcHyTwoMlss());
                    rbYycRjyAll.add(tableDay.getRbShcYyOneDo());
                    rbYycRjyAll.add(tableDay.getRbShcYyTwoDo());
                    rbQycRjyAll.add(tableDay.getRbShcQyOneDo());
                    rbQycRjyAll.add(tableDay.getRbShcQyTwoDo());
                    rbWncjbAll.add(tableDay.getRbShcHyOneSv());
                    rbWncjbAll.add(tableDay.getRbShcHyTwoSv());
                    rbWntjzsAll.add(tableDay.getRbShcHyOneSvi());
                    rbWntjzsAll.add(tableDay.getRbShcHyTwoSvi());
                    rbHfxwnndAll.add(tableDay.getRbShcHyOneMlvss());
                    rbHfxwnndAll.add(tableDay.getRbShcHyTwoMlvss());

                    hyHycxsyAll.add(tableDay.getHyNo3Hlj1Jqr());
                    hyHycxsyAll.add(tableDay.getHyNo3Hlj2Jqr());
                    hyQyanAll.add(tableDay.getHyNh31Jqr());
                    hyQyanAll.add(tableDay.getHyNh32Jqr());
                    hyQyckxsyAll.add(tableDay.getHyNo3Qyc1Jqr());
                    hyQyckxsyAll.add(tableDay.getHyNo3Qyc2Jqr());
                    hyHyzlsyAll.add(tableDay.getHyTpHl1Jqr());
                    hyHyzlsyAll.add(tableDay.getHyTpHl2Jqr());

                    tableDay.setGyHycRjyAll(formatList(gyHycRjyAll));
                    tableDay.setGyHycRjyZdAll(formatList(gyHycRjyZdAll));
                    tableDay.setGyHycWnndAll(formatList(gyHycWnndAll));
                    tableDay.setRbHycRjyAll(formatList(rbHycRjyAll));
                    tableDay.setRbHycWnndAll(formatList(rbHycWnndAll));
                    tableDay.setRbYycRjyAll(formatList(rbYycRjyAll));
                    tableDay.setRbQycRjyAll(formatList(rbQycRjyAll));
                    tableDay.setRbWncjbAll(formatList(rbWncjbAll));
                    tableDay.setRbWntjzsAll(formatList(rbWntjzsAll));
                    tableDay.setRbHfxwnndAll(formatList(rbHfxwnndAll));
                    tableDay.setHyHycxsyAll(formatList(hyHycxsyAll));
                    tableDay.setHyQyanAll(formatList(hyQyanAll));
                    tableDay.setHyQyckxsyAll(formatList(hyQyckxsyAll));
                    tableDay.setHyHyzlsyAll(formatList(hyHyzlsyAll));

                    tableDay.setTestDate(testDate);

                    bigTableDayList.add(tableDay);
                }
            }

            if (!CollectionUtils.isEmpty(bigTableDayList)) {
                SqlSession sqlSession = sqlSessionFactory.openSession(ExecutorType.BATCH, false);
                TXinyiBigTableDayMapper sqlSessionMapper =  sqlSession.getMapper(TXinyiBigTableDayMapper.class);
                bigTableDayList.forEach(sqlSessionMapper::insertTXinyiBigTableDay);
                sqlSession.commit();
                sqlSession.close();
            }
        }
        long end = System.currentTimeMillis();
        return "ok;耗时：" + (end - begin) / 1000 + "秒。";
    }


    /**
     * 处理big_table_hour历史数据
     * @return
     */
    @GetMapping("/handleBigTableHourHistoryData")
    public String handleBigTableHourHistoryData () {
        log.info("进入了 处理big_table_hour历史数据");
        long begin = System.currentTimeMillis();

        int size = 500;
        int count = xinyiIndustryMapper.getCount();

        int num = ( count / size ) + 1;

        for (int i = 0; i < num; i++) {
            List<TXinyiIndustry> tXinyiIndustries = xinyiIndustryMapper.selectTXinyiIndustryListByPage(i * size, size);
            if ( !CollectionUtils.isEmpty(tXinyiIndustries) ) {

                List<TXinyiBigTableHour> tXinyiBigTableHourList = new ArrayList();

                for (int j = 0; j < tXinyiIndustries.size(); j++) {
                    TXinyiBigTableHour xinyiBigTableHour = new TXinyiBigTableHour();
                    TXinyiIndustry tXinyiIndustry = tXinyiIndustries.get(j);

                    String testHour = tXinyiIndustry.getTestHour();
                    String testDate = tXinyiIndustry.getTestDate();

                    // 处理工业库
                    handleIndustryData(xinyiBigTableHour, tXinyiIndustry);

                    // 处理计算表
                    List<TXinyiCalculate> tXinyiCalculates = xinyiCalculateMapper.selectTXinyiCalculateList(TXinyiCalculate.builder().testHour(testHour).build());
                    if ( !CollectionUtils.isEmpty(tXinyiCalculates) ) {
                        TXinyiCalculate tXinyiCalculate = tXinyiCalculates.get(0);
                        handleCalculateData(xinyiBigTableHour, tXinyiCalculate);
                    }

                    // 处理日报表
                    List<TXinyiDaily> tXinyiDailies = xinyiDailyMapper.selectTXinyiDailyList(TXinyiDaily.builder().testDate(testDate).build());
                    if ( !CollectionUtils.isEmpty(tXinyiDailies) ) {
                        TXinyiDaily tXinyiDaily = tXinyiDailies.get(0);
                        handleDailyData(xinyiBigTableHour, tXinyiDaily);
                    }

                    // 处理化验室
                    List<TXinyiRobot> tXinyiRobots = xinyiRobotMapper.selectTXinyiRobotList(TXinyiRobot.builder().testHour(testHour).build());
                    if (!CollectionUtils.isEmpty(tXinyiRobots)) {
                        TXinyiRobot tXinyiRobot = tXinyiRobots.get(0);
                        handleRobotData(xinyiBigTableHour, tXinyiRobot);
                    }
                    // TXinyiRobot tXinyiRobot = xinyiRobotMapper.selectTXinyiRobotByAvg(TXinyiRobot.builder().testHour(testHour).build());
                    // if ( !Objects.isNull(tXinyiRobot) ) {
                    //     handleRobotData(xinyiBigTableHour, tXinyiRobot);
                    // }

                    tXinyiBigTableHourList.add(xinyiBigTableHour);
                }

                if (!CollectionUtils.isEmpty(tXinyiBigTableHourList)) {
                    SqlSession sqlSession = sqlSessionFactory.openSession(ExecutorType.BATCH,false);
                    TXinyiBigTableHourMapper sqlSessionMapper = sqlSession.getMapper(TXinyiBigTableHourMapper.class);
                    tXinyiBigTableHourList.forEach(sqlSessionMapper::insertTXinyiBigTableHour);
                    sqlSession.commit();
                    sqlSession.close();
                }
            }
        }

        long end = System.currentTimeMillis();
        return "ok;耗时：" + (end - begin) /1000 + "秒。";
    }

    // 处理工业库
    private void handleIndustryData(TXinyiBigTableHour xinyiBigTableHour, TXinyiIndustry tXinyiIndustry) {
        xinyiBigTableHour.setTestDate(tXinyiIndustry.getTestDate());
        xinyiBigTableHour.setTestHour(tXinyiIndustry.getTestHour());
        xinyiBigTableHour.setGyJsCod(tXinyiIndustry.getJsCod());
        xinyiBigTableHour.setGyJsPh(tXinyiIndustry.getJsPh());
        xinyiBigTableHour.setGyJsSs(tXinyiIndustry.getJsSs());
        xinyiBigTableHour.setGyJsTp(tXinyiIndustry.getJsTp());
        xinyiBigTableHour.setGyJsTn(tXinyiIndustry.getJsTn());
        xinyiBigTableHour.setGyJsNh3(tXinyiIndustry.getJsNh3());
        xinyiBigTableHour.setGyJsSwPh(tXinyiIndustry.getJsSwPh());
        xinyiBigTableHour.setGyJsBfyw(tXinyiIndustry.getJsBfyw());
        xinyiBigTableHour.setGyCsSlqc(tXinyiIndustry.getCsSlqc());
        xinyiBigTableHour.setGyCsCod(tXinyiIndustry.getCsCod());
        xinyiBigTableHour.setGyCsPh(tXinyiIndustry.getCsPh());
        xinyiBigTableHour.setGyCsSs(tXinyiIndustry.getCsSs());
        xinyiBigTableHour.setGyCsTn(tXinyiIndustry.getCsTn());
        xinyiBigTableHour.setGyCsTp(tXinyiIndustry.getCsTp());
        xinyiBigTableHour.setGyCsNh3(tXinyiIndustry.getCsNh3());
        xinyiBigTableHour.setGyOneHyzdDo(tXinyiIndustry.getOneHyzdDo());
        xinyiBigTableHour.setGyOneHymdDo(tXinyiIndustry.getOneHymdDo());
        xinyiBigTableHour.setGyTwoHyzdDo(tXinyiIndustry.getTwoHyzdDo());
        xinyiBigTableHour.setGyTwoHymdDo(tXinyiIndustry.getTwoHymdDo());
        xinyiBigTableHour.setGyOneMlss(tXinyiIndustry.getOneMlss());
        xinyiBigTableHour.setGyTwoMlss(tXinyiIndustry.getTwoMlss());
        xinyiBigTableHour.setGyJsTds(tXinyiIndustry.getJsTds());
        xinyiBigTableHour.setGyJsSlq(tXinyiIndustry.getJsSlq());
        xinyiBigTableHour.setGyNHlbOneGp(tXinyiIndustry.getNHlbOneGp());
        xinyiBigTableHour.setGyNHlbTwoGp(tXinyiIndustry.getNHlbTwoGp());
        xinyiBigTableHour.setGyNHlbThreeGp(tXinyiIndustry.getNHlbThreeGp());
        xinyiBigTableHour.setGyNHlbFourGp(tXinyiIndustry.getNHlbFourGp());
        xinyiBigTableHour.setGyNhlBFiveGp(tXinyiIndustry.getNhlBFiveGp());
        xinyiBigTableHour.setGyNHlbSixGp(tXinyiIndustry.getNHlbSixGp());
        xinyiBigTableHour.setGyWHlbOneGp(tXinyiIndustry.getWHlbOneGp());
        xinyiBigTableHour.setGyWHlbTwoGp(tXinyiIndustry.getWHlbTwoGp());
        xinyiBigTableHour.setGyWHlbThreeGp(tXinyiIndustry.getWHlbThreeGp());
        xinyiBigTableHour.setGyWHlbFourGp(tXinyiIndustry.getWHlbFourGp());
        xinyiBigTableHour.setGyWHlbFiveGp(tXinyiIndustry.getWHlbFiveGp());
        xinyiBigTableHour.setGyFjOne(tXinyiIndustry.getFjOne());
        xinyiBigTableHour.setGyFjTwo(tXinyiIndustry.getFjTwo());
        xinyiBigTableHour.setGyFjThree(tXinyiIndustry.getFjThree());
        xinyiBigTableHour.setGyFjFour(tXinyiIndustry.getFjFour());
        xinyiBigTableHour.setGyFjFive(tXinyiIndustry.getFjFive());
        xinyiBigTableHour.setGyFjSix(tXinyiIndustry.getFjSix());
        xinyiBigTableHour.setGyKqllOne(tXinyiIndustry.getKqllOne());
        xinyiBigTableHour.setGyKqllTwo(tXinyiIndustry.getKqllTwo());
        xinyiBigTableHour.setGyKqllThree(tXinyiIndustry.getKqllThree());
        xinyiBigTableHour.setGyKqllFour(tXinyiIndustry.getKqllFour());
        xinyiBigTableHour.setGyKqllFive(tXinyiIndustry.getKqllFive());
        xinyiBigTableHour.setGyKqllSix(tXinyiIndustry.getKqllSix());
        xinyiBigTableHour.setGySjtyjly(tXinyiIndustry.getSJTYJLY());
        xinyiBigTableHour.setGyCljyssll(tXinyiIndustry.getCLJYSSLL());
        xinyiBigTableHour.setGyHycRjyAll(tXinyiIndustry.getHycRjyAll());
        xinyiBigTableHour.setGyHycRjyZdAll(tXinyiIndustry.getHycRjyZdAll());
        xinyiBigTableHour.setGyHycWnndAll(tXinyiIndustry.getHycWnndAll());
        xinyiBigTableHour.setGyClP04Ycz(tXinyiIndustry.getCLP04YCZ());
        //2025年04月03日10:31:13 新增风机 泵相关参数处理
        xinyiBigTableHour.setGyOneFjDl(tXinyiIndustry.getOneFjDl());
        xinyiBigTableHour.setGyTwoFjDl(tXinyiIndustry.getTwoFjDl());
        xinyiBigTableHour.setGyThreeFjDl(tXinyiIndustry.getThreeFjDl());
        xinyiBigTableHour.setGyFourFjDl(tXinyiIndustry.getFourFjDl());
        xinyiBigTableHour.setGyFiveFjDl(tXinyiIndustry.getFiveFjDl());
        xinyiBigTableHour.setGySixFjDl(tXinyiIndustry.getSixFjDl());
        xinyiBigTableHour.setGyOneXgsQt(tXinyiIndustry.getOneXgsQt());
        xinyiBigTableHour.setGyTwoXgsQt(tXinyiIndustry.getTwoXgsQt());
        xinyiBigTableHour.setGyThreeXgsQt(tXinyiIndustry.getThreeXgsQt());
        xinyiBigTableHour.setGyFourXgsQt(tXinyiIndustry.getFourXgsQt());
        xinyiBigTableHour.setGyFiveXgsQt(tXinyiIndustry.getFiveXgsQt());
        xinyiBigTableHour.setGySixXgsQt(tXinyiIndustry.getSixXgsQt());
        xinyiBigTableHour.setGyOneNhlbDl(tXinyiIndustry.getOneNhlbDl());
        xinyiBigTableHour.setGyTwoNhlbDl(tXinyiIndustry.getTwoNhlbDl());
        xinyiBigTableHour.setGyThreeNhlbDl(tXinyiIndustry.getThreeNhlbDl());
        xinyiBigTableHour.setGyFourNhlbDl(tXinyiIndustry.getFourNhlbDl());
        xinyiBigTableHour.setGyFiveNhlbDl(tXinyiIndustry.getFiveNhlbDl());
        xinyiBigTableHour.setGySixNhlbDl(tXinyiIndustry.getSixNhlbDl());
        xinyiBigTableHour.setGyOneCccpnbQt(tXinyiIndustry.getOneCccpnbQt());
        xinyiBigTableHour.setGyTwoCccpnbQt(tXinyiIndustry.getTwoCccpnbQt());
        xinyiBigTableHour.setGyOneSywndbQt(tXinyiIndustry.getOneSywndbQt());
        xinyiBigTableHour.setGyTwoSywndbQt(tXinyiIndustry.getTwoSywndbQt());
        xinyiBigTableHour.setGyOneSdclDl(tXinyiIndustry.getOneSdclDl());
        xinyiBigTableHour.setGyTwoSdclDl(tXinyiIndustry.getTwoSdclDl());
        xinyiBigTableHour.setGyThreeSdclDl(tXinyiIndustry.getThreeSdclDl());
        xinyiBigTableHour.setGyFourSdclDl(tXinyiIndustry.getFourSdclDl());
    }

    // 处理计算表
    private void handleCalculateData(TXinyiBigTableHour xinyiBigTableHour, TXinyiCalculate xinyiCalculate) {
        xinyiBigTableHour.setJsJsTdb(xinyiCalculate.getJsTdb());
        xinyiBigTableHour.setJsJsTlb(xinyiCalculate.getJsTlb());
        xinyiBigTableHour.setJsJsBodBCod(xinyiCalculate.getJsBodBCod());
        xinyiBigTableHour.setJsYyqHrt(xinyiCalculate.getYyqHrt());
        xinyiBigTableHour.setJsQyqHrt(xinyiCalculate.getQyqHrt());
        xinyiBigTableHour.setJsHyqHrt(xinyiCalculate.getHyqHrt());
        xinyiBigTableHour.setJsHfxwnndzb(xinyiCalculate.getHFXWNNDZB());
        xinyiBigTableHour.setJsFM(xinyiCalculate.getFM());
        xinyiBigTableHour.setJsGsls(xinyiCalculate.getGSLS());
        xinyiBigTableHour.setJsGslsOne(xinyiCalculate.getGslsOne());
        xinyiBigTableHour.setJsGslsTwo(xinyiCalculate.getGslsTwo());
        xinyiBigTableHour.setJsXgsGsls(xinyiCalculate.getXgsGsls());
        xinyiBigTableHour.setJsXlcscBmfh(xinyiCalculate.getXlcscBmfh());
        xinyiBigTableHour.setJsXlcscHrt(xinyiCalculate.getXlcscHrt());
        xinyiBigTableHour.setJsCccdcBmfh(xinyiCalculate.getCccdcBmfh());
        xinyiBigTableHour.setJsCccdcHrt(xinyiCalculate.getCccdcHrt());
        xinyiBigTableHour.setJsEccBmfh(xinyiCalculate.getEccBmfh());
        xinyiBigTableHour.setJsEccHrt(xinyiCalculate.getEccHrt());
        xinyiBigTableHour.setJsEccGtfh(xinyiCalculate.getEccGtfh());
        xinyiBigTableHour.setJsClsnJcsj(xinyiCalculate.getClsnJcsj());
        xinyiBigTableHour.setJsXgcdcQsqSsls(xinyiCalculate.getXgcdcQsqSsls());
        xinyiBigTableHour.setJsWhlb(xinyiCalculate.getWHLB());
        xinyiBigTableHour.setJsNhlb(xinyiCalculate.getNHLB());
        xinyiBigTableHour.setJsWdscnl(xinyiCalculate.getWDSCNL());
        xinyiBigTableHour.setJsQsb(xinyiCalculate.getQSB());
        xinyiBigTableHour.setJsFcxsl(xinyiCalculate.getFCXSL());
        xinyiBigTableHour.setJsFcxslbl(xinyiCalculate.getFCXSLBL());
        //2024年7月11日15:57:20 外回流比采用新的公式计算
        xinyiBigTableHour.setJsWhlbRN(xinyiCalculate.getWhlRN());
        //2025年03月19日17:14:35 处理 超污染物限制 和 超污染物负荷 进出水五大指标相关计算
        xinyiBigTableHour.setJsCsCodCwrwxz(xinyiCalculate.getCsCodCwrwxz());
        xinyiBigTableHour.setJsCsSsCwrwxz(xinyiCalculate.getCsSsCwrwxz());
        xinyiBigTableHour.setJsCsZdCwrwxz(xinyiCalculate.getCsZdCwrwxz());
        xinyiBigTableHour.setJsCsZlCwrwxz(xinyiCalculate.getCsZlCwrwxz());
        xinyiBigTableHour.setJsCsAdCwrwxz(xinyiCalculate.getCsAdCwrwxz());

        xinyiBigTableHour.setJsJsCodCwrwfh(xinyiCalculate.getJsCodCwrwfh());
        xinyiBigTableHour.setJsJsSsCwrwfh(xinyiCalculate.getJsSsCwrwfh());
        xinyiBigTableHour.setJsJsZdCwrwfh(xinyiCalculate.getJsZdCwrwfh());
        xinyiBigTableHour.setJsJsZlCwrwfh(xinyiCalculate.getJsZlCwrwfh());
        xinyiBigTableHour.setJsJsAdCwrwfh(xinyiCalculate.getJsAdCwrwfh());

        xinyiBigTableHour.setJsJsCodCwrwxz(xinyiCalculate.getJsCodCwrwxz());
        xinyiBigTableHour.setJsJsSsCwrwxz(xinyiCalculate.getJsSsCwrwxz());
        xinyiBigTableHour.setJsJsZdCwrwxz(xinyiCalculate.getJsZdCwrwxz());
        xinyiBigTableHour.setJsJsZlCwrwxz(xinyiCalculate.getJsZlCwrwxz());
        xinyiBigTableHour.setJsJsAdCwrwxz(xinyiCalculate.getJsAdCwrwxz());
    }

    // 处理日报
    private void handleDailyData(TXinyiBigTableHour tXinyiBigTableHour, TXinyiDaily tXinyiDaily) {
        tXinyiBigTableHour.setRbJsCod(tXinyiDaily.getJsCod());
        tXinyiBigTableHour.setRbJsPh(tXinyiDaily.getJsPh());
        tXinyiBigTableHour.setRbJsBod5(tXinyiDaily.getJsBod5());
        tXinyiBigTableHour.setRbJsSs(tXinyiDaily.getJsSs());
        tXinyiBigTableHour.setRbJsNh3(tXinyiDaily.getJsNh3());
        tXinyiBigTableHour.setRbJsTn(tXinyiDaily.getJsTn());
        tXinyiBigTableHour.setRbJsTp(tXinyiDaily.getJsTp());
        tXinyiBigTableHour.setRbJsDcgj(tXinyiDaily.getJsDcgj());
        tXinyiBigTableHour.setRbCsCod(tXinyiDaily.getCsCod());
        tXinyiBigTableHour.setRbCsPh(tXinyiDaily.getCsPh());
        tXinyiBigTableHour.setRbCsBod5(tXinyiDaily.getCsBod5());
        tXinyiBigTableHour.setRbCsSs(tXinyiDaily.getCsSs());
        tXinyiBigTableHour.setRbCsNh3(tXinyiDaily.getCsNh3());
        tXinyiBigTableHour.setRbCsTn(tXinyiDaily.getCsTn());
        tXinyiBigTableHour.setRbCsTp(tXinyiDaily.getCsTp());
        tXinyiBigTableHour.setRbCsDcgj(tXinyiDaily.getCsDcgj());
        tXinyiBigTableHour.setRbJsSw(tXinyiDaily.getJsSw());
        tXinyiBigTableHour.setRbCsSw(tXinyiDaily.getCsSw());
        tXinyiBigTableHour.setRbShcOnePh(tXinyiDaily.getShcOnePh());
        tXinyiBigTableHour.setRbShcTwoPh(tXinyiDaily.getShcTwoPh());
        tXinyiBigTableHour.setRbShcHyOneSv(tXinyiDaily.getShcHyOneSv());
        tXinyiBigTableHour.setRbShcHyTwoSv(tXinyiDaily.getShcHyTwoSv());
        tXinyiBigTableHour.setRbShcHyOneSvi(tXinyiDaily.getShcHyOneSvi());
        tXinyiBigTableHour.setRbShcHyTwoSvi(tXinyiDaily.getShcHyTwoSvi());
        tXinyiBigTableHour.setRbShcHyOneMlss(tXinyiDaily.getShcHyOneMlss());
        tXinyiBigTableHour.setRbShcHyTwoMlss(tXinyiDaily.getShcHyTwoMlss());
        tXinyiBigTableHour.setRbShcHyOneMlvss(tXinyiDaily.getShcHyOneMlvss());
        tXinyiBigTableHour.setRbShcHyTwoMlvss(tXinyiDaily.getShcHyTwoMlvss());
        tXinyiBigTableHour.setRbShcYyOneDo(tXinyiDaily.getShcYyOneDo());
        tXinyiBigTableHour.setRbShcYyTwoDo(tXinyiDaily.getShcYyTwoDo());
        tXinyiBigTableHour.setRbShcQyOneDo(tXinyiDaily.getShcQyOneDo());
        tXinyiBigTableHour.setRbShcQyTwoDo(tXinyiDaily.getShcQyTwoDo());
        tXinyiBigTableHour.setRbShcHyOneDo(tXinyiDaily.getShcHyOneDo());
        tXinyiBigTableHour.setRbShcHyTwoDo(tXinyiDaily.getShcHyTwoDo());
        tXinyiBigTableHour.setRbJsl(tXinyiDaily.getJSL());
        tXinyiBigTableHour.setRbCsl(tXinyiDaily.getCSL());
        tXinyiBigTableHour.setRbSdclcxsl(tXinyiDaily.getSDCLCXSL());
        tXinyiBigTableHour.setRbQsb(tXinyiDaily.getQSB());
        tXinyiBigTableHour.setRbFM(tXinyiDaily.getFM());
        tXinyiBigTableHour.setRbYyHrt(tXinyiDaily.getYyHrt());
        tXinyiBigTableHour.setRbHyHrt(tXinyiDaily.getHyHrt());
        tXinyiBigTableHour.setRbQyHrt(tXinyiDaily.getQyHrt());
        tXinyiBigTableHour.setRbNhlR(tXinyiDaily.getNhlR());
        tXinyiBigTableHour.setRbWhlR(tXinyiDaily.getWhlR());
        tXinyiBigTableHour.setRbSrt(tXinyiDaily.getSRT());
        tXinyiBigTableHour.setRbCnl(tXinyiDaily.getCNL());
        tXinyiBigTableHour.setRbTyqBod5Tn(tXinyiDaily.getTyqBod5Tn());
        tXinyiBigTableHour.setRbTyhBod5Tn(tXinyiDaily.getTyhBod5Tn());
        tXinyiBigTableHour.setRbHycRjyAll(tXinyiDaily.getHycRjyAll());
        tXinyiBigTableHour.setRbHycWnndAll(tXinyiDaily.getHycWnndAll());
        tXinyiBigTableHour.setRbYycRjyAll(tXinyiDaily.getYycRjyAll());
        tXinyiBigTableHour.setRbQycRjyAll(tXinyiDaily.getQycRjyAll());
        tXinyiBigTableHour.setRbWncjbAll(tXinyiDaily.getWncjbAll());
        tXinyiBigTableHour.setRbWntjzsAll(tXinyiDaily.getWntjzsAll());
        tXinyiBigTableHour.setRbHfxwnndAll(tXinyiDaily.getHfxwnndAll());
        tXinyiBigTableHour.setRbChuniliang(tXinyiDaily.getCHUNILIANG());
        tXinyiBigTableHour.setRbCnhsl(tXinyiDaily.getCNHSL());
        tXinyiBigTableHour.setRbGwnl(tXinyiDaily.getGWNL());
        tXinyiBigTableHour.setRbDf(tXinyiDaily.getDF());
        tXinyiBigTableHour.setRbXnjf(tXinyiDaily.getXNJF());
        tXinyiBigTableHour.setRbClf(tXinyiDaily.getCLF());
        tXinyiBigTableHour.setRbTyf(tXinyiDaily.getTYF());
        tXinyiBigTableHour.setRbXdjf(tXinyiDaily.getXDJF());
        tXinyiBigTableHour.setRbQtyjf(tXinyiDaily.getQTYJF());
        tXinyiBigTableHour.setRbCnf(tXinyiDaily.getCNF());
        tXinyiBigTableHour.setRbZlsf(tXinyiDaily.getZLSF());
        tXinyiBigTableHour.setRbZjcb(tXinyiDaily.getZJCB());
        tXinyiBigTableHour.setRbDwcb(tXinyiDaily.getDWCB());
    }

    // 处理化验室
    private void handleRobotData(TXinyiBigTableHour tXinyiBigTableHour, TXinyiRobot tXinyiRobot) {
        tXinyiBigTableHour.setHyCodYb(tXinyiRobot.getCodYb());
        tXinyiBigTableHour.setHyCodJqr(tXinyiRobot.getCodJqr());
        tXinyiBigTableHour.setHyCodYz(tXinyiRobot.getCodYz());
        tXinyiBigTableHour.setHyTpHl1Jqr(tXinyiRobot.getTpHl1Jqr());
        tXinyiBigTableHour.setHyTpHl2Jqr(tXinyiRobot.getTpHl2Jqr());
        tXinyiBigTableHour.setHyTpRccJqr(tXinyiRobot.getTpRccJqr());
        tXinyiBigTableHour.setHyTp1Yz(tXinyiRobot.getTp1Yz());
        tXinyiBigTableHour.setHyTp2Yz(tXinyiRobot.getTp2Yz());
        tXinyiBigTableHour.setHyTpRccYz(tXinyiRobot.getTpRccYz());
        tXinyiBigTableHour.setHyNh31Jqr(tXinyiRobot.getNh31Jqr());
        tXinyiBigTableHour.setHyNh32Jqr(tXinyiRobot.getNh32Jqr());
        tXinyiBigTableHour.setHyNh31Yz(tXinyiRobot.getNh31Yz());
        tXinyiBigTableHour.setHyNo3Hlc1Yz(tXinyiRobot.getNo3Hlc1Yz());
        tXinyiBigTableHour.setHyNh32Yz(tXinyiRobot.getNh32Yz());
        tXinyiBigTableHour.setHyNo3Hlc2Yz(tXinyiRobot.getNo3Hlc2Yz());
        tXinyiBigTableHour.setHyNo3Hlj1Jqr(tXinyiRobot.getNo3Hlj1Jqr());
        tXinyiBigTableHour.setHyNo3Hlj2Jqr(tXinyiRobot.getNo3Hlj2Jqr());
        tXinyiBigTableHour.setHyTyll(tXinyiRobot.getTYLL());
        tXinyiBigTableHour.setHyNo3Qyc1Jqr(tXinyiRobot.getNo3Qyc1Jqr());
        tXinyiBigTableHour.setHyNo3Qyc2Jqr(tXinyiRobot.getNo3Qyc2Jqr());
        tXinyiBigTableHour.setHyNo3Qyc1Yz(tXinyiRobot.getNo3Qyc1Yz());
        tXinyiBigTableHour.setHyNo3Qyc2Yz(tXinyiRobot.getNo3Qyc2Yz());
        tXinyiBigTableHour.setHyJsll(tXinyiRobot.getJSLL());
        tXinyiBigTableHour.setHyHycxsyAll(tXinyiRobot.getHycxsyAll());
        tXinyiBigTableHour.setHyQyanAll(tXinyiRobot.getQyanAll());
        tXinyiBigTableHour.setHyQyckxsyAll(tXinyiRobot.getQyckxsyAll());
        tXinyiBigTableHour.setHyHyzlsyAll(tXinyiRobot.getHyzlsyAll());
    }


    private void handlePredictorWarning(String[] split, String hour, String task, List<TXinyiIndustry> tXinyiIndustries6, List<TXinyiRobot> tXinyiRobots6, String date) {

        String[] hours = hour.split(",");
        //2024年6月23日18:28:55 因为存在跨天问题  所以日期也是逗号拼接的
        String[] dates = date.split(",");
        //2024年6月18日13:41:10 统一格式，否则查询不到结果
        //2024年6月18日10:36:49 增加预测记录，预测准确度计算等
        TXinyiForecastComparison tXinyiForecastComparison = new TXinyiForecastComparison();
        //2024年7月11日17:04:11 TP改为zlsy
        tXinyiForecastComparison.setCategory(BusinessEnum.BigModelForecastEnum.TP.getCode().equalsIgnoreCase(task) ? BusinessEnum.BigModelForecastEnum.ZLSY.getCode() : task);
        tXinyiForecastComparison.setForecastTimeOne(dates[0].replaceAll("-", "/") + " " + hours[0]);
        tXinyiForecastComparison.setForecastTimeTwo(dates[1].replaceAll("-", "/") + " " + hours[1]);
        tXinyiForecastComparison.setForecastTimeThree(dates[2].replaceAll("-", "/") + " " + hours[2]);
        tXinyiForecastComparison.setHsForecastOne(new BigDecimal(split[0]));
        tXinyiForecastComparison.setHsForecastTwo(new BigDecimal(split[1]));
        tXinyiForecastComparison.setHsForecastThree(new BigDecimal(split[2]));
        //2024年6月20日14:28:31  增加字段，方便查询
        tXinyiForecastComparison.setRemark(DateUtil.format(DateUtils.getNowDate(), DateUtils.YYYYMMDDHH_TS));

        //防止工业库挂掉以后持续预测同一数据
        //2024年6月20日14:59:23 因为预测bug(以工业库为准，假如工业库挂了，获取的全是挂了时间段后的三小时) 判断是否生成过了否则不生成
        TXinyiForecastComparison tXinyiForecastComparisonReq = new TXinyiForecastComparison();
        //2024年08月20日16:24:56  因为remark存放的是当前时间，也就是每个小时的，所以都是不一样的，修复此bug
//        tXinyiForecastComparisonReq.setRemark(tXinyiForecastComparison.getRemark());
        tXinyiForecastComparisonReq.setCategory(tXinyiForecastComparison.getCategory());
        //2024年7月18日15:04:37 如果工业库挂掉以后，不管什么时刻，调用预测返回的未来三小时时间都是一样的，再增加一个查询条件
        tXinyiForecastComparisonReq.setForecastTimeOne(tXinyiForecastComparison.getForecastTimeOne());//一个时刻就可以了 没必要再比较第二和第三时刻了。
        List<TXinyiForecastComparison> tXinyiForecastComparisons = this.xinyiForecastComparisonService.selectTXinyiForecastComparisonList(tXinyiForecastComparisonReq);
        if(!CollectionUtils.isEmpty(tXinyiForecastComparisons)){
            log.error("预测已经进行过了，无需重复运行~~~~~~~~~~~@@@@@@@，要保存的预测数据为{}", JSON.toJSONString(tXinyiForecastComparison));
            return;
        }

        //获取配置表
        List<TXinyiNormConfig> tXinyiNormConfigs = this.xinyiNormConfigMapper.selectTXinyiNormConfigList(null);
        if(CollectionUtils.isEmpty(tXinyiNormConfigs)) {
            log.error( "未查询到配置信息");
            return;
        }
        TXinyiNormConfig normConfig = tXinyiNormConfigs.get(0);
        //获取最新的工业库的数据
//        TXinyiIndustry tXinyiIndustry = this.xinyiIndustryMapper.selectTXinyiIndustryNewest();
        //2024年7月18日10:29:44  因为获取了最新的六条数据，所以无需再查询最新的数据了
        TXinyiIndustry tXinyiIndustry = tXinyiIndustries6.get(0);
        TXinyiRobot tXinyiRobot = tXinyiRobots6.get(0);
        List<ChartBasic> chartsDataList = new ArrayList<>(9);
        if(BusinessEnum.BigModelForecastEnum.COD.getCode().equals(task)){
            //同时调用跃渊的预测接口 保存记录值
            try {
                String result = HttpUtil.get("http://10.0.3.52:10003/system/forecast?type=2&time=" + DateUtil.format(DateUtils.getNowDate(), DateUtils.YYYY_MM_DD_HH), INT_10000);
                if(!StringUtils.isBlank(result)){
                    JSONArray array = JSON.parseArray(result);
                    tXinyiForecastComparison.setYyForecastOne(array.getBigDecimal(6));
                    tXinyiForecastComparison.setYyForecastTwo(array.getBigDecimal(7));
                    tXinyiForecastComparison.setYyForecastThree(array.getBigDecimal(8));
                }
            } catch (Exception e) {
                log.error("调用跃渊的预测接口出现异常，异常信息为{}", e.getMessage());
            }
            // this.xinyiForecastComparisonService.insertTXinyiForecastComparison(tXinyiForecastComparison);
            BigDecimal cscodBzz = normConfig.getCscodBzz();
            BigDecimal cscodGkz = normConfig.getCscodGkz();
            //处理展示数据
            for (int i = 0; i < tXinyiIndustries6.size(); i++) {
                TXinyiIndustry tXinyiIndustryTemp = tXinyiIndustries6.get(5 - i);
                ChartBasic chartBasic = new ChartBasic();
                chartBasic.setTime(tXinyiIndustryTemp.getTestHour().substring(11));
                chartBasic.setVal(DecimalUtils.getAbsAndScale(tXinyiIndustryTemp.getCsCod(), INT_2));
                chartsDataList.add(chartBasic);
            }
            for (int i = 0; i < split.length; i++) {
                String val = split[i];
                ChartBasic chartBasic = new ChartBasic();
                chartBasic.setTime(hours[i]);
                chartBasic.setVal(DecimalUtils.getAbsAndScale(new BigDecimal(val), INT_2));
                chartsDataList.add(chartBasic);
            }
            ryTask.handleXinYiWarningsYC(cscodBzz, split, cscodGkz, BusinessEnum.WarningCategoryEnum.CS_COD_YC.getCode(), hour, normConfig, tXinyiIndustry.getCsCod(), tXinyiIndustry, chartsDataList, date);
        }else if(BusinessEnum.BigModelForecastEnum.SS.getCode().equals(task)){
            //同时调用跃渊的预测接口 保存记录值
            try {
                String result = HttpUtil.get("http://10.0.3.52:10003/system/forecast?type=5&time=" + DateUtil.format(DateUtils.getNowDate(), DateUtils.YYYY_MM_DD_HH), INT_10000);
                if(!StringUtils.isBlank(result)){
                    JSONArray array = JSON.parseArray(result);
                    tXinyiForecastComparison.setYyForecastOne(array.getBigDecimal(6));
                    tXinyiForecastComparison.setYyForecastTwo(array.getBigDecimal(7));
                    tXinyiForecastComparison.setYyForecastThree(array.getBigDecimal(8));
                }
            } catch (Exception e) {
                log.error("调用跃渊的预测接口出现异常，异常信息为{}", e.getMessage());
            }
            // this.xinyiForecastComparisonService.insertTXinyiForecastComparison(tXinyiForecastComparison);
            BigDecimal csSSBzz = normConfig.getCsssBzz();
            BigDecimal csssGkz = normConfig.getCsssGkz();
            //处理展示数据
            for (int i = 0; i < tXinyiIndustries6.size(); i++) {
                TXinyiIndustry tXinyiIndustryTemp = tXinyiIndustries6.get(5 - i);
                ChartBasic chartBasic = new ChartBasic();
                chartBasic.setTime(tXinyiIndustryTemp.getTestHour().substring(11));
                chartBasic.setVal(DecimalUtils.getAbsAndScale(tXinyiIndustryTemp.getCsSs(), INT_2));
                chartsDataList.add(chartBasic);
            }
            for (int i = 0; i < split.length; i++) {
                String val = split[i];
                ChartBasic chartBasic = new ChartBasic();
                chartBasic.setTime(hours[i]);
                chartBasic.setVal(DecimalUtils.getAbsAndScale(new BigDecimal(val), INT_2));
                chartsDataList.add(chartBasic);
            }
            ryTask.handleXinYiWarningsYC(csSSBzz, split, csssGkz, BusinessEnum.WarningCategoryEnum.CS_SS_YC.getCode(), hour, normConfig, tXinyiIndustry.getCsSs(), tXinyiIndustry, chartsDataList, date);
        }/*else if(BusinessEnum.BigModelForecastEnum.TN.getCode().equals(task)){
            //同时调用跃渊的预测接口 保存记录值
            try {
                String result = HttpUtil.get("http://10.0.3.52:10003/system/forecast?type=3&time=" + DateUtil.format(DateUtils.getNowDate(), DateUtils.YYYY_MM_DD_HH), INT_10);
                if(!StringUtils.isBlank(result)){
                    JSONArray array = JSON.parseArray(result);
                    tXinyiForecastComparison.setYyForecastOne(array.getBigDecimal(6));
                    tXinyiForecastComparison.setYyForecastTwo(array.getBigDecimal(7));
                    tXinyiForecastComparison.setYyForecastThree(array.getBigDecimal(8));
                }
            } catch (Exception e) {
                log.error("调用跃渊的预测接口出现异常，异常信息为{}", e.getMessage());
            }
            // this.xinyiForecastComparisonService.insertTXinyiForecastComparison(tXinyiForecastComparison);
            BigDecimal cszzBzz = normConfig.getCszzBzz();
            BigDecimal cszzGkz = normConfig.getCszzGkz();
            //处理展示数据
            for (int i = 0; i < tXinyiIndustries6.size(); i++) {
                TXinyiIndustry tXinyiIndustryTemp = tXinyiIndustries6.get(5 - i);
                ChartBasic chartBasic = new ChartBasic();
                chartBasic.setTime(tXinyiIndustryTemp.getTestHour().substring(11));
                chartBasic.setVal(DecimalUtils.getAbsAndScale(tXinyiIndustryTemp.getCsTn(), INT_2));
                chartsDataList.add(chartBasic);
            }
            for (int i = 0; i < split.length; i++) {
                String val = split[i];
                ChartBasic chartBasic = new ChartBasic();
                chartBasic.setTime(hours[i]);
                chartBasic.setVal(DecimalUtils.getAbsAndScale(new BigDecimal(val), INT_2));
                chartsDataList.add(chartBasic);
            }
            handleXinYiWarningsYC(cszzBzz, split, cszzGkz, BusinessEnum.WarningCategoryEnum.CS_TN_YC.getCode(), hour, normConfig,tXinyiIndustry.getCsCod(), tXinyiIndustry, chartsDataList, date);
        }*/else if(BusinessEnum.BigModelForecastEnum.TP.getCode().equals(task)){
            //同时调用跃渊的预测接口 保存记录值
            try {
                String result = HttpUtil.get("http://10.0.3.52:10003/system/forecast?type=1&time=" + DateUtil.format(DateUtils.getNowDate(), DateUtils.YYYY_MM_DD_HH), INT_10000);
                if(!StringUtils.isBlank(result)){
                    JSONArray array = JSON.parseArray(result);
                    tXinyiForecastComparison.setYyForecastOne(array.getBigDecimal(6));
                    tXinyiForecastComparison.setYyForecastTwo(array.getBigDecimal(7));
                    tXinyiForecastComparison.setYyForecastThree(array.getBigDecimal(8));
                }
            } catch (Exception e) {
                log.error("调用跃渊的预测接口出现异常，异常信息为{}", e.getMessage());
            }
            // this.xinyiForecastComparisonService.insertTXinyiForecastComparison(tXinyiForecastComparison);
            BigDecimal cszlBzz = normConfig.getCszlBzz();
            BigDecimal cszlGkz = normConfig.getCszlGkz();
            //处理展示数据
            for (int i = 0; i < tXinyiRobots6.size(); i++) {
                TXinyiRobot tXinyiRobotTemp = tXinyiRobots6.get(5 - i);
                ChartBasic chartBasic = new ChartBasic();
                chartBasic.setTime(tXinyiRobotTemp.getTestHour().substring(11));
                chartBasic.setVal(DecimalUtils.getAbsAndScale(tXinyiRobotTemp.getTpRccJqr(), INT_2));
                chartsDataList.add(chartBasic);
            }
            for (int i = 0; i < split.length; i++) {
                String val = split[i];
                ChartBasic chartBasic = new ChartBasic();
                chartBasic.setTime(hours[i]);
                chartBasic.setVal(DecimalUtils.getAbsAndScale(new BigDecimal(val), INT_2));
                chartsDataList.add(chartBasic);
            }
            ryTask.handleXinYiWarningsYC(cszlBzz, split, cszlGkz, CS_TP_YC.getCode(), hour, normConfig, tXinyiRobot.getTpRccJqr(), tXinyiIndustry, chartsDataList, date);
        }else if(BusinessEnum.BigModelForecastEnum.NH3.getCode().equals(task)){
            //同时调用跃渊的预测接口 保存记录值
            try {
                String result = HttpUtil.get("http://10.0.3.52:10003/system/forecast?type=4&time=" + DateUtil.format(DateUtils.getNowDate(), DateUtils.YYYY_MM_DD_HH), INT_10000);
                if(!StringUtils.isBlank(result)){
                    JSONArray array = JSON.parseArray(result);
                    tXinyiForecastComparison.setYyForecastOne(array.getBigDecimal(6));
                    tXinyiForecastComparison.setYyForecastTwo(array.getBigDecimal(7));
                    tXinyiForecastComparison.setYyForecastThree(array.getBigDecimal(8));
                }
            } catch (Exception e) {
                log.error("调用跃渊的预测接口出现异常，异常信息为{}", e.getMessage());
            }
            // this.xinyiForecastComparisonService.insertTXinyiForecastComparison(tXinyiForecastComparison);
            BigDecimal csadBzz = normConfig.getCsadBzz();
            BigDecimal csadGkz = normConfig.getCsadGkz();
            //处理展示数据
            for (int i = 0; i < tXinyiIndustries6.size(); i++) {
                TXinyiIndustry tXinyiIndustryTemp = tXinyiIndustries6.get(5 - i);
                ChartBasic chartBasic = new ChartBasic();
                chartBasic.setTime(tXinyiIndustryTemp.getTestHour().substring(11));
                chartBasic.setVal(DecimalUtils.getAbsAndScale(tXinyiIndustryTemp.getCsNh3(), INT_2));
                chartsDataList.add(chartBasic);
            }
            for (int i = 0; i < split.length; i++) {
                String val = split[i];
                ChartBasic chartBasic = new ChartBasic();
                chartBasic.setTime(hours[i]);
                chartBasic.setVal(DecimalUtils.getAbsAndScale(new BigDecimal(val), INT_2));
                chartsDataList.add(chartBasic);
            }
            ryTask.handleXinYiWarningsYC(csadBzz, split, csadGkz, BusinessEnum.WarningCategoryEnum.CS_AD_YC.getCode(), hour, normConfig, tXinyiIndustry.getCsNh3(), tXinyiIndustry, chartsDataList, date);
        }else if(BusinessEnum.BigModelForecastEnum.XSY1.getCode().equals(task)){
            //2024年6月21日14:57:02 红杉的出水总氮预测改成 不用工业库的，用化验科的两个xsy 相关指标
            //同时调用跃渊的预测接口 保存记录值
            try {
                String result = HttpUtil.get("http://10.0.3.52:10003/system/forecast?type=6&time=" + DateUtil.format(DateUtils.getNowDate(), DateUtils.YYYY_MM_DD_HH), INT_10000);
                if(!StringUtils.isBlank(result)){
                    JSONArray array = JSON.parseArray(result);
                    tXinyiForecastComparison.setYyForecastOne(array.getBigDecimal(6));
                    tXinyiForecastComparison.setYyForecastTwo(array.getBigDecimal(7));
                    tXinyiForecastComparison.setYyForecastThree(array.getBigDecimal(8));
                }
            } catch (Exception e) {
                log.error("调用跃渊的预测接口出现异常，异常信息为{}", e.getMessage());
            }
            // this.xinyiForecastComparisonService.insertTXinyiForecastComparison(tXinyiForecastComparison);
            /*BigDecimal cscodBzz = new BigDecimal(XIAOSUANYAN_BZK);
            BigDecimal cscodGkz = new BigDecimal(XIAOSUANYAN_GKZ);*/
            //2024年7月11日17:19:47  1#好氧硝酸盐、2#好氧硝酸盐使用总氮标准值和管控值来预警
            BigDecimal cszzBzz = normConfig.getCszzBzz();
            BigDecimal cszzGkz = normConfig.getCszzGkz();
            //处理展示数据
            for (int i = 0; i < tXinyiRobots6.size(); i++) {
                TXinyiRobot tXinyiRobotTemp = tXinyiRobots6.get(5 - i);
                ChartBasic chartBasic = new ChartBasic();
                chartBasic.setTime(tXinyiRobotTemp.getTestHour().substring(11));
                chartBasic.setVal(DecimalUtils.getAbsAndScale(tXinyiRobotTemp.getNo3Hlj1Jqr(), INT_2));
                chartsDataList.add(chartBasic);
            }
            for (int i = 0; i < split.length; i++) {
                String val = split[i];
                ChartBasic chartBasic = new ChartBasic();
                chartBasic.setTime(hours[i]);
                chartBasic.setVal(DecimalUtils.getAbsAndScale(new BigDecimal(val), INT_2));
                chartsDataList.add(chartBasic);
            }
            ryTask.handleXinYiWarningsYC(cszzBzz, split, cszzGkz, BusinessEnum.WarningCategoryEnum.CS_XSY_1_YC.getCode(), hour, normConfig, tXinyiRobot.getNo3Hlj1Jqr(), tXinyiIndustry, chartsDataList, date);
        }else if(BusinessEnum.BigModelForecastEnum.XSY2.getCode().equals(task)){
            //同时调用跃渊的预测接口 保存记录值
            try {
                String result = HttpUtil.get("http://10.0.3.52:10003/system/forecast?type=7&time=" + DateUtil.format(DateUtils.getNowDate(), DateUtils.YYYY_MM_DD_HH), INT_10000);
                if(!StringUtils.isBlank(result)){
                    JSONArray array = JSON.parseArray(result);
                    tXinyiForecastComparison.setYyForecastOne(array.getBigDecimal(6));
                    tXinyiForecastComparison.setYyForecastTwo(array.getBigDecimal(7));
                    tXinyiForecastComparison.setYyForecastThree(array.getBigDecimal(8));
                }
            } catch (Exception e) {
                log.error("调用跃渊的预测接口出现异常，异常信息为{}", e.getMessage());
            }
            // this.xinyiForecastComparisonService.insertTXinyiForecastComparison(tXinyiForecastComparison);
            /*BigDecimal cscodBzz = new BigDecimal(XIAOSUANYAN_BZK);
            BigDecimal cscodGkz = new BigDecimal(XIAOSUANYAN_GKZ);*/
            //2024年7月11日17:19:47  1#好氧硝酸盐、2#好氧硝酸盐使用总氮标准值和管控值来预警
            BigDecimal cszzBzz = normConfig.getCszzBzz();
            BigDecimal cszzGkz = normConfig.getCszzGkz();
            //处理展示数据
            for (int i = 0; i < tXinyiRobots6.size(); i++) {
                TXinyiRobot tXinyiRobotTemp = tXinyiRobots6.get(5 - i);
                ChartBasic chartBasic = new ChartBasic();
                chartBasic.setTime(tXinyiRobotTemp.getTestHour().substring(11));
                chartBasic.setVal(DecimalUtils.getAbsAndScale(tXinyiRobotTemp.getNo3Hlj2Jqr(), INT_2));
                chartsDataList.add(chartBasic);
            }
            for (int i = 0; i < split.length; i++) {
                String val = split[i];
                ChartBasic chartBasic = new ChartBasic();
                chartBasic.setTime(hours[i]);
                chartBasic.setVal(DecimalUtils.getAbsAndScale(new BigDecimal(val), INT_2));
                chartsDataList.add(chartBasic);
            }
            ryTask.handleXinYiWarningsYC(cszzBzz, split, cszzGkz, BusinessEnum.WarningCategoryEnum.CS_XSY_2_YC.getCode(), hour, normConfig, tXinyiRobot.getNo3Hlj2Jqr(), tXinyiIndustry, chartsDataList, date);
        }else if(BusinessEnum.BigModelForecastEnum.QYXSY1.getCode().equals(task)){
            //同时调用跃渊的预测接口 保存记录值
            /*try {
                String result = HttpUtil.get("http://10.0.3.52:10003/system/forecast?type=7&time=" + DateUtil.format(DateUtils.getNowDate(), DateUtils.YYYY_MM_DD_HH), INT_10000);
                if(!StringUtils.isBlank(result)){
                    JSONArray array = JSON.parseArray(result);
                    tXinyiForecastComparison.setYyForecastOne(array.getBigDecimal(6));
                    tXinyiForecastComparison.setYyForecastTwo(array.getBigDecimal(7));
                    tXinyiForecastComparison.setYyForecastThree(array.getBigDecimal(8));
                }
            } catch (Exception e) {
                log.error("调用跃渊的预测接口出现异常，异常信息为{}", e.getMessage());
            }*/
            // this.xinyiForecastComparisonService.insertTXinyiForecastComparison(tXinyiForecastComparison);
            /*BigDecimal cscodBzz = new BigDecimal(XIAOSUANYAN_BZK);
            BigDecimal cscodGkz = new BigDecimal(XIAOSUANYAN_GKZ);*/
            //2024年7月11日17:19:47  1#好氧硝酸盐、2#好氧硝酸盐使用总氮标准值和管控值来预警
            BigDecimal cszzBzz = normConfig.getCszzBzz();
            BigDecimal cszzGkz = normConfig.getCszzGkz();
            //处理展示数据
            for (int i = 0; i < tXinyiRobots6.size(); i++) {
                TXinyiRobot tXinyiRobotTemp = tXinyiRobots6.get(5 - i);
                ChartBasic chartBasic = new ChartBasic();
                chartBasic.setTime(tXinyiRobotTemp.getTestHour().substring(11));
                chartBasic.setVal(DecimalUtils.getAbsAndScale(tXinyiRobotTemp.getNo3Qyc1Jqr(), INT_2));
                chartsDataList.add(chartBasic);
            }
            for (int i = 0; i < split.length; i++) {
                String val = split[i];
                ChartBasic chartBasic = new ChartBasic();
                chartBasic.setTime(hours[i]);
                chartBasic.setVal(DecimalUtils.getAbsAndScale(new BigDecimal(val), INT_2));
                chartsDataList.add(chartBasic);
            }
//            ryTask.handleXinYiWarningsYC(cszzBzz, split, cszzGkz, BusinessEnum.WarningCategoryEnum.QYCXSY_1.getCode(), hour, normConfig, tXinyiRobot.getNo3Hlj2Jqr(), tXinyiIndustry, chartsDataList, date);
        }else if(BusinessEnum.BigModelForecastEnum.QYXSY2.getCode().equals(task)){
            //同时调用跃渊的预测接口 保存记录值
            /*try {
                String result = HttpUtil.get("http://10.0.3.52:10003/system/forecast?type=7&time=" + DateUtil.format(DateUtils.getNowDate(), DateUtils.YYYY_MM_DD_HH), INT_10000);
                if(!StringUtils.isBlank(result)){
                    JSONArray array = JSON.parseArray(result);
                    tXinyiForecastComparison.setYyForecastOne(array.getBigDecimal(6));
                    tXinyiForecastComparison.setYyForecastTwo(array.getBigDecimal(7));
                    tXinyiForecastComparison.setYyForecastThree(array.getBigDecimal(8));
                }
            } catch (Exception e) {
                log.error("调用跃渊的预测接口出现异常，异常信息为{}", e.getMessage());
            }*/
            // this.xinyiForecastComparisonService.insertTXinyiForecastComparison(tXinyiForecastComparison);
            /*BigDecimal cscodBzz = new BigDecimal(XIAOSUANYAN_BZK);
            BigDecimal cscodGkz = new BigDecimal(XIAOSUANYAN_GKZ);*/
            //2024年7月11日17:19:47  1#好氧硝酸盐、2#好氧硝酸盐使用总氮标准值和管控值来预警
            BigDecimal cszzBzz = normConfig.getCszzBzz();
            BigDecimal cszzGkz = normConfig.getCszzGkz();
            //处理展示数据
            for (int i = 0; i < tXinyiRobots6.size(); i++) {
                TXinyiRobot tXinyiRobotTemp = tXinyiRobots6.get(5 - i);
                ChartBasic chartBasic = new ChartBasic();
                chartBasic.setTime(tXinyiRobotTemp.getTestHour().substring(11));
                chartBasic.setVal(DecimalUtils.getAbsAndScale(tXinyiRobotTemp.getNo3Qyc2Jqr(), INT_2));
                chartsDataList.add(chartBasic);
            }
            for (int i = 0; i < split.length; i++) {
                String val = split[i];
                ChartBasic chartBasic = new ChartBasic();
                chartBasic.setTime(hours[i]);
                chartBasic.setVal(DecimalUtils.getAbsAndScale(new BigDecimal(val), INT_2));
                chartsDataList.add(chartBasic);
            }
//            ryTask.handleXinYiWarningsYC(cszzBzz, split, cszzGkz, BusinessEnum.WarningCategoryEnum.QYCXSY_2.getCode(), hour, normConfig, tXinyiRobot.getNo3Hlj2Jqr(), tXinyiIndustry, chartsDataList, date);
        }else if(BusinessEnum.BigModelForecastEnum.QYNH31.getCode().equals(task)){
            //同时调用跃渊的预测接口 保存记录值
            /*try {
                String result = HttpUtil.get("http://10.0.3.52:10003/system/forecast?type=7&time=" + DateUtil.format(DateUtils.getNowDate(), DateUtils.YYYY_MM_DD_HH), INT_10000);
                if(!StringUtils.isBlank(result)){
                    JSONArray array = JSON.parseArray(result);
                    tXinyiForecastComparison.setYyForecastOne(array.getBigDecimal(6));
                    tXinyiForecastComparison.setYyForecastTwo(array.getBigDecimal(7));
                    tXinyiForecastComparison.setYyForecastThree(array.getBigDecimal(8));
                }
            } catch (Exception e) {
                log.error("调用跃渊的预测接口出现异常，异常信息为{}", e.getMessage());
            }*/
            // this.xinyiForecastComparisonService.insertTXinyiForecastComparison(tXinyiForecastComparison);
            /*BigDecimal cscodBzz = new BigDecimal(XIAOSUANYAN_BZK);
            BigDecimal cscodGkz = new BigDecimal(XIAOSUANYAN_GKZ);*/
            //2024年09月08日11:21:25 采用出水氨氮的标准值和管控值
            BigDecimal csadBzz = normConfig.getCsadBzz();
            BigDecimal csadGkz = normConfig.getCsadGkz();
            //处理展示数据
            for (int i = 0; i < tXinyiRobots6.size(); i++) {
                TXinyiRobot tXinyiRobotTemp = tXinyiRobots6.get(5 - i);
                ChartBasic chartBasic = new ChartBasic();
                chartBasic.setTime(tXinyiRobotTemp.getTestHour().substring(11));
                chartBasic.setVal(DecimalUtils.getAbsAndScale(tXinyiRobotTemp.getNh31Jqr(), INT_2));
                chartsDataList.add(chartBasic);
            }
            for (int i = 0; i < split.length; i++) {
                String val = split[i];
                ChartBasic chartBasic = new ChartBasic();
                chartBasic.setTime(hours[i]);
                chartBasic.setVal(DecimalUtils.getAbsAndScale(new BigDecimal(val), INT_2));
                chartsDataList.add(chartBasic);
            }
//            ryTask.handleXinYiWarningsYC(csadBzz, split, csadGkz, BusinessEnum.WarningCategoryEnum.QYAD_1.getCode(), hour, normConfig, tXinyiRobot.getNo3Hlj2Jqr(), tXinyiIndustry, chartsDataList, date);
        }else if(BusinessEnum.BigModelForecastEnum.QYNH32.getCode().equals(task)){
            //同时调用跃渊的预测接口 保存记录值
            /*try {
                String result = HttpUtil.get("http://10.0.3.52:10003/system/forecast?type=7&time=" + DateUtil.format(DateUtils.getNowDate(), DateUtils.YYYY_MM_DD_HH), INT_10000);
                if(!StringUtils.isBlank(result)){
                    JSONArray array = JSON.parseArray(result);
                    tXinyiForecastComparison.setYyForecastOne(array.getBigDecimal(6));
                    tXinyiForecastComparison.setYyForecastTwo(array.getBigDecimal(7));
                    tXinyiForecastComparison.setYyForecastThree(array.getBigDecimal(8));
                }
            } catch (Exception e) {
                log.error("调用跃渊的预测接口出现异常，异常信息为{}", e.getMessage());
            }*/
            // this.xinyiForecastComparisonService.insertTXinyiForecastComparison(tXinyiForecastComparison);
            /*BigDecimal cscodBzz = new BigDecimal(XIAOSUANYAN_BZK);
            BigDecimal cscodGkz = new BigDecimal(XIAOSUANYAN_GKZ);*/
            //2024年09月08日11:21:25 采用出水氨氮的标准值和管控值
            BigDecimal csadBzz = normConfig.getCsadBzz();
            BigDecimal csadGkz = normConfig.getCsadGkz();
            //处理展示数据
            for (int i = 0; i < tXinyiRobots6.size(); i++) {
                TXinyiRobot tXinyiRobotTemp = tXinyiRobots6.get(5 - i);
                ChartBasic chartBasic = new ChartBasic();
                chartBasic.setTime(tXinyiRobotTemp.getTestHour().substring(11));
                chartBasic.setVal(DecimalUtils.getAbsAndScale(tXinyiRobotTemp.getNh32Jqr(), INT_2));
                chartsDataList.add(chartBasic);
            }
            for (int i = 0; i < split.length; i++) {
                String val = split[i];
                ChartBasic chartBasic = new ChartBasic();
                chartBasic.setTime(hours[i]);
                chartBasic.setVal(DecimalUtils.getAbsAndScale(new BigDecimal(val), INT_2));
                chartsDataList.add(chartBasic);
            }
//            ryTask.handleXinYiWarningsYC(csadBzz, split, csadGkz, BusinessEnum.WarningCategoryEnum.QYAD_2.getCode(), hour, normConfig, tXinyiRobot.getNo3Hlj2Jqr(), tXinyiIndustry, chartsDataList, date);
        }else {
            log.error("暂未支持的类型{}", task);
        }
        //插入到数据库
        //2024年6月21日14:18:55  如果红杉预测和跃渊预测都有数据再保存
        //2024年7月8日15:15:46 逻辑调整：只要红杉的数据不为空就保存
        if(Objects.isNull(tXinyiForecastComparison.getHsForecastOne()) || Objects.isNull(tXinyiForecastComparison.getHsForecastTwo()) ||Objects.isNull(tXinyiForecastComparison.getHsForecastThree())){
//            || Objects.isNull(tXinyiForecastComparison.getYyForecastOne()) || Objects.isNull(tXinyiForecastComparison.getYyForecastTwo()) || Objects.isNull(tXinyiForecastComparison.getYyForecastThree())){
            log.error("保存预测对比数据时，有存在不满足条件的数据，不再保存数据，数据为{}", JSON.toJSONString(tXinyiForecastComparison));
        }else
            xinyiForecastComparisonService.insertTXinyiForecastComparison(tXinyiForecastComparison);
    }


    //2025年05月08日10:02:48  下面是新的手动操作数据的接口

    /**
     *手动处理水质报警-新的逻辑 并且需要传入起止时间
     */
    @PostMapping("/waterWarningNewByDate")
    public String waterWarningNewByDate(String dateBegin, String dateEnd){
        log.info("进入了 手动处理水质报警-新的逻辑 并且需要传入起止时间 操作");
        //获取配置表
        List<TXinyiNormConfig> tXinyiNormConfigs = this.xinyiNormConfigMapper.selectTXinyiNormConfigList(null);
        if(CollectionUtils.isEmpty(tXinyiNormConfigs))
            throw new RuntimeException("未查询到配置信息");
        TXinyiNormConfig normConfig = tXinyiNormConfigs.get(0);
        //查询最近N天的数据，遍历，处理报警信息
        List<TXinyiIndustry> tXinyiIndustries = this.xinyiIndustryMapper.selectTXinyiIndustryListNew(TXinyiIndustry.builder().timeBegin(dateBegin).timeEnd(dateEnd).build());
        if(!CollectionUtils.isEmpty(tXinyiIndustries)){
            for (TXinyiIndustry tXinyiIndustry : tXinyiIndustries) {
//                asyncTask.handleSZWarningNew(tXinyiIndustry, normConfig);
                //2025年05月08日15:47:39 只处理调用决策相关的报警
                this.handleSZWarningNew(tXinyiIndustry, normConfig);
            }
        }
        return "success";
    }

    private void handleSZWarningNew(TXinyiIndustry tXinyiIndustry, TXinyiNormConfig normConfig) {
        BigDecimal jsSlq = tXinyiIndustry.getJsSlq();
        BigDecimal jsslSjz = normConfig.getJsslSjz();
        BigDecimal jszdSjz = normConfig.getJszdSjz();
        BigDecimal jsadSjz = normConfig.getJsadSjz();
        BigDecimal cscodBzz = normConfig.getCscodBzz();
        BigDecimal cscodGkz = normConfig.getCscodGkz();
        BigDecimal jscodSjz = normConfig.getJscodSjz();
        BigDecimal jszlSjz = normConfig.getJszlSjz();
        //进水总氮超标报警
        BigDecimal jsTn = tXinyiIndustry.getJsTn();
        //进水氨氮超标报警
        BigDecimal jsNh3 = tXinyiIndustry.getJsNh3();
        //进水Cod报警
        BigDecimal jsCod = tXinyiIndustry.getJsCod();
        //出水Cod报警
        BigDecimal csCod = tXinyiIndustry.getCsCod();
        //进水总磷
        BigDecimal jsTp = tXinyiIndustry.getJsTp();

        if(!Objects.isNull(jszdSjz) && jszdSjz.compareTo(BigDecimal.ZERO) > 0)
            handleXinYiWarningRecordJSOriginZD(jszdSjz, jsTn, BusinessEnum.WarningCategoryEnum.JS_ZD.getCode(), tXinyiIndustry, normConfig, getCwrwfhzByDetail(jsSlq, tXinyiIndustry.getJsTn(), jsslSjz, normConfig.getJszdSjz()));
        if(!Objects.isNull(jsadSjz) && jsadSjz.compareTo(BigDecimal.ZERO) > 0)
            handleXinYiWarningRecordJSOriginNh3(jsadSjz, jsNh3, BusinessEnum.WarningCategoryEnum.JS_AD.getCode(), tXinyiIndustry, normConfig, getCwrwfhzByDetail(jsSlq, tXinyiIndustry.getJsNh3(), jsslSjz, normConfig.getJsadSjz()));
        if(!Objects.isNull(cscodBzz) && cscodBzz.compareTo(BigDecimal.ZERO) > 0 && !Objects.isNull(cscodGkz) && cscodGkz.compareTo(BigDecimal.ZERO) > 0)
            handleXinYiWarningsCsOriginCod(cscodBzz, csCod, cscodGkz, CS_COD.getCode(), tXinyiIndustry, normConfig, getCwrwfhzByDetail(jsSlq, tXinyiIndustry.getJsCod(), jsslSjz, normConfig.getJscodSjz()));
        if(!Objects.isNull(jscodSjz) && jscodSjz.compareTo(BigDecimal.ZERO) > 0)
            handleXinYiWarningRecordJSOriginCod(jscodSjz, jsCod, JS_COD.getCode(), tXinyiIndustry, normConfig, getCwrwfhzByDetail(jsSlq, tXinyiIndustry.getJsCod(), jsslSjz, normConfig.getJscodSjz()));
        if(!Objects.isNull(jszlSjz) && jszlSjz.compareTo(BigDecimal.ZERO) > 0)
            handleXinYiWarningRecordJSOriginTp(jszlSjz, jsTp, JS_ZL.getCode(), tXinyiIndustry, normConfig, getCwrwfhzByDetail(jsSlq, jsTp, jsslSjz, jszlSjz));
    }


    /**
     * 不同指标报警规则不一样，全部区分开来处理，此方法为：进水tp
     * 通过输入的值 生成对应类型的报警对象（进水）- 总磷
     *
     * @param jsBzz
     * @param currentVal
     * @param category
     * @param tXinyiIndustry
     * @param normConfig
     * @param cwrwfhz
     * @return
     */
    private void handleXinYiWarningRecordJSOriginTp(BigDecimal jsBzz, BigDecimal currentVal, String category, TXinyiIndustry tXinyiIndustry, TXinyiNormConfig normConfig, BigDecimal cwrwfhz) {

        String testHour = tXinyiIndustry.getTestHour();
        //这里也不能用当前日期，要用对应检测时间
//        Date nowDate = DateUtils.getNowDate();
        Date nowDate = DateUtils.parseDate(testHour);

        List<TXinyiIndustry> tXinyiIndustries = this.xinyiIndustryMapper.selectNIndustry(INT_8);
        if(CollectionUtils.isEmpty(tXinyiIndustries) || tXinyiIndustries.size() < INT_8){
            log.error("处理生化报警时，获取最近的8条工业库数据失败~~~~~~~");
            return ;
        }
        //最开始的工艺报警  （超标准工艺报警） 2025年04月16日15:40:23 改成只有超标准才会报警，并且具体逻辑做拆分
        normalIndustryWarningJsTp(jsBzz, currentVal, category, tXinyiIndustry, normConfig, cwrwfhz, nowDate, tXinyiIndustries);

    }


    /**
     * 最开始的工艺报警  （超标准工艺报警） -- 进水tp
     * @param jsBzz
     * @param currentVal
     * @param category
     * @param tXinyiIndustry
     * @param normConfig
     * @param cwrwfhz
     * @param nowDate
     * @param tXinyiIndustries
     */
    private void normalIndustryWarningJsTp(BigDecimal jsBzz, BigDecimal currentVal, String category, TXinyiIndustry tXinyiIndustry, TXinyiNormConfig normConfig, BigDecimal cwrwfhz, Date nowDate, List<TXinyiIndustry> tXinyiIndustries) {
        //新的判断进水氨氮是否超标
        TXinyiWarningRecord tXinyiWarningRecord = existsNormalJsTp(jsBzz, currentVal, category, cwrwfhz, tXinyiIndustries, normConfig, nowDate);

        //最近3条输出 连续升高趋势 和 新增的报警都需要
        //当前状态正常 需要查询历史有无正在报警的数据，如果有，将报警状态改完2(系统自动关闭)
        List<TXinyiWarningRecord> tXinyiWarningRecords = this.xinyiWarningRecordMapper.selectTXinyiWarningRecordList(TXinyiWarningRecord.builder().type(0).category(category).status(0).build());
        if(Objects.isNull(tXinyiWarningRecord)){//数据正常，无告警信息
            if(!CollectionUtils.isEmpty(tXinyiWarningRecords)){
                log.info( "{}:现在恢复正常，历史报警数据为{}", category,JSON.toJSONString(tXinyiWarningRecords));
                for (TXinyiWarningRecord xinyiWarningRecord : tXinyiWarningRecords) {
                    closeWarning(xinyiWarningRecord);
                }
            }
        }else{//有告警信息
            if(CollectionUtils.isEmpty(tXinyiWarningRecords)){//之前没有告警记录
                //保存到数据库中
                //2024年7月15日11:06:16 因为只有一个告警记录，但是如果一直报警，现在报警时间取的是更新时间，兼容第一次报警处理
                tXinyiWarningRecord.setUpdateTime(nowDate);
                this.xinyiWarningRecordMapper.insertTXinyiWarningRecord(tXinyiWarningRecord);
                //继续调用决策
                this.handleDecision(tXinyiWarningRecord, tXinyiIndustry, normConfig, false, nowDate);
            }else{
                log.info("{}:之前已经有过告警记录了，且还是继续报警，无需重复添加报警，但是决策仍然要调用", category);
                for (TXinyiWarningRecord xinyiWarningRecord : tXinyiWarningRecords) {//理论上只有一个的
                    //2024年7月5日10:45:24 逻辑调整：更新一直报警的那条记录的显示值
                    xinyiWarningRecord.setWarningVal(tXinyiWarningRecord.getWarningVal());
//                        xinyiWarningRecord.setDesignVal(tXinyiWarningRecord.getDesignVal());
//                        tXinyiWarningRecord.setControlVal(tXinyiWarningRecord.getControlVal());
                    xinyiWarningRecord.setTime(tXinyiWarningRecord.getTime());
                    xinyiWarningRecord.setUpdateTime(nowDate);
                    xinyiWarningRecord.setUpdateBy(WARNING_DEFAULT_CREATE);
                    //2024年7月15日11:07:33 报警的级别也要重新计算并更新
                    xinyiWarningRecord.setLevel(tXinyiWarningRecord.getLevel());
                    //2024年7月31日09:20:47 报警的原因（超标还是超管控也需要更新）
                    xinyiWarningRecord.setReason(tXinyiWarningRecord.getReason());
                    //更新数据库
                    this.xinyiWarningRecordMapper.updateTXinyiWarningRecord(xinyiWarningRecord);
                    //继续调用决策
                    this.handleDecision(xinyiWarningRecord, tXinyiIndustry, normConfig, false, nowDate);
                }
            }
        }
    }



    /**
     * 根据新的规则，判断进水氨氮是否超标，超标了则返回报警对象；没有超标，返回空对象 -- 进水cod
     *
     * @param jsBzz
     * @param currentVal
     * @param category
     * @param cwrwfhz
     * @param tXinyiIndustries
     * @param normConfig
     * @param nowDate
     * @return
     */
    private TXinyiWarningRecord existsNormalJsTp(BigDecimal jsBzz, BigDecimal currentVal, String category, BigDecimal cwrwfhz, List<TXinyiIndustry> tXinyiIndustries, TXinyiNormConfig normConfig, Date nowDate) {
        boolean flag = false;
        TXinyiIndustry tXinyiIndustry = tXinyiIndustries.get(INDEX_0);
        BigDecimal jsTp0 = tXinyiIndustry.getJsTp();
        BigDecimal jsTp1 = tXinyiIndustries.get(INDEX_1).getJsTp();
        BigDecimal jsTp2 = tXinyiIndustries.get(INDEX_2).getJsTp();
        BigDecimal jsTp3 = tXinyiIndustries.get(INDEX_3).getJsTp();
        if(!Objects.isNull(jsTp0) && jsTp0.compareTo(jsBzz) > 0 && !Objects.isNull(jsTp1) && jsTp1.compareTo(jsBzz) > 0
                && !Objects.isNull(jsTp2) && jsTp2.compareTo(jsBzz) > 0 && !Objects.isNull(jsTp3) && jsTp3.compareTo(jsBzz) > 0)
            flag = true;//最近4个都超标
        if(!Objects.isNull(jsTp0) && jsTp0.compareTo(jsBzz) > 0 && !Objects.isNull(jsTp1) && jsTp0.compareTo(jsTp1) >= 0
                && !Objects.isNull(jsTp2) && jsTp1.compareTo(jsTp2) >= 0)
            flag = true;//最新的超标了并且连续3个值都有升高趋势
        BigDecimal jsCod = tXinyiIndustry.getJsCod();
        BigDecimal jsTn = tXinyiIndustry.getJsTn();
        BigDecimal jsNh3 = tXinyiIndustry.getJsNh3();
        //在线仪表，一个进水总磷数据 > 7.1，并且 cod> 630 或当前进水总氮> 65 或 当前进水氨氮 >58
        if(!Objects.isNull(jsTp0) && jsTp0.compareTo(jsBzz) > 0 && (!Objects.isNull(jsCod) && jsCod.compareTo(BigDecimal.valueOf(630)) > 0
                || !Objects.isNull(jsTn) && jsTn.compareTo(BigDecimal.valueOf(65)) > 0 || !Objects.isNull(jsNh3) && jsNh3.compareTo(BigDecimal.valueOf(58)) > 0))
            flag = true;
        if(!flag)
            return null;
        //存在符合的报警情况，生成报警对象
        TXinyiWarningRecord tXinyiWarningRecord = new TXinyiWarningRecord();
        /*String category = BusinessEnum.WarningCategoryEnum.CS_AD.getCode();*/
        tXinyiWarningRecord.setStatus(0);
        tXinyiWarningRecord.setType(0);
        tXinyiWarningRecord.setCategory(category);
        tXinyiWarningRecord.setTime(nowDate);
        tXinyiWarningRecord.setWarningVal(currentVal);
        tXinyiWarningRecord.setDesignVal(jsBzz);
//        tXinyiWarningRecord.setControlVal(csGkz);
        tXinyiWarningRecord.setCreateBy(WARNING_DEFAULT_CREATE);
        tXinyiWarningRecord.setCreateTime(nowDate);
        tXinyiWarningRecord.setRemark(ZERO_SZ_WARNING.getCode());
        //2025年02月10日14:45:08 下面是新增加的字段
        tXinyiWarningRecord.setWaterType(BusinessEnum.WaterTypeEnum.JS.getCode());
        //超污染物限制：计算公式为：当前氨氮/氨氮设计值 或者 当前氨氮/氨氮管控值（智能工单使用）  这里是出水的 【需要根据超标还是超管控，具体计算】
        //超污染物负荷值：计算公式为：当前水量与氨氮乘积  /  设计水量与设计进水氨氮的乘积（智能工单使用）
        tXinyiWarningRecord.setCwrwfhz(cwrwfhz);//2025年02月14日10:48:32 具体的值由上游传过来
        tXinyiWarningRecord.setReason(category + CHAOBIAO_WARNING);
        tXinyiWarningRecord.setLevel(WARNING_LEVEL_ONE);
        tXinyiWarningRecord.setSymbol(BusinessEnum.WarningSymbolEnum.CBZZ.getCode());
        tXinyiWarningRecord.setCwrwxz(getCwrwxzByDetail(currentVal, normConfig, category, true));//根据当前值和类型以及是否超标处理

        return tXinyiWarningRecord;
    }



    /**
     * 不同指标报警规则不一样，全部区分开来处理，此方法为：进水cod
     * 通过输入的值 生成对应类型的报警对象（进水）- cod
     *
     * @param jsBzz
     * @param currentVal
     * @param category
     * @param tXinyiIndustry
     * @param normConfig
     * @param cwrwfhz
     * @return
     */
    private void handleXinYiWarningRecordJSOriginCod(BigDecimal jsBzz, BigDecimal currentVal, String category, TXinyiIndustry tXinyiIndustry, TXinyiNormConfig normConfig, BigDecimal cwrwfhz) {

        String testHour = tXinyiIndustry.getTestHour();
        //这里也不能用当前日期，要用对应检测时间
//        Date nowDate = DateUtils.getNowDate();
        Date nowDate = DateUtils.parseDate(testHour);

        List<TXinyiIndustry> tXinyiIndustries = this.xinyiIndustryMapper.selectNIndustry(INT_8);
        if(CollectionUtils.isEmpty(tXinyiIndustries) || tXinyiIndustries.size() < INT_8){
            log.error("处理生化报警时，获取最近的8条工业库数据失败~~~~~~~");
            return ;
        }

        //最开始的工艺报警  （超标准工艺报警） 2025年04月16日15:40:23 改成只有超标准才会报警，并且具体逻辑做拆分
        normalIndustryWarningJsCod(jsBzz, currentVal, category, tXinyiIndustry, normConfig, cwrwfhz, nowDate, tXinyiIndustries);

    }


    /**
     * 最开始的工艺报警  （超标准工艺报警） -- 进水cod
     * @param jsBzz
     * @param currentVal
     * @param category
     * @param tXinyiIndustry
     * @param normConfig
     * @param cwrwfhz
     * @param nowDate
     * @param tXinyiIndustries
     */
    private void normalIndustryWarningJsCod(BigDecimal jsBzz, BigDecimal currentVal, String category, TXinyiIndustry tXinyiIndustry, TXinyiNormConfig normConfig, BigDecimal cwrwfhz, Date nowDate, List<TXinyiIndustry> tXinyiIndustries) {
        //新的判断进水氨氮是否超标
        TXinyiWarningRecord tXinyiWarningRecord = existsNormalJsCod(jsBzz, currentVal, category, cwrwfhz, tXinyiIndustries, normConfig, nowDate);

        //最近3条输出 连续升高趋势 和 新增的报警都需要
        //当前状态正常 需要查询历史有无正在报警的数据，如果有，将报警状态改完2(系统自动关闭)
        List<TXinyiWarningRecord> tXinyiWarningRecords = this.xinyiWarningRecordMapper.selectTXinyiWarningRecordList(TXinyiWarningRecord.builder().type(0).category(category).status(0).build());
        if(Objects.isNull(tXinyiWarningRecord)){//数据正常，无告警信息
            if(!CollectionUtils.isEmpty(tXinyiWarningRecords)){
                log.info( "{}:现在恢复正常，历史报警数据为{}", category,JSON.toJSONString(tXinyiWarningRecords));
                for (TXinyiWarningRecord xinyiWarningRecord : tXinyiWarningRecords) {
                    closeWarning(xinyiWarningRecord);
                }
            }
        }else{//有告警信息
            if(CollectionUtils.isEmpty(tXinyiWarningRecords)){//之前没有告警记录
                //保存到数据库中
                //2024年7月15日11:06:16 因为只有一个告警记录，但是如果一直报警，现在报警时间取的是更新时间，兼容第一次报警处理
                tXinyiWarningRecord.setUpdateTime(nowDate);
                this.xinyiWarningRecordMapper.insertTXinyiWarningRecord(tXinyiWarningRecord);
                //继续调用决策
                this.handleDecision(tXinyiWarningRecord, tXinyiIndustry, normConfig, false, nowDate);
            }else{
                log.info("{}:之前已经有过告警记录了，且还是继续报警，无需重复添加报警，但是决策仍然要调用", category);
                for (TXinyiWarningRecord xinyiWarningRecord : tXinyiWarningRecords) {//理论上只有一个的
                    //2024年7月5日10:45:24 逻辑调整：更新一直报警的那条记录的显示值
                    xinyiWarningRecord.setWarningVal(tXinyiWarningRecord.getWarningVal());
//                        xinyiWarningRecord.setDesignVal(tXinyiWarningRecord.getDesignVal());
//                        tXinyiWarningRecord.setControlVal(tXinyiWarningRecord.getControlVal());
                    xinyiWarningRecord.setTime(tXinyiWarningRecord.getTime());
                    xinyiWarningRecord.setUpdateTime(nowDate);
                    xinyiWarningRecord.setUpdateBy(WARNING_DEFAULT_CREATE);
                    //2024年7月15日11:07:33 报警的级别也要重新计算并更新
                    xinyiWarningRecord.setLevel(tXinyiWarningRecord.getLevel());
                    //2024年7月31日09:20:47 报警的原因（超标还是超管控也需要更新）
                    xinyiWarningRecord.setReason(tXinyiWarningRecord.getReason());
                    //更新数据库
                    this.xinyiWarningRecordMapper.updateTXinyiWarningRecord(xinyiWarningRecord);
                    //继续调用决策
                    this.handleDecision(xinyiWarningRecord, tXinyiIndustry, normConfig, false, nowDate);
                }
            }
        }
    }


    /**
     * 根据新的规则，判断进水氨氮是否超标，超标了则返回报警对象；没有超标，返回空对象 -- 进水cod
     *
     * @param jsBzz
     * @param currentVal
     * @param category
     * @param cwrwfhz
     * @param tXinyiIndustries
     * @param normConfig
     * @param nowDate
     * @return
     */
    private TXinyiWarningRecord existsNormalJsCod(BigDecimal jsBzz, BigDecimal currentVal, String category, BigDecimal cwrwfhz, List<TXinyiIndustry> tXinyiIndustries, TXinyiNormConfig normConfig, Date nowDate) {
        boolean flag = false;
        TXinyiIndustry tXinyiIndustry = tXinyiIndustries.get(INDEX_0);
        BigDecimal jsCod0 = tXinyiIndustry.getJsCod();
        BigDecimal jsCod1 = tXinyiIndustries.get(INDEX_1).getJsCod();
        /*BigDecimal jsCod2 = tXinyiIndustries.get(INDEX_2).getJsCod();
        BigDecimal jsCod3 = tXinyiIndustries.get(INDEX_3).getJsCod();*/
        if(!Objects.isNull(jsCod0) && jsCod0.compareTo(jsBzz) > 0 && !Objects.isNull(jsCod1) && jsCod1.compareTo(jsBzz) > 0)
            flag = true;//在线仪表，连续两个不同的进水COD数据 > 630
        if(!Objects.isNull(jsCod0) && jsCod0.compareTo(jsBzz) > 0 && !Objects.isNull(jsCod1) && jsCod0.compareTo(jsCod1) > 0)
            flag = true;//在线仪表，一个进水COD数据 > 630，与前一个数据呈上升趋势
        BigDecimal jsTn = tXinyiIndustry.getJsTn();
        BigDecimal jsNh3 = tXinyiIndustry.getJsNh3();
        BigDecimal jsTp = tXinyiIndustry.getJsTp();
        if(!Objects.isNull(jsCod0) && jsCod0.compareTo(jsBzz) > 0 && (!Objects.isNull(jsTn) && jsTn.compareTo(BigDecimal.valueOf(65)) > 0
                || !Objects.isNull(jsNh3) && jsNh3.compareTo(BigDecimal.valueOf(58)) > 0 || !Objects.isNull(jsTp) && jsTp.compareTo(BigDecimal.valueOf(7.1)) > 0))
            flag = true;
        if(!flag)
            return null;
        //存在符合的报警情况，生成报警对象
        TXinyiWarningRecord tXinyiWarningRecord = new TXinyiWarningRecord();
        /*String category = BusinessEnum.WarningCategoryEnum.CS_AD.getCode();*/
        tXinyiWarningRecord.setStatus(0);
        tXinyiWarningRecord.setType(0);
        tXinyiWarningRecord.setCategory(category);
        tXinyiWarningRecord.setTime(nowDate);
        tXinyiWarningRecord.setWarningVal(currentVal);
        tXinyiWarningRecord.setDesignVal(jsBzz);
//        tXinyiWarningRecord.setControlVal(csGkz);
        tXinyiWarningRecord.setCreateBy(WARNING_DEFAULT_CREATE);
        tXinyiWarningRecord.setCreateTime(nowDate);
        tXinyiWarningRecord.setRemark(ZERO_SZ_WARNING.getCode());
        //2025年02月10日14:45:08 下面是新增加的字段
        tXinyiWarningRecord.setWaterType(BusinessEnum.WaterTypeEnum.JS.getCode());
        //超污染物限制：计算公式为：当前氨氮/氨氮设计值 或者 当前氨氮/氨氮管控值（智能工单使用）  这里是出水的 【需要根据超标还是超管控，具体计算】
        //超污染物负荷值：计算公式为：当前水量与氨氮乘积  /  设计水量与设计进水氨氮的乘积（智能工单使用）
        tXinyiWarningRecord.setCwrwfhz(cwrwfhz);//2025年02月14日10:48:32 具体的值由上游传过来
        tXinyiWarningRecord.setReason(category + CHAOBIAO_WARNING);
        tXinyiWarningRecord.setLevel(WARNING_LEVEL_ONE);
        tXinyiWarningRecord.setSymbol(BusinessEnum.WarningSymbolEnum.CBZZ.getCode());
        tXinyiWarningRecord.setCwrwxz(getCwrwxzByDetail(currentVal, normConfig, category, true));//根据当前值和类型以及是否超标处理

        return tXinyiWarningRecord;
    }


    private String getJsCodStrByList(List<TXinyiIndustry> tXinyiIndustries) {
        int size = tXinyiIndustries.size();
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < size; i++) {
            TXinyiIndustry tXinyiIndustry = tXinyiIndustries.get(i);
            //2025年05月08日14:07:50 bug修复：传过来几条数据，都需要拼接
            if(i < size - 1)
                sb.append(DecimalUtils.getAbsAndScale(tXinyiIndustry.getJsCod(), INT_2)).append("mg/L、");
            else
                sb.append(DecimalUtils.getAbsAndScale(tXinyiIndustry.getJsCod(), INT_2)).append("mg/L。");
        }
        return sb.toString();
    }



    /**
     * 通过输入的值 生成对应类型的报警对象（出水）- 新的 按照不同的类型区分了，因为每个报警都不一样了
     *
     * @param csBzz
     * @param currentVal
     * @param csGkz
     * @param category
     * @param tXinyiIndustry
     * @param normConfig
     * @param cwrwfhz
     * 2025年05月14日15:15:48 cod报警比较特殊：没有异常升高、异常偏低、高低值报警；并且把断点和连续不变合成了一个叫 【设备故障的报警】
     * @return
     */
    private void handleXinYiWarningsCsOriginCod(BigDecimal csBzz, BigDecimal currentVal, BigDecimal csGkz, String category, TXinyiIndustry tXinyiIndustry, TXinyiNormConfig normConfig, BigDecimal cwrwfhz) {

        String testHour = tXinyiIndustry.getTestHour();
        //这里也不能用当前日期，要用对应检测时间
//        Date nowDate = DateUtils.getNowDate();
        Date nowDate = DateUtils.parseDate(testHour);

        List<TXinyiIndustry> tXinyiIndustries = this.xinyiIndustryMapper.selectNIndustry(INT_4);
        if(CollectionUtils.isEmpty(tXinyiIndustries) || tXinyiIndustries.size() < INT_4){
            log.error("处理生化报警时，获取最近的4条工业库数据失败~~~~~~~");
            return ;
        }

//        //拼接决策的最近4小时的值
//        String last4Str = this.getJsNh3StrByList(tXinyiIndustries);
//
//        //报警设备故障
//        if (existsCsCodDeviceErr(csBzz, currentVal, category, tXinyiIndustry, normConfig, cwrwfhz, tXinyiIndustries, nowDate, last4Str, csGkz))
//            return;

        //工艺报警
        //最开始的工艺报警  （超标准工艺报警）
        normalIndustryWarningCsCod(csBzz, currentVal, category, tXinyiIndustry, normConfig, cwrwfhz, nowDate, tXinyiIndustries, csGkz);
    }



    /**
     * 最开始的工艺报警  （超标准工艺报警） -- 出水cod
     * @param csBzz
     * @param currentVal
     * @param category
     * @param tXinyiIndustry
     * @param normConfig
     * @param cwrwfhz
     * @param nowDate
     * @param tXinyiIndustries
     */
    private void normalIndustryWarningCsCod(BigDecimal csBzz, BigDecimal currentVal, String category, TXinyiIndustry tXinyiIndustry, TXinyiNormConfig normConfig, BigDecimal cwrwfhz, Date nowDate, List<TXinyiIndustry> tXinyiIndustries, BigDecimal csGkz) {
        //新的判断进水氨氮是否超标
        TXinyiWarningRecord tXinyiWarningRecord = existsNormalCsCod(csBzz, currentVal, category, cwrwfhz, tXinyiIndustries, normConfig, csGkz, nowDate);

        //最近3条输出 连续升高趋势 和 新增的报警都需要
        //当前状态正常 需要查询历史有无正在报警的数据，如果有，将报警状态改完2(系统自动关闭)
        List<TXinyiWarningRecord> tXinyiWarningRecords = this.xinyiWarningRecordMapper.selectTXinyiWarningRecordList(TXinyiWarningRecord.builder().type(0).category(category).status(0).build());
        if(Objects.isNull(tXinyiWarningRecord)){//数据正常，无告警信息
            if(!CollectionUtils.isEmpty(tXinyiWarningRecords)){
                log.info( "{}:现在恢复正常，历史报警数据为{}", category,JSON.toJSONString(tXinyiWarningRecords));
                for (TXinyiWarningRecord xinyiWarningRecord : tXinyiWarningRecords) {
                    closeWarning(xinyiWarningRecord);
                }
            }
        }else{//有告警信息
            if(CollectionUtils.isEmpty(tXinyiWarningRecords)){//之前没有告警记录
                //保存到数据库中
                //2024年7月15日11:06:16 因为只有一个告警记录，但是如果一直报警，现在报警时间取的是更新时间，兼容第一次报警处理
                tXinyiWarningRecord.setUpdateTime(nowDate);
                this.xinyiWarningRecordMapper.insertTXinyiWarningRecord(tXinyiWarningRecord);
                //继续调用决策
                this.handleDecision(tXinyiWarningRecord, tXinyiIndustry, normConfig, false, nowDate);
            }else{
                log.info("{}:之前已经有过告警记录了，且还是继续报警，无需重复添加报警，但是决策仍然要调用", category);
                for (TXinyiWarningRecord xinyiWarningRecord : tXinyiWarningRecords) {//理论上只有一个的
                    //2024年7月5日10:45:24 逻辑调整：更新一直报警的那条记录的显示值
                    xinyiWarningRecord.setWarningVal(tXinyiWarningRecord.getWarningVal());
//                        xinyiWarningRecord.setDesignVal(tXinyiWarningRecord.getDesignVal());
//                        tXinyiWarningRecord.setControlVal(tXinyiWarningRecord.getControlVal());
                    xinyiWarningRecord.setTime(tXinyiWarningRecord.getTime());
                    xinyiWarningRecord.setUpdateTime(nowDate);
                    xinyiWarningRecord.setUpdateBy(WARNING_DEFAULT_CREATE);
                    //2024年7月15日11:07:33 报警的级别也要重新计算并更新
                    xinyiWarningRecord.setLevel(tXinyiWarningRecord.getLevel());
                    //2024年7月31日09:20:47 报警的原因（超标还是超管控也需要更新）
                    xinyiWarningRecord.setReason(tXinyiWarningRecord.getReason());
                    //更新数据库
                    this.xinyiWarningRecordMapper.updateTXinyiWarningRecord(xinyiWarningRecord);
                    //继续调用决策
                    this.handleDecision(xinyiWarningRecord, tXinyiIndustry, normConfig, false, nowDate);
                }
            }
        }
    }


    /**
     * 根据新的规则，判断出水cod是否超标，超标了则返回报警对象；没有超标，返回空对象 -- 出水cod
     *
     * @param csBzz
     * @param currentVal
     * @param category
     * @param cwrwfhz
     * @param tXinyiIndustries
     * @param normConfig
     * @param nowDate
     * @return
     */
    private TXinyiWarningRecord existsNormalCsCod(BigDecimal csBzz, BigDecimal currentVal, String category, BigDecimal cwrwfhz, List<TXinyiIndustry> tXinyiIndustries, TXinyiNormConfig normConfig, BigDecimal csGkz, Date nowDate) {
        boolean flag = false;
        TXinyiIndustry tXinyiIndustry = tXinyiIndustries.get(INDEX_0);
        BigDecimal csCod0 = tXinyiIndustry.getCsCod();
        BigDecimal csCod1 = tXinyiIndustries.get(INDEX_1).getCsCod();
        BigDecimal csCod2 = tXinyiIndustries.get(INDEX_2).getCsCod();
        BigDecimal csCod3 = tXinyiIndustries.get(INDEX_3).getCsCod();
        if(!Objects.isNull(csCod0) && !Objects.isNull(csCod1) && !Objects.isNull(csCod2) && !Objects.isNull(csCod3)){
            //出水COD在线仪表 > 40 and 连续4小时
            if(csCod0.compareTo(csBzz) > 0 && csCod1.compareTo(csBzz) > 0 && csCod2.compareTo(csBzz) > 0 && csCod3.compareTo(csBzz) > 0)
                flag = true;
            //出水COD在线仪表 > 40 and 连续三小时数据呈现大于等于上一小时的情况
            if(csCod0.compareTo(csBzz) > 0 && csCod0.compareTo(csCod1) >= 0 && csCod1.compareTo(csCod2) >= 0 && csCod2.compareTo(csCod3) >= 0)
                flag = true;
        }
        //出水COD在线仪表 > 40 and 出水氨氮连续检测数据 > 4
        //查询同时刻的化验数据，计算出水氨氮
        List<TXinyiRobot> tXinyiRobots = this.xinyiRobotMapper.selectTXinyiRobotList(TXinyiRobot.builder().testHour(tXinyiIndustry.getTestHour()).build());
        if(!CollectionUtils.isEmpty(tXinyiRobots)){
            TXinyiRobot xinyiRobot = tXinyiRobots.get(0);
            BigDecimal no3Hlj1JqrTemp = xinyiRobot.getNo3Hlj1Jqr();
            //#2好氧硝酸盐
            BigDecimal no3Hlj2JqrTemp = xinyiRobot.getNo3Hlj2Jqr();
            //1#缺氧出-硝酸盐
            BigDecimal no3Qyc1JqrTemp = xinyiRobot.getNo3Qyc1Jqr();
            BigDecimal nh31JqrTemp = xinyiRobot.getNh31Jqr();
            //2#缺氧出-硝酸盐
            BigDecimal no3Qyc2JqrTemp = xinyiRobot.getNo3Qyc2Jqr();
            BigDecimal nh32JqrTemp = xinyiRobot.getNh32Jqr();
            if (Objects.isNull(no3Qyc1JqrTemp))
                no3Qyc1JqrTemp = BigDecimal.ZERO;
            if (Objects.isNull(nh31JqrTemp))
                nh31JqrTemp = BigDecimal.ZERO;
            if (Objects.isNull(no3Hlj1JqrTemp))
                no3Hlj1JqrTemp = BigDecimal.ZERO;
            BigDecimal anDan1 = no3Qyc1JqrTemp.add(nh31JqrTemp).subtract(no3Hlj1JqrTemp);

            //判断 增加容错
            if (Objects.isNull(no3Qyc2JqrTemp))
                no3Qyc2JqrTemp = BigDecimal.ZERO;
            if (Objects.isNull(nh32JqrTemp))
                nh32JqrTemp = BigDecimal.ZERO;
            if (Objects.isNull(no3Hlj2JqrTemp))
                no3Hlj2JqrTemp = BigDecimal.ZERO;
            BigDecimal anDan2 = no3Qyc2JqrTemp.add(nh32JqrTemp).subtract(no3Hlj2JqrTemp);
            BigDecimal divide = anDan1.add(anDan2).divide(DECIMAL_2, INT_2, RoundingMode.HALF_UP);
            //出水COD在线仪表 > 40 and 出水氨氮连续检测数据 > 4
            if(!Objects.isNull(csCod0) && csCod0.compareTo(csBzz) > 0 && divide.compareTo(BigDecimal.valueOf(4)) > 0)
                flag = true;
        }


        if(!flag)
            return null;
        //存在符合的报警情况，生成报警对象
        TXinyiWarningRecord tXinyiWarningRecord = new TXinyiWarningRecord();
        tXinyiWarningRecord.setStatus(0);
        tXinyiWarningRecord.setType(0);
        tXinyiWarningRecord.setCategory(category);
        tXinyiWarningRecord.setTime(nowDate);
        tXinyiWarningRecord.setWarningVal(currentVal);
        tXinyiWarningRecord.setDesignVal(csBzz);
        tXinyiWarningRecord.setControlVal(csGkz);
        tXinyiWarningRecord.setCreateBy(WARNING_DEFAULT_CREATE);
        tXinyiWarningRecord.setCreateTime(nowDate);
        tXinyiWarningRecord.setRemark(ZERO_SZ_WARNING.getCode());
        //2025年02月10日14:45:08 下面是新增加的字段
        tXinyiWarningRecord.setWaterType(BusinessEnum.WaterTypeEnum.CS.getCode());
        //超污染物限制：计算公式为：当前氨氮/氨氮设计值 或者 当前氨氮/氨氮管控值（智能工单使用）  这里是出水的 【需要根据超标还是超管控，具体计算】
        //超污染物负荷值：计算公式为：当前水量与氨氮乘积  /  设计水量与设计进水氨氮的乘积（智能工单使用）
        tXinyiWarningRecord.setCwrwfhz(cwrwfhz);//2025年02月14日10:48:32 具体的值由上游传过来
        tXinyiWarningRecord.setReason(category + CHAOBIAO_WARNING);
        tXinyiWarningRecord.setLevel(WARNING_LEVEL_ONE);
        tXinyiWarningRecord.setSymbol(BusinessEnum.WarningSymbolEnum.CBZZ.getCode());
        tXinyiWarningRecord.setCwrwxz(getCwrwxzByDetail(currentVal, normConfig, category, true));//根据当前值和类型以及是否超标处理

        return tXinyiWarningRecord;
    }


    /**
     * 查看出水cod是否存在 设备故障 的报警判断，如果存在处理数据，并报警。
     *
     * @param csBzz
     * @param currentVal
     * @param category
     * @param tXinyiIndustry
     * @param normConfig
     * @param cwrwfhz
     * @param tXinyiIndustries
     * @param nowDate
     * @param last4Str
     * @param csGkz
     * @return
     */
    private boolean existsCsCodDeviceErr(BigDecimal csBzz, BigDecimal currentVal, String category, TXinyiIndustry tXinyiIndustry, TXinyiNormConfig normConfig, BigDecimal cwrwfhz, List<TXinyiIndustry> tXinyiIndustries, Date nowDate, String last4Str, BigDecimal csGkz) {
        if(!CollectionUtils.isEmpty(tXinyiIndustries) && tXinyiIndustries.size() == INT_4){
            //查询同类型的历史报警
            TXinyiWarningRecord csCodDeviceErrWarning = TXinyiWarningRecord.builder().type(0).category(category).symbol(BusinessEnum.WarningSymbolEnum.DEVICE_ERR_CS_COD.getCode()).status(0).build();
            List<TXinyiWarningRecord> csCodDeviceErrList = this.xinyiWarningRecordMapper.selectTXinyiWarningRecordList(csCodDeviceErrWarning);
            //2025年02月21日14:33:37 这里要改成当前值和上个小时比较  上个小时和上上个小时比较
            if(existsCsCodDeviceErr(tXinyiIndustries)){//这里不能只返回一个布尔类型的结果，因为还要获取百分比的值
                //关闭同类型的其他报警
                closeOtherWarningsByCategory(category, BusinessEnum.WarningSymbolEnum.DEVICE_ERR_CS_COD.getCode());
                //触发报警 并且模拟大模型返回决策问答数据
                if(CollectionUtils.isEmpty(csCodDeviceErrList)){
                    //插入该类型报警
                    csCodDeviceErrWarning.setTime(nowDate);
                    csCodDeviceErrWarning.setReason(category + BusinessEnum.WarningSymbolEnum.DEVICE_ERR_CS_COD.getMsg());
                    csCodDeviceErrWarning.setWaterType(BusinessEnum.WaterTypeEnum.CS.getCode());
                    csCodDeviceErrWarning.setSymbol(BusinessEnum.WarningSymbolEnum.DEVICE_ERR_CS_COD.getCode());
                    csCodDeviceErrWarning.setCreateBy(WARNING_DEFAULT_CREATE);
                    csCodDeviceErrWarning.setCreateTime(nowDate);
                    csCodDeviceErrWarning.setWarningVal(currentVal);
                    csCodDeviceErrWarning.setDesignVal(csBzz);
                    csCodDeviceErrWarning.setControlVal(csGkz);
                    csCodDeviceErrWarning.setRemark(ZERO_SZ_WARNING.getCode());
                    csCodDeviceErrWarning.setCwrwfhz(cwrwfhz);
                    csCodDeviceErrWarning.setCwrwxz(getCwrwxzByDetail(currentVal, normConfig, category, true));//根据当前值和类型以及是否超标处理
                    this.xinyiWarningRecordMapper.insertTXinyiWarningRecord(csCodDeviceErrWarning);
                    //同时处理决策 不用调用大模型，本地处理问答
                    addChatRecordByCsCodDeviceErr(csCodDeviceErrWarning, tXinyiIndustry, normConfig, category, last4Str);
                }else{
                    //2025年04月16日15:56:47 这种的继续报警，所以决策还需要再次调用一次
                    //2025年05月08日13:34:23bug修改 这里不能用new的对象 要获取历史报警的值
//                    addChatRecordByGDZ(warningRecordGDZ, tXinyiIndustry, normConfig, category, exceedVal, resultMap.get(LASTVAL), last8Str);
                    addChatRecordByCsCodDeviceErr(csCodDeviceErrList.get(0), tXinyiIndustry, normConfig, category, last4Str);
                }
                //后续的报警不再进行
                return true;
            }else{//不存在 查看历史是否有报警，有的话关闭
                if(!CollectionUtils.isEmpty(csCodDeviceErrList)){
                    closeWarning(csCodDeviceErrList.get(0));
                }
            }
        }
        return false;
    }



    /**
     *
     * 出水cod - 设备故障 本地决策处理
     * @param warningRecord
     * @param tXinyiIndustry
     * @param normConfig
     * @param category
     * @param last4Str
     */
    private void addChatRecordByCsCodDeviceErr(TXinyiWarningRecord warningRecord, TXinyiIndustry tXinyiIndustry, TXinyiNormConfig normConfig, String category,String last4Str) {
        ChatReq chatReq = new ChatReq();
        //保存聊天记录
        //将问答更新到数据库中
        chatReq.setSessionId(IdUtils.simpleUUID());
        chatReq.setType(1);//0问答 1决策 2本地 3仿真预测
        chatReq.setModule(3);
            /*String userId = SecurityUtils.getUserId().toString();
            String username = SecurityUtils.getUsername();*/
        chatReq.setUserId(WARNING_DEFAULT_CREATE);
        String showVal = this.buildShowValue(warningRecord, tXinyiIndustry, normConfig, DateUtils.getNowDate());
        chatReq.setShowVal(showVal);//前端展示的数据和提问的数据不一致
        chatReq.setQuestion(BusinessEnum.WarningSymbolEnum.DEVICE_ERR_CS_COD.getMsg());//本地问题
//        chatReq.setAnswer(category + YCSG_ANSWER_ONE + exceedVal.multiply(BigDecimal_100) + "%" + YCSG_ANSWER_TWO + warningRecord.getWarningVal() + YCSG_ANSWER_THREE);
        chatReq.setAnswer(CS_COD_DEVICE_ERR_ANSWER_REPLACE.replaceAll("@@@0", category).replaceAll("@@@1", last4Str));//只替换最近8小时的值 和 类型
        chatReq.setWarningId(String.valueOf(warningRecord.getId()));
        chatReq.setCounts(1);//问答次数

        chatReq.setCreateBy(WARNING_DEFAULT_CREATE);
        chatReq.setCreateTime(DateUtils.getNowDate());
        this.xinyiChatRecordMapper.insertTXinyiChatRecord(chatReq);
    }


    /**
     * 将此化验类型的其他的报警全部关闭
     * @param category
     */
    private void closeOtherWarningsByCategory(String category, Integer symbol) {
        List<TXinyiWarningRecord> tXinyiWarningRecords = this.xinyiWarningRecordMapper.getOtherWarningsByCategory(category, symbol);
        if(!CollectionUtils.isEmpty(tXinyiWarningRecords)){
            for (TXinyiWarningRecord tXinyiWarningRecord : tXinyiWarningRecords) {
                this.closeWarning(tXinyiWarningRecord);
            }
        }
    }


    private String getJsNh3StrByList(List<TXinyiIndustry> tXinyiIndustries) {
//        return StringUtil.join(tXinyiIndustries.stream().map(TXinyiIndustry::getJsNh3).collect(Collectors.toList()) , "mg/L、");
        int size = tXinyiIndustries.size();
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < size; i++) {
            TXinyiIndustry tXinyiIndustry = tXinyiIndustries.get(i);
            if(i < size - 1)
                sb.append(DecimalUtils.getAbsAndScale(tXinyiIndustry.getJsNh3(), INT_2)).append("mg/L、");
            else
                sb.append(DecimalUtils.getAbsAndScale(tXinyiIndustry.getJsNh3(), INT_2)).append("mg/L。");
        }
        return sb.toString();
    }


    /**
     * 出水cod是否存在设备故障报警
     * @param industryList
     * @return
     */
    private boolean existsCsCodDeviceErr(List<TXinyiIndustry> industryList) {
        boolean result = false;
        BigDecimal csCod0 = industryList.get(0).getCsCod();
        BigDecimal csCod1 = industryList.get(1).getCsCod();
        BigDecimal csCod2 = industryList.get(2).getCsCod();
        BigDecimal csCod3 = industryList.get(3).getCsCod();
        //全部为空
        if(Objects.isNull(csCod0) && Objects.isNull(csCod1) && Objects.isNull(csCod2) && Objects.isNull(csCod3))
            return true;
        //数据为0、 数据相同 and 出水COD>40
        if(!Objects.isNull(csCod0) && !Objects.isNull(csCod1) && !Objects.isNull(csCod2) && !Objects.isNull(csCod3)){
            if(BigDecimal.ZERO.compareTo(csCod0) == 0 && BigDecimal.ZERO.compareTo(csCod1) == 0 && BigDecimal.ZERO.compareTo(csCod2) == 0 && BigDecimal.ZERO.compareTo(csCod3) == 0)
                return true;
            if(csCod0.compareTo(BigDecimal.valueOf(40)) > 0 && csCod0.compareTo(csCod1) == 0 && csCod0.compareTo(csCod2) == 0 && csCod0.compareTo(csCod3) == 0)
                return true;
        }

        return result;
    }


    /**
     * 不同指标报警规则不一样，全部区分开来处理，此方法为：氨氮
     * 通过输入的值 生成对应类型的报警对象（进水）- 氨氮
     *
     * @param jsBzz
     * @param currentVal
     * @param category
     * @param tXinyiIndustry
     * @param normConfig
     * @param cwrwfhz
     * @return
     */
    private void handleXinYiWarningRecordJSOriginNh3(BigDecimal jsBzz, BigDecimal currentVal, String category, TXinyiIndustry tXinyiIndustry, TXinyiNormConfig normConfig, BigDecimal cwrwfhz) {

        String testHour = tXinyiIndustry.getTestHour();
        //这里也不能用当前日期，要用对应检测时间
//        Date nowDate = DateUtils.getNowDate();
        Date nowDate = DateUtils.parseDate(testHour);

        List<TXinyiIndustry> tXinyiIndustries = this.xinyiIndustryMapper.selectNIndustryBeforeHour(INT_8, testHour);
        if(CollectionUtils.isEmpty(tXinyiIndustries) || tXinyiIndustries.size() < INT_8){
            log.error("处理生化报警时，获取最近的8条工业库数据失败~~~~~~~");
            return ;
        }

        //最开始的工艺报警  （超标准工艺报警） 2025年04月16日15:40:23 改成只有超标准才会报警，并且具体逻辑做拆分
        normalIndustryWarningJsNh3(jsBzz, currentVal, category, tXinyiIndustry, normConfig, cwrwfhz, nowDate, tXinyiIndustries);

    }


    /**
     * 最开始的工艺报警  （超标准工艺报警） -- 进水氨氮
     * @param jsBzz
     * @param currentVal
     * @param category
     * @param tXinyiIndustry
     * @param normConfig
     * @param cwrwfhz
     * @param nowDate
     * @param tXinyiIndustries
     */
    private void normalIndustryWarningJsNh3(BigDecimal jsBzz, BigDecimal currentVal, String category, TXinyiIndustry tXinyiIndustry, TXinyiNormConfig normConfig, BigDecimal cwrwfhz, Date nowDate, List<TXinyiIndustry> tXinyiIndustries) {
        //新的判断进水氨氮是否超标
        TXinyiWarningRecord tXinyiWarningRecord = existsNormalJsNh3(jsBzz, currentVal, category, cwrwfhz, tXinyiIndustries, normConfig, nowDate);

        //最近3条输出 连续升高趋势 和 新增的报警都需要
        //当前状态正常 需要查询历史有无正在报警的数据，如果有，将报警状态改完2(系统自动关闭)
        List<TXinyiWarningRecord> tXinyiWarningRecords = this.xinyiWarningRecordMapper.selectTXinyiWarningRecordList(TXinyiWarningRecord.builder().type(0).category(category).status(0).build());
        if(Objects.isNull(tXinyiWarningRecord)){//数据正常，无告警信息
            if(!CollectionUtils.isEmpty(tXinyiWarningRecords)){
                log.info( "{}:现在恢复正常，历史报警数据为{}", category,JSON.toJSONString(tXinyiWarningRecords));
                for (TXinyiWarningRecord xinyiWarningRecord : tXinyiWarningRecords) {
                    closeWarning(xinyiWarningRecord);
                }
            }
        }else{//有告警信息
            if(CollectionUtils.isEmpty(tXinyiWarningRecords)){//之前没有告警记录
                //保存到数据库中
                //2024年7月15日11:06:16 因为只有一个告警记录，但是如果一直报警，现在报警时间取的是更新时间，兼容第一次报警处理
                tXinyiWarningRecord.setUpdateTime(nowDate);
                this.xinyiWarningRecordMapper.insertTXinyiWarningRecord(tXinyiWarningRecord);
                //继续调用决策
                this.handleDecision(tXinyiWarningRecord, tXinyiIndustry, normConfig, false, nowDate);
            }else{
                log.info("{}:之前已经有过告警记录了，且还是继续报警，无需重复添加报警，但是决策仍然要调用", category);
                for (TXinyiWarningRecord xinyiWarningRecord : tXinyiWarningRecords) {//理论上只有一个的
                    //2024年7月5日10:45:24 逻辑调整：更新一直报警的那条记录的显示值
                    xinyiWarningRecord.setWarningVal(tXinyiWarningRecord.getWarningVal());
//                        xinyiWarningRecord.setDesignVal(tXinyiWarningRecord.getDesignVal());
//                        tXinyiWarningRecord.setControlVal(tXinyiWarningRecord.getControlVal());
                    xinyiWarningRecord.setTime(tXinyiWarningRecord.getTime());
                    xinyiWarningRecord.setUpdateTime(nowDate);
                    xinyiWarningRecord.setUpdateBy(WARNING_DEFAULT_CREATE);
                    //2024年7月15日11:07:33 报警的级别也要重新计算并更新
                    xinyiWarningRecord.setLevel(tXinyiWarningRecord.getLevel());
                    //2024年7月31日09:20:47 报警的原因（超标还是超管控也需要更新）
                    xinyiWarningRecord.setReason(tXinyiWarningRecord.getReason());
                    //更新数据库
                    this.xinyiWarningRecordMapper.updateTXinyiWarningRecord(xinyiWarningRecord);
                    //继续调用决策
                    this.handleDecision(xinyiWarningRecord, tXinyiIndustry, normConfig, false, nowDate);
                }
            }
        }
    }


    /**
     * 根据新的规则，判断进水氨氮是否超标，超标了则返回报警对象；没有超标，返回空对象 -- 进水氨氮
     *
     * @param jsBzz
     * @param currentVal
     * @param category
     * @param cwrwfhz
     * @param tXinyiIndustries
     * @param normConfig
     * @param nowDate
     * @return
     */
    private TXinyiWarningRecord existsNormalJsNh3(BigDecimal jsBzz, BigDecimal currentVal, String category, BigDecimal cwrwfhz, List<TXinyiIndustry> tXinyiIndustries, TXinyiNormConfig normConfig, Date nowDate) {
        boolean flag = false;
        TXinyiIndustry tXinyiIndustry = tXinyiIndustries.get(INDEX_0);
        BigDecimal jsNh30 = tXinyiIndustry.getJsNh3();
        BigDecimal jsNh31 = tXinyiIndustries.get(INDEX_1).getJsNh3();
        BigDecimal jsNh32 = tXinyiIndustries.get(INDEX_2).getJsNh3();
        BigDecimal jsNh33 = tXinyiIndustries.get(INDEX_3).getJsNh3();
        if(!Objects.isNull(jsNh30) && jsNh30.compareTo(jsBzz) > 0 && !Objects.isNull(jsNh31) && jsNh31.compareTo(jsBzz) > 0
                && !Objects.isNull(jsNh32) && jsNh32.compareTo(jsBzz) > 0 && !Objects.isNull(jsNh33) && jsNh33.compareTo(jsBzz) > 0)
            flag = true;//最近4个都超标
        if(!Objects.isNull(jsNh30) && jsNh30.compareTo(jsBzz) > 0 && !Objects.isNull(jsNh31) && jsNh30.compareTo(jsNh31) >= 0
                && !Objects.isNull(jsNh32) && jsNh31.compareTo(jsNh32) >= 0)
            flag = true;//最新的超标了并且连续3个值都有升高趋势
        BigDecimal jsCod = tXinyiIndustry.getJsCod();
        BigDecimal jsTn = tXinyiIndustry.getJsTn();
        BigDecimal jsTp = tXinyiIndustry.getJsTp();
        if(!Objects.isNull(jsNh30) && jsNh30.compareTo(jsBzz) > 0 && (!Objects.isNull(jsCod) && jsCod.compareTo(BigDecimal.valueOf(630)) > 0
                || !Objects.isNull(jsTn) && jsTn.compareTo(BigDecimal.valueOf(65)) > 0 || !Objects.isNull(jsTp) && jsTp.compareTo(BigDecimal.valueOf(7.1)) > 0))
            flag = true;
        if(!flag)
            return null;
        //存在符合的报警情况，生成报警对象
        TXinyiWarningRecord tXinyiWarningRecord = new TXinyiWarningRecord();
        /*String category = BusinessEnum.WarningCategoryEnum.CS_AD.getCode();*/
        tXinyiWarningRecord.setStatus(0);
        tXinyiWarningRecord.setType(0);
        tXinyiWarningRecord.setCategory(category);
        tXinyiWarningRecord.setTime(nowDate);
        tXinyiWarningRecord.setWarningVal(currentVal);
        tXinyiWarningRecord.setDesignVal(jsBzz);
//        tXinyiWarningRecord.setControlVal(csGkz);
        tXinyiWarningRecord.setCreateBy(WARNING_DEFAULT_CREATE);
        tXinyiWarningRecord.setCreateTime(nowDate);
        tXinyiWarningRecord.setRemark(ZERO_SZ_WARNING.getCode());
        //2025年02月10日14:45:08 下面是新增加的字段
        tXinyiWarningRecord.setWaterType(BusinessEnum.WaterTypeEnum.JS.getCode());
        //超污染物限制：计算公式为：当前氨氮/氨氮设计值 或者 当前氨氮/氨氮管控值（智能工单使用）  这里是出水的 【需要根据超标还是超管控，具体计算】
        //超污染物负荷值：计算公式为：当前水量与氨氮乘积  /  设计水量与设计进水氨氮的乘积（智能工单使用）
        tXinyiWarningRecord.setCwrwfhz(cwrwfhz);//2025年02月14日10:48:32 具体的值由上游传过来
        tXinyiWarningRecord.setReason(category + CHAOBIAO_WARNING);
        tXinyiWarningRecord.setLevel(WARNING_LEVEL_ONE);
        tXinyiWarningRecord.setSymbol(BusinessEnum.WarningSymbolEnum.CBZZ.getCode());
        tXinyiWarningRecord.setCwrwxz(getCwrwxzByDetail(currentVal, normConfig, category, true));//根据当前值和类型以及是否超标处理

        return tXinyiWarningRecord;
    }


    /**
     * 不同指标报警规则不一样，全部区分开来处理，此方法为：总氮
     * 通过输入的值 生成对应类型的报警对象（进水）- 总氮
     *
     * @param jsBzz
     * @param currentVal
     * @param category
     * @param tXinyiIndustry
     * @param normConfig
     * @param cwrwfhz
     * @return
     */
    private void handleXinYiWarningRecordJSOriginZD(BigDecimal jsBzz, BigDecimal currentVal, String category, TXinyiIndustry tXinyiIndustry, TXinyiNormConfig normConfig, BigDecimal cwrwfhz) {

        String testHour = tXinyiIndustry.getTestHour();
        //这里也不能用当前日期，要用对应检测时间
//        Date nowDate = DateUtils.getNowDate();
        Date nowDate = DateUtils.parseDate(testHour);

        //2025年05月08日15:49:42 这里获取某个时间段之前的数据，新增方法，不影响原来的逻辑
        List<TXinyiIndustry> tXinyiIndustries = this.xinyiIndustryMapper.selectNIndustryBeforeHour(INT_8, testHour);
        if(CollectionUtils.isEmpty(tXinyiIndustries) || tXinyiIndustries.size() < INT_8){
            log.error("处理生化报警时，获取最近的8条工业库数据失败~~~~~~~");
            return ;
        }

        //最开始的工艺报警  （超标准工艺报警） 2025年04月16日15:40:23 改成只有超标准才会报警，并且具体逻辑做拆分
        normalIndustryWarningJsTD(jsBzz, currentVal, category, tXinyiIndustry, normConfig, cwrwfhz, nowDate, tXinyiIndustries);
    }



    /**
     * 最开始的工艺报警  （超标准工艺报警） -- 进水总氮
     * @param jsBzz
     * @param currentVal
     * @param category
     * @param tXinyiIndustry
     * @param normConfig
     * @param cwrwfhz
     * @param nowDate
     * @param tXinyiIndustries
     */
    private void normalIndustryWarningJsTD(BigDecimal jsBzz, BigDecimal currentVal, String category, TXinyiIndustry tXinyiIndustry, TXinyiNormConfig normConfig, BigDecimal cwrwfhz, Date nowDate, List<TXinyiIndustry> tXinyiIndustries) {
        //新的判断进水氨氮是否超标
        TXinyiWarningRecord tXinyiWarningRecord = existsNormalJsZD(jsBzz, currentVal, category, cwrwfhz, tXinyiIndustries, normConfig, nowDate);

        //最近3条输出 连续升高趋势 和 新增的报警都需要
        //当前状态正常 需要查询历史有无正在报警的数据，如果有，将报警状态改完2(系统自动关闭)
        List<TXinyiWarningRecord> tXinyiWarningRecords = this.xinyiWarningRecordMapper.selectTXinyiWarningRecordList(TXinyiWarningRecord.builder().type(0).category(category).status(0).build());
        if(Objects.isNull(tXinyiWarningRecord)){//数据正常，无告警信息
            if(!CollectionUtils.isEmpty(tXinyiWarningRecords)){
                log.info( "{}:现在恢复正常，历史报警数据为{}", category,JSON.toJSONString(tXinyiWarningRecords));
                for (TXinyiWarningRecord xinyiWarningRecord : tXinyiWarningRecords) {
                    closeWarning(xinyiWarningRecord);
                }
            }
        }else{//有告警信息
            if(CollectionUtils.isEmpty(tXinyiWarningRecords)){//之前没有告警记录
                //保存到数据库中
                //2024年7月15日11:06:16 因为只有一个告警记录，但是如果一直报警，现在报警时间取的是更新时间，兼容第一次报警处理
                tXinyiWarningRecord.setUpdateTime(nowDate);
                this.xinyiWarningRecordMapper.insertTXinyiWarningRecord(tXinyiWarningRecord);
                //继续调用决策
                this.handleDecision(tXinyiWarningRecord, tXinyiIndustry, normConfig, false, nowDate);
            }else{
                log.info("{}:之前已经有过告警记录了，且还是继续报警，无需重复添加报警，但是决策仍然要调用", category);
                for (TXinyiWarningRecord xinyiWarningRecord : tXinyiWarningRecords) {//理论上只有一个的
                    //2024年7月5日10:45:24 逻辑调整：更新一直报警的那条记录的显示值
                    xinyiWarningRecord.setWarningVal(tXinyiWarningRecord.getWarningVal());
//                        xinyiWarningRecord.setDesignVal(tXinyiWarningRecord.getDesignVal());
//                        tXinyiWarningRecord.setControlVal(tXinyiWarningRecord.getControlVal());
                    xinyiWarningRecord.setTime(tXinyiWarningRecord.getTime());
                    xinyiWarningRecord.setUpdateTime(nowDate);
                    xinyiWarningRecord.setUpdateBy(WARNING_DEFAULT_CREATE);
                    //2024年7月15日11:07:33 报警的级别也要重新计算并更新
                    xinyiWarningRecord.setLevel(tXinyiWarningRecord.getLevel());
                    //2024年7月31日09:20:47 报警的原因（超标还是超管控也需要更新）
                    xinyiWarningRecord.setReason(tXinyiWarningRecord.getReason());
                    //更新数据库
                    this.xinyiWarningRecordMapper.updateTXinyiWarningRecord(xinyiWarningRecord);
                    //继续调用决策
                    this.handleDecision(xinyiWarningRecord, tXinyiIndustry, normConfig, false, nowDate);
                }
            }
        }
    }


    /**
     * 根据新的规则，判断进水氨氮是否超标，超标了则返回报警对象；没有超标，返回空对象 -- 进水总氮
     *
     * @param jsBzz
     * @param currentVal
     * @param category
     * @param cwrwfhz
     * @param tXinyiIndustries
     * @param normConfig
     * @param nowDate
     * @return
     */
    private TXinyiWarningRecord existsNormalJsZD(BigDecimal jsBzz, BigDecimal currentVal, String category, BigDecimal cwrwfhz, List<TXinyiIndustry> tXinyiIndustries, TXinyiNormConfig normConfig, Date nowDate) {
        boolean flag = false;
        TXinyiIndustry tXinyiIndustry = tXinyiIndustries.get(INDEX_0);
        BigDecimal jsTn0 = tXinyiIndustry.getJsTn();
        BigDecimal jsTn1 = tXinyiIndustries.get(INDEX_1).getJsTn();
        BigDecimal jsTn2 = tXinyiIndustries.get(INDEX_2).getJsTn();
        BigDecimal jsTn3 = tXinyiIndustries.get(INDEX_3).getJsTn();
        if(!Objects.isNull(jsTn0) && jsTn0.compareTo(jsBzz) > 0 && !Objects.isNull(jsTn1) && jsTn1.compareTo(jsBzz) > 0
                && !Objects.isNull(jsTn2) && jsTn2.compareTo(jsBzz) > 0 && !Objects.isNull(jsTn3) && jsTn3.compareTo(jsBzz) > 0)
            flag = true;//最近4个都超标
        if(!Objects.isNull(jsTn0) && jsTn0.compareTo(jsBzz) > 0 && !Objects.isNull(jsTn1) && jsTn0.compareTo(jsTn1) >= 0
                && !Objects.isNull(jsTn2) && jsTn1.compareTo(jsTn2) >= 0)
            flag = true;//最新的超标了并且连续3个值都有升高趋势
        BigDecimal jsCod = tXinyiIndustry.getJsCod();
        BigDecimal jsNh3 = tXinyiIndustry.getJsNh3();
        BigDecimal jsTp = tXinyiIndustry.getJsTp();
        if(!Objects.isNull(jsTn0) && jsTn0.compareTo(jsBzz) > 0 && (!Objects.isNull(jsCod) && jsCod.compareTo(BigDecimal.valueOf(630)) > 0
                || !Objects.isNull(jsNh3) && jsNh3.compareTo(BigDecimal.valueOf(58)) > 0 || !Objects.isNull(jsTp) && jsTp.compareTo(BigDecimal.valueOf(7.1)) > 0))
            flag = true;
        if(!flag)
            return null;
        //存在符合的报警情况，生成报警对象
        TXinyiWarningRecord tXinyiWarningRecord = new TXinyiWarningRecord();
        /*String category = BusinessEnum.WarningCategoryEnum.CS_AD.getCode();*/
        tXinyiWarningRecord.setStatus(0);
        tXinyiWarningRecord.setType(0);
        tXinyiWarningRecord.setCategory(category);
        tXinyiWarningRecord.setTime(nowDate);
        tXinyiWarningRecord.setWarningVal(currentVal);
        tXinyiWarningRecord.setDesignVal(jsBzz);
//        tXinyiWarningRecord.setControlVal(csGkz);
        tXinyiWarningRecord.setCreateBy(WARNING_DEFAULT_CREATE);
        tXinyiWarningRecord.setCreateTime(nowDate);
        tXinyiWarningRecord.setRemark(ZERO_SZ_WARNING.getCode());
        //2025年02月10日14:45:08 下面是新增加的字段
        tXinyiWarningRecord.setWaterType(BusinessEnum.WaterTypeEnum.JS.getCode());
        //超污染物限制：计算公式为：当前氨氮/氨氮设计值 或者 当前氨氮/氨氮管控值（智能工单使用）  这里是出水的 【需要根据超标还是超管控，具体计算】
        //超污染物负荷值：计算公式为：当前水量与氨氮乘积  /  设计水量与设计进水氨氮的乘积（智能工单使用）
        tXinyiWarningRecord.setCwrwfhz(cwrwfhz);//2025年02月14日10:48:32 具体的值由上游传过来
        tXinyiWarningRecord.setReason(category + CHAOBIAO_WARNING);
        tXinyiWarningRecord.setLevel(WARNING_LEVEL_ONE);
        tXinyiWarningRecord.setSymbol(BusinessEnum.WarningSymbolEnum.CBZZ.getCode());
        tXinyiWarningRecord.setCwrwxz(getCwrwxzByDetail(currentVal, normConfig, category, true));//根据当前值和类型以及是否超标处理

        return tXinyiWarningRecord;
    }


    /**
     * 调用大模型获取决策结果 并同时记录对应信息到聊天记录表中
     *
     * @param tXinyiWarningRecord
     * @param tXinyiIndustry
     * @param normConfig
     * @param isSpecial           机器人化验库，需要把总磷和总氮的值特殊处理一下
     * @param nowDate
     */
    private void handleDecision(TXinyiWarningRecord tXinyiWarningRecord, TXinyiIndustry tXinyiIndustry, TXinyiNormConfig normConfig, boolean isSpecial, Date nowDate) {
        log.info("进入了调⽤大模型决策接口");
        ChatReq chatReq = new ChatReq();
//        StringBuilder sb = new StringBuilder();
        //大模型结果 放入一个结合中
        List<String> resultData = new ArrayList<>();
        //决策和问答不一样 没有历史的概念 所以sessionId都是新的  次数都是1
        String sessionId = IdUtils.simpleUUID();
//        String feedback = chatReq.getFeedback();
        //决策请求的业务参数
//        List<HashMap<String, Object>> list = this.xinyiIndustryMapper.selectLast10RecordsForDecision();
        //2024年5月21日15:23:07 这里不能用关联查询处理，日报要获取最新的一条而不是今日的数据。
        List<DecisionReq> decisionReqs = this.xinyiIndustryMapper.selectLast10RecordsForDecisionOnlyIndustryByHour(tXinyiIndustry.getTestHour());
        if(!CollectionUtils.isEmpty(decisionReqs)){
            //处理日报数据
//            TXinyiDaily daily = this.xinyiDailyMapper.selectNewestData();
            TXinyiDaily daily = this.xinyiDailyMapper.getDetailByDay(tXinyiIndustry.getTestDate());

            for (DecisionReq decisionReq : decisionReqs) {
                if(!Objects.isNull(daily)){
                    WaterFormat.getWaterDecimationData(decisionReq, daily);
                }
            }
        }
//        String rows = JSON.toJSONString(decisionReqs, JSONWriter.Feature.WriteNulls);
        // 获取输出流
        ManagedChannel channel = null;
        String dataJson = "";
        try {
            channel = ManagedChannelBuilder.forAddress(bigModelConfig.getIp(), bigModelConfig.getPort())
                    .usePlaintext()
                    .build();
            InferenceAPIsServiceGrpc.InferenceAPIsServiceBlockingStub stub = InferenceAPIsServiceGrpc.newBlockingStub(channel);
//            dataJson = "{\"bot_id\":\"b00001\",\"exp_id\":\"721\",\"norm\":\"" + tXinyiWarningRecord.getCategory() + "\",\"feedback\":" + feedback + ",\"session_id\":" + "\"" + sessionId + "\"" + ",\"generate_args\":{\"max_new_tokens\":1024,\"max_length\":4096,\"num_beams\":1,\"do_sample\":true,\"top_p\":0.7,\"temperature\":0.95},\"extra\":{\"rows\":" +  rows + "}}";
            //2024年6月24日17:59:17  优化，不再拼接JSON字符串
            PolicyReq policyReq = new PolicyReq();
            //2024年7月11日17:57:53 因为化验室的改了  但是 调用决策还得用原来的几个值
            String category = tXinyiWarningRecord.getCategory();
            /*if(ROBOT_XSY_1.getCode().equalsIgnoreCase(category) || ROBOT_XSY_2.getCode().equalsIgnoreCase(category)){
                category = CS_ZD.getCode();
            } else if (ROBOT_ANDAN_1.getCode().equalsIgnoreCase(category) || ROBOT_ANDAN_2.getCode().equalsIgnoreCase(category)) {
                category = CS_AD.getCode();
            }else if (ROBOT_ECCZLSY.getCode().equalsIgnoreCase(category)) {
                category = CS_ZL.getCode();
            }*/
            //2024年08月25日15:40:31 处理数据映射，改成字母，但是显示的还是中文
            category = this.parseCategory(category);
            policyReq.setNorm(category);
            HashMap<String, Object> hashMap = new HashMap<>();
            policyReq.setFeedback(hashMap);//不能传null
            policyReq.setSimulate(hashMap);//不能传null
            policyReq.setSessionId(sessionId);
            //2024年7月5日13:24:10 temperature做区分
            GenerateArgs generateArgs = new GenerateArgs();
            generateArgs.setTemperature(bigModelConfig.getTemperature());
            policyReq.setGenerateArgs(generateArgs);
            HashMap<String, Object> map = new HashMap<>();
            map.put("rows", decisionReqs);
            //2024年6月25日14:16:05 增加报警是管控值报警还是标准值报警
            if(WARNING_LEVEL_ONE.equals(tXinyiWarningRecord.getLevel()) || WARNING_LEVEL_TWO.equals(tXinyiWarningRecord.getLevel()))
                map.put("source", "bzz");
            else
                map.put("source", "gkz");
            //2025年05月08日16:04:18 调用历史决策要传该参数
            map.put("current_time", DateUtils.parseDateToStr(DateUtils.YYYY_MM_DD_HH_MM_SS , tXinyiWarningRecord.getCreateTime()));
            policyReq.setExtra(map);
            dataJson = JSON.toJSONString(policyReq, JSONWriter.Feature.WriteNulls);
//            log.info("~~~~~~请求大模型的决策的参数为{}", dataJson);
            PredictionsRequest request = PredictionsRequest.newBuilder()
                    .setModelName("slibra_bot")
                    .putInput("method", ByteString.copyFrom("decision_stream", "utf-8"))//推理
                    .putInput("data", ByteString.copyFrom(dataJson, "utf-8"))
                    .buildPartial();
            Iterator<PredictionResponse> predictions = stub.streamPredictions(request);
            while (predictions.hasNext()) {
                String responseStr = predictions.next().getPrediction().toStringUtf8();
//                log.info("决策流式返回的结果是{}", responseStr);

                //2024年5月25日16:37:16  按照大模型返回的类型解析数据
                String biz = JSON.parseObject(responseStr).getString("biz");
                if(BusinessEnum.BigModelBizEnum.OK.getCode().equals(biz)){
                    log.info("结尾语句并且是非JSON，无需处理");
                    //结束语句也流式输出，但是并不记录下来  2024年5月24日11:15:23 也不返回前端
                    /*outputStream.write(responseStr.getBytes());
                    outputStream.flush();*/
                }else if(BusinessEnum.BigModelBizEnum.DECISION_DEBUGGER.getCode().equals(biz)){
                    log.info("中间过程，目前只打印日志，不记录数据，也不返回给前端，返回数据为{}", responseStr);
                    //结束语句也流式输出，但是并不记录下来  2024年5月24日11:15:23 也不返回前端
                    /*outputStream.write(responseStr.getBytes());
                    outputStream.flush();*/
                }else{//其他 要么错误 要么alert 要么出的报告
//                    sb.append(responseStr);
                    resultData.add(responseStr);
                }
            }
        } catch (Exception e) {
//            throw new RuntimeException(e);
            log.error("定时任务处理告警调用决策异常，异常信息为{}", JSON.toJSONString(e));
            resultData.add("{\"biz\":\"ERROR\",\"message\":\"大模型分析数据异常，请稍后再试\"}");
        } finally {
//            log.info("决策最终要保存的数据是{}", JSON.toJSONString(resultData));
            //保存聊天记录
            //将问答更新到数据库中
            chatReq.setSessionId(sessionId);
            chatReq.setType(1);//0问答 1决策
            chatReq.setModule(3);
            /*String userId = SecurityUtils.getUserId().toString();
            String username = SecurityUtils.getUsername();*/
            chatReq.setUserId(WARNING_DEFAULT_CREATE);
            String showVal = this.buildShowValue(tXinyiWarningRecord, tXinyiIndustry, normConfig, nowDate);
            chatReq.setShowVal(showVal);//前端展示的数据和提问的数据不一致
            chatReq.setQuestion(dataJson);
            chatReq.setAnswer(JSON.toJSONString(resultData));
            chatReq.setWarningId(String.valueOf(tXinyiWarningRecord.getId()));
            chatReq.setCounts(1);//问答次数

            chatReq.setCreateBy(WARNING_DEFAULT_CREATE);
            chatReq.setCreateTime(DateUtils.getNowDate());
            this.xinyiChatRecordMapper.insertTXinyiChatRecord(chatReq);
            // 关闭输出流
            if(!Objects.isNull(channel))
                channel.shutdown();
        }
    }


    private String buildShowValue(TXinyiWarningRecord tXinyiWarningRecord, TXinyiIndustry tXinyiIndustry, TXinyiNormConfig normConfig, Date nowDate) {
        JSONObject result = new JSONObject();
//        JSONObject basic = new JSONObject();
        Integer status = tXinyiWarningRecord.getStatus();
//        Date warningTime = tXinyiWarningRecord.getTime();
        //2025年02月21日17:09:29 因为报警时间改过一次逻辑，以前是最开始的那个时候，后来每次报警都更新它，所以这里需要的是创建时间
        Date warningTime = tXinyiWarningRecord.getCreateTime();
        String remark = tXinyiWarningRecord.getRemark();
        //2025年02月26日16:17:10 这里计算的截止时间可能是当前时间，也可能是报警结束时间，需要判断
        Date endDate = null;
        //判断类型 如果结束了 截止时间就是告警截止时间；  如果正在报警 截止时间就是当前时间
        if(0 == tXinyiWarningRecord.getStatus() || 3 == tXinyiWarningRecord.getStatus())
            endDate = DateUtils.getNowDate();
        else
            endDate = tXinyiWarningRecord.getOffTime();
        long count = DateUtils.differentHoursByLocalDateTime(warningTime, endDate) + 1;
        String category = tXinyiWarningRecord.getCategory();
        /*basic.put("title", tXinyiWarningRecord.getReason());
        basic.put("报警时间", DateUtils.parseDateToStr(DateUtils.YYYY_MM_DD_HH_MM ,warningTime));
        basic.put("报警值", tXinyiWarningRecord.getWarningVal());
        basic.put("标准值", tXinyiWarningRecord.getDesignVal());
        basic.put("管控值", tXinyiWarningRecord.getControlVal());
        basic.put("报警次数", count > MAX_COUNT ? MAX_COUNT_STR : count);
        if(tXinyiWarningRecord.getType() != 2)
            basic.put("状态", status == 0 ? "报警中" : status == 1 ? "用户关闭" : status == 2 ? "系统关闭" : "应急处理中");
        else
            basic.put("状态", status == 0 ? "预警中" : "已完成");
        //2024年5月27日14:04:22  额外返回2个字段 [管控值 和 告警级别]  返回的json没有数据是因为value没有值
//        basic.put("管控值", tXinyiWarningRecord.getControlVal());
        basic.put("告警级别", tXinyiWarningRecord.getLevel());*/
        //2024年6月25日16:00:18 进出水展示的不一样
        //2024年7月15日10:57:31 因为新增了化验室的3个指标，也是出水数据
        if(category.contains(CHUSHUI)
                || ROBOT_ECCZLSY.getCode().equalsIgnoreCase(category)
                || ROBOT_XSY_1.getCode().equalsIgnoreCase(category)
                || ROBOT_XSY_2.getCode().equalsIgnoreCase(category)
                || ROBOT_ANDAN_1.getCode().equalsIgnoreCase(category)
                || ROBOT_ANDAN_2.getCode().equalsIgnoreCase(category)
                || ROBOT_CS_AD.getCode().equalsIgnoreCase(category)){//出水的展示
            ShowValueCSBasic showValueCSBasic = new ShowValueCSBasic();
            if(ZERO_SZ_WARNING.getCode().equals(remark)){//水质报警
                showValueCSBasic.setH(ZAIXIANYIBIAO);
//                showValueCSBasic.setF(tXinyiWarningRecord.getLevel());
                showValueCSBasic.setF(tXinyiWarningRecord.getSymbolDesc());
            }else if(ONE_SH_WARNING.getCode().equals(remark)){//生化报警
                showValueCSBasic.setH(ZAIXIANYIBIAO);
            }else if(BusinessEnum.BigModelWarningTypeRemarkEnum.TWO_YC_WARNING.getCode().equals(remark)){//预测报警
                showValueCSBasic.setH(YVCE);
//                showValueCSBasic.setF(tXinyiWarningRecord.getLevel());
            }else {//机器人化验室报警（特殊的水质报警）
                showValueCSBasic.setH(LIANXUJIANCE);
//                showValueCSBasic.setF(tXinyiWarningRecord.getLevel());
                showValueCSBasic.setF(tXinyiWarningRecord.getSymbolDesc());
            }
            //通用的
            //        showValueBasic.setA(tXinyiWarningRecord.getReason());
//            showValueCSBasic.setB(DateUtils.parseDateToStr(DateUtils.YYYY_MM_DD_HH_MM ,warningTime));
            showValueCSBasic.setB(DateUtils.parseDateToStr(DateUtils.YYYY_MM_DD_HH_MM ,nowDate));
            showValueCSBasic.setC(DecimalUtils.getAbsAndScale(tXinyiWarningRecord.getWarningVal(), INT_2));
            showValueCSBasic.setD(DecimalUtils.getAbsAndScale(tXinyiWarningRecord.getControlVal(), INT_2));
            showValueCSBasic.setE(DecimalUtils.getAbsAndScale(tXinyiWarningRecord.getDesignVal(), INT_2));
            showValueCSBasic.setG(count > MAX_COUNT ? MAX_COUNT_STR : String.valueOf(count));
            if(tXinyiWarningRecord.getType() != 2)
                showValueCSBasic.setI(status == 0 ? "报警中" : status == 1 ? "用户关闭" : status == 2 ? "系统关闭" : "应急处理中");
            else
                showValueCSBasic.setI(status == 0 ? "预警中" : "已完成");
            result.put("basic", showValueCSBasic);
        }else{//进水的展示
            ShowValueJSBasic showValueJSBasic = new ShowValueJSBasic();
            if(ZERO_SZ_WARNING.getCode().equals(remark)){//水质报警
                showValueJSBasic.setH(ZAIXIANYIBIAO);
//                showValueJSBasic.setF(tXinyiWarningRecord.getLevel());
                showValueJSBasic.setF(tXinyiWarningRecord.getSymbolDesc());
            }else if(ONE_SH_WARNING.getCode().equals(remark)){//生化报警
                showValueJSBasic.setH(ZAIXIANYIBIAO);
            }else if(BusinessEnum.BigModelWarningTypeRemarkEnum.TWO_YC_WARNING.getCode().equals(remark)){//预测报警
                showValueJSBasic.setH(YVCE);
//                showValueCSBasic.setF(tXinyiWarningRecord.getLevel());
            }else {//机器人化验室报警（特殊的 水质报警）
                showValueJSBasic.setH(LIANXUJIANCE);
//                showValueJSBasic.setF(tXinyiWarningRecord.getLevel());
                showValueJSBasic.setF(tXinyiWarningRecord.getSymbolDesc());
            }
            //通用的
            //        showValueBasic.setA(tXinyiWarningRecord.getReason());
            showValueJSBasic.setB(DateUtils.parseDateToStr(DateUtils.YYYY_MM_DD_HH_MM ,tXinyiWarningRecord.getTime()));
            showValueJSBasic.setC(DecimalUtils.getAbsAndScale(tXinyiWarningRecord.getWarningVal(), INT_2));
            showValueJSBasic.setE(DecimalUtils.getAbsAndScale(tXinyiWarningRecord.getDesignVal(), INT_2));
            showValueJSBasic.setG(count > MAX_COUNT ? MAX_COUNT_STR : String.valueOf(count));
            if(tXinyiWarningRecord.getType() != 2)
                showValueJSBasic.setI(status == 0 ? "报警中" : status == 1 ? "用户关闭" : status == 2 ? "系统关闭" : "应急处理中");
            else
                showValueJSBasic.setI(status == 0 ? "预警中" : "已完成");
            result.put("basic", showValueJSBasic);
        }
        JSONObject jsData = jsCsFormatData.getJsonObject(tXinyiIndustry, normConfig);//进水数据
        result.put("jsData", jsData);
        JSONObject csData = jsCsFormatData.getCsonObject(tXinyiIndustry, normConfig);//出水数据
        result.put("csData", csData);
//        return JSON.toJSONString(result, JSONWriter.Feature.WriteNulls);
        return JSON.toJSONString(result);
    }


    private String parseCategory(String category) {
        switch (category) {
            case "进水COD" : return "js_cod";
            case "进水总磷" : return "js_tp";
            case "进水总氮" : return "js_tn";
            case "进水氨氮" : return "js_andan";
            case "进水SS" : return "js_ss";
            case "出水COD" : return "cs_cod";
            case "出水总磷" : return "cs_tp";
            case "出水总氮" : return "cs_tn";
            case "出水氨氮" : return "cs_andan";
            case "出水SS" : return "cs_ss";
            case "#1好氧硝酸盐" : return "cs_tn_lxjc1";
            case "#2好氧硝酸盐" : return "cs_tn_lxjc2";
            case "出水氨氮连续检测" : return "cs_andan_lxjc1";
            case "二沉池正磷酸盐" : return "cs_tp_lxjc";
            default: throw new ServiceException("暂时不支持的类型");
        }
    }


    private void closeWarning(TXinyiWarningRecord tXinyiWarningRecord) {
//        Date nowDate = DateUtils.getNowDate();
        tXinyiWarningRecord.setStatus(2);
        //2025年05月10日13:33:35 因为要处理历史数据，所以这里的时间不能用当前时间，应该用报警的下一个时段
        Date nowDate = DateUtils.addHours(tXinyiWarningRecord.getUpdateTime(), 1);
        tXinyiWarningRecord.setOffTime(nowDate);
        tXinyiWarningRecord.setUpdateTime(nowDate);
        tXinyiWarningRecord.setUpdateBy(WARNING_DEFAULT_CREATE);
        this.xinyiWarningRecordMapper.updateTXinyiWarningRecord(tXinyiWarningRecord);
    }



    /**
     *手动处理化验室报警-新的逻辑 并且需要传入起止时间
     */
    @PostMapping("/robotWarningNewByDate")
    public String robotWarningNewByDate(String dateBegin, String dateEnd){
        log.info("进入了 手动处理化验室报警-新的逻辑 并且需要传入起止时间 操作");
        List<TXinyiRobot> tXinyiRobots = this.xinyiRobotMapper.selectTXinyiRobotListNew(TXinyiRobot.builder().timeBegin(dateBegin).timeEnd(dateEnd).build());
        if(!CollectionUtils.isEmpty(tXinyiRobots)){
            for (TXinyiRobot tXinyiRobot : tXinyiRobots) {
                asyncTask.handleRobotWarningNew(tXinyiRobot);
                this.handleRobotWarningNew(tXinyiRobot);
            }
        }
        return "success";
    }


    public void handleRobotWarningNew(TXinyiRobot tXinyiRobot) {

        log.info("进入了定时任务判断机器人化验库是否超标及后续逻辑--新的逻辑处理");
        //查询配置
        List<TXinyiNormConfig> tXinyiNormConfigs = this.xinyiNormConfigMapper.selectTXinyiNormConfigList(null);
        if(CollectionUtils.isEmpty(tXinyiNormConfigs)){
//            throw new ServiceException("未查询到配置信息");
            log.error("未查询到配置信息");
            return;
        }
        TXinyiNormConfig normConfig = tXinyiNormConfigs.get(0);

        String testHour = tXinyiRobot.getTestHour();
        if(StringUtils.isBlank(testHour)){
            log.error("化验室报警的时候，获取化验室的化验时间-小时失败，无法处理后续操作");
            return;
        }

        //查询最新的一条工业库的数据（showvalue展示使用）
        //2025年02月26日15:55:16 逻辑调整：这里不使用最新的一条工业库数据，获取化验室的同时段的数据
//        List<TXinyiIndustry> tXinyiIndustries = this.xinyiIndustryMapper.selectNIndustry(1);
        List<TXinyiIndustry> tXinyiIndustries = this.xinyiIndustryMapper.selectTXinyiIndustryList(TXinyiIndustry.builder().testHour(testHour).build());
        if(CollectionUtils.isEmpty(tXinyiIndustries)){
//            throw new ServiceException("未查询到对应的工业库数据，无法进行图表数据展示！");
            log.error("未查询到对应的工业库数据，无法进行图表数据展示！");
            return;
        }

        TXinyiIndustry tXinyiIndustry = tXinyiIndustries.get(0);

        //新的逻辑：
        //只要当前获取的工业库数据和当前时间
        //如果当前时间和工业库传过来的相差不到一个小时，说明正常，工业库没挂掉：需要查询是否有挂掉的记录，有的话，关闭此报警，并触发整体的业务数据报警。
        //如果超过1小时了，说明工业库同步数据挂掉了，这时候去查询有无此类型的报警，如果有，不做任何处理，程序结束；如果没有，新增该类型报警并结束程序。
        robotWarningDetailNew(tXinyiRobot, normConfig, tXinyiIndustry);//采用新的逻辑
    }



    /**
     * 2025年04月18日15:53:45  由于报警逻辑和以前几乎完全不一样在，所以在保留原有的基础上，新增了该方法。
     * 机器人化验室报警逻辑处理
     * @param tXinyiRobot
     * @param normConfig
     * @param tXinyiIndustry
     */
    private void robotWarningDetailNew(TXinyiRobot tXinyiRobot, TXinyiNormConfig normConfig, TXinyiIndustry tXinyiIndustry) {
        //#1好氧硝酸盐
        BigDecimal no3Hlj1Jqr = tXinyiRobot.getNo3Hlj1Jqr();
        //#2好氧硝酸盐
        BigDecimal no3Hlj2Jqr = tXinyiRobot.getNo3Hlj2Jqr();

        String testHour = tXinyiRobot.getTestHour();

        //2025年04月21日17:04:28 逻辑调整，需要取最近的十条数据，计算获取到十个值
        //2025年05月08日16:27:47 这里要获取某个日期下面的值
//        List<TXinyiRobot> tXinyiRobots = this.xinyiRobotMapper.selectNRobot(INT_10);
        List<TXinyiRobot> tXinyiRobots = this.xinyiRobotMapper.selectNRobotAfterHour(INT_10, testHour);
        if(CollectionUtils.isEmpty(tXinyiRobots) || tXinyiRobots.size() < INT_10){
            log.error("化验室报警-新逻辑获取最近的10条化验室数据失败，无法处理报警，退出");
            return;
        }

        List<BigDecimal> tenVals = new ArrayList<>(10);

        //取前6个，硝酸盐是6个

        for (int i = 0; i < tXinyiRobots.size(); i++) {
            TXinyiRobot xinyiRobot = tXinyiRobots.get(i);
            //判断 增加容错
            BigDecimal no3Hlj1JqrTemp = xinyiRobot.getNo3Hlj1Jqr();
            //#2好氧硝酸盐
            BigDecimal no3Hlj2JqrTemp = xinyiRobot.getNo3Hlj2Jqr();
            //1#缺氧出-硝酸盐
            BigDecimal no3Qyc1JqrTemp = xinyiRobot.getNo3Qyc1Jqr();
            BigDecimal nh31JqrTemp = xinyiRobot.getNh31Jqr();
            //2#缺氧出-硝酸盐
            BigDecimal no3Qyc2JqrTemp = xinyiRobot.getNo3Qyc2Jqr();
            BigDecimal nh32JqrTemp = xinyiRobot.getNh32Jqr();
            if (Objects.isNull(no3Qyc1JqrTemp))
                no3Qyc1JqrTemp = BigDecimal.ZERO;
            if (Objects.isNull(nh31JqrTemp))
                nh31JqrTemp = BigDecimal.ZERO;
            if (Objects.isNull(no3Hlj1JqrTemp))
                no3Hlj1JqrTemp = BigDecimal.ZERO;
            BigDecimal anDan1 = no3Qyc1JqrTemp.add(nh31JqrTemp).subtract(no3Hlj1JqrTemp);

            //判断 增加容错
            if (Objects.isNull(no3Qyc2JqrTemp))
                no3Qyc2JqrTemp = BigDecimal.ZERO;
            if (Objects.isNull(nh32JqrTemp))
                nh32JqrTemp = BigDecimal.ZERO;
            if (Objects.isNull(no3Hlj2JqrTemp))
                no3Hlj2JqrTemp = BigDecimal.ZERO;
            BigDecimal anDan2 = no3Qyc2JqrTemp.add(nh32JqrTemp).subtract(no3Hlj2JqrTemp);
            BigDecimal divide = anDan1.add(anDan2).divide(DECIMAL_2, INT_2, RoundingMode.HALF_UP);
            //2025年04月21日17:22:30 如果计算结果小于0，当0处理
            if (divide.compareTo(BigDecimal.ZERO) < 0)
                divide = BigDecimal.ZERO;
            tenVals.add(divide);
        }


        //总氮的标准值和管控值
        BigDecimal cszzBzz = normConfig.getCszzBzz();
        BigDecimal cszzGkz = normConfig.getCszzGkz();
        //氨氮的标准值和管控值
        BigDecimal csadBzz = normConfig.getCsadBzz();
        BigDecimal csadGkz = normConfig.getCsadGkz();
        //总磷的标准值和管控值
        BigDecimal cszlBzz = normConfig.getCszlBzz();
        BigDecimal cszlGkz = normConfig.getCszlGkz();
        //进水量和进水流量设计值
        BigDecimal jsSlq = tXinyiIndustry.getJsSlq();
        BigDecimal jsslSjz = normConfig.getJsslSjz();



        //#1好氧硝酸盐
        if(no3Hlj1Jqr.compareTo(BigDecimal.ZERO) > 0){
            if(!Objects.isNull(cszzBzz)){
                handleXinYiWarningsRobotOriginCsXsy(cszzBzz, no3Hlj1Jqr, cszzGkz, ROBOT_XSY_1.getCode(), tXinyiIndustry, normConfig, getCwrwfhzByDetail(jsSlq, tXinyiIndustry.getJsTn(), jsslSjz, normConfig.getJszdSjz()), tXinyiRobots);
            }
        }

        //#2好氧硝酸盐
        if(no3Hlj2Jqr.compareTo(BigDecimal.ZERO) > 0){
            if(!Objects.isNull(cszzBzz)){
                handleXinYiWarningsRobotOriginCsXsy(cszzBzz, no3Hlj2Jqr, cszzGkz, ROBOT_XSY_2.getCode(), tXinyiIndustry, normConfig, getCwrwfhzByDetail(jsSlq, tXinyiIndustry.getJsTn(), jsslSjz, normConfig.getJszdSjz()), tXinyiRobots);
            }
        }


        //出水氨氮
        if(!Objects.isNull(csadBzz)){
            handleXinYiWarningsRobotOriginCsAd(csadBzz, tenVals.get(INDEX_0), csadGkz, ROBOT_CS_AD.getCode(), tXinyiIndustry, normConfig, getCwrwfhzByDetail(jsSlq, tXinyiIndustry.getJsNh3(), jsslSjz, normConfig.getJsadSjz()), tXinyiRobots, tenVals);
        }

        //二沉池正磷酸盐
        if(!Objects.isNull(cszlBzz)){
            handleXinYiWarningsRobotOriginCsTp(cszlBzz, tenVals.get(INDEX_0), cszlGkz, ROBOT_ECCZLSY.getCode(), tXinyiIndustry, normConfig, getCwrwfhzByDetail(jsSlq, tXinyiIndustry.getJsTp(), jsslSjz, normConfig.getJszlSjz()), tXinyiRobots);
        }
    }


    /**
     * 通过输入的值 生成对应类型的报警对象（出水）- 二沉池正磷酸盐
     *
     * @param csBzz
     * @param currentVal
     * @param csGkz
     * @param category
     * @param tXinyiIndustry
     * @param normConfig
     * @param cwrwfhz
     * @param tXinyiRobots
     * @return
     */
    private void handleXinYiWarningsRobotOriginCsTp(BigDecimal csBzz, BigDecimal currentVal, BigDecimal csGkz, String category, TXinyiIndustry tXinyiIndustry, TXinyiNormConfig normConfig, BigDecimal cwrwfhz, List<TXinyiRobot> tXinyiRobots) {

        String testHour = tXinyiIndustry.getTestHour();
        //这里也不能用当前日期，要用对应检测时间
//        Date nowDate = DateUtils.getNowDate();
        Date nowDate = DateUtils.parseDate(testHour);

//        //单点突变-异常升高报警
//        if (existsYcsgRobots(csBzz, currentVal, csGkz, category, tXinyiIndustry, normConfig, cwrwfhz, tXinyiRobots, nowDate))
//            return;

        //下面是最原始的处理 超标准 超管控报警
        robotCsTpGybz(csBzz, currentVal, csGkz, category, tXinyiIndustry, normConfig, cwrwfhz, tXinyiRobots, nowDate);

    }


    /**
     *
     * 化验室-出水总磷（二沉池正磷酸盐） 的 超标准工艺报警
     * @param csBzz
     * @param currentVal
     * @param csGkz
     * @param category
     * @param tXinyiIndustry
     * @param normConfig
     * @param cwrwfhz
     * @param tXinyiRobots
     * @param nowDate
     */
    private void robotCsTpGybz(BigDecimal csBzz, BigDecimal currentVal, BigDecimal csGkz, String category, TXinyiIndustry tXinyiIndustry, TXinyiNormConfig normConfig, BigDecimal cwrwfhz, List<TXinyiRobot> tXinyiRobots, Date nowDate) {
        TXinyiWarningRecord tXinyiWarningRecord = getRobotCsTpWarningBean(csBzz, currentVal, csGkz, category, normConfig, cwrwfhz, tXinyiRobots, nowDate);
        //判断是否存在要报警的数据
        //当前状态正常 需要查询历史有无正在报警的数据，如果有，将报警状态改完2(系统自动关闭)
        List<TXinyiWarningRecord> tXinyiWarningRecords = this.xinyiWarningRecordMapper.selectTXinyiWarningRecordList(TXinyiWarningRecord.builder().delFlag(0).type(0).category(category).status(0).build());
        if(Objects.isNull(tXinyiWarningRecord)){//数据正常，无告警信息
            if(!CollectionUtils.isEmpty(tXinyiWarningRecords)){
                log.info( "{}:现在恢复正常，历史报警数据为{}", category,JSON.toJSONString(tXinyiWarningRecords));
                for (TXinyiWarningRecord xinyiWarningRecord : tXinyiWarningRecords) {
                    this.closeWarning(xinyiWarningRecord);
                }
            }
        }else{//有告警信息
            if(CollectionUtils.isEmpty(tXinyiWarningRecords)){//之前没有告警记录
                //保存到数据库中
                //2024年7月15日11:06:16 因为只有一个告警记录，但是如果一直报警，现在报警时间取的是更新时间，兼容第一次报警处理
                tXinyiWarningRecord.setUpdateTime(nowDate);
                this.xinyiWarningRecordMapper.insertTXinyiWarningRecord(tXinyiWarningRecord);
                //继续调用决策
                this.handleDecision(tXinyiWarningRecord, tXinyiIndustry, normConfig, true, nowDate);
            }else{
                log.info("{}:之前已经有过告警记录了，且还是继续报警，无需重复添加报警，但是决策仍然要调用", category);
                for (TXinyiWarningRecord xinyiWarningRecord : tXinyiWarningRecords) {//理论上只有一个的
                    //2024年7月5日10:45:24 逻辑调整：更新一直报警的那条记录的显示值
                    xinyiWarningRecord.setWarningVal(tXinyiWarningRecord.getWarningVal());
//                        xinyiWarningRecord.setDesignVal(tXinyiWarningRecord.getDesignVal());
//                        tXinyiWarningRecord.setControlVal(tXinyiWarningRecord.getControlVal());
                    xinyiWarningRecord.setTime(tXinyiWarningRecord.getTime());
                    xinyiWarningRecord.setUpdateTime(nowDate);
                    xinyiWarningRecord.setUpdateBy(WARNING_DEFAULT_CREATE);
                    //2024年7月15日11:07:33 报警的级别也要重新计算并更新
                    xinyiWarningRecord.setLevel(tXinyiWarningRecord.getLevel());
                    //2024年7月31日09:20:47 报警的原因（超标还是超管控也需要更新）
                    xinyiWarningRecord.setReason(tXinyiWarningRecord.getReason());
                    //更新数据库
                    this.xinyiWarningRecordMapper.updateTXinyiWarningRecord(xinyiWarningRecord);
                    //继续调用决策
                    this.handleDecision(xinyiWarningRecord, tXinyiIndustry, normConfig, true, nowDate);
                }
            }
        }
    }


    /**
     * 判断化验室的-出水氨氮是否存在报警，如果存在返回报警对象；如果不存在，返回null
     *
     * @param csBzz
     * @param currentVal
     * @param csGkz
     * @param category
     * @param normConfig
     * @param cwrwfhz
     * @param tXinyiRobots
     * @param nowDate
     * @return
     */
    private TXinyiWarningRecord getRobotCsTpWarningBean(BigDecimal csBzz, BigDecimal currentVal, BigDecimal csGkz, String category, TXinyiNormConfig normConfig, BigDecimal cwrwfhz, List<TXinyiRobot> tXinyiRobots, Date nowDate) {
        //判断是否存在
        boolean flag1 = true;
        for (TXinyiRobot xinyiRobot : tXinyiRobots) {
            //是否连续6小时超标 正磷酸盐数据 > 0.5 and 连续6小时
            BigDecimal val = xinyiRobot.getTpRccJqr();
            if (!Objects.isNull(val) && val.compareTo(csBzz) <= 0) {
                flag1 = false;
                break;//只要出现一个不超标的就不算超标
            }
        }

        //存放则返回对象，不存在，则返回null  2个条件都不满足报警，返回空对象
        if(!flag1)
            return null;
        TXinyiWarningRecord tXinyiWarningRecord = new TXinyiWarningRecord();
        tXinyiWarningRecord.setStatus(0);
        tXinyiWarningRecord.setType(0);
        tXinyiWarningRecord.setCategory(category);
        tXinyiWarningRecord.setTime(nowDate);
        tXinyiWarningRecord.setWarningVal(currentVal);
        tXinyiWarningRecord.setDesignVal(csBzz);
        tXinyiWarningRecord.setControlVal(csGkz);
        tXinyiWarningRecord.setCreateBy(WARNING_DEFAULT_CREATE);
        tXinyiWarningRecord.setCreateTime(nowDate);
        tXinyiWarningRecord.setRemark(THREE_HYS_WARNING.getCode());//化验室
        tXinyiWarningRecord.setCwrwfhz(cwrwfhz);//2025年02月14日10:42:53 具体指标具体计算，由上游传过来。
        //2025年02月17日13:53:49 化验室的报警都是对应的类型都是出水
        tXinyiWarningRecord.setWaterType(BusinessEnum.WaterTypeEnum.CS.getCode());
        tXinyiWarningRecord.setReason(category + CHAOBIAO_WARNING);
        tXinyiWarningRecord.setLevel(WARNING_LEVEL_ONE);
        tXinyiWarningRecord.setSymbol(BusinessEnum.WarningSymbolEnum.CBZZ.getCode());
        tXinyiWarningRecord.setCwrwxz(getCwrwxzByDetail(currentVal, normConfig, category, true));//根据当前值和类型以及是否超标处理
        return tXinyiWarningRecord;
    }


    /**
     * 通过输入的值 生成对应类型的报警对象（出水）
     *
     * @param csBzz
     * @param currentVal
     * @param csGkz
     * @param category
     * @param tXinyiIndustry
     * @param normConfig
     * @param cwrwfhz
     * @param tXinyiRobots
     * @param tenVals
     * @return
     */
    private void handleXinYiWarningsRobotOriginCsAd(BigDecimal csBzz, BigDecimal currentVal, BigDecimal csGkz, String category, TXinyiIndustry tXinyiIndustry, TXinyiNormConfig normConfig, BigDecimal cwrwfhz, List<TXinyiRobot> tXinyiRobots, List<BigDecimal> tenVals) {

        String testHour = tXinyiIndustry.getTestHour();
        //这里也不能用当前日期，要用对应检测时间
//        Date nowDate = DateUtils.getNowDate();
        Date nowDate = DateUtils.parseDate(testHour);

        //下面是最原始的处理 超标准 超管控报警
        robotCsAdGybz(csBzz, currentVal, csGkz, category, tXinyiIndustry, normConfig, cwrwfhz, tenVals, nowDate);

    }


    /**
     *
     * 化验室-出水氨氮 的 超标准工艺报警
     * @param csBzz
     * @param currentVal
     * @param csGkz
     * @param category
     * @param tXinyiIndustry
     * @param normConfig
     * @param cwrwfhz
     * @param tXinyiRobots
     * @param nowDate
     */
    private void robotCsAdGybz(BigDecimal csBzz, BigDecimal currentVal, BigDecimal csGkz, String category, TXinyiIndustry tXinyiIndustry, TXinyiNormConfig normConfig, BigDecimal cwrwfhz, List<BigDecimal> tXinyiRobots, Date nowDate) {
        TXinyiWarningRecord tXinyiWarningRecord = getRobotCsAdWarningBean(csBzz, currentVal, csGkz, category, normConfig, cwrwfhz, tXinyiRobots, nowDate);
        //判断是否存在要报警的数据
        //当前状态正常 需要查询历史有无正在报警的数据，如果有，将报警状态改完2(系统自动关闭)
        List<TXinyiWarningRecord> tXinyiWarningRecords = this.xinyiWarningRecordMapper.selectTXinyiWarningRecordList(TXinyiWarningRecord.builder().delFlag(0).type(0).category(category).status(0).build());
        if(Objects.isNull(tXinyiWarningRecord)){//数据正常，无告警信息
            if(!CollectionUtils.isEmpty(tXinyiWarningRecords)){
                log.info( "{}:现在恢复正常，历史报警数据为{}", category,JSON.toJSONString(tXinyiWarningRecords));
                for (TXinyiWarningRecord xinyiWarningRecord : tXinyiWarningRecords) {
                    this.closeWarning(xinyiWarningRecord);
                }
            }
        }else{//有告警信息
            if(CollectionUtils.isEmpty(tXinyiWarningRecords)){//之前没有告警记录
                //保存到数据库中
                //2024年7月15日11:06:16 因为只有一个告警记录，但是如果一直报警，现在报警时间取的是更新时间，兼容第一次报警处理
                tXinyiWarningRecord.setUpdateTime(nowDate);
                this.xinyiWarningRecordMapper.insertTXinyiWarningRecord(tXinyiWarningRecord);
                //继续调用决策
                this.handleDecision(tXinyiWarningRecord, tXinyiIndustry, normConfig, true, nowDate);
            }else{
                log.info("{}:之前已经有过告警记录了，且还是继续报警，无需重复添加报警，但是决策仍然要调用", category);
                for (TXinyiWarningRecord xinyiWarningRecord : tXinyiWarningRecords) {//理论上只有一个的
                    //2024年7月5日10:45:24 逻辑调整：更新一直报警的那条记录的显示值
                    xinyiWarningRecord.setWarningVal(tXinyiWarningRecord.getWarningVal());
//                        xinyiWarningRecord.setDesignVal(tXinyiWarningRecord.getDesignVal());
//                        tXinyiWarningRecord.setControlVal(tXinyiWarningRecord.getControlVal());
                    xinyiWarningRecord.setTime(tXinyiWarningRecord.getTime());
                    xinyiWarningRecord.setUpdateTime(nowDate);
                    xinyiWarningRecord.setUpdateBy(WARNING_DEFAULT_CREATE);
                    //2024年7月15日11:07:33 报警的级别也要重新计算并更新
                    xinyiWarningRecord.setLevel(tXinyiWarningRecord.getLevel());
                    //2024年7月31日09:20:47 报警的原因（超标还是超管控也需要更新）
                    xinyiWarningRecord.setReason(tXinyiWarningRecord.getReason());
                    //更新数据库
                    this.xinyiWarningRecordMapper.updateTXinyiWarningRecord(xinyiWarningRecord);
                    //继续调用决策
                    this.handleDecision(xinyiWarningRecord, tXinyiIndustry, normConfig, true, nowDate);
                }
            }
        }
    }


    /**
     * 判断化验室的-出水氨氮是否存在报警，如果存在返回报警对象；如果不存在，返回null
     *
     * @param csBzz
     * @param currentVal
     * @param csGkz
     * @param category
     * @param normConfig
     * @param cwrwfhz
     * @param tXinyiRobots
     * @param nowDate
     * @return
     */
    private TXinyiWarningRecord getRobotCsAdWarningBean(BigDecimal csBzz, BigDecimal currentVal, BigDecimal csGkz, String category, TXinyiNormConfig normConfig, BigDecimal cwrwfhz, List<BigDecimal> tXinyiRobots, Date nowDate) {
        //判断是否存在
        boolean flag = true;
        for (BigDecimal val : tXinyiRobots) {
            if (!Objects.isNull(val) && val.compareTo(csBzz) <= 0) {
                flag = false;
                break;//只要出现一个不超标的就不算超标
            }
        }
        //存放则返回对象，不存在，则返回null
        if(!flag)
            return null;
        TXinyiWarningRecord tXinyiWarningRecord = new TXinyiWarningRecord();
        tXinyiWarningRecord.setStatus(0);
        tXinyiWarningRecord.setType(0);
        tXinyiWarningRecord.setCategory(category);
        tXinyiWarningRecord.setTime(nowDate);
        tXinyiWarningRecord.setWarningVal(currentVal);
        tXinyiWarningRecord.setDesignVal(csBzz);
        tXinyiWarningRecord.setControlVal(csGkz);
        tXinyiWarningRecord.setCreateBy(WARNING_DEFAULT_CREATE);
        tXinyiWarningRecord.setCreateTime(nowDate);
        tXinyiWarningRecord.setRemark(THREE_HYS_WARNING.getCode());//化验室
        tXinyiWarningRecord.setCwrwfhz(cwrwfhz);//2025年02月14日10:42:53 具体指标具体计算，由上游传过来。
        //2025年02月17日13:53:49 化验室的报警都是对应的类型都是出水
        tXinyiWarningRecord.setWaterType(BusinessEnum.WaterTypeEnum.CS.getCode());
        tXinyiWarningRecord.setReason(category + CHAOBIAO_WARNING);
        tXinyiWarningRecord.setLevel(WARNING_LEVEL_ONE);
        tXinyiWarningRecord.setSymbol(BusinessEnum.WarningSymbolEnum.CBZZ.getCode());
        tXinyiWarningRecord.setCwrwxz(getCwrwxzByDetail(currentVal, normConfig, category, true));//根据当前值和类型以及是否超标处理
        return tXinyiWarningRecord;
    }


    /**
     * 通过输入的值 生成对应类型的报警对象（出水）
     *
     * @param csBzz
     * @param currentVal
     * @param csGkz
     * @param category
     * @param tXinyiIndustry
     * @param normConfig
     * @param cwrwfhz
     * @param tXinyiRobots
     * @return
     */
    private void handleXinYiWarningsRobotOriginCsXsy(BigDecimal csBzz, BigDecimal currentVal, BigDecimal csGkz, String category, TXinyiIndustry tXinyiIndustry, TXinyiNormConfig normConfig, BigDecimal cwrwfhz, List<TXinyiRobot> tXinyiRobots) {

        String testHour = tXinyiIndustry.getTestHour();
        //这里也不能用当前日期，要用对应检测时间
//        Date nowDate = DateUtils.getNowDate();
        Date nowDate = DateUtils.parseDate(testHour);

        //下面是最原始的处理 超标准 超管控报警
        robotCsXsyGybz(csBzz, currentVal, csGkz, category, tXinyiIndustry, normConfig, cwrwfhz, tXinyiRobots, nowDate);

    }


    /**
     *
     * 化验室-出水硝酸盐 的 超标准工艺报警
     * @param csBzz
     * @param currentVal
     * @param csGkz
     * @param category
     * @param tXinyiIndustry
     * @param normConfig
     * @param cwrwfhz
     * @param tXinyiRobots
     * @param nowDate
     */
    private void robotCsXsyGybz(BigDecimal csBzz, BigDecimal currentVal, BigDecimal csGkz, String category, TXinyiIndustry tXinyiIndustry, TXinyiNormConfig normConfig, BigDecimal cwrwfhz, List<TXinyiRobot> tXinyiRobots, Date nowDate) {
        TXinyiWarningRecord tXinyiWarningRecord = getRobotCsXsyWarningBean(csBzz, currentVal, csGkz, category, normConfig, cwrwfhz, tXinyiRobots, nowDate);
        //判断是否存在要报警的数据
        //当前状态正常 需要查询历史有无正在报警的数据，如果有，将报警状态改完2(系统自动关闭)
        List<TXinyiWarningRecord> tXinyiWarningRecords = this.xinyiWarningRecordMapper.selectTXinyiWarningRecordList(TXinyiWarningRecord.builder().delFlag(0).type(0).category(category).status(0).build());
        if(Objects.isNull(tXinyiWarningRecord)){//数据正常，无告警信息
            if(!CollectionUtils.isEmpty(tXinyiWarningRecords)){
                log.info( "{}:现在恢复正常，历史报警数据为{}", category,JSON.toJSONString(tXinyiWarningRecords));
                for (TXinyiWarningRecord xinyiWarningRecord : tXinyiWarningRecords) {
                    this.closeWarning(xinyiWarningRecord);
                }
            }
        }else{//有告警信息
            if(CollectionUtils.isEmpty(tXinyiWarningRecords)){//之前没有告警记录
                //保存到数据库中
                //2024年7月15日11:06:16 因为只有一个告警记录，但是如果一直报警，现在报警时间取的是更新时间，兼容第一次报警处理
                tXinyiWarningRecord.setUpdateTime(nowDate);
                this.xinyiWarningRecordMapper.insertTXinyiWarningRecord(tXinyiWarningRecord);
                //继续调用决策
                this.handleDecision(tXinyiWarningRecord, tXinyiIndustry, normConfig, true, nowDate);
            }else{
                log.info("{}:之前已经有过告警记录了，且还是继续报警，无需重复添加报警，但是决策仍然要调用", category);
                for (TXinyiWarningRecord xinyiWarningRecord : tXinyiWarningRecords) {//理论上只有一个的
                    //2024年7月5日10:45:24 逻辑调整：更新一直报警的那条记录的显示值
                    xinyiWarningRecord.setWarningVal(tXinyiWarningRecord.getWarningVal());
//                        xinyiWarningRecord.setDesignVal(tXinyiWarningRecord.getDesignVal());
//                        tXinyiWarningRecord.setControlVal(tXinyiWarningRecord.getControlVal());
                    xinyiWarningRecord.setTime(tXinyiWarningRecord.getTime());
                    xinyiWarningRecord.setUpdateTime(nowDate);
                    xinyiWarningRecord.setUpdateBy(WARNING_DEFAULT_CREATE);
                    //2024年7月15日11:07:33 报警的级别也要重新计算并更新
                    xinyiWarningRecord.setLevel(tXinyiWarningRecord.getLevel());
                    //2024年7月31日09:20:47 报警的原因（超标还是超管控也需要更新）
                    xinyiWarningRecord.setReason(tXinyiWarningRecord.getReason());
                    //更新数据库
                    this.xinyiWarningRecordMapper.updateTXinyiWarningRecord(xinyiWarningRecord);
                    //继续调用决策
                    this.handleDecision(xinyiWarningRecord, tXinyiIndustry, normConfig, true, nowDate);
                }
            }
        }
    }



    /**
     * 判断化验室的-出水氨氮是否存在报警，如果存在返回报警对象；如果不存在，返回null
     *
     * @param csBzz
     * @param currentVal
     * @param csGkz
     * @param category
     * @param normConfig
     * @param cwrwfhz
     * @param tXinyiRobots
     * @param nowDate
     * @return
     */
    private TXinyiWarningRecord getRobotCsXsyWarningBean(BigDecimal csBzz, BigDecimal currentVal, BigDecimal csGkz, String category, TXinyiNormConfig normConfig, BigDecimal cwrwfhz, List<TXinyiRobot> tXinyiRobots, Date nowDate) {
        //判断是否存在
        boolean flag1 = true;
        boolean flag2 = true;
        int index = 0;
        for (TXinyiRobot xinyiRobot : tXinyiRobots) {
            //是否连续6小时超标
            if(index < 6){
                BigDecimal val = null;
                if(ROBOT_XSY_1.getCode().equals(category))
                    val = xinyiRobot.getNo3Hlj1Jqr();
                else if(ROBOT_XSY_2.getCode().equals(category))
                    val = xinyiRobot.getNo3Hlj2Jqr();
                if (!Objects.isNull(val) && val.compareTo(csBzz) <= 0) {
                    flag1 = false;
                    //2025年05月07日16:04:56 bug修复：这里不能退出，因为一个循环里有2个判断逻辑处理。
//                    break;//只要出现一个不超标的就不算超标
                }
            }
            index++;

            //是否满足{缺氧区出水氨氮+缺氧区出水硝酸盐 > 15（文件配置） and 连续10小时}
            BigDecimal one = null;
            BigDecimal two = null;
            if(ROBOT_XSY_1.getCode().equals(category)){
                one = xinyiRobot.getNh31Jqr();
                two = xinyiRobot.getNo3Qyc1Jqr();
            }
            else if(ROBOT_XSY_2.getCode().equals(category)){
                one = xinyiRobot.getNh32Jqr();
                two = xinyiRobot.getNo3Qyc2Jqr();
            }
            //兜底计算
            if(Objects.isNull(one))
                one = BigDecimal.ZERO;
            if(Objects.isNull(two))
                two = BigDecimal.ZERO;
            if(one.add(two).compareTo(BigDecimal.valueOf(15)) <= 0) {
                flag2 = false;
                //2025年05月07日16:04:56 bug修复：这里不能退出，因为一个循环里有2个判断逻辑处理。
//                break;//只要出现一个不超标的就不算超标
            }

        }

        //存放则返回对象，不存在，则返回null  2个条件都不满足报警，返回空对象
        if(!flag1 && !flag2)
            return null;
        TXinyiWarningRecord tXinyiWarningRecord = new TXinyiWarningRecord();
        tXinyiWarningRecord.setStatus(0);
        tXinyiWarningRecord.setType(0);
        tXinyiWarningRecord.setCategory(category);
        tXinyiWarningRecord.setTime(nowDate);
        tXinyiWarningRecord.setWarningVal(currentVal);
        tXinyiWarningRecord.setDesignVal(csBzz);
        tXinyiWarningRecord.setControlVal(csGkz);
        tXinyiWarningRecord.setCreateBy(WARNING_DEFAULT_CREATE);
        tXinyiWarningRecord.setCreateTime(nowDate);
        tXinyiWarningRecord.setRemark(THREE_HYS_WARNING.getCode());//化验室
        tXinyiWarningRecord.setCwrwfhz(cwrwfhz);//2025年02月14日10:42:53 具体指标具体计算，由上游传过来。
        //2025年02月17日13:53:49 化验室的报警都是对应的类型都是出水
        tXinyiWarningRecord.setWaterType(BusinessEnum.WaterTypeEnum.CS.getCode());
        tXinyiWarningRecord.setReason(category + CHAOBIAO_WARNING);
        tXinyiWarningRecord.setLevel(WARNING_LEVEL_ONE);
        tXinyiWarningRecord.setSymbol(BusinessEnum.WarningSymbolEnum.CBZZ.getCode());
        tXinyiWarningRecord.setCwrwxz(getCwrwxzByDetail(currentVal, normConfig, category, true));//根据当前值和类型以及是否超标处理
        return tXinyiWarningRecord;
    }



}

